#include "ua_types_encoding_xml.h"
#include "ua_util.h"
#include "ua_xml.h"

/* Boolean */

UA_Int32 UA_Boolean_copycstring(cstring src, UA_Boolean *dst) {
	*dst = UA_FALSE;
	if(0 == strncmp(src, "true", 4) || 0 == strncmp(src, "TRUE", 4))
		*dst = UA_TRUE;
	return UA_SUCCESS;
}

UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Boolean)
UA_Int32 UA_Boolean_decodeXML(XML_Stack *s, XML_Attr *attr, UA_Boolean *dst, _Bool isStart) {
	DBG_VERBOSE(printf("UA_Boolean entered with dst=%p,isStart=%d\n", (void * )dst, isStart));
	if(isStart) {
		if(dst == UA_NULL) {
			UA_Boolean_new(&dst);
			s->parent[s->depth - 1].children[s->parent[s->depth - 1].activeChild].obj = (void *)dst;
		}
		UA_Boolean_copycstring((cstring)attr[1], dst);
	}
	return UA_SUCCESS;
}

/* SByte */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SByte)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SByte)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SByte)

/* Byte */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Byte)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Byte)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Byte)

/* Int16 */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Int16)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Int16)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Int16)

/* UInt16 */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UInt16)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UInt16)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UInt16)

/* Int32 */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Int32)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Int32)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Int32)

/* UInt32 */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UInt32)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UInt32)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UInt32)

/* Int64 */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Int64)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Int64)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Int64)

/* UInt64 */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UInt64)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UInt64)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UInt64)

/* Float */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Float)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Float)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Float)

/* Double */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Double)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Double)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Double)

/* String */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_String)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_String)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_String)

/* DateTime */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DateTime)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DateTime)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DateTime)

/* Guid */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Guid)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Guid)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Guid)

/* ByteString */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ByteString)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ByteString)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ByteString)

/* XmlElement */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_XmlElement)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_XmlElement)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_XmlElement)

/* NodeId */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NodeId)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NodeId)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NodeId)

/* ExpandedNodeId */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ExpandedNodeId)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ExpandedNodeId)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ExpandedNodeId)

/* StatusCode */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_StatusCode)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_StatusCode)
UA_Int32 UA_StatusCode_decodeXML(XML_Stack *s, XML_Attr *attr, UA_StatusCode *dst, _Bool isStart) {
	DBG_VERBOSE(printf("UA_StatusCode_decodeXML entered with dst=%p,isStart=%d\n", (void * )dst, isStart));
	return UA_ERR_NOT_IMPLEMENTED;
}

/* QualifiedName */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_QualifiedName)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_QualifiedName)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_QualifiedName)

/* LocalizedText */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_LocalizedText)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_LocalizedText)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_LocalizedText)

/* ExtensionObject */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ExtensionObject)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ExtensionObject)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ExtensionObject)

/* DataValue */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DataValue)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DataValue)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DataValue)

/* Variant */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Variant)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Variant)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Variant)

/* DiagnosticInfo */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DiagnosticInfo)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DiagnosticInfo)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DiagnosticInfo)

/* InvalidType */
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_InvalidType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_InvalidType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_InvalidType)
