/**
 * @file ua_types_generated.c
 *
 * @brief Autogenerated function implementations to manage the data types defined in the UA standard
 *
 * Generated from ../schema/Opc.Ua.Types.bsd with script ../tools/generate_builtin.py
 * on host jpfr-VirtualBox by user jpfr at 2014-06-06 02:08:25
 */
 
#include "ua_types_generated.h"

UA_TYPE_AS(UA_NodeIdType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_NodeIdType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NodeIdType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NodeIdType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NodeIdType
)
UA_TYPE_AS(UA_ImageBMP, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_ImageBMP, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ImageBMP)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ImageBMP)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ImageBMP)

UA_TYPE_AS(UA_ImageGIF, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_ImageGIF, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ImageGIF)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ImageGIF)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ImageGIF)

UA_TYPE_AS(UA_ImageJPG, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_ImageJPG, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ImageJPG)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ImageJPG)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ImageJPG)

UA_TYPE_AS(UA_ImagePNG, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_ImagePNG, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ImagePNG)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ImagePNG)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ImagePNG)

UA_TYPE_AS(UA_BitFieldMaskDataType, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_BitFieldMaskDataType, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BitFieldMaskDataType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BitFieldMaskDataType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BitFieldMaskDataType)

UA_TYPE_AS(UA_OpenFileMode, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_OpenFileMode, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_OpenFileMode)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_OpenFileMode)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_OpenFileMode
)
UA_TYPE_AS(UA_IdType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_IdType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_IdType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_IdType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_IdType
)
UA_TYPE_AS(UA_NodeClass, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_NodeClass, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NodeClass)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NodeClass)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NodeClass
)
UA_Int32 UA_ReferenceNode_calcSizeBinary(UA_ReferenceNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReferenceNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + sizeof(UA_Boolean) // isInverse
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->targetId)
	;
}

UA_Int32 UA_ReferenceNode_encodeBinary(UA_ReferenceNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isInverse,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->targetId,dst,offset);
	return retval;
}

UA_Int32 UA_ReferenceNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReferenceNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReferenceNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_ReferenceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isInverse), UA_ReferenceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->targetId), UA_ReferenceNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReferenceNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReferenceNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReferenceNode)
UA_Int32 UA_ReferenceNode_delete(UA_ReferenceNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReferenceNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReferenceNode_deleteMembers(UA_ReferenceNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->targetId);
	return retval;
}

UA_Int32 UA_ReferenceNode_init(UA_ReferenceNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_Boolean_init(&p->isInverse);
	retval |= UA_ExpandedNodeId_init(&p->targetId);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReferenceNode)
UA_Int32 UA_ReferenceNode_copy(const UA_ReferenceNode *src,UA_ReferenceNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReferenceNode));
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	retval |= UA_ExpandedNodeId_copy(&src->targetId,&dst->targetId);
	return retval;
}

UA_Int32 UA_Argument_calcSizeBinary(UA_Argument const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_Argument);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->name)
	 + UA_NodeId_calcSizeBinary(&ptr->dataType)
	 + sizeof(UA_Int32) // valueRank
	 + UA_Array_calcSizeBinary(ptr->arrayDimensionsSize,UA_UINT32,ptr->arrayDimensions)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	;
}

UA_Int32 UA_Argument_encodeBinary(UA_Argument const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->name,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->dataType,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->valueRank,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->arrayDimensionsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->arrayDimensions,src->arrayDimensionsSize,UA_UINT32,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	return retval;
}

UA_Int32 UA_Argument_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_Argument * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_Argument_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->name), UA_Argument_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->dataType), UA_Argument_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->valueRank), UA_Argument_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->arrayDimensionsSize),UA_Argument_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions), UA_Argument_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_Argument_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Argument)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Argument)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Argument)
UA_Int32 UA_Argument_delete(UA_Argument *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Argument_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_Argument_deleteMembers(UA_Argument *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->name);
	retval |= UA_NodeId_deleteMembers(&p->dataType);
	retval |= UA_Array_delete((void**)&p->arrayDimensions,p->arrayDimensionsSize,UA_UINT32);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_Argument_init(UA_Argument *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->name);
	retval |= UA_NodeId_init(&p->dataType);
	retval |= UA_Int32_init(&p->valueRank);
	p->arrayDimensionsSize = 0;
	p->arrayDimensions = UA_NULL;
	retval |= UA_LocalizedText_init(&p->description);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_Argument)
UA_Int32 UA_Argument_copy(const UA_Argument *src,UA_Argument *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_Argument));
	retval |= UA_String_copy(&src->name,&dst->name);
	retval |= UA_NodeId_copy(&src->dataType,&dst->dataType);
	dst->arrayDimensions = src->arrayDimensions;
	retval |= UA_Array_copy(&src->arrayDimensions, src->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_Int32 UA_EnumValueType_calcSizeBinary(UA_EnumValueType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EnumValueType);
    	return 0
	 + sizeof(UA_Int64) // value
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	;
}

UA_Int32 UA_EnumValueType_encodeBinary(UA_EnumValueType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int64_encodeBinary(&src->value,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	return retval;
}

UA_Int32 UA_EnumValueType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EnumValueType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EnumValueType_init(dst);
	CHECKED_DECODE(UA_Int64_decodeBinary(src,offset,&dst->value), UA_EnumValueType_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_EnumValueType_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_EnumValueType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EnumValueType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EnumValueType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EnumValueType)
UA_Int32 UA_EnumValueType_delete(UA_EnumValueType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EnumValueType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EnumValueType_deleteMembers(UA_EnumValueType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_EnumValueType_init(UA_EnumValueType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int64_init(&p->value);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EnumValueType)
UA_Int32 UA_EnumValueType_copy(const UA_EnumValueType *src,UA_EnumValueType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EnumValueType));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_TYPE_AS(UA_Duration, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_Duration, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Duration)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Duration)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Duration)

UA_TYPE_AS(UA_UtcTime, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_UtcTime, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UtcTime)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UtcTime)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UtcTime)

UA_TYPE_AS(UA_LocaleId, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_LocaleId, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_LocaleId)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_LocaleId)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_LocaleId)

UA_Int32 UA_TimeZoneDataType_calcSizeBinary(UA_TimeZoneDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TimeZoneDataType);
    	return 0
	 + sizeof(UA_Int16) // offset
	 + sizeof(UA_Boolean) // daylightSavingInOffset
	;
}

UA_Int32 UA_TimeZoneDataType_encodeBinary(UA_TimeZoneDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int16_encodeBinary(&src->offset,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->daylightSavingInOffset,dst,offset);
	return retval;
}

UA_Int32 UA_TimeZoneDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TimeZoneDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TimeZoneDataType_init(dst);
	CHECKED_DECODE(UA_Int16_decodeBinary(src,offset,&dst->offset), UA_TimeZoneDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->daylightSavingInOffset), UA_TimeZoneDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TimeZoneDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TimeZoneDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TimeZoneDataType)
UA_Int32 UA_TimeZoneDataType_delete(UA_TimeZoneDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TimeZoneDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TimeZoneDataType_deleteMembers(UA_TimeZoneDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_TimeZoneDataType_init(UA_TimeZoneDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int16_init(&p->offset);
	retval |= UA_Boolean_init(&p->daylightSavingInOffset);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TimeZoneDataType)
UA_Int32 UA_TimeZoneDataType_copy(const UA_TimeZoneDataType *src,UA_TimeZoneDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TimeZoneDataType));
	return retval;
}

UA_TYPE_AS(UA_IntegerId, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_IntegerId, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_IntegerId)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_IntegerId)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_IntegerId)

UA_TYPE_AS(UA_ApplicationType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_ApplicationType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ApplicationType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ApplicationType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ApplicationType
)
UA_Int32 UA_ApplicationDescription_calcSizeBinary(UA_ApplicationDescription const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ApplicationDescription);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->applicationUri)
	 + UA_String_calcSizeBinary(&ptr->productUri)
	 + UA_LocalizedText_calcSizeBinary(&ptr->applicationName)
	 + sizeof(UA_ApplicationType) // applicationType
	 + UA_String_calcSizeBinary(&ptr->gatewayServerUri)
	 + UA_String_calcSizeBinary(&ptr->discoveryProfileUri)
	 + UA_Array_calcSizeBinary(ptr->discoveryUrlsSize,UA_STRING,ptr->discoveryUrls)
	;
}

UA_Int32 UA_ApplicationDescription_encodeBinary(UA_ApplicationDescription const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->applicationUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->productUri,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->applicationName,dst,offset);
	retval |= UA_ApplicationType_encodeBinary(&src->applicationType,dst,offset);
	retval |= UA_String_encodeBinary(&src->gatewayServerUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->discoveryProfileUri,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->discoveryUrlsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->discoveryUrls,src->discoveryUrlsSize,UA_STRING,dst,offset);
	return retval;
}

UA_Int32 UA_ApplicationDescription_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ApplicationDescription * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ApplicationDescription_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->applicationUri), UA_ApplicationDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->productUri), UA_ApplicationDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->applicationName), UA_ApplicationDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_ApplicationType_decodeBinary(src,offset,&dst->applicationType), UA_ApplicationDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->gatewayServerUri), UA_ApplicationDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->discoveryProfileUri), UA_ApplicationDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->discoveryUrlsSize),UA_ApplicationDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->discoveryUrlsSize,UA_STRING,(void**)&dst->discoveryUrls), UA_ApplicationDescription_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ApplicationDescription)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ApplicationDescription)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ApplicationDescription)
UA_Int32 UA_ApplicationDescription_delete(UA_ApplicationDescription *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ApplicationDescription_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ApplicationDescription_deleteMembers(UA_ApplicationDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->applicationUri);
	retval |= UA_String_deleteMembers(&p->productUri);
	retval |= UA_LocalizedText_deleteMembers(&p->applicationName);
	retval |= UA_String_deleteMembers(&p->gatewayServerUri);
	retval |= UA_String_deleteMembers(&p->discoveryProfileUri);
	retval |= UA_Array_delete((void**)&p->discoveryUrls,p->discoveryUrlsSize,UA_STRING);
	return retval;
}

UA_Int32 UA_ApplicationDescription_init(UA_ApplicationDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->applicationUri);
	retval |= UA_String_init(&p->productUri);
	retval |= UA_LocalizedText_init(&p->applicationName);
	retval |= UA_ApplicationType_init(&p->applicationType);
	retval |= UA_String_init(&p->gatewayServerUri);
	retval |= UA_String_init(&p->discoveryProfileUri);
	p->discoveryUrlsSize = 0;
	p->discoveryUrls = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ApplicationDescription)
UA_Int32 UA_ApplicationDescription_copy(const UA_ApplicationDescription *src,UA_ApplicationDescription *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ApplicationDescription));
	retval |= UA_String_copy(&src->applicationUri,&dst->applicationUri);
	retval |= UA_String_copy(&src->productUri,&dst->productUri);
	retval |= UA_LocalizedText_copy(&src->applicationName,&dst->applicationName);
	retval |= UA_String_copy(&src->gatewayServerUri,&dst->gatewayServerUri);
	retval |= UA_String_copy(&src->discoveryProfileUri,&dst->discoveryProfileUri);
	dst->discoveryUrls = src->discoveryUrls;
	retval |= UA_Array_copy(&src->discoveryUrls, src->discoveryUrlsSize,UA_STRING,(void**)&dst->discoveryUrls);
	return retval;
}

UA_Int32 UA_RequestHeader_calcSizeBinary(UA_RequestHeader const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RequestHeader);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->authenticationToken)
	 + sizeof(UA_DateTime) // timestamp
	 + sizeof(UA_UInt32) // requestHandle
	 + sizeof(UA_UInt32) // returnDiagnostics
	 + UA_String_calcSizeBinary(&ptr->auditEntryId)
	 + sizeof(UA_UInt32) // timeoutHint
	 + UA_ExtensionObject_calcSizeBinary(&ptr->additionalHeader)
	;
}

UA_Int32 UA_RequestHeader_encodeBinary(UA_RequestHeader const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->authenticationToken,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->timestamp,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestHandle,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->returnDiagnostics,dst,offset);
	retval |= UA_String_encodeBinary(&src->auditEntryId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->timeoutHint,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->additionalHeader,dst,offset);
	return retval;
}

UA_Int32 UA_RequestHeader_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RequestHeader * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RequestHeader_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->authenticationToken), UA_RequestHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->timestamp), UA_RequestHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestHandle), UA_RequestHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->returnDiagnostics), UA_RequestHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->auditEntryId), UA_RequestHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->timeoutHint), UA_RequestHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->additionalHeader), UA_RequestHeader_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RequestHeader)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RequestHeader)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RequestHeader)
UA_Int32 UA_RequestHeader_delete(UA_RequestHeader *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RequestHeader_deleteMembers(UA_RequestHeader *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->authenticationToken);
	retval |= UA_String_deleteMembers(&p->auditEntryId);
	retval |= UA_ExtensionObject_deleteMembers(&p->additionalHeader);
	return retval;
}

UA_Int32 UA_RequestHeader_init(UA_RequestHeader *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->authenticationToken);
	retval |= UA_DateTime_init(&p->timestamp);
	retval |= UA_UInt32_init(&p->requestHandle);
	retval |= UA_UInt32_init(&p->returnDiagnostics);
	retval |= UA_String_init(&p->auditEntryId);
	retval |= UA_UInt32_init(&p->timeoutHint);
	retval |= UA_ExtensionObject_init(&p->additionalHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RequestHeader)
UA_Int32 UA_RequestHeader_copy(const UA_RequestHeader *src,UA_RequestHeader *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RequestHeader));
	retval |= UA_NodeId_copy(&src->authenticationToken,&dst->authenticationToken);
	retval |= UA_String_copy(&src->auditEntryId,&dst->auditEntryId);
	retval |= UA_ExtensionObject_copy(&src->additionalHeader,&dst->additionalHeader);
	return retval;
}

UA_Int32 UA_ResponseHeader_calcSizeBinary(UA_ResponseHeader const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ResponseHeader);
    	return 0
	 + sizeof(UA_DateTime) // timestamp
	 + sizeof(UA_UInt32) // requestHandle
	 + sizeof(UA_StatusCode) // serviceResult
	 + UA_DiagnosticInfo_calcSizeBinary(&ptr->serviceDiagnostics)
	 + UA_Array_calcSizeBinary(ptr->stringTableSize,UA_STRING,ptr->stringTable)
	 + UA_ExtensionObject_calcSizeBinary(&ptr->additionalHeader)
	;
}

UA_Int32 UA_ResponseHeader_encodeBinary(UA_ResponseHeader const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_encodeBinary(&src->timestamp,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestHandle,dst,offset);
	retval |= UA_StatusCode_encodeBinary(&src->serviceResult,dst,offset);
	retval |= UA_DiagnosticInfo_encodeBinary(&src->serviceDiagnostics,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->stringTableSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->stringTable,src->stringTableSize,UA_STRING,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->additionalHeader,dst,offset);
	return retval;
}

UA_Int32 UA_ResponseHeader_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ResponseHeader * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ResponseHeader_init(dst);
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->timestamp), UA_ResponseHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestHandle), UA_ResponseHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->serviceResult), UA_ResponseHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_DiagnosticInfo_decodeBinary(src,offset,&dst->serviceDiagnostics), UA_ResponseHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->stringTableSize),UA_ResponseHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->stringTableSize,UA_STRING,(void**)&dst->stringTable), UA_ResponseHeader_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->additionalHeader), UA_ResponseHeader_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ResponseHeader)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ResponseHeader)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ResponseHeader)
UA_Int32 UA_ResponseHeader_delete(UA_ResponseHeader *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ResponseHeader_deleteMembers(UA_ResponseHeader *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DiagnosticInfo_deleteMembers(&p->serviceDiagnostics);
	retval |= UA_Array_delete((void**)&p->stringTable,p->stringTableSize,UA_STRING);
	retval |= UA_ExtensionObject_deleteMembers(&p->additionalHeader);
	return retval;
}

UA_Int32 UA_ResponseHeader_init(UA_ResponseHeader *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_init(&p->timestamp);
	retval |= UA_UInt32_init(&p->requestHandle);
	retval |= UA_StatusCode_init(&p->serviceResult);
	retval |= UA_DiagnosticInfo_init(&p->serviceDiagnostics);
	p->stringTableSize = 0;
	p->stringTable = UA_NULL;
	retval |= UA_ExtensionObject_init(&p->additionalHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ResponseHeader)
UA_Int32 UA_ResponseHeader_copy(const UA_ResponseHeader *src,UA_ResponseHeader *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ResponseHeader));
	retval |= UA_DiagnosticInfo_copy(&src->serviceDiagnostics,&dst->serviceDiagnostics);
	dst->stringTable = src->stringTable;
	retval |= UA_Array_copy(&src->stringTable, src->stringTableSize,UA_STRING,(void**)&dst->stringTable);
	retval |= UA_ExtensionObject_copy(&src->additionalHeader,&dst->additionalHeader);
	return retval;
}

UA_Int32 UA_ServiceFault_calcSizeBinary(UA_ServiceFault const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ServiceFault);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	;
}

UA_Int32 UA_ServiceFault_encodeBinary(UA_ServiceFault const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	return retval;
}

UA_Int32 UA_ServiceFault_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ServiceFault * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ServiceFault_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_ServiceFault_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ServiceFault)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ServiceFault)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ServiceFault)
UA_Int32 UA_ServiceFault_delete(UA_ServiceFault *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ServiceFault_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ServiceFault_deleteMembers(UA_ServiceFault *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_ServiceFault_init(UA_ServiceFault *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ServiceFault)
UA_Int32 UA_ServiceFault_copy(const UA_ServiceFault *src,UA_ServiceFault *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ServiceFault));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_Int32 UA_FindServersRequest_calcSizeBinary(UA_FindServersRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_FindServersRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_String_calcSizeBinary(&ptr->endpointUrl)
	 + UA_Array_calcSizeBinary(ptr->localeIdsSize,UA_STRING,ptr->localeIds)
	 + UA_Array_calcSizeBinary(ptr->serverUrisSize,UA_STRING,ptr->serverUris)
	;
}

UA_Int32 UA_FindServersRequest_encodeBinary(UA_FindServersRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_String_encodeBinary(&src->endpointUrl,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->localeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->localeIds,src->localeIdsSize,UA_STRING,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->serverUrisSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->serverUris,src->serverUrisSize,UA_STRING,dst,offset);
	return retval;
}

UA_Int32 UA_FindServersRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_FindServersRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_FindServersRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_FindServersRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->endpointUrl), UA_FindServersRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->localeIdsSize),UA_FindServersRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->localeIdsSize,UA_STRING,(void**)&dst->localeIds), UA_FindServersRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->serverUrisSize),UA_FindServersRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->serverUrisSize,UA_STRING,(void**)&dst->serverUris), UA_FindServersRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_FindServersRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_FindServersRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_FindServersRequest)
UA_Int32 UA_FindServersRequest_delete(UA_FindServersRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_FindServersRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_FindServersRequest_deleteMembers(UA_FindServersRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_String_deleteMembers(&p->endpointUrl);
	retval |= UA_Array_delete((void**)&p->localeIds,p->localeIdsSize,UA_STRING);
	retval |= UA_Array_delete((void**)&p->serverUris,p->serverUrisSize,UA_STRING);
	return retval;
}

UA_Int32 UA_FindServersRequest_init(UA_FindServersRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_String_init(&p->endpointUrl);
	p->localeIdsSize = 0;
	p->localeIds = UA_NULL;
	p->serverUrisSize = 0;
	p->serverUris = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_FindServersRequest)
UA_Int32 UA_FindServersRequest_copy(const UA_FindServersRequest *src,UA_FindServersRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_FindServersRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_String_copy(&src->endpointUrl,&dst->endpointUrl);
	dst->localeIds = src->localeIds;
	retval |= UA_Array_copy(&src->localeIds, src->localeIdsSize,UA_STRING,(void**)&dst->localeIds);
	dst->serverUris = src->serverUris;
	retval |= UA_Array_copy(&src->serverUris, src->serverUrisSize,UA_STRING,(void**)&dst->serverUris);
	return retval;
}

UA_Int32 UA_FindServersResponse_calcSizeBinary(UA_FindServersResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_FindServersResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->serversSize,UA_APPLICATIONDESCRIPTION,ptr->servers)
	;
}

UA_Int32 UA_FindServersResponse_encodeBinary(UA_FindServersResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->serversSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->servers,src->serversSize,UA_APPLICATIONDESCRIPTION,dst,offset);
	return retval;
}

UA_Int32 UA_FindServersResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_FindServersResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_FindServersResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_FindServersResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->serversSize),UA_FindServersResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->serversSize,UA_APPLICATIONDESCRIPTION,(void**)&dst->servers), UA_FindServersResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_FindServersResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_FindServersResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_FindServersResponse)
UA_Int32 UA_FindServersResponse_delete(UA_FindServersResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_FindServersResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_FindServersResponse_deleteMembers(UA_FindServersResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->servers,p->serversSize,UA_APPLICATIONDESCRIPTION);
	return retval;
}

UA_Int32 UA_FindServersResponse_init(UA_FindServersResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->serversSize = 0;
	p->servers = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_FindServersResponse)
UA_Int32 UA_FindServersResponse_copy(const UA_FindServersResponse *src,UA_FindServersResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_FindServersResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->servers = src->servers;
	retval |= UA_Array_copy(&src->servers, src->serversSize,UA_APPLICATIONDESCRIPTION,(void**)&dst->servers);
	return retval;
}

UA_TYPE_AS(UA_ApplicationInstanceCertificate, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_ApplicationInstanceCertificate, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ApplicationInstanceCertificate)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ApplicationInstanceCertificate)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ApplicationInstanceCertificate)

UA_TYPE_AS(UA_MessageSecurityMode, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_MessageSecurityMode, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MessageSecurityMode)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MessageSecurityMode)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MessageSecurityMode
)
UA_TYPE_AS(UA_UserTokenType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_UserTokenType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UserTokenType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UserTokenType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UserTokenType
)
UA_Int32 UA_UserTokenPolicy_calcSizeBinary(UA_UserTokenPolicy const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UserTokenPolicy);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->policyId)
	 + sizeof(UA_UserTokenType) // tokenType
	 + UA_String_calcSizeBinary(&ptr->issuedTokenType)
	 + UA_String_calcSizeBinary(&ptr->issuerEndpointUrl)
	 + UA_String_calcSizeBinary(&ptr->securityPolicyUri)
	;
}

UA_Int32 UA_UserTokenPolicy_encodeBinary(UA_UserTokenPolicy const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->policyId,dst,offset);
	retval |= UA_UserTokenType_encodeBinary(&src->tokenType,dst,offset);
	retval |= UA_String_encodeBinary(&src->issuedTokenType,dst,offset);
	retval |= UA_String_encodeBinary(&src->issuerEndpointUrl,dst,offset);
	retval |= UA_String_encodeBinary(&src->securityPolicyUri,dst,offset);
	return retval;
}

UA_Int32 UA_UserTokenPolicy_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UserTokenPolicy * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UserTokenPolicy_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->policyId), UA_UserTokenPolicy_deleteMembers(dst));
	CHECKED_DECODE(UA_UserTokenType_decodeBinary(src,offset,&dst->tokenType), UA_UserTokenPolicy_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->issuedTokenType), UA_UserTokenPolicy_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->issuerEndpointUrl), UA_UserTokenPolicy_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->securityPolicyUri), UA_UserTokenPolicy_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UserTokenPolicy)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UserTokenPolicy)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UserTokenPolicy)
UA_Int32 UA_UserTokenPolicy_delete(UA_UserTokenPolicy *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UserTokenPolicy_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UserTokenPolicy_deleteMembers(UA_UserTokenPolicy *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->policyId);
	retval |= UA_String_deleteMembers(&p->issuedTokenType);
	retval |= UA_String_deleteMembers(&p->issuerEndpointUrl);
	retval |= UA_String_deleteMembers(&p->securityPolicyUri);
	return retval;
}

UA_Int32 UA_UserTokenPolicy_init(UA_UserTokenPolicy *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->policyId);
	retval |= UA_UserTokenType_init(&p->tokenType);
	retval |= UA_String_init(&p->issuedTokenType);
	retval |= UA_String_init(&p->issuerEndpointUrl);
	retval |= UA_String_init(&p->securityPolicyUri);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UserTokenPolicy)
UA_Int32 UA_UserTokenPolicy_copy(const UA_UserTokenPolicy *src,UA_UserTokenPolicy *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UserTokenPolicy));
	retval |= UA_String_copy(&src->policyId,&dst->policyId);
	retval |= UA_String_copy(&src->issuedTokenType,&dst->issuedTokenType);
	retval |= UA_String_copy(&src->issuerEndpointUrl,&dst->issuerEndpointUrl);
	retval |= UA_String_copy(&src->securityPolicyUri,&dst->securityPolicyUri);
	return retval;
}

UA_Int32 UA_EndpointDescription_calcSizeBinary(UA_EndpointDescription const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EndpointDescription);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->endpointUrl)
	 + UA_ApplicationDescription_calcSizeBinary(&ptr->server)
	 + UA_ByteString_calcSizeBinary(&ptr->serverCertificate)
	 + sizeof(UA_MessageSecurityMode) // securityMode
	 + UA_String_calcSizeBinary(&ptr->securityPolicyUri)
	 + UA_Array_calcSizeBinary(ptr->userIdentityTokensSize,UA_USERTOKENPOLICY,ptr->userIdentityTokens)
	 + UA_String_calcSizeBinary(&ptr->transportProfileUri)
	 + sizeof(UA_Byte) // securityLevel
	;
}

UA_Int32 UA_EndpointDescription_encodeBinary(UA_EndpointDescription const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->endpointUrl,dst,offset);
	retval |= UA_ApplicationDescription_encodeBinary(&src->server,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->serverCertificate,dst,offset);
	retval |= UA_MessageSecurityMode_encodeBinary(&src->securityMode,dst,offset);
	retval |= UA_String_encodeBinary(&src->securityPolicyUri,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->userIdentityTokensSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->userIdentityTokens,src->userIdentityTokensSize,UA_USERTOKENPOLICY,dst,offset);
	retval |= UA_String_encodeBinary(&src->transportProfileUri,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->securityLevel,dst,offset);
	return retval;
}

UA_Int32 UA_EndpointDescription_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EndpointDescription * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EndpointDescription_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->endpointUrl), UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_ApplicationDescription_decodeBinary(src,offset,&dst->server), UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->serverCertificate), UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_MessageSecurityMode_decodeBinary(src,offset,&dst->securityMode), UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->securityPolicyUri), UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->userIdentityTokensSize),UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->userIdentityTokensSize,UA_USERTOKENPOLICY,(void**)&dst->userIdentityTokens), UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->transportProfileUri), UA_EndpointDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->securityLevel), UA_EndpointDescription_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EndpointDescription)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EndpointDescription)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EndpointDescription)
UA_Int32 UA_EndpointDescription_delete(UA_EndpointDescription *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EndpointDescription_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EndpointDescription_deleteMembers(UA_EndpointDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->endpointUrl);
	retval |= UA_ApplicationDescription_deleteMembers(&p->server);
	retval |= UA_ByteString_deleteMembers(&p->serverCertificate);
	retval |= UA_String_deleteMembers(&p->securityPolicyUri);
	retval |= UA_Array_delete((void**)&p->userIdentityTokens,p->userIdentityTokensSize,UA_USERTOKENPOLICY);
	retval |= UA_String_deleteMembers(&p->transportProfileUri);
	return retval;
}

UA_Int32 UA_EndpointDescription_init(UA_EndpointDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->endpointUrl);
	retval |= UA_ApplicationDescription_init(&p->server);
	retval |= UA_ByteString_init(&p->serverCertificate);
	retval |= UA_MessageSecurityMode_init(&p->securityMode);
	retval |= UA_String_init(&p->securityPolicyUri);
	p->userIdentityTokensSize = 0;
	p->userIdentityTokens = UA_NULL;
	retval |= UA_String_init(&p->transportProfileUri);
	retval |= UA_Byte_init(&p->securityLevel);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EndpointDescription)
UA_Int32 UA_EndpointDescription_copy(const UA_EndpointDescription *src,UA_EndpointDescription *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EndpointDescription));
	retval |= UA_String_copy(&src->endpointUrl,&dst->endpointUrl);
	retval |= UA_ApplicationDescription_copy(&src->server,&dst->server);
	retval |= UA_ByteString_copy(&src->serverCertificate,&dst->serverCertificate);
	retval |= UA_String_copy(&src->securityPolicyUri,&dst->securityPolicyUri);
	dst->userIdentityTokens = src->userIdentityTokens;
	retval |= UA_Array_copy(&src->userIdentityTokens, src->userIdentityTokensSize,UA_USERTOKENPOLICY,(void**)&dst->userIdentityTokens);
	retval |= UA_String_copy(&src->transportProfileUri,&dst->transportProfileUri);
	return retval;
}

UA_Int32 UA_GetEndpointsRequest_calcSizeBinary(UA_GetEndpointsRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_GetEndpointsRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_String_calcSizeBinary(&ptr->endpointUrl)
	 + UA_Array_calcSizeBinary(ptr->localeIdsSize,UA_STRING,ptr->localeIds)
	 + UA_Array_calcSizeBinary(ptr->profileUrisSize,UA_STRING,ptr->profileUris)
	;
}

UA_Int32 UA_GetEndpointsRequest_encodeBinary(UA_GetEndpointsRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_String_encodeBinary(&src->endpointUrl,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->localeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->localeIds,src->localeIdsSize,UA_STRING,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->profileUrisSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->profileUris,src->profileUrisSize,UA_STRING,dst,offset);
	return retval;
}

UA_Int32 UA_GetEndpointsRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_GetEndpointsRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_GetEndpointsRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_GetEndpointsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->endpointUrl), UA_GetEndpointsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->localeIdsSize),UA_GetEndpointsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->localeIdsSize,UA_STRING,(void**)&dst->localeIds), UA_GetEndpointsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->profileUrisSize),UA_GetEndpointsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->profileUrisSize,UA_STRING,(void**)&dst->profileUris), UA_GetEndpointsRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_GetEndpointsRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_GetEndpointsRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_GetEndpointsRequest)
UA_Int32 UA_GetEndpointsRequest_delete(UA_GetEndpointsRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_GetEndpointsRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_GetEndpointsRequest_deleteMembers(UA_GetEndpointsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_String_deleteMembers(&p->endpointUrl);
	retval |= UA_Array_delete((void**)&p->localeIds,p->localeIdsSize,UA_STRING);
	retval |= UA_Array_delete((void**)&p->profileUris,p->profileUrisSize,UA_STRING);
	return retval;
}

UA_Int32 UA_GetEndpointsRequest_init(UA_GetEndpointsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_String_init(&p->endpointUrl);
	p->localeIdsSize = 0;
	p->localeIds = UA_NULL;
	p->profileUrisSize = 0;
	p->profileUris = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_GetEndpointsRequest)
UA_Int32 UA_GetEndpointsRequest_copy(const UA_GetEndpointsRequest *src,UA_GetEndpointsRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_GetEndpointsRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_String_copy(&src->endpointUrl,&dst->endpointUrl);
	dst->localeIds = src->localeIds;
	retval |= UA_Array_copy(&src->localeIds, src->localeIdsSize,UA_STRING,(void**)&dst->localeIds);
	dst->profileUris = src->profileUris;
	retval |= UA_Array_copy(&src->profileUris, src->profileUrisSize,UA_STRING,(void**)&dst->profileUris);
	return retval;
}

UA_Int32 UA_GetEndpointsResponse_calcSizeBinary(UA_GetEndpointsResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_GetEndpointsResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->endpointsSize,UA_ENDPOINTDESCRIPTION,ptr->endpoints)
	;
}

UA_Int32 UA_GetEndpointsResponse_encodeBinary(UA_GetEndpointsResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->endpointsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->endpoints,src->endpointsSize,UA_ENDPOINTDESCRIPTION,dst,offset);
	return retval;
}

UA_Int32 UA_GetEndpointsResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_GetEndpointsResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_GetEndpointsResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_GetEndpointsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->endpointsSize),UA_GetEndpointsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->endpointsSize,UA_ENDPOINTDESCRIPTION,(void**)&dst->endpoints), UA_GetEndpointsResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_GetEndpointsResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_GetEndpointsResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_GetEndpointsResponse)
UA_Int32 UA_GetEndpointsResponse_delete(UA_GetEndpointsResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_GetEndpointsResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_GetEndpointsResponse_deleteMembers(UA_GetEndpointsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->endpoints,p->endpointsSize,UA_ENDPOINTDESCRIPTION);
	return retval;
}

UA_Int32 UA_GetEndpointsResponse_init(UA_GetEndpointsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->endpointsSize = 0;
	p->endpoints = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_GetEndpointsResponse)
UA_Int32 UA_GetEndpointsResponse_copy(const UA_GetEndpointsResponse *src,UA_GetEndpointsResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_GetEndpointsResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->endpoints = src->endpoints;
	retval |= UA_Array_copy(&src->endpoints, src->endpointsSize,UA_ENDPOINTDESCRIPTION,(void**)&dst->endpoints);
	return retval;
}

UA_Int32 UA_RegisteredServer_calcSizeBinary(UA_RegisteredServer const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RegisteredServer);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->serverUri)
	 + UA_String_calcSizeBinary(&ptr->productUri)
	 + UA_Array_calcSizeBinary(ptr->serverNamesSize,UA_LOCALIZEDTEXT,ptr->serverNames)
	 + sizeof(UA_ApplicationType) // serverType
	 + UA_String_calcSizeBinary(&ptr->gatewayServerUri)
	 + UA_Array_calcSizeBinary(ptr->discoveryUrlsSize,UA_STRING,ptr->discoveryUrls)
	 + UA_String_calcSizeBinary(&ptr->semaphoreFilePath)
	 + sizeof(UA_Boolean) // isOnline
	;
}

UA_Int32 UA_RegisteredServer_encodeBinary(UA_RegisteredServer const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->serverUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->productUri,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->serverNamesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->serverNames,src->serverNamesSize,UA_LOCALIZEDTEXT,dst,offset);
	retval |= UA_ApplicationType_encodeBinary(&src->serverType,dst,offset);
	retval |= UA_String_encodeBinary(&src->gatewayServerUri,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->discoveryUrlsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->discoveryUrls,src->discoveryUrlsSize,UA_STRING,dst,offset);
	retval |= UA_String_encodeBinary(&src->semaphoreFilePath,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isOnline,dst,offset);
	return retval;
}

UA_Int32 UA_RegisteredServer_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RegisteredServer * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RegisteredServer_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->serverUri), UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->productUri), UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->serverNamesSize),UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->serverNamesSize,UA_LOCALIZEDTEXT,(void**)&dst->serverNames), UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_ApplicationType_decodeBinary(src,offset,&dst->serverType), UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->gatewayServerUri), UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->discoveryUrlsSize),UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->discoveryUrlsSize,UA_STRING,(void**)&dst->discoveryUrls), UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->semaphoreFilePath), UA_RegisteredServer_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isOnline), UA_RegisteredServer_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RegisteredServer)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RegisteredServer)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RegisteredServer)
UA_Int32 UA_RegisteredServer_delete(UA_RegisteredServer *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RegisteredServer_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RegisteredServer_deleteMembers(UA_RegisteredServer *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->serverUri);
	retval |= UA_String_deleteMembers(&p->productUri);
	retval |= UA_Array_delete((void**)&p->serverNames,p->serverNamesSize,UA_LOCALIZEDTEXT);
	retval |= UA_String_deleteMembers(&p->gatewayServerUri);
	retval |= UA_Array_delete((void**)&p->discoveryUrls,p->discoveryUrlsSize,UA_STRING);
	retval |= UA_String_deleteMembers(&p->semaphoreFilePath);
	return retval;
}

UA_Int32 UA_RegisteredServer_init(UA_RegisteredServer *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->serverUri);
	retval |= UA_String_init(&p->productUri);
	p->serverNamesSize = 0;
	p->serverNames = UA_NULL;
	retval |= UA_ApplicationType_init(&p->serverType);
	retval |= UA_String_init(&p->gatewayServerUri);
	p->discoveryUrlsSize = 0;
	p->discoveryUrls = UA_NULL;
	retval |= UA_String_init(&p->semaphoreFilePath);
	retval |= UA_Boolean_init(&p->isOnline);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RegisteredServer)
UA_Int32 UA_RegisteredServer_copy(const UA_RegisteredServer *src,UA_RegisteredServer *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RegisteredServer));
	retval |= UA_String_copy(&src->serverUri,&dst->serverUri);
	retval |= UA_String_copy(&src->productUri,&dst->productUri);
	dst->serverNames = src->serverNames;
	retval |= UA_Array_copy(&src->serverNames, src->serverNamesSize,UA_LOCALIZEDTEXT,(void**)&dst->serverNames);
	retval |= UA_String_copy(&src->gatewayServerUri,&dst->gatewayServerUri);
	dst->discoveryUrls = src->discoveryUrls;
	retval |= UA_Array_copy(&src->discoveryUrls, src->discoveryUrlsSize,UA_STRING,(void**)&dst->discoveryUrls);
	retval |= UA_String_copy(&src->semaphoreFilePath,&dst->semaphoreFilePath);
	return retval;
}

UA_Int32 UA_RegisterServerRequest_calcSizeBinary(UA_RegisterServerRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RegisterServerRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_RegisteredServer_calcSizeBinary(&ptr->server)
	;
}

UA_Int32 UA_RegisterServerRequest_encodeBinary(UA_RegisterServerRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_RegisteredServer_encodeBinary(&src->server,dst,offset);
	return retval;
}

UA_Int32 UA_RegisterServerRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RegisterServerRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RegisterServerRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_RegisterServerRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_RegisteredServer_decodeBinary(src,offset,&dst->server), UA_RegisterServerRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RegisterServerRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RegisterServerRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RegisterServerRequest)
UA_Int32 UA_RegisterServerRequest_delete(UA_RegisterServerRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RegisterServerRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RegisterServerRequest_deleteMembers(UA_RegisterServerRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_RegisteredServer_deleteMembers(&p->server);
	return retval;
}

UA_Int32 UA_RegisterServerRequest_init(UA_RegisterServerRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_RegisteredServer_init(&p->server);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RegisterServerRequest)
UA_Int32 UA_RegisterServerRequest_copy(const UA_RegisterServerRequest *src,UA_RegisterServerRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RegisterServerRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_RegisteredServer_copy(&src->server,&dst->server);
	return retval;
}

UA_Int32 UA_RegisterServerResponse_calcSizeBinary(UA_RegisterServerResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RegisterServerResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	;
}

UA_Int32 UA_RegisterServerResponse_encodeBinary(UA_RegisterServerResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	return retval;
}

UA_Int32 UA_RegisterServerResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RegisterServerResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RegisterServerResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_RegisterServerResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RegisterServerResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RegisterServerResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RegisterServerResponse)
UA_Int32 UA_RegisterServerResponse_delete(UA_RegisterServerResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RegisterServerResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RegisterServerResponse_deleteMembers(UA_RegisterServerResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_RegisterServerResponse_init(UA_RegisterServerResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RegisterServerResponse)
UA_Int32 UA_RegisterServerResponse_copy(const UA_RegisterServerResponse *src,UA_RegisterServerResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RegisterServerResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_TYPE_AS(UA_SecurityTokenRequestType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_SecurityTokenRequestType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SecurityTokenRequestType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SecurityTokenRequestType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SecurityTokenRequestType
)
UA_Int32 UA_ChannelSecurityToken_calcSizeBinary(UA_ChannelSecurityToken const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ChannelSecurityToken);
    	return 0
	 + sizeof(UA_UInt32) // channelId
	 + sizeof(UA_UInt32) // tokenId
	 + sizeof(UA_DateTime) // createdAt
	 + sizeof(UA_UInt32) // revisedLifetime
	;
}

UA_Int32 UA_ChannelSecurityToken_encodeBinary(UA_ChannelSecurityToken const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->channelId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->tokenId,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->createdAt,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->revisedLifetime,dst,offset);
	return retval;
}

UA_Int32 UA_ChannelSecurityToken_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ChannelSecurityToken * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ChannelSecurityToken_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->channelId), UA_ChannelSecurityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->tokenId), UA_ChannelSecurityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->createdAt), UA_ChannelSecurityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->revisedLifetime), UA_ChannelSecurityToken_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ChannelSecurityToken)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ChannelSecurityToken)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ChannelSecurityToken)
UA_Int32 UA_ChannelSecurityToken_delete(UA_ChannelSecurityToken *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ChannelSecurityToken_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ChannelSecurityToken_deleteMembers(UA_ChannelSecurityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_ChannelSecurityToken_init(UA_ChannelSecurityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->channelId);
	retval |= UA_UInt32_init(&p->tokenId);
	retval |= UA_DateTime_init(&p->createdAt);
	retval |= UA_UInt32_init(&p->revisedLifetime);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ChannelSecurityToken)
UA_Int32 UA_ChannelSecurityToken_copy(const UA_ChannelSecurityToken *src,UA_ChannelSecurityToken *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ChannelSecurityToken));
	return retval;
}

UA_Int32 UA_OpenSecureChannelRequest_calcSizeBinary(UA_OpenSecureChannelRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_OpenSecureChannelRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // clientProtocolVersion
	 + sizeof(UA_SecurityTokenRequestType) // requestType
	 + sizeof(UA_MessageSecurityMode) // securityMode
	 + UA_ByteString_calcSizeBinary(&ptr->clientNonce)
	 + sizeof(UA_UInt32) // requestedLifetime
	;
}

UA_Int32 UA_OpenSecureChannelRequest_encodeBinary(UA_OpenSecureChannelRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->clientProtocolVersion,dst,offset);
	retval |= UA_SecurityTokenRequestType_encodeBinary(&src->requestType,dst,offset);
	retval |= UA_MessageSecurityMode_encodeBinary(&src->securityMode,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->clientNonce,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestedLifetime,dst,offset);
	return retval;
}

UA_Int32 UA_OpenSecureChannelRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_OpenSecureChannelRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_OpenSecureChannelRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_OpenSecureChannelRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->clientProtocolVersion), UA_OpenSecureChannelRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_SecurityTokenRequestType_decodeBinary(src,offset,&dst->requestType), UA_OpenSecureChannelRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_MessageSecurityMode_decodeBinary(src,offset,&dst->securityMode), UA_OpenSecureChannelRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->clientNonce), UA_OpenSecureChannelRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestedLifetime), UA_OpenSecureChannelRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_OpenSecureChannelRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_OpenSecureChannelRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_OpenSecureChannelRequest)
UA_Int32 UA_OpenSecureChannelRequest_delete(UA_OpenSecureChannelRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_OpenSecureChannelRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_OpenSecureChannelRequest_deleteMembers(UA_OpenSecureChannelRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_ByteString_deleteMembers(&p->clientNonce);
	return retval;
}

UA_Int32 UA_OpenSecureChannelRequest_init(UA_OpenSecureChannelRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->clientProtocolVersion);
	retval |= UA_SecurityTokenRequestType_init(&p->requestType);
	retval |= UA_MessageSecurityMode_init(&p->securityMode);
	retval |= UA_ByteString_init(&p->clientNonce);
	retval |= UA_UInt32_init(&p->requestedLifetime);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_OpenSecureChannelRequest)
UA_Int32 UA_OpenSecureChannelRequest_copy(const UA_OpenSecureChannelRequest *src,UA_OpenSecureChannelRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_OpenSecureChannelRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_ByteString_copy(&src->clientNonce,&dst->clientNonce);
	return retval;
}

UA_Int32 UA_OpenSecureChannelResponse_calcSizeBinary(UA_OpenSecureChannelResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_OpenSecureChannelResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + sizeof(UA_UInt32) // serverProtocolVersion
	 + sizeof(UA_ChannelSecurityToken) // securityToken
	 + UA_ByteString_calcSizeBinary(&ptr->serverNonce)
	;
}

UA_Int32 UA_OpenSecureChannelResponse_encodeBinary(UA_OpenSecureChannelResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->serverProtocolVersion,dst,offset);
	retval |= UA_ChannelSecurityToken_encodeBinary(&src->securityToken,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->serverNonce,dst,offset);
	return retval;
}

UA_Int32 UA_OpenSecureChannelResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_OpenSecureChannelResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_OpenSecureChannelResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_OpenSecureChannelResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->serverProtocolVersion), UA_OpenSecureChannelResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ChannelSecurityToken_decodeBinary(src,offset,&dst->securityToken), UA_OpenSecureChannelResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->serverNonce), UA_OpenSecureChannelResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_OpenSecureChannelResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_OpenSecureChannelResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_OpenSecureChannelResponse)
UA_Int32 UA_OpenSecureChannelResponse_delete(UA_OpenSecureChannelResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_OpenSecureChannelResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_OpenSecureChannelResponse_deleteMembers(UA_OpenSecureChannelResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_ByteString_deleteMembers(&p->serverNonce);
	return retval;
}

UA_Int32 UA_OpenSecureChannelResponse_init(UA_OpenSecureChannelResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_UInt32_init(&p->serverProtocolVersion);
	retval |= UA_ChannelSecurityToken_init(&p->securityToken);
	retval |= UA_ByteString_init(&p->serverNonce);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_OpenSecureChannelResponse)
UA_Int32 UA_OpenSecureChannelResponse_copy(const UA_OpenSecureChannelResponse *src,UA_OpenSecureChannelResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_OpenSecureChannelResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	retval |= UA_ByteString_copy(&src->serverNonce,&dst->serverNonce);
	return retval;
}

UA_Int32 UA_CloseSecureChannelRequest_calcSizeBinary(UA_CloseSecureChannelRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CloseSecureChannelRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	;
}

UA_Int32 UA_CloseSecureChannelRequest_encodeBinary(UA_CloseSecureChannelRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	return retval;
}

UA_Int32 UA_CloseSecureChannelRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CloseSecureChannelRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CloseSecureChannelRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_CloseSecureChannelRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CloseSecureChannelRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CloseSecureChannelRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CloseSecureChannelRequest)
UA_Int32 UA_CloseSecureChannelRequest_delete(UA_CloseSecureChannelRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CloseSecureChannelRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CloseSecureChannelRequest_deleteMembers(UA_CloseSecureChannelRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	return retval;
}

UA_Int32 UA_CloseSecureChannelRequest_init(UA_CloseSecureChannelRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CloseSecureChannelRequest)
UA_Int32 UA_CloseSecureChannelRequest_copy(const UA_CloseSecureChannelRequest *src,UA_CloseSecureChannelRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CloseSecureChannelRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	return retval;
}

UA_Int32 UA_CloseSecureChannelResponse_calcSizeBinary(UA_CloseSecureChannelResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CloseSecureChannelResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	;
}

UA_Int32 UA_CloseSecureChannelResponse_encodeBinary(UA_CloseSecureChannelResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	return retval;
}

UA_Int32 UA_CloseSecureChannelResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CloseSecureChannelResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CloseSecureChannelResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_CloseSecureChannelResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CloseSecureChannelResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CloseSecureChannelResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CloseSecureChannelResponse)
UA_Int32 UA_CloseSecureChannelResponse_delete(UA_CloseSecureChannelResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CloseSecureChannelResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CloseSecureChannelResponse_deleteMembers(UA_CloseSecureChannelResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_CloseSecureChannelResponse_init(UA_CloseSecureChannelResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CloseSecureChannelResponse)
UA_Int32 UA_CloseSecureChannelResponse_copy(const UA_CloseSecureChannelResponse *src,UA_CloseSecureChannelResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CloseSecureChannelResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_Int32 UA_SignedSoftwareCertificate_calcSizeBinary(UA_SignedSoftwareCertificate const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SignedSoftwareCertificate);
    	return 0
	 + UA_ByteString_calcSizeBinary(&ptr->certificateData)
	 + UA_ByteString_calcSizeBinary(&ptr->signature)
	;
}

UA_Int32 UA_SignedSoftwareCertificate_encodeBinary(UA_SignedSoftwareCertificate const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ByteString_encodeBinary(&src->certificateData,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->signature,dst,offset);
	return retval;
}

UA_Int32 UA_SignedSoftwareCertificate_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SignedSoftwareCertificate * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SignedSoftwareCertificate_init(dst);
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->certificateData), UA_SignedSoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->signature), UA_SignedSoftwareCertificate_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SignedSoftwareCertificate)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SignedSoftwareCertificate)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SignedSoftwareCertificate)
UA_Int32 UA_SignedSoftwareCertificate_delete(UA_SignedSoftwareCertificate *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SignedSoftwareCertificate_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SignedSoftwareCertificate_deleteMembers(UA_SignedSoftwareCertificate *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ByteString_deleteMembers(&p->certificateData);
	retval |= UA_ByteString_deleteMembers(&p->signature);
	return retval;
}

UA_Int32 UA_SignedSoftwareCertificate_init(UA_SignedSoftwareCertificate *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ByteString_init(&p->certificateData);
	retval |= UA_ByteString_init(&p->signature);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SignedSoftwareCertificate)
UA_Int32 UA_SignedSoftwareCertificate_copy(const UA_SignedSoftwareCertificate *src,UA_SignedSoftwareCertificate *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SignedSoftwareCertificate));
	retval |= UA_ByteString_copy(&src->certificateData,&dst->certificateData);
	retval |= UA_ByteString_copy(&src->signature,&dst->signature);
	return retval;
}

UA_TYPE_AS(UA_SessionAuthenticationToken, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_SessionAuthenticationToken, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SessionAuthenticationToken)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SessionAuthenticationToken)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SessionAuthenticationToken)

UA_Int32 UA_SignatureData_calcSizeBinary(UA_SignatureData const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SignatureData);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->algorithm)
	 + UA_ByteString_calcSizeBinary(&ptr->signature)
	;
}

UA_Int32 UA_SignatureData_encodeBinary(UA_SignatureData const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->algorithm,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->signature,dst,offset);
	return retval;
}

UA_Int32 UA_SignatureData_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SignatureData * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SignatureData_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->algorithm), UA_SignatureData_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->signature), UA_SignatureData_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SignatureData)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SignatureData)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SignatureData)
UA_Int32 UA_SignatureData_delete(UA_SignatureData *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SignatureData_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SignatureData_deleteMembers(UA_SignatureData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->algorithm);
	retval |= UA_ByteString_deleteMembers(&p->signature);
	return retval;
}

UA_Int32 UA_SignatureData_init(UA_SignatureData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->algorithm);
	retval |= UA_ByteString_init(&p->signature);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SignatureData)
UA_Int32 UA_SignatureData_copy(const UA_SignatureData *src,UA_SignatureData *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SignatureData));
	retval |= UA_String_copy(&src->algorithm,&dst->algorithm);
	retval |= UA_ByteString_copy(&src->signature,&dst->signature);
	return retval;
}

UA_Int32 UA_CreateSessionRequest_calcSizeBinary(UA_CreateSessionRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CreateSessionRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_ApplicationDescription_calcSizeBinary(&ptr->clientDescription)
	 + UA_String_calcSizeBinary(&ptr->serverUri)
	 + UA_String_calcSizeBinary(&ptr->endpointUrl)
	 + UA_String_calcSizeBinary(&ptr->sessionName)
	 + UA_ByteString_calcSizeBinary(&ptr->clientNonce)
	 + UA_ByteString_calcSizeBinary(&ptr->clientCertificate)
	 + sizeof(UA_Double) // requestedSessionTimeout
	 + sizeof(UA_UInt32) // maxResponseMessageSize
	;
}

UA_Int32 UA_CreateSessionRequest_encodeBinary(UA_CreateSessionRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_ApplicationDescription_encodeBinary(&src->clientDescription,dst,offset);
	retval |= UA_String_encodeBinary(&src->serverUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->endpointUrl,dst,offset);
	retval |= UA_String_encodeBinary(&src->sessionName,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->clientNonce,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->clientCertificate,dst,offset);
	retval |= UA_Double_encodeBinary(&src->requestedSessionTimeout,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxResponseMessageSize,dst,offset);
	return retval;
}

UA_Int32 UA_CreateSessionRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CreateSessionRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CreateSessionRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ApplicationDescription_decodeBinary(src,offset,&dst->clientDescription), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->serverUri), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->endpointUrl), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->sessionName), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->clientNonce), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->clientCertificate), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->requestedSessionTimeout), UA_CreateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxResponseMessageSize), UA_CreateSessionRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CreateSessionRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CreateSessionRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CreateSessionRequest)
UA_Int32 UA_CreateSessionRequest_delete(UA_CreateSessionRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CreateSessionRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CreateSessionRequest_deleteMembers(UA_CreateSessionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_ApplicationDescription_deleteMembers(&p->clientDescription);
	retval |= UA_String_deleteMembers(&p->serverUri);
	retval |= UA_String_deleteMembers(&p->endpointUrl);
	retval |= UA_String_deleteMembers(&p->sessionName);
	retval |= UA_ByteString_deleteMembers(&p->clientNonce);
	retval |= UA_ByteString_deleteMembers(&p->clientCertificate);
	return retval;
}

UA_Int32 UA_CreateSessionRequest_init(UA_CreateSessionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_ApplicationDescription_init(&p->clientDescription);
	retval |= UA_String_init(&p->serverUri);
	retval |= UA_String_init(&p->endpointUrl);
	retval |= UA_String_init(&p->sessionName);
	retval |= UA_ByteString_init(&p->clientNonce);
	retval |= UA_ByteString_init(&p->clientCertificate);
	retval |= UA_Double_init(&p->requestedSessionTimeout);
	retval |= UA_UInt32_init(&p->maxResponseMessageSize);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CreateSessionRequest)
UA_Int32 UA_CreateSessionRequest_copy(const UA_CreateSessionRequest *src,UA_CreateSessionRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CreateSessionRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_ApplicationDescription_copy(&src->clientDescription,&dst->clientDescription);
	retval |= UA_String_copy(&src->serverUri,&dst->serverUri);
	retval |= UA_String_copy(&src->endpointUrl,&dst->endpointUrl);
	retval |= UA_String_copy(&src->sessionName,&dst->sessionName);
	retval |= UA_ByteString_copy(&src->clientNonce,&dst->clientNonce);
	retval |= UA_ByteString_copy(&src->clientCertificate,&dst->clientCertificate);
	return retval;
}

UA_Int32 UA_CreateSessionResponse_calcSizeBinary(UA_CreateSessionResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CreateSessionResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_NodeId_calcSizeBinary(&ptr->sessionId)
	 + UA_NodeId_calcSizeBinary(&ptr->authenticationToken)
	 + sizeof(UA_Double) // revisedSessionTimeout
	 + UA_ByteString_calcSizeBinary(&ptr->serverNonce)
	 + UA_ByteString_calcSizeBinary(&ptr->serverCertificate)
	 + UA_Array_calcSizeBinary(ptr->serverEndpointsSize,UA_ENDPOINTDESCRIPTION,ptr->serverEndpoints)
	 + UA_Array_calcSizeBinary(ptr->serverSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,ptr->serverSoftwareCertificates)
	 + UA_SignatureData_calcSizeBinary(&ptr->serverSignature)
	 + sizeof(UA_UInt32) // maxRequestMessageSize
	;
}

UA_Int32 UA_CreateSessionResponse_encodeBinary(UA_CreateSessionResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->sessionId,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->authenticationToken,dst,offset);
	retval |= UA_Double_encodeBinary(&src->revisedSessionTimeout,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->serverNonce,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->serverCertificate,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->serverEndpointsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->serverEndpoints,src->serverEndpointsSize,UA_ENDPOINTDESCRIPTION,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->serverSoftwareCertificatesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->serverSoftwareCertificates,src->serverSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,dst,offset);
	retval |= UA_SignatureData_encodeBinary(&src->serverSignature,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxRequestMessageSize,dst,offset);
	return retval;
}

UA_Int32 UA_CreateSessionResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CreateSessionResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CreateSessionResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->sessionId), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->authenticationToken), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->revisedSessionTimeout), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->serverNonce), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->serverCertificate), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->serverEndpointsSize),UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->serverEndpointsSize,UA_ENDPOINTDESCRIPTION,(void**)&dst->serverEndpoints), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->serverSoftwareCertificatesSize),UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->serverSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,(void**)&dst->serverSoftwareCertificates), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_SignatureData_decodeBinary(src,offset,&dst->serverSignature), UA_CreateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxRequestMessageSize), UA_CreateSessionResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CreateSessionResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CreateSessionResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CreateSessionResponse)
UA_Int32 UA_CreateSessionResponse_delete(UA_CreateSessionResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CreateSessionResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CreateSessionResponse_deleteMembers(UA_CreateSessionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_NodeId_deleteMembers(&p->sessionId);
	retval |= UA_NodeId_deleteMembers(&p->authenticationToken);
	retval |= UA_ByteString_deleteMembers(&p->serverNonce);
	retval |= UA_ByteString_deleteMembers(&p->serverCertificate);
	retval |= UA_Array_delete((void**)&p->serverEndpoints,p->serverEndpointsSize,UA_ENDPOINTDESCRIPTION);
	retval |= UA_Array_delete((void**)&p->serverSoftwareCertificates,p->serverSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE);
	retval |= UA_SignatureData_deleteMembers(&p->serverSignature);
	return retval;
}

UA_Int32 UA_CreateSessionResponse_init(UA_CreateSessionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_NodeId_init(&p->sessionId);
	retval |= UA_NodeId_init(&p->authenticationToken);
	retval |= UA_Double_init(&p->revisedSessionTimeout);
	retval |= UA_ByteString_init(&p->serverNonce);
	retval |= UA_ByteString_init(&p->serverCertificate);
	p->serverEndpointsSize = 0;
	p->serverEndpoints = UA_NULL;
	p->serverSoftwareCertificatesSize = 0;
	p->serverSoftwareCertificates = UA_NULL;
	retval |= UA_SignatureData_init(&p->serverSignature);
	retval |= UA_UInt32_init(&p->maxRequestMessageSize);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CreateSessionResponse)
UA_Int32 UA_CreateSessionResponse_copy(const UA_CreateSessionResponse *src,UA_CreateSessionResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CreateSessionResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	retval |= UA_NodeId_copy(&src->sessionId,&dst->sessionId);
	retval |= UA_NodeId_copy(&src->authenticationToken,&dst->authenticationToken);
	retval |= UA_ByteString_copy(&src->serverNonce,&dst->serverNonce);
	retval |= UA_ByteString_copy(&src->serverCertificate,&dst->serverCertificate);
	dst->serverEndpoints = src->serverEndpoints;
	retval |= UA_Array_copy(&src->serverEndpoints, src->serverEndpointsSize,UA_ENDPOINTDESCRIPTION,(void**)&dst->serverEndpoints);
	dst->serverSoftwareCertificates = src->serverSoftwareCertificates;
	retval |= UA_Array_copy(&src->serverSoftwareCertificates, src->serverSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,(void**)&dst->serverSoftwareCertificates);
	retval |= UA_SignatureData_copy(&src->serverSignature,&dst->serverSignature);
	return retval;
}

UA_Int32 UA_UserIdentityToken_calcSizeBinary(UA_UserIdentityToken const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UserIdentityToken);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->policyId)
	;
}

UA_Int32 UA_UserIdentityToken_encodeBinary(UA_UserIdentityToken const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->policyId,dst,offset);
	return retval;
}

UA_Int32 UA_UserIdentityToken_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UserIdentityToken * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UserIdentityToken_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->policyId), UA_UserIdentityToken_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UserIdentityToken)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UserIdentityToken)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UserIdentityToken)
UA_Int32 UA_UserIdentityToken_delete(UA_UserIdentityToken *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UserIdentityToken_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UserIdentityToken_deleteMembers(UA_UserIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->policyId);
	return retval;
}

UA_Int32 UA_UserIdentityToken_init(UA_UserIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->policyId);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UserIdentityToken)
UA_Int32 UA_UserIdentityToken_copy(const UA_UserIdentityToken *src,UA_UserIdentityToken *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UserIdentityToken));
	retval |= UA_String_copy(&src->policyId,&dst->policyId);
	return retval;
}

UA_Int32 UA_AnonymousIdentityToken_calcSizeBinary(UA_AnonymousIdentityToken const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AnonymousIdentityToken);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->policyId)
	;
}

UA_Int32 UA_AnonymousIdentityToken_encodeBinary(UA_AnonymousIdentityToken const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->policyId,dst,offset);
	return retval;
}

UA_Int32 UA_AnonymousIdentityToken_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AnonymousIdentityToken * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AnonymousIdentityToken_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->policyId), UA_AnonymousIdentityToken_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AnonymousIdentityToken)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AnonymousIdentityToken)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AnonymousIdentityToken)
UA_Int32 UA_AnonymousIdentityToken_delete(UA_AnonymousIdentityToken *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AnonymousIdentityToken_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AnonymousIdentityToken_deleteMembers(UA_AnonymousIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->policyId);
	return retval;
}

UA_Int32 UA_AnonymousIdentityToken_init(UA_AnonymousIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->policyId);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AnonymousIdentityToken)
UA_Int32 UA_AnonymousIdentityToken_copy(const UA_AnonymousIdentityToken *src,UA_AnonymousIdentityToken *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AnonymousIdentityToken));
	retval |= UA_String_copy(&src->policyId,&dst->policyId);
	return retval;
}

UA_Int32 UA_UserNameIdentityToken_calcSizeBinary(UA_UserNameIdentityToken const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UserNameIdentityToken);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->policyId)
	 + UA_String_calcSizeBinary(&ptr->userName)
	 + UA_ByteString_calcSizeBinary(&ptr->password)
	 + UA_String_calcSizeBinary(&ptr->encryptionAlgorithm)
	;
}

UA_Int32 UA_UserNameIdentityToken_encodeBinary(UA_UserNameIdentityToken const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->policyId,dst,offset);
	retval |= UA_String_encodeBinary(&src->userName,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->password,dst,offset);
	retval |= UA_String_encodeBinary(&src->encryptionAlgorithm,dst,offset);
	return retval;
}

UA_Int32 UA_UserNameIdentityToken_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UserNameIdentityToken * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UserNameIdentityToken_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->policyId), UA_UserNameIdentityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->userName), UA_UserNameIdentityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->password), UA_UserNameIdentityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->encryptionAlgorithm), UA_UserNameIdentityToken_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UserNameIdentityToken)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UserNameIdentityToken)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UserNameIdentityToken)
UA_Int32 UA_UserNameIdentityToken_delete(UA_UserNameIdentityToken *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UserNameIdentityToken_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UserNameIdentityToken_deleteMembers(UA_UserNameIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->policyId);
	retval |= UA_String_deleteMembers(&p->userName);
	retval |= UA_ByteString_deleteMembers(&p->password);
	retval |= UA_String_deleteMembers(&p->encryptionAlgorithm);
	return retval;
}

UA_Int32 UA_UserNameIdentityToken_init(UA_UserNameIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->policyId);
	retval |= UA_String_init(&p->userName);
	retval |= UA_ByteString_init(&p->password);
	retval |= UA_String_init(&p->encryptionAlgorithm);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UserNameIdentityToken)
UA_Int32 UA_UserNameIdentityToken_copy(const UA_UserNameIdentityToken *src,UA_UserNameIdentityToken *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UserNameIdentityToken));
	retval |= UA_String_copy(&src->policyId,&dst->policyId);
	retval |= UA_String_copy(&src->userName,&dst->userName);
	retval |= UA_ByteString_copy(&src->password,&dst->password);
	retval |= UA_String_copy(&src->encryptionAlgorithm,&dst->encryptionAlgorithm);
	return retval;
}

UA_Int32 UA_X509IdentityToken_calcSizeBinary(UA_X509IdentityToken const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_X509IdentityToken);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->policyId)
	 + UA_ByteString_calcSizeBinary(&ptr->certificateData)
	;
}

UA_Int32 UA_X509IdentityToken_encodeBinary(UA_X509IdentityToken const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->policyId,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->certificateData,dst,offset);
	return retval;
}

UA_Int32 UA_X509IdentityToken_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_X509IdentityToken * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_X509IdentityToken_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->policyId), UA_X509IdentityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->certificateData), UA_X509IdentityToken_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_X509IdentityToken)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_X509IdentityToken)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_X509IdentityToken)
UA_Int32 UA_X509IdentityToken_delete(UA_X509IdentityToken *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_X509IdentityToken_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_X509IdentityToken_deleteMembers(UA_X509IdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->policyId);
	retval |= UA_ByteString_deleteMembers(&p->certificateData);
	return retval;
}

UA_Int32 UA_X509IdentityToken_init(UA_X509IdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->policyId);
	retval |= UA_ByteString_init(&p->certificateData);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_X509IdentityToken)
UA_Int32 UA_X509IdentityToken_copy(const UA_X509IdentityToken *src,UA_X509IdentityToken *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_X509IdentityToken));
	retval |= UA_String_copy(&src->policyId,&dst->policyId);
	retval |= UA_ByteString_copy(&src->certificateData,&dst->certificateData);
	return retval;
}

UA_Int32 UA_IssuedIdentityToken_calcSizeBinary(UA_IssuedIdentityToken const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_IssuedIdentityToken);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->policyId)
	 + UA_ByteString_calcSizeBinary(&ptr->tokenData)
	 + UA_String_calcSizeBinary(&ptr->encryptionAlgorithm)
	;
}

UA_Int32 UA_IssuedIdentityToken_encodeBinary(UA_IssuedIdentityToken const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->policyId,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->tokenData,dst,offset);
	retval |= UA_String_encodeBinary(&src->encryptionAlgorithm,dst,offset);
	return retval;
}

UA_Int32 UA_IssuedIdentityToken_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_IssuedIdentityToken * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_IssuedIdentityToken_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->policyId), UA_IssuedIdentityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->tokenData), UA_IssuedIdentityToken_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->encryptionAlgorithm), UA_IssuedIdentityToken_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_IssuedIdentityToken)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_IssuedIdentityToken)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_IssuedIdentityToken)
UA_Int32 UA_IssuedIdentityToken_delete(UA_IssuedIdentityToken *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_IssuedIdentityToken_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_IssuedIdentityToken_deleteMembers(UA_IssuedIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->policyId);
	retval |= UA_ByteString_deleteMembers(&p->tokenData);
	retval |= UA_String_deleteMembers(&p->encryptionAlgorithm);
	return retval;
}

UA_Int32 UA_IssuedIdentityToken_init(UA_IssuedIdentityToken *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->policyId);
	retval |= UA_ByteString_init(&p->tokenData);
	retval |= UA_String_init(&p->encryptionAlgorithm);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_IssuedIdentityToken)
UA_Int32 UA_IssuedIdentityToken_copy(const UA_IssuedIdentityToken *src,UA_IssuedIdentityToken *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_IssuedIdentityToken));
	retval |= UA_String_copy(&src->policyId,&dst->policyId);
	retval |= UA_ByteString_copy(&src->tokenData,&dst->tokenData);
	retval |= UA_String_copy(&src->encryptionAlgorithm,&dst->encryptionAlgorithm);
	return retval;
}

UA_Int32 UA_ActivateSessionRequest_calcSizeBinary(UA_ActivateSessionRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ActivateSessionRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_SignatureData_calcSizeBinary(&ptr->clientSignature)
	 + UA_Array_calcSizeBinary(ptr->clientSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,ptr->clientSoftwareCertificates)
	 + UA_Array_calcSizeBinary(ptr->localeIdsSize,UA_STRING,ptr->localeIds)
	 + UA_ExtensionObject_calcSizeBinary(&ptr->userIdentityToken)
	 + UA_SignatureData_calcSizeBinary(&ptr->userTokenSignature)
	;
}

UA_Int32 UA_ActivateSessionRequest_encodeBinary(UA_ActivateSessionRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_SignatureData_encodeBinary(&src->clientSignature,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->clientSoftwareCertificatesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->clientSoftwareCertificates,src->clientSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->localeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->localeIds,src->localeIdsSize,UA_STRING,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->userIdentityToken,dst,offset);
	retval |= UA_SignatureData_encodeBinary(&src->userTokenSignature,dst,offset);
	return retval;
}

UA_Int32 UA_ActivateSessionRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ActivateSessionRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ActivateSessionRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_ActivateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_SignatureData_decodeBinary(src,offset,&dst->clientSignature), UA_ActivateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->clientSoftwareCertificatesSize),UA_ActivateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->clientSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,(void**)&dst->clientSoftwareCertificates), UA_ActivateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->localeIdsSize),UA_ActivateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->localeIdsSize,UA_STRING,(void**)&dst->localeIds), UA_ActivateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->userIdentityToken), UA_ActivateSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_SignatureData_decodeBinary(src,offset,&dst->userTokenSignature), UA_ActivateSessionRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ActivateSessionRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ActivateSessionRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ActivateSessionRequest)
UA_Int32 UA_ActivateSessionRequest_delete(UA_ActivateSessionRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ActivateSessionRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ActivateSessionRequest_deleteMembers(UA_ActivateSessionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_SignatureData_deleteMembers(&p->clientSignature);
	retval |= UA_Array_delete((void**)&p->clientSoftwareCertificates,p->clientSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE);
	retval |= UA_Array_delete((void**)&p->localeIds,p->localeIdsSize,UA_STRING);
	retval |= UA_ExtensionObject_deleteMembers(&p->userIdentityToken);
	retval |= UA_SignatureData_deleteMembers(&p->userTokenSignature);
	return retval;
}

UA_Int32 UA_ActivateSessionRequest_init(UA_ActivateSessionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_SignatureData_init(&p->clientSignature);
	p->clientSoftwareCertificatesSize = 0;
	p->clientSoftwareCertificates = UA_NULL;
	p->localeIdsSize = 0;
	p->localeIds = UA_NULL;
	retval |= UA_ExtensionObject_init(&p->userIdentityToken);
	retval |= UA_SignatureData_init(&p->userTokenSignature);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ActivateSessionRequest)
UA_Int32 UA_ActivateSessionRequest_copy(const UA_ActivateSessionRequest *src,UA_ActivateSessionRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ActivateSessionRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_SignatureData_copy(&src->clientSignature,&dst->clientSignature);
	dst->clientSoftwareCertificates = src->clientSoftwareCertificates;
	retval |= UA_Array_copy(&src->clientSoftwareCertificates, src->clientSoftwareCertificatesSize,UA_SIGNEDSOFTWARECERTIFICATE,(void**)&dst->clientSoftwareCertificates);
	dst->localeIds = src->localeIds;
	retval |= UA_Array_copy(&src->localeIds, src->localeIdsSize,UA_STRING,(void**)&dst->localeIds);
	retval |= UA_ExtensionObject_copy(&src->userIdentityToken,&dst->userIdentityToken);
	retval |= UA_SignatureData_copy(&src->userTokenSignature,&dst->userTokenSignature);
	return retval;
}

UA_Int32 UA_ActivateSessionResponse_calcSizeBinary(UA_ActivateSessionResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ActivateSessionResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_ByteString_calcSizeBinary(&ptr->serverNonce)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_ActivateSessionResponse_encodeBinary(UA_ActivateSessionResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->serverNonce,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_ActivateSessionResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ActivateSessionResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ActivateSessionResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_ActivateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->serverNonce), UA_ActivateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_ActivateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_ActivateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_ActivateSessionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_ActivateSessionResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ActivateSessionResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ActivateSessionResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ActivateSessionResponse)
UA_Int32 UA_ActivateSessionResponse_delete(UA_ActivateSessionResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ActivateSessionResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ActivateSessionResponse_deleteMembers(UA_ActivateSessionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_ByteString_deleteMembers(&p->serverNonce);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_ActivateSessionResponse_init(UA_ActivateSessionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_ByteString_init(&p->serverNonce);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ActivateSessionResponse)
UA_Int32 UA_ActivateSessionResponse_copy(const UA_ActivateSessionResponse *src,UA_ActivateSessionResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ActivateSessionResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	retval |= UA_ByteString_copy(&src->serverNonce,&dst->serverNonce);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_CloseSessionRequest_calcSizeBinary(UA_CloseSessionRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CloseSessionRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_Boolean) // deleteSubscriptions
	;
}

UA_Int32 UA_CloseSessionRequest_encodeBinary(UA_CloseSessionRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->deleteSubscriptions,dst,offset);
	return retval;
}

UA_Int32 UA_CloseSessionRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CloseSessionRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CloseSessionRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_CloseSessionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->deleteSubscriptions), UA_CloseSessionRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CloseSessionRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CloseSessionRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CloseSessionRequest)
UA_Int32 UA_CloseSessionRequest_delete(UA_CloseSessionRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CloseSessionRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CloseSessionRequest_deleteMembers(UA_CloseSessionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	return retval;
}

UA_Int32 UA_CloseSessionRequest_init(UA_CloseSessionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_Boolean_init(&p->deleteSubscriptions);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CloseSessionRequest)
UA_Int32 UA_CloseSessionRequest_copy(const UA_CloseSessionRequest *src,UA_CloseSessionRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CloseSessionRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	return retval;
}

UA_Int32 UA_CloseSessionResponse_calcSizeBinary(UA_CloseSessionResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CloseSessionResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	;
}

UA_Int32 UA_CloseSessionResponse_encodeBinary(UA_CloseSessionResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	return retval;
}

UA_Int32 UA_CloseSessionResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CloseSessionResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CloseSessionResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_CloseSessionResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CloseSessionResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CloseSessionResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CloseSessionResponse)
UA_Int32 UA_CloseSessionResponse_delete(UA_CloseSessionResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CloseSessionResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CloseSessionResponse_deleteMembers(UA_CloseSessionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_CloseSessionResponse_init(UA_CloseSessionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CloseSessionResponse)
UA_Int32 UA_CloseSessionResponse_copy(const UA_CloseSessionResponse *src,UA_CloseSessionResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CloseSessionResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_Int32 UA_CancelRequest_calcSizeBinary(UA_CancelRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CancelRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // requestHandle
	;
}

UA_Int32 UA_CancelRequest_encodeBinary(UA_CancelRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestHandle,dst,offset);
	return retval;
}

UA_Int32 UA_CancelRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CancelRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CancelRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_CancelRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestHandle), UA_CancelRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CancelRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CancelRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CancelRequest)
UA_Int32 UA_CancelRequest_delete(UA_CancelRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CancelRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CancelRequest_deleteMembers(UA_CancelRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	return retval;
}

UA_Int32 UA_CancelRequest_init(UA_CancelRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->requestHandle);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CancelRequest)
UA_Int32 UA_CancelRequest_copy(const UA_CancelRequest *src,UA_CancelRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CancelRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	return retval;
}

UA_Int32 UA_CancelResponse_calcSizeBinary(UA_CancelResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CancelResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + sizeof(UA_UInt32) // cancelCount
	;
}

UA_Int32 UA_CancelResponse_encodeBinary(UA_CancelResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->cancelCount,dst,offset);
	return retval;
}

UA_Int32 UA_CancelResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CancelResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CancelResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_CancelResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->cancelCount), UA_CancelResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CancelResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CancelResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CancelResponse)
UA_Int32 UA_CancelResponse_delete(UA_CancelResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CancelResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CancelResponse_deleteMembers(UA_CancelResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_CancelResponse_init(UA_CancelResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_UInt32_init(&p->cancelCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CancelResponse)
UA_Int32 UA_CancelResponse_copy(const UA_CancelResponse *src,UA_CancelResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CancelResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_TYPE_AS(UA_NodeAttributesMask, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_NodeAttributesMask, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NodeAttributesMask)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NodeAttributesMask)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NodeAttributesMask
)
UA_Int32 UA_NodeAttributes_calcSizeBinary(UA_NodeAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_NodeAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	;
}

UA_Int32 UA_NodeAttributes_encodeBinary(UA_NodeAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	return retval;
}

UA_Int32 UA_NodeAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_NodeAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_NodeAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_NodeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_NodeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_NodeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_NodeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_NodeAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NodeAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NodeAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NodeAttributes)
UA_Int32 UA_NodeAttributes_delete(UA_NodeAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_NodeAttributes_deleteMembers(UA_NodeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_NodeAttributes_init(UA_NodeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_NodeAttributes)
UA_Int32 UA_NodeAttributes_copy(const UA_NodeAttributes *src,UA_NodeAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_NodeAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_Int32 UA_ObjectAttributes_calcSizeBinary(UA_ObjectAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ObjectAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + sizeof(UA_Byte) // eventNotifier
	;
}

UA_Int32 UA_ObjectAttributes_encodeBinary(UA_ObjectAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->eventNotifier,dst,offset);
	return retval;
}

UA_Int32 UA_ObjectAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ObjectAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ObjectAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_ObjectAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ObjectAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ObjectAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ObjectAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ObjectAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->eventNotifier), UA_ObjectAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ObjectAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ObjectAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ObjectAttributes)
UA_Int32 UA_ObjectAttributes_delete(UA_ObjectAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ObjectAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ObjectAttributes_deleteMembers(UA_ObjectAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_ObjectAttributes_init(UA_ObjectAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Byte_init(&p->eventNotifier);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ObjectAttributes)
UA_Int32 UA_ObjectAttributes_copy(const UA_ObjectAttributes *src,UA_ObjectAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ObjectAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_Int32 UA_VariableAttributes_calcSizeBinary(UA_VariableAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_VariableAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Variant_calcSizeBinary(&ptr->value)
	 + UA_NodeId_calcSizeBinary(&ptr->dataType)
	 + sizeof(UA_Int32) // valueRank
	 + UA_Array_calcSizeBinary(ptr->arrayDimensionsSize,UA_UINT32,ptr->arrayDimensions)
	 + sizeof(UA_Byte) // accessLevel
	 + sizeof(UA_Byte) // userAccessLevel
	 + sizeof(UA_Double) // minimumSamplingInterval
	 + sizeof(UA_Boolean) // historizing
	;
}

UA_Int32 UA_VariableAttributes_encodeBinary(UA_VariableAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Variant_encodeBinary(&src->value,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->dataType,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->valueRank,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->arrayDimensionsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->arrayDimensions,src->arrayDimensionsSize,UA_UINT32,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->accessLevel,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->userAccessLevel,dst,offset);
	retval |= UA_Double_encodeBinary(&src->minimumSamplingInterval,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->historizing,dst,offset);
	return retval;
}

UA_Int32 UA_VariableAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_VariableAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_VariableAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Variant_decodeBinary(src,offset,&dst->value), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->dataType), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->valueRank), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->arrayDimensionsSize),UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->accessLevel), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->userAccessLevel), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->minimumSamplingInterval), UA_VariableAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->historizing), UA_VariableAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_VariableAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_VariableAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_VariableAttributes)
UA_Int32 UA_VariableAttributes_delete(UA_VariableAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_VariableAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_VariableAttributes_deleteMembers(UA_VariableAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Variant_deleteMembers(&p->value);
	retval |= UA_NodeId_deleteMembers(&p->dataType);
	retval |= UA_Array_delete((void**)&p->arrayDimensions,p->arrayDimensionsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_VariableAttributes_init(UA_VariableAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Variant_init(&p->value);
	retval |= UA_NodeId_init(&p->dataType);
	retval |= UA_Int32_init(&p->valueRank);
	p->arrayDimensionsSize = 0;
	p->arrayDimensions = UA_NULL;
	retval |= UA_Byte_init(&p->accessLevel);
	retval |= UA_Byte_init(&p->userAccessLevel);
	retval |= UA_Double_init(&p->minimumSamplingInterval);
	retval |= UA_Boolean_init(&p->historizing);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_VariableAttributes)
UA_Int32 UA_VariableAttributes_copy(const UA_VariableAttributes *src,UA_VariableAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_VariableAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	retval |= UA_Variant_copy(&src->value,&dst->value);
	retval |= UA_NodeId_copy(&src->dataType,&dst->dataType);
	dst->arrayDimensions = src->arrayDimensions;
	retval |= UA_Array_copy(&src->arrayDimensions, src->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions);
	return retval;
}

UA_Int32 UA_MethodAttributes_calcSizeBinary(UA_MethodAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MethodAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + sizeof(UA_Boolean) // executable
	 + sizeof(UA_Boolean) // userExecutable
	;
}

UA_Int32 UA_MethodAttributes_encodeBinary(UA_MethodAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->executable,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->userExecutable,dst,offset);
	return retval;
}

UA_Int32 UA_MethodAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MethodAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MethodAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_MethodAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_MethodAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_MethodAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_MethodAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_MethodAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->executable), UA_MethodAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->userExecutable), UA_MethodAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MethodAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MethodAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MethodAttributes)
UA_Int32 UA_MethodAttributes_delete(UA_MethodAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MethodAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MethodAttributes_deleteMembers(UA_MethodAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_MethodAttributes_init(UA_MethodAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Boolean_init(&p->executable);
	retval |= UA_Boolean_init(&p->userExecutable);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MethodAttributes)
UA_Int32 UA_MethodAttributes_copy(const UA_MethodAttributes *src,UA_MethodAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MethodAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_Int32 UA_ObjectTypeAttributes_calcSizeBinary(UA_ObjectTypeAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ObjectTypeAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + sizeof(UA_Boolean) // isAbstract
	;
}

UA_Int32 UA_ObjectTypeAttributes_encodeBinary(UA_ObjectTypeAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	return retval;
}

UA_Int32 UA_ObjectTypeAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ObjectTypeAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ObjectTypeAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_ObjectTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ObjectTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ObjectTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ObjectTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ObjectTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_ObjectTypeAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ObjectTypeAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ObjectTypeAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ObjectTypeAttributes)
UA_Int32 UA_ObjectTypeAttributes_delete(UA_ObjectTypeAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ObjectTypeAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ObjectTypeAttributes_deleteMembers(UA_ObjectTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_ObjectTypeAttributes_init(UA_ObjectTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Boolean_init(&p->isAbstract);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ObjectTypeAttributes)
UA_Int32 UA_ObjectTypeAttributes_copy(const UA_ObjectTypeAttributes *src,UA_ObjectTypeAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ObjectTypeAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_Int32 UA_VariableTypeAttributes_calcSizeBinary(UA_VariableTypeAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_VariableTypeAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Variant_calcSizeBinary(&ptr->value)
	 + UA_NodeId_calcSizeBinary(&ptr->dataType)
	 + sizeof(UA_Int32) // valueRank
	 + UA_Array_calcSizeBinary(ptr->arrayDimensionsSize,UA_UINT32,ptr->arrayDimensions)
	 + sizeof(UA_Boolean) // isAbstract
	;
}

UA_Int32 UA_VariableTypeAttributes_encodeBinary(UA_VariableTypeAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Variant_encodeBinary(&src->value,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->dataType,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->valueRank,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->arrayDimensionsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->arrayDimensions,src->arrayDimensionsSize,UA_UINT32,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	return retval;
}

UA_Int32 UA_VariableTypeAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_VariableTypeAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_VariableTypeAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Variant_decodeBinary(src,offset,&dst->value), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->dataType), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->valueRank), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->arrayDimensionsSize),UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions), UA_VariableTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_VariableTypeAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_VariableTypeAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_VariableTypeAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_VariableTypeAttributes)
UA_Int32 UA_VariableTypeAttributes_delete(UA_VariableTypeAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_VariableTypeAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_VariableTypeAttributes_deleteMembers(UA_VariableTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Variant_deleteMembers(&p->value);
	retval |= UA_NodeId_deleteMembers(&p->dataType);
	retval |= UA_Array_delete((void**)&p->arrayDimensions,p->arrayDimensionsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_VariableTypeAttributes_init(UA_VariableTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Variant_init(&p->value);
	retval |= UA_NodeId_init(&p->dataType);
	retval |= UA_Int32_init(&p->valueRank);
	p->arrayDimensionsSize = 0;
	p->arrayDimensions = UA_NULL;
	retval |= UA_Boolean_init(&p->isAbstract);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_VariableTypeAttributes)
UA_Int32 UA_VariableTypeAttributes_copy(const UA_VariableTypeAttributes *src,UA_VariableTypeAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_VariableTypeAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	retval |= UA_Variant_copy(&src->value,&dst->value);
	retval |= UA_NodeId_copy(&src->dataType,&dst->dataType);
	dst->arrayDimensions = src->arrayDimensions;
	retval |= UA_Array_copy(&src->arrayDimensions, src->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions);
	return retval;
}

UA_Int32 UA_ReferenceTypeAttributes_calcSizeBinary(UA_ReferenceTypeAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReferenceTypeAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + sizeof(UA_Boolean) // isAbstract
	 + sizeof(UA_Boolean) // symmetric
	 + UA_LocalizedText_calcSizeBinary(&ptr->inverseName)
	;
}

UA_Int32 UA_ReferenceTypeAttributes_encodeBinary(UA_ReferenceTypeAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->symmetric,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->inverseName,dst,offset);
	return retval;
}

UA_Int32 UA_ReferenceTypeAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReferenceTypeAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReferenceTypeAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_ReferenceTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ReferenceTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ReferenceTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ReferenceTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ReferenceTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_ReferenceTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->symmetric), UA_ReferenceTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->inverseName), UA_ReferenceTypeAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReferenceTypeAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReferenceTypeAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReferenceTypeAttributes)
UA_Int32 UA_ReferenceTypeAttributes_delete(UA_ReferenceTypeAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReferenceTypeAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReferenceTypeAttributes_deleteMembers(UA_ReferenceTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_LocalizedText_deleteMembers(&p->inverseName);
	return retval;
}

UA_Int32 UA_ReferenceTypeAttributes_init(UA_ReferenceTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Boolean_init(&p->isAbstract);
	retval |= UA_Boolean_init(&p->symmetric);
	retval |= UA_LocalizedText_init(&p->inverseName);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReferenceTypeAttributes)
UA_Int32 UA_ReferenceTypeAttributes_copy(const UA_ReferenceTypeAttributes *src,UA_ReferenceTypeAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReferenceTypeAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	retval |= UA_LocalizedText_copy(&src->inverseName,&dst->inverseName);
	return retval;
}

UA_Int32 UA_DataTypeAttributes_calcSizeBinary(UA_DataTypeAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DataTypeAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + sizeof(UA_Boolean) // isAbstract
	;
}

UA_Int32 UA_DataTypeAttributes_encodeBinary(UA_DataTypeAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	return retval;
}

UA_Int32 UA_DataTypeAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DataTypeAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DataTypeAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_DataTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_DataTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_DataTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_DataTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_DataTypeAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_DataTypeAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DataTypeAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DataTypeAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DataTypeAttributes)
UA_Int32 UA_DataTypeAttributes_delete(UA_DataTypeAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DataTypeAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DataTypeAttributes_deleteMembers(UA_DataTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_DataTypeAttributes_init(UA_DataTypeAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Boolean_init(&p->isAbstract);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DataTypeAttributes)
UA_Int32 UA_DataTypeAttributes_copy(const UA_DataTypeAttributes *src,UA_DataTypeAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DataTypeAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_Int32 UA_ViewAttributes_calcSizeBinary(UA_ViewAttributes const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ViewAttributes);
    	return 0
	 + sizeof(UA_UInt32) // specifiedAttributes
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + sizeof(UA_Boolean) // containsNoLoops
	 + sizeof(UA_Byte) // eventNotifier
	;
}

UA_Int32 UA_ViewAttributes_encodeBinary(UA_ViewAttributes const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->specifiedAttributes,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->containsNoLoops,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->eventNotifier,dst,offset);
	return retval;
}

UA_Int32 UA_ViewAttributes_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ViewAttributes * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ViewAttributes_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->specifiedAttributes), UA_ViewAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ViewAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ViewAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ViewAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ViewAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->containsNoLoops), UA_ViewAttributes_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->eventNotifier), UA_ViewAttributes_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ViewAttributes)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ViewAttributes)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ViewAttributes)
UA_Int32 UA_ViewAttributes_delete(UA_ViewAttributes *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ViewAttributes_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ViewAttributes_deleteMembers(UA_ViewAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_ViewAttributes_init(UA_ViewAttributes *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->specifiedAttributes);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	retval |= UA_Boolean_init(&p->containsNoLoops);
	retval |= UA_Byte_init(&p->eventNotifier);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ViewAttributes)
UA_Int32 UA_ViewAttributes_copy(const UA_ViewAttributes *src,UA_ViewAttributes *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ViewAttributes));
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_Int32 UA_AddNodesItem_calcSizeBinary(UA_AddNodesItem const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AddNodesItem);
    	return 0
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->parentNodeId)
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->requestedNewNodeId)
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_ExtensionObject_calcSizeBinary(&ptr->nodeAttributes)
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->typeDefinition)
	;
}

UA_Int32 UA_AddNodesItem_encodeBinary(UA_AddNodesItem const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_encodeBinary(&src->parentNodeId,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->requestedNewNodeId,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->nodeAttributes,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->typeDefinition,dst,offset);
	return retval;
}

UA_Int32 UA_AddNodesItem_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AddNodesItem * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AddNodesItem_init(dst);
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->parentNodeId), UA_AddNodesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_AddNodesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->requestedNewNodeId), UA_AddNodesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_AddNodesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_AddNodesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->nodeAttributes), UA_AddNodesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->typeDefinition), UA_AddNodesItem_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AddNodesItem)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AddNodesItem)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AddNodesItem)
UA_Int32 UA_AddNodesItem_delete(UA_AddNodesItem *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AddNodesItem_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AddNodesItem_deleteMembers(UA_AddNodesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_deleteMembers(&p->parentNodeId);
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->requestedNewNodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_ExtensionObject_deleteMembers(&p->nodeAttributes);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->typeDefinition);
	return retval;
}

UA_Int32 UA_AddNodesItem_init(UA_AddNodesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_init(&p->parentNodeId);
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_ExpandedNodeId_init(&p->requestedNewNodeId);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_ExtensionObject_init(&p->nodeAttributes);
	retval |= UA_ExpandedNodeId_init(&p->typeDefinition);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AddNodesItem)
UA_Int32 UA_AddNodesItem_copy(const UA_AddNodesItem *src,UA_AddNodesItem *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AddNodesItem));
	retval |= UA_ExpandedNodeId_copy(&src->parentNodeId,&dst->parentNodeId);
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	retval |= UA_ExpandedNodeId_copy(&src->requestedNewNodeId,&dst->requestedNewNodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_ExtensionObject_copy(&src->nodeAttributes,&dst->nodeAttributes);
	retval |= UA_ExpandedNodeId_copy(&src->typeDefinition,&dst->typeDefinition);
	return retval;
}

UA_Int32 UA_AddNodesResult_calcSizeBinary(UA_AddNodesResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AddNodesResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_NodeId_calcSizeBinary(&ptr->addedNodeId)
	;
}

UA_Int32 UA_AddNodesResult_encodeBinary(UA_AddNodesResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->addedNodeId,dst,offset);
	return retval;
}

UA_Int32 UA_AddNodesResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AddNodesResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AddNodesResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_AddNodesResult_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->addedNodeId), UA_AddNodesResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AddNodesResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AddNodesResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AddNodesResult)
UA_Int32 UA_AddNodesResult_delete(UA_AddNodesResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AddNodesResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AddNodesResult_deleteMembers(UA_AddNodesResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->addedNodeId);
	return retval;
}

UA_Int32 UA_AddNodesResult_init(UA_AddNodesResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_NodeId_init(&p->addedNodeId);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AddNodesResult)
UA_Int32 UA_AddNodesResult_copy(const UA_AddNodesResult *src,UA_AddNodesResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AddNodesResult));
	retval |= UA_NodeId_copy(&src->addedNodeId,&dst->addedNodeId);
	return retval;
}

UA_Int32 UA_AddNodesRequest_calcSizeBinary(UA_AddNodesRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AddNodesRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->nodesToAddSize,UA_ADDNODESITEM,ptr->nodesToAdd)
	;
}

UA_Int32 UA_AddNodesRequest_encodeBinary(UA_AddNodesRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToAddSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToAdd,src->nodesToAddSize,UA_ADDNODESITEM,dst,offset);
	return retval;
}

UA_Int32 UA_AddNodesRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AddNodesRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AddNodesRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_AddNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToAddSize),UA_AddNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToAddSize,UA_ADDNODESITEM,(void**)&dst->nodesToAdd), UA_AddNodesRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AddNodesRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AddNodesRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AddNodesRequest)
UA_Int32 UA_AddNodesRequest_delete(UA_AddNodesRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AddNodesRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AddNodesRequest_deleteMembers(UA_AddNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->nodesToAdd,p->nodesToAddSize,UA_ADDNODESITEM);
	return retval;
}

UA_Int32 UA_AddNodesRequest_init(UA_AddNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->nodesToAddSize = 0;
	p->nodesToAdd = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AddNodesRequest)
UA_Int32 UA_AddNodesRequest_copy(const UA_AddNodesRequest *src,UA_AddNodesRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AddNodesRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->nodesToAdd = src->nodesToAdd;
	retval |= UA_Array_copy(&src->nodesToAdd, src->nodesToAddSize,UA_ADDNODESITEM,(void**)&dst->nodesToAdd);
	return retval;
}

UA_Int32 UA_AddNodesResponse_calcSizeBinary(UA_AddNodesResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AddNodesResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_ADDNODESRESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_AddNodesResponse_encodeBinary(UA_AddNodesResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_ADDNODESRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_AddNodesResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AddNodesResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AddNodesResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_AddNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_AddNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_ADDNODESRESULT,(void**)&dst->results), UA_AddNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_AddNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_AddNodesResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AddNodesResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AddNodesResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AddNodesResponse)
UA_Int32 UA_AddNodesResponse_delete(UA_AddNodesResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AddNodesResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AddNodesResponse_deleteMembers(UA_AddNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_ADDNODESRESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_AddNodesResponse_init(UA_AddNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AddNodesResponse)
UA_Int32 UA_AddNodesResponse_copy(const UA_AddNodesResponse *src,UA_AddNodesResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AddNodesResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_ADDNODESRESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_AddReferencesItem_calcSizeBinary(UA_AddReferencesItem const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AddReferencesItem);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->sourceNodeId)
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + sizeof(UA_Boolean) // isForward
	 + UA_String_calcSizeBinary(&ptr->targetServerUri)
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->targetNodeId)
	 + sizeof(UA_NodeClass) // targetNodeClass
	;
}

UA_Int32 UA_AddReferencesItem_encodeBinary(UA_AddReferencesItem const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->sourceNodeId,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isForward,dst,offset);
	retval |= UA_String_encodeBinary(&src->targetServerUri,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->targetNodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->targetNodeClass,dst,offset);
	return retval;
}

UA_Int32 UA_AddReferencesItem_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AddReferencesItem * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AddReferencesItem_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->sourceNodeId), UA_AddReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_AddReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isForward), UA_AddReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->targetServerUri), UA_AddReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->targetNodeId), UA_AddReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->targetNodeClass), UA_AddReferencesItem_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AddReferencesItem)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AddReferencesItem)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AddReferencesItem)
UA_Int32 UA_AddReferencesItem_delete(UA_AddReferencesItem *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AddReferencesItem_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AddReferencesItem_deleteMembers(UA_AddReferencesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->sourceNodeId);
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	retval |= UA_String_deleteMembers(&p->targetServerUri);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->targetNodeId);
	return retval;
}

UA_Int32 UA_AddReferencesItem_init(UA_AddReferencesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->sourceNodeId);
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_Boolean_init(&p->isForward);
	retval |= UA_String_init(&p->targetServerUri);
	retval |= UA_ExpandedNodeId_init(&p->targetNodeId);
	retval |= UA_NodeClass_init(&p->targetNodeClass);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AddReferencesItem)
UA_Int32 UA_AddReferencesItem_copy(const UA_AddReferencesItem *src,UA_AddReferencesItem *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AddReferencesItem));
	retval |= UA_NodeId_copy(&src->sourceNodeId,&dst->sourceNodeId);
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	retval |= UA_String_copy(&src->targetServerUri,&dst->targetServerUri);
	retval |= UA_ExpandedNodeId_copy(&src->targetNodeId,&dst->targetNodeId);
	return retval;
}

UA_Int32 UA_AddReferencesRequest_calcSizeBinary(UA_AddReferencesRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AddReferencesRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->referencesToAddSize,UA_ADDREFERENCESITEM,ptr->referencesToAdd)
	;
}

UA_Int32 UA_AddReferencesRequest_encodeBinary(UA_AddReferencesRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesToAddSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->referencesToAdd,src->referencesToAddSize,UA_ADDREFERENCESITEM,dst,offset);
	return retval;
}

UA_Int32 UA_AddReferencesRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AddReferencesRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AddReferencesRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_AddReferencesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesToAddSize),UA_AddReferencesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesToAddSize,UA_ADDREFERENCESITEM,(void**)&dst->referencesToAdd), UA_AddReferencesRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AddReferencesRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AddReferencesRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AddReferencesRequest)
UA_Int32 UA_AddReferencesRequest_delete(UA_AddReferencesRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AddReferencesRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AddReferencesRequest_deleteMembers(UA_AddReferencesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->referencesToAdd,p->referencesToAddSize,UA_ADDREFERENCESITEM);
	return retval;
}

UA_Int32 UA_AddReferencesRequest_init(UA_AddReferencesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->referencesToAddSize = 0;
	p->referencesToAdd = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AddReferencesRequest)
UA_Int32 UA_AddReferencesRequest_copy(const UA_AddReferencesRequest *src,UA_AddReferencesRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AddReferencesRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->referencesToAdd = src->referencesToAdd;
	retval |= UA_Array_copy(&src->referencesToAdd, src->referencesToAddSize,UA_ADDREFERENCESITEM,(void**)&dst->referencesToAdd);
	return retval;
}

UA_Int32 UA_AddReferencesResponse_calcSizeBinary(UA_AddReferencesResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AddReferencesResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_AddReferencesResponse_encodeBinary(UA_AddReferencesResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_AddReferencesResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AddReferencesResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AddReferencesResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_AddReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_AddReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_AddReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_AddReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_AddReferencesResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AddReferencesResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AddReferencesResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AddReferencesResponse)
UA_Int32 UA_AddReferencesResponse_delete(UA_AddReferencesResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AddReferencesResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AddReferencesResponse_deleteMembers(UA_AddReferencesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_AddReferencesResponse_init(UA_AddReferencesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AddReferencesResponse)
UA_Int32 UA_AddReferencesResponse_copy(const UA_AddReferencesResponse *src,UA_AddReferencesResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AddReferencesResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_DeleteNodesItem_calcSizeBinary(UA_DeleteNodesItem const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteNodesItem);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_Boolean) // deleteTargetReferences
	;
}

UA_Int32 UA_DeleteNodesItem_encodeBinary(UA_DeleteNodesItem const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->deleteTargetReferences,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteNodesItem_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteNodesItem * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteNodesItem_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_DeleteNodesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->deleteTargetReferences), UA_DeleteNodesItem_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteNodesItem)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteNodesItem)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteNodesItem)
UA_Int32 UA_DeleteNodesItem_delete(UA_DeleteNodesItem *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteNodesItem_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteNodesItem_deleteMembers(UA_DeleteNodesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	return retval;
}

UA_Int32 UA_DeleteNodesItem_init(UA_DeleteNodesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_Boolean_init(&p->deleteTargetReferences);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteNodesItem)
UA_Int32 UA_DeleteNodesItem_copy(const UA_DeleteNodesItem *src,UA_DeleteNodesItem *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteNodesItem));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	return retval;
}

UA_Int32 UA_DeleteNodesRequest_calcSizeBinary(UA_DeleteNodesRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteNodesRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->nodesToDeleteSize,UA_DELETENODESITEM,ptr->nodesToDelete)
	;
}

UA_Int32 UA_DeleteNodesRequest_encodeBinary(UA_DeleteNodesRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToDeleteSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToDelete,src->nodesToDeleteSize,UA_DELETENODESITEM,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteNodesRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteNodesRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteNodesRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_DeleteNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToDeleteSize),UA_DeleteNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToDeleteSize,UA_DELETENODESITEM,(void**)&dst->nodesToDelete), UA_DeleteNodesRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteNodesRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteNodesRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteNodesRequest)
UA_Int32 UA_DeleteNodesRequest_delete(UA_DeleteNodesRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteNodesRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteNodesRequest_deleteMembers(UA_DeleteNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->nodesToDelete,p->nodesToDeleteSize,UA_DELETENODESITEM);
	return retval;
}

UA_Int32 UA_DeleteNodesRequest_init(UA_DeleteNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->nodesToDeleteSize = 0;
	p->nodesToDelete = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteNodesRequest)
UA_Int32 UA_DeleteNodesRequest_copy(const UA_DeleteNodesRequest *src,UA_DeleteNodesRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteNodesRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->nodesToDelete = src->nodesToDelete;
	retval |= UA_Array_copy(&src->nodesToDelete, src->nodesToDeleteSize,UA_DELETENODESITEM,(void**)&dst->nodesToDelete);
	return retval;
}

UA_Int32 UA_DeleteNodesResponse_calcSizeBinary(UA_DeleteNodesResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteNodesResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_DeleteNodesResponse_encodeBinary(UA_DeleteNodesResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteNodesResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteNodesResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteNodesResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_DeleteNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_DeleteNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_DeleteNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_DeleteNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_DeleteNodesResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteNodesResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteNodesResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteNodesResponse)
UA_Int32 UA_DeleteNodesResponse_delete(UA_DeleteNodesResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteNodesResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteNodesResponse_deleteMembers(UA_DeleteNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_DeleteNodesResponse_init(UA_DeleteNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteNodesResponse)
UA_Int32 UA_DeleteNodesResponse_copy(const UA_DeleteNodesResponse *src,UA_DeleteNodesResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteNodesResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_DeleteReferencesItem_calcSizeBinary(UA_DeleteReferencesItem const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteReferencesItem);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->sourceNodeId)
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + sizeof(UA_Boolean) // isForward
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->targetNodeId)
	 + sizeof(UA_Boolean) // deleteBidirectional
	;
}

UA_Int32 UA_DeleteReferencesItem_encodeBinary(UA_DeleteReferencesItem const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->sourceNodeId,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isForward,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->targetNodeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->deleteBidirectional,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteReferencesItem_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteReferencesItem * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteReferencesItem_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->sourceNodeId), UA_DeleteReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_DeleteReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isForward), UA_DeleteReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->targetNodeId), UA_DeleteReferencesItem_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->deleteBidirectional), UA_DeleteReferencesItem_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteReferencesItem)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteReferencesItem)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteReferencesItem)
UA_Int32 UA_DeleteReferencesItem_delete(UA_DeleteReferencesItem *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteReferencesItem_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteReferencesItem_deleteMembers(UA_DeleteReferencesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->sourceNodeId);
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->targetNodeId);
	return retval;
}

UA_Int32 UA_DeleteReferencesItem_init(UA_DeleteReferencesItem *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->sourceNodeId);
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_Boolean_init(&p->isForward);
	retval |= UA_ExpandedNodeId_init(&p->targetNodeId);
	retval |= UA_Boolean_init(&p->deleteBidirectional);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteReferencesItem)
UA_Int32 UA_DeleteReferencesItem_copy(const UA_DeleteReferencesItem *src,UA_DeleteReferencesItem *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteReferencesItem));
	retval |= UA_NodeId_copy(&src->sourceNodeId,&dst->sourceNodeId);
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	retval |= UA_ExpandedNodeId_copy(&src->targetNodeId,&dst->targetNodeId);
	return retval;
}

UA_Int32 UA_DeleteReferencesRequest_calcSizeBinary(UA_DeleteReferencesRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteReferencesRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->referencesToDeleteSize,UA_DELETEREFERENCESITEM,ptr->referencesToDelete)
	;
}

UA_Int32 UA_DeleteReferencesRequest_encodeBinary(UA_DeleteReferencesRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesToDeleteSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->referencesToDelete,src->referencesToDeleteSize,UA_DELETEREFERENCESITEM,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteReferencesRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteReferencesRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteReferencesRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_DeleteReferencesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesToDeleteSize),UA_DeleteReferencesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesToDeleteSize,UA_DELETEREFERENCESITEM,(void**)&dst->referencesToDelete), UA_DeleteReferencesRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteReferencesRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteReferencesRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteReferencesRequest)
UA_Int32 UA_DeleteReferencesRequest_delete(UA_DeleteReferencesRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteReferencesRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteReferencesRequest_deleteMembers(UA_DeleteReferencesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->referencesToDelete,p->referencesToDeleteSize,UA_DELETEREFERENCESITEM);
	return retval;
}

UA_Int32 UA_DeleteReferencesRequest_init(UA_DeleteReferencesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->referencesToDeleteSize = 0;
	p->referencesToDelete = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteReferencesRequest)
UA_Int32 UA_DeleteReferencesRequest_copy(const UA_DeleteReferencesRequest *src,UA_DeleteReferencesRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteReferencesRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->referencesToDelete = src->referencesToDelete;
	retval |= UA_Array_copy(&src->referencesToDelete, src->referencesToDeleteSize,UA_DELETEREFERENCESITEM,(void**)&dst->referencesToDelete);
	return retval;
}

UA_Int32 UA_DeleteReferencesResponse_calcSizeBinary(UA_DeleteReferencesResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteReferencesResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_DeleteReferencesResponse_encodeBinary(UA_DeleteReferencesResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteReferencesResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteReferencesResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteReferencesResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_DeleteReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_DeleteReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_DeleteReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_DeleteReferencesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_DeleteReferencesResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteReferencesResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteReferencesResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteReferencesResponse)
UA_Int32 UA_DeleteReferencesResponse_delete(UA_DeleteReferencesResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteReferencesResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteReferencesResponse_deleteMembers(UA_DeleteReferencesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_DeleteReferencesResponse_init(UA_DeleteReferencesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteReferencesResponse)
UA_Int32 UA_DeleteReferencesResponse_copy(const UA_DeleteReferencesResponse *src,UA_DeleteReferencesResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteReferencesResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_TYPE_AS(UA_AttributeWriteMask, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_AttributeWriteMask, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AttributeWriteMask)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AttributeWriteMask)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AttributeWriteMask
)
UA_TYPE_AS(UA_BrowseDirection, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_BrowseDirection, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseDirection)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseDirection)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseDirection
)
UA_Int32 UA_ViewDescription_calcSizeBinary(UA_ViewDescription const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ViewDescription);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->viewId)
	 + sizeof(UA_DateTime) // timestamp
	 + sizeof(UA_UInt32) // viewVersion
	;
}

UA_Int32 UA_ViewDescription_encodeBinary(UA_ViewDescription const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->viewId,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->timestamp,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->viewVersion,dst,offset);
	return retval;
}

UA_Int32 UA_ViewDescription_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ViewDescription * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ViewDescription_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->viewId), UA_ViewDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->timestamp), UA_ViewDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->viewVersion), UA_ViewDescription_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ViewDescription)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ViewDescription)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ViewDescription)
UA_Int32 UA_ViewDescription_delete(UA_ViewDescription *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ViewDescription_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ViewDescription_deleteMembers(UA_ViewDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->viewId);
	return retval;
}

UA_Int32 UA_ViewDescription_init(UA_ViewDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->viewId);
	retval |= UA_DateTime_init(&p->timestamp);
	retval |= UA_UInt32_init(&p->viewVersion);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ViewDescription)
UA_Int32 UA_ViewDescription_copy(const UA_ViewDescription *src,UA_ViewDescription *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ViewDescription));
	retval |= UA_NodeId_copy(&src->viewId,&dst->viewId);
	return retval;
}

UA_Int32 UA_BrowseDescription_calcSizeBinary(UA_BrowseDescription const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowseDescription);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_BrowseDirection) // browseDirection
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + sizeof(UA_Boolean) // includeSubtypes
	 + sizeof(UA_UInt32) // nodeClassMask
	 + sizeof(UA_UInt32) // resultMask
	;
}

UA_Int32 UA_BrowseDescription_encodeBinary(UA_BrowseDescription const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_BrowseDirection_encodeBinary(&src->browseDirection,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->includeSubtypes,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->nodeClassMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->resultMask,dst,offset);
	return retval;
}

UA_Int32 UA_BrowseDescription_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowseDescription * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowseDescription_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_BrowseDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_BrowseDirection_decodeBinary(src,offset,&dst->browseDirection), UA_BrowseDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_BrowseDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->includeSubtypes), UA_BrowseDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->nodeClassMask), UA_BrowseDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->resultMask), UA_BrowseDescription_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseDescription)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseDescription)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseDescription)
UA_Int32 UA_BrowseDescription_delete(UA_BrowseDescription *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowseDescription_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowseDescription_deleteMembers(UA_BrowseDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	return retval;
}

UA_Int32 UA_BrowseDescription_init(UA_BrowseDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_BrowseDirection_init(&p->browseDirection);
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_Boolean_init(&p->includeSubtypes);
	retval |= UA_UInt32_init(&p->nodeClassMask);
	retval |= UA_UInt32_init(&p->resultMask);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowseDescription)
UA_Int32 UA_BrowseDescription_copy(const UA_BrowseDescription *src,UA_BrowseDescription *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowseDescription));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	return retval;
}

UA_TYPE_AS(UA_BrowseResultMask, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_BrowseResultMask, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseResultMask)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseResultMask)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseResultMask
)
UA_Int32 UA_ReferenceDescription_calcSizeBinary(UA_ReferenceDescription const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReferenceDescription);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + sizeof(UA_Boolean) // isForward
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->typeDefinition)
	;
}

UA_Int32 UA_ReferenceDescription_encodeBinary(UA_ReferenceDescription const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isForward,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->typeDefinition,dst,offset);
	return retval;
}

UA_Int32 UA_ReferenceDescription_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReferenceDescription * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReferenceDescription_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_ReferenceDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isForward), UA_ReferenceDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->nodeId), UA_ReferenceDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_ReferenceDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ReferenceDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_ReferenceDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->typeDefinition), UA_ReferenceDescription_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReferenceDescription)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReferenceDescription)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReferenceDescription)
UA_Int32 UA_ReferenceDescription_delete(UA_ReferenceDescription *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReferenceDescription_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReferenceDescription_deleteMembers(UA_ReferenceDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->typeDefinition);
	return retval;
}

UA_Int32 UA_ReferenceDescription_init(UA_ReferenceDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_Boolean_init(&p->isForward);
	retval |= UA_ExpandedNodeId_init(&p->nodeId);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_ExpandedNodeId_init(&p->typeDefinition);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReferenceDescription)
UA_Int32 UA_ReferenceDescription_copy(const UA_ReferenceDescription *src,UA_ReferenceDescription *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReferenceDescription));
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	retval |= UA_ExpandedNodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_ExpandedNodeId_copy(&src->typeDefinition,&dst->typeDefinition);
	return retval;
}

UA_TYPE_AS(UA_ContinuationPoint, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_ContinuationPoint, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ContinuationPoint)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ContinuationPoint)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ContinuationPoint)

UA_Int32 UA_BrowseResult_calcSizeBinary(UA_BrowseResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowseResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_ByteString_calcSizeBinary(&ptr->continuationPoint)
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCEDESCRIPTION,ptr->references)
	;
}

UA_Int32 UA_BrowseResult_encodeBinary(UA_BrowseResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->continuationPoint,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCEDESCRIPTION,dst,offset);
	return retval;
}

UA_Int32 UA_BrowseResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowseResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowseResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_BrowseResult_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->continuationPoint), UA_BrowseResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_BrowseResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCEDESCRIPTION,(void**)&dst->references), UA_BrowseResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseResult)
UA_Int32 UA_BrowseResult_delete(UA_BrowseResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowseResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowseResult_deleteMembers(UA_BrowseResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ByteString_deleteMembers(&p->continuationPoint);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCEDESCRIPTION);
	return retval;
}

UA_Int32 UA_BrowseResult_init(UA_BrowseResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_ByteString_init(&p->continuationPoint);
	p->referencesSize = 0;
	p->references = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowseResult)
UA_Int32 UA_BrowseResult_copy(const UA_BrowseResult *src,UA_BrowseResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowseResult));
	retval |= UA_ByteString_copy(&src->continuationPoint,&dst->continuationPoint);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCEDESCRIPTION,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_BrowseRequest_calcSizeBinary(UA_BrowseRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowseRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_ViewDescription_calcSizeBinary(&ptr->view)
	 + sizeof(UA_UInt32) // requestedMaxReferencesPerNode
	 + UA_Array_calcSizeBinary(ptr->nodesToBrowseSize,UA_BROWSEDESCRIPTION,ptr->nodesToBrowse)
	;
}

UA_Int32 UA_BrowseRequest_encodeBinary(UA_BrowseRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_ViewDescription_encodeBinary(&src->view,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestedMaxReferencesPerNode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToBrowseSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToBrowse,src->nodesToBrowseSize,UA_BROWSEDESCRIPTION,dst,offset);
	return retval;
}

UA_Int32 UA_BrowseRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowseRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowseRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_BrowseRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ViewDescription_decodeBinary(src,offset,&dst->view), UA_BrowseRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestedMaxReferencesPerNode), UA_BrowseRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToBrowseSize),UA_BrowseRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToBrowseSize,UA_BROWSEDESCRIPTION,(void**)&dst->nodesToBrowse), UA_BrowseRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseRequest)
UA_Int32 UA_BrowseRequest_delete(UA_BrowseRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowseRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowseRequest_deleteMembers(UA_BrowseRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_ViewDescription_deleteMembers(&p->view);
	retval |= UA_Array_delete((void**)&p->nodesToBrowse,p->nodesToBrowseSize,UA_BROWSEDESCRIPTION);
	return retval;
}

UA_Int32 UA_BrowseRequest_init(UA_BrowseRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_ViewDescription_init(&p->view);
	retval |= UA_UInt32_init(&p->requestedMaxReferencesPerNode);
	p->nodesToBrowseSize = 0;
	p->nodesToBrowse = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowseRequest)
UA_Int32 UA_BrowseRequest_copy(const UA_BrowseRequest *src,UA_BrowseRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowseRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_ViewDescription_copy(&src->view,&dst->view);
	dst->nodesToBrowse = src->nodesToBrowse;
	retval |= UA_Array_copy(&src->nodesToBrowse, src->nodesToBrowseSize,UA_BROWSEDESCRIPTION,(void**)&dst->nodesToBrowse);
	return retval;
}

UA_Int32 UA_BrowseResponse_calcSizeBinary(UA_BrowseResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowseResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_BROWSERESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_BrowseResponse_encodeBinary(UA_BrowseResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_BROWSERESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_BrowseResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowseResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowseResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_BrowseResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_BrowseResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_BROWSERESULT,(void**)&dst->results), UA_BrowseResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_BrowseResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_BrowseResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseResponse)
UA_Int32 UA_BrowseResponse_delete(UA_BrowseResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowseResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowseResponse_deleteMembers(UA_BrowseResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_BROWSERESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_BrowseResponse_init(UA_BrowseResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowseResponse)
UA_Int32 UA_BrowseResponse_copy(const UA_BrowseResponse *src,UA_BrowseResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowseResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_BROWSERESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_BrowseNextRequest_calcSizeBinary(UA_BrowseNextRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowseNextRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_Boolean) // releaseContinuationPoints
	 + UA_Array_calcSizeBinary(ptr->continuationPointsSize,UA_BYTESTRING,ptr->continuationPoints)
	;
}

UA_Int32 UA_BrowseNextRequest_encodeBinary(UA_BrowseNextRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->releaseContinuationPoints,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->continuationPointsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->continuationPoints,src->continuationPointsSize,UA_BYTESTRING,dst,offset);
	return retval;
}

UA_Int32 UA_BrowseNextRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowseNextRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowseNextRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_BrowseNextRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->releaseContinuationPoints), UA_BrowseNextRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->continuationPointsSize),UA_BrowseNextRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->continuationPointsSize,UA_BYTESTRING,(void**)&dst->continuationPoints), UA_BrowseNextRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseNextRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseNextRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseNextRequest)
UA_Int32 UA_BrowseNextRequest_delete(UA_BrowseNextRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowseNextRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowseNextRequest_deleteMembers(UA_BrowseNextRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->continuationPoints,p->continuationPointsSize,UA_BYTESTRING);
	return retval;
}

UA_Int32 UA_BrowseNextRequest_init(UA_BrowseNextRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_Boolean_init(&p->releaseContinuationPoints);
	p->continuationPointsSize = 0;
	p->continuationPoints = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowseNextRequest)
UA_Int32 UA_BrowseNextRequest_copy(const UA_BrowseNextRequest *src,UA_BrowseNextRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowseNextRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->continuationPoints = src->continuationPoints;
	retval |= UA_Array_copy(&src->continuationPoints, src->continuationPointsSize,UA_BYTESTRING,(void**)&dst->continuationPoints);
	return retval;
}

UA_Int32 UA_BrowseNextResponse_calcSizeBinary(UA_BrowseNextResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowseNextResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_BROWSERESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_BrowseNextResponse_encodeBinary(UA_BrowseNextResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_BROWSERESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_BrowseNextResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowseNextResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowseNextResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_BrowseNextResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_BrowseNextResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_BROWSERESULT,(void**)&dst->results), UA_BrowseNextResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_BrowseNextResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_BrowseNextResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowseNextResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowseNextResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowseNextResponse)
UA_Int32 UA_BrowseNextResponse_delete(UA_BrowseNextResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowseNextResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowseNextResponse_deleteMembers(UA_BrowseNextResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_BROWSERESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_BrowseNextResponse_init(UA_BrowseNextResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowseNextResponse)
UA_Int32 UA_BrowseNextResponse_copy(const UA_BrowseNextResponse *src,UA_BrowseNextResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowseNextResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_BROWSERESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_RelativePathElement_calcSizeBinary(UA_RelativePathElement const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RelativePathElement);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + sizeof(UA_Boolean) // isInverse
	 + sizeof(UA_Boolean) // includeSubtypes
	 + UA_QualifiedName_calcSizeBinary(&ptr->targetName)
	;
}

UA_Int32 UA_RelativePathElement_encodeBinary(UA_RelativePathElement const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isInverse,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->includeSubtypes,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->targetName,dst,offset);
	return retval;
}

UA_Int32 UA_RelativePathElement_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RelativePathElement * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RelativePathElement_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_RelativePathElement_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isInverse), UA_RelativePathElement_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->includeSubtypes), UA_RelativePathElement_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->targetName), UA_RelativePathElement_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RelativePathElement)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RelativePathElement)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RelativePathElement)
UA_Int32 UA_RelativePathElement_delete(UA_RelativePathElement *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RelativePathElement_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RelativePathElement_deleteMembers(UA_RelativePathElement *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	retval |= UA_QualifiedName_deleteMembers(&p->targetName);
	return retval;
}

UA_Int32 UA_RelativePathElement_init(UA_RelativePathElement *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_Boolean_init(&p->isInverse);
	retval |= UA_Boolean_init(&p->includeSubtypes);
	retval |= UA_QualifiedName_init(&p->targetName);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RelativePathElement)
UA_Int32 UA_RelativePathElement_copy(const UA_RelativePathElement *src,UA_RelativePathElement *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RelativePathElement));
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	retval |= UA_QualifiedName_copy(&src->targetName,&dst->targetName);
	return retval;
}

UA_Int32 UA_RelativePath_calcSizeBinary(UA_RelativePath const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RelativePath);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->elementsSize,UA_RELATIVEPATHELEMENT,ptr->elements)
	;
}

UA_Int32 UA_RelativePath_encodeBinary(UA_RelativePath const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->elementsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->elements,src->elementsSize,UA_RELATIVEPATHELEMENT,dst,offset);
	return retval;
}

UA_Int32 UA_RelativePath_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RelativePath * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RelativePath_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->elementsSize),UA_RelativePath_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->elementsSize,UA_RELATIVEPATHELEMENT,(void**)&dst->elements), UA_RelativePath_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RelativePath)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RelativePath)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RelativePath)
UA_Int32 UA_RelativePath_delete(UA_RelativePath *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RelativePath_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RelativePath_deleteMembers(UA_RelativePath *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->elements,p->elementsSize,UA_RELATIVEPATHELEMENT);
	return retval;
}

UA_Int32 UA_RelativePath_init(UA_RelativePath *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->elementsSize = 0;
	p->elements = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RelativePath)
UA_Int32 UA_RelativePath_copy(const UA_RelativePath *src,UA_RelativePath *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RelativePath));
	dst->elements = src->elements;
	retval |= UA_Array_copy(&src->elements, src->elementsSize,UA_RELATIVEPATHELEMENT,(void**)&dst->elements);
	return retval;
}

UA_Int32 UA_BrowsePath_calcSizeBinary(UA_BrowsePath const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowsePath);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->startingNode)
	 + UA_RelativePath_calcSizeBinary(&ptr->relativePath)
	;
}

UA_Int32 UA_BrowsePath_encodeBinary(UA_BrowsePath const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->startingNode,dst,offset);
	retval |= UA_RelativePath_encodeBinary(&src->relativePath,dst,offset);
	return retval;
}

UA_Int32 UA_BrowsePath_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowsePath * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowsePath_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->startingNode), UA_BrowsePath_deleteMembers(dst));
	CHECKED_DECODE(UA_RelativePath_decodeBinary(src,offset,&dst->relativePath), UA_BrowsePath_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowsePath)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowsePath)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowsePath)
UA_Int32 UA_BrowsePath_delete(UA_BrowsePath *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowsePath_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowsePath_deleteMembers(UA_BrowsePath *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->startingNode);
	retval |= UA_RelativePath_deleteMembers(&p->relativePath);
	return retval;
}

UA_Int32 UA_BrowsePath_init(UA_BrowsePath *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->startingNode);
	retval |= UA_RelativePath_init(&p->relativePath);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowsePath)
UA_Int32 UA_BrowsePath_copy(const UA_BrowsePath *src,UA_BrowsePath *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowsePath));
	retval |= UA_NodeId_copy(&src->startingNode,&dst->startingNode);
	retval |= UA_RelativePath_copy(&src->relativePath,&dst->relativePath);
	return retval;
}

UA_Int32 UA_BrowsePathTarget_calcSizeBinary(UA_BrowsePathTarget const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowsePathTarget);
    	return 0
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->targetId)
	 + sizeof(UA_UInt32) // remainingPathIndex
	;
}

UA_Int32 UA_BrowsePathTarget_encodeBinary(UA_BrowsePathTarget const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_encodeBinary(&src->targetId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->remainingPathIndex,dst,offset);
	return retval;
}

UA_Int32 UA_BrowsePathTarget_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowsePathTarget * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowsePathTarget_init(dst);
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->targetId), UA_BrowsePathTarget_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->remainingPathIndex), UA_BrowsePathTarget_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowsePathTarget)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowsePathTarget)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowsePathTarget)
UA_Int32 UA_BrowsePathTarget_delete(UA_BrowsePathTarget *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowsePathTarget_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowsePathTarget_deleteMembers(UA_BrowsePathTarget *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_deleteMembers(&p->targetId);
	return retval;
}

UA_Int32 UA_BrowsePathTarget_init(UA_BrowsePathTarget *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_init(&p->targetId);
	retval |= UA_UInt32_init(&p->remainingPathIndex);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowsePathTarget)
UA_Int32 UA_BrowsePathTarget_copy(const UA_BrowsePathTarget *src,UA_BrowsePathTarget *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowsePathTarget));
	retval |= UA_ExpandedNodeId_copy(&src->targetId,&dst->targetId);
	return retval;
}

UA_Int32 UA_BrowsePathResult_calcSizeBinary(UA_BrowsePathResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BrowsePathResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_Array_calcSizeBinary(ptr->targetsSize,UA_BROWSEPATHTARGET,ptr->targets)
	;
}

UA_Int32 UA_BrowsePathResult_encodeBinary(UA_BrowsePathResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->targetsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->targets,src->targetsSize,UA_BROWSEPATHTARGET,dst,offset);
	return retval;
}

UA_Int32 UA_BrowsePathResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BrowsePathResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BrowsePathResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_BrowsePathResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->targetsSize),UA_BrowsePathResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->targetsSize,UA_BROWSEPATHTARGET,(void**)&dst->targets), UA_BrowsePathResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BrowsePathResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BrowsePathResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BrowsePathResult)
UA_Int32 UA_BrowsePathResult_delete(UA_BrowsePathResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BrowsePathResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BrowsePathResult_deleteMembers(UA_BrowsePathResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->targets,p->targetsSize,UA_BROWSEPATHTARGET);
	return retval;
}

UA_Int32 UA_BrowsePathResult_init(UA_BrowsePathResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	p->targetsSize = 0;
	p->targets = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BrowsePathResult)
UA_Int32 UA_BrowsePathResult_copy(const UA_BrowsePathResult *src,UA_BrowsePathResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BrowsePathResult));
	dst->targets = src->targets;
	retval |= UA_Array_copy(&src->targets, src->targetsSize,UA_BROWSEPATHTARGET,(void**)&dst->targets);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsRequest_calcSizeBinary(UA_TranslateBrowsePathsToNodeIdsRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TranslateBrowsePathsToNodeIdsRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->browsePathsSize,UA_BROWSEPATH,ptr->browsePaths)
	;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsRequest_encodeBinary(UA_TranslateBrowsePathsToNodeIdsRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->browsePathsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->browsePaths,src->browsePathsSize,UA_BROWSEPATH,dst,offset);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TranslateBrowsePathsToNodeIdsRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TranslateBrowsePathsToNodeIdsRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_TranslateBrowsePathsToNodeIdsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->browsePathsSize),UA_TranslateBrowsePathsToNodeIdsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->browsePathsSize,UA_BROWSEPATH,(void**)&dst->browsePaths), UA_TranslateBrowsePathsToNodeIdsRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TranslateBrowsePathsToNodeIdsRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TranslateBrowsePathsToNodeIdsRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TranslateBrowsePathsToNodeIdsRequest)
UA_Int32 UA_TranslateBrowsePathsToNodeIdsRequest_delete(UA_TranslateBrowsePathsToNodeIdsRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TranslateBrowsePathsToNodeIdsRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsRequest_deleteMembers(UA_TranslateBrowsePathsToNodeIdsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->browsePaths,p->browsePathsSize,UA_BROWSEPATH);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsRequest_init(UA_TranslateBrowsePathsToNodeIdsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->browsePathsSize = 0;
	p->browsePaths = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TranslateBrowsePathsToNodeIdsRequest)
UA_Int32 UA_TranslateBrowsePathsToNodeIdsRequest_copy(const UA_TranslateBrowsePathsToNodeIdsRequest *src,UA_TranslateBrowsePathsToNodeIdsRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TranslateBrowsePathsToNodeIdsRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->browsePaths = src->browsePaths;
	retval |= UA_Array_copy(&src->browsePaths, src->browsePathsSize,UA_BROWSEPATH,(void**)&dst->browsePaths);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsResponse_calcSizeBinary(UA_TranslateBrowsePathsToNodeIdsResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TranslateBrowsePathsToNodeIdsResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_BROWSEPATHRESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsResponse_encodeBinary(UA_TranslateBrowsePathsToNodeIdsResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_BROWSEPATHRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TranslateBrowsePathsToNodeIdsResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TranslateBrowsePathsToNodeIdsResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_TranslateBrowsePathsToNodeIdsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_TranslateBrowsePathsToNodeIdsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_BROWSEPATHRESULT,(void**)&dst->results), UA_TranslateBrowsePathsToNodeIdsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_TranslateBrowsePathsToNodeIdsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_TranslateBrowsePathsToNodeIdsResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TranslateBrowsePathsToNodeIdsResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TranslateBrowsePathsToNodeIdsResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TranslateBrowsePathsToNodeIdsResponse)
UA_Int32 UA_TranslateBrowsePathsToNodeIdsResponse_delete(UA_TranslateBrowsePathsToNodeIdsResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TranslateBrowsePathsToNodeIdsResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsResponse_deleteMembers(UA_TranslateBrowsePathsToNodeIdsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_BROWSEPATHRESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_TranslateBrowsePathsToNodeIdsResponse_init(UA_TranslateBrowsePathsToNodeIdsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TranslateBrowsePathsToNodeIdsResponse)
UA_Int32 UA_TranslateBrowsePathsToNodeIdsResponse_copy(const UA_TranslateBrowsePathsToNodeIdsResponse *src,UA_TranslateBrowsePathsToNodeIdsResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TranslateBrowsePathsToNodeIdsResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_BROWSEPATHRESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_RegisterNodesRequest_calcSizeBinary(UA_RegisterNodesRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RegisterNodesRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->nodesToRegisterSize,UA_NODEID,ptr->nodesToRegister)
	;
}

UA_Int32 UA_RegisterNodesRequest_encodeBinary(UA_RegisterNodesRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToRegisterSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToRegister,src->nodesToRegisterSize,UA_NODEID,dst,offset);
	return retval;
}

UA_Int32 UA_RegisterNodesRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RegisterNodesRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RegisterNodesRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_RegisterNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToRegisterSize),UA_RegisterNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToRegisterSize,UA_NODEID,(void**)&dst->nodesToRegister), UA_RegisterNodesRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RegisterNodesRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RegisterNodesRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RegisterNodesRequest)
UA_Int32 UA_RegisterNodesRequest_delete(UA_RegisterNodesRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RegisterNodesRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RegisterNodesRequest_deleteMembers(UA_RegisterNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->nodesToRegister,p->nodesToRegisterSize,UA_NODEID);
	return retval;
}

UA_Int32 UA_RegisterNodesRequest_init(UA_RegisterNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->nodesToRegisterSize = 0;
	p->nodesToRegister = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RegisterNodesRequest)
UA_Int32 UA_RegisterNodesRequest_copy(const UA_RegisterNodesRequest *src,UA_RegisterNodesRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RegisterNodesRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->nodesToRegister = src->nodesToRegister;
	retval |= UA_Array_copy(&src->nodesToRegister, src->nodesToRegisterSize,UA_NODEID,(void**)&dst->nodesToRegister);
	return retval;
}

UA_Int32 UA_RegisterNodesResponse_calcSizeBinary(UA_RegisterNodesResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RegisterNodesResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->registeredNodeIdsSize,UA_NODEID,ptr->registeredNodeIds)
	;
}

UA_Int32 UA_RegisterNodesResponse_encodeBinary(UA_RegisterNodesResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->registeredNodeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->registeredNodeIds,src->registeredNodeIdsSize,UA_NODEID,dst,offset);
	return retval;
}

UA_Int32 UA_RegisterNodesResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RegisterNodesResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RegisterNodesResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_RegisterNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->registeredNodeIdsSize),UA_RegisterNodesResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->registeredNodeIdsSize,UA_NODEID,(void**)&dst->registeredNodeIds), UA_RegisterNodesResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RegisterNodesResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RegisterNodesResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RegisterNodesResponse)
UA_Int32 UA_RegisterNodesResponse_delete(UA_RegisterNodesResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RegisterNodesResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RegisterNodesResponse_deleteMembers(UA_RegisterNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->registeredNodeIds,p->registeredNodeIdsSize,UA_NODEID);
	return retval;
}

UA_Int32 UA_RegisterNodesResponse_init(UA_RegisterNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->registeredNodeIdsSize = 0;
	p->registeredNodeIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RegisterNodesResponse)
UA_Int32 UA_RegisterNodesResponse_copy(const UA_RegisterNodesResponse *src,UA_RegisterNodesResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RegisterNodesResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->registeredNodeIds = src->registeredNodeIds;
	retval |= UA_Array_copy(&src->registeredNodeIds, src->registeredNodeIdsSize,UA_NODEID,(void**)&dst->registeredNodeIds);
	return retval;
}

UA_Int32 UA_UnregisterNodesRequest_calcSizeBinary(UA_UnregisterNodesRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UnregisterNodesRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->nodesToUnregisterSize,UA_NODEID,ptr->nodesToUnregister)
	;
}

UA_Int32 UA_UnregisterNodesRequest_encodeBinary(UA_UnregisterNodesRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToUnregisterSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToUnregister,src->nodesToUnregisterSize,UA_NODEID,dst,offset);
	return retval;
}

UA_Int32 UA_UnregisterNodesRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UnregisterNodesRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UnregisterNodesRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_UnregisterNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToUnregisterSize),UA_UnregisterNodesRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToUnregisterSize,UA_NODEID,(void**)&dst->nodesToUnregister), UA_UnregisterNodesRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UnregisterNodesRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UnregisterNodesRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UnregisterNodesRequest)
UA_Int32 UA_UnregisterNodesRequest_delete(UA_UnregisterNodesRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UnregisterNodesRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UnregisterNodesRequest_deleteMembers(UA_UnregisterNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->nodesToUnregister,p->nodesToUnregisterSize,UA_NODEID);
	return retval;
}

UA_Int32 UA_UnregisterNodesRequest_init(UA_UnregisterNodesRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->nodesToUnregisterSize = 0;
	p->nodesToUnregister = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UnregisterNodesRequest)
UA_Int32 UA_UnregisterNodesRequest_copy(const UA_UnregisterNodesRequest *src,UA_UnregisterNodesRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UnregisterNodesRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->nodesToUnregister = src->nodesToUnregister;
	retval |= UA_Array_copy(&src->nodesToUnregister, src->nodesToUnregisterSize,UA_NODEID,(void**)&dst->nodesToUnregister);
	return retval;
}

UA_Int32 UA_UnregisterNodesResponse_calcSizeBinary(UA_UnregisterNodesResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UnregisterNodesResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	;
}

UA_Int32 UA_UnregisterNodesResponse_encodeBinary(UA_UnregisterNodesResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	return retval;
}

UA_Int32 UA_UnregisterNodesResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UnregisterNodesResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UnregisterNodesResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_UnregisterNodesResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UnregisterNodesResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UnregisterNodesResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UnregisterNodesResponse)
UA_Int32 UA_UnregisterNodesResponse_delete(UA_UnregisterNodesResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UnregisterNodesResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UnregisterNodesResponse_deleteMembers(UA_UnregisterNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_UnregisterNodesResponse_init(UA_UnregisterNodesResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UnregisterNodesResponse)
UA_Int32 UA_UnregisterNodesResponse_copy(const UA_UnregisterNodesResponse *src,UA_UnregisterNodesResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UnregisterNodesResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_TYPE_AS(UA_Counter, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_Counter, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Counter)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Counter)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Counter)

UA_TYPE_AS(UA_NumericRange, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_NumericRange, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NumericRange)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NumericRange)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NumericRange)

UA_TYPE_AS(UA_Time, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_Time, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Time)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Time)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Time)

UA_TYPE_AS(UA_Date, UA_ByteString)
UA_TYPE_BINARY_ENCODING_AS(UA_Date, UA_ByteString)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Date)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Date)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Date)

UA_Int32 UA_EndpointConfiguration_calcSizeBinary(UA_EndpointConfiguration const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EndpointConfiguration);
    	return 0
	 + sizeof(UA_Int32) // operationTimeout
	 + sizeof(UA_Boolean) // useBinaryEncoding
	 + sizeof(UA_Int32) // maxStringLength
	 + sizeof(UA_Int32) // maxByteStringLength
	 + sizeof(UA_Int32) // maxArrayLength
	 + sizeof(UA_Int32) // maxMessageSize
	 + sizeof(UA_Int32) // maxBufferSize
	 + sizeof(UA_Int32) // channelLifetime
	 + sizeof(UA_Int32) // securityTokenLifetime
	;
}

UA_Int32 UA_EndpointConfiguration_encodeBinary(UA_EndpointConfiguration const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->operationTimeout,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->useBinaryEncoding,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->maxStringLength,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->maxByteStringLength,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->maxArrayLength,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->maxMessageSize,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->maxBufferSize,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->channelLifetime,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->securityTokenLifetime,dst,offset);
	return retval;
}

UA_Int32 UA_EndpointConfiguration_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EndpointConfiguration * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EndpointConfiguration_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->operationTimeout), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->useBinaryEncoding), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->maxStringLength), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->maxByteStringLength), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->maxArrayLength), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->maxMessageSize), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->maxBufferSize), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->channelLifetime), UA_EndpointConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->securityTokenLifetime), UA_EndpointConfiguration_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EndpointConfiguration)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EndpointConfiguration)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EndpointConfiguration)
UA_Int32 UA_EndpointConfiguration_delete(UA_EndpointConfiguration *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EndpointConfiguration_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EndpointConfiguration_deleteMembers(UA_EndpointConfiguration *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_EndpointConfiguration_init(UA_EndpointConfiguration *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_init(&p->operationTimeout);
	retval |= UA_Boolean_init(&p->useBinaryEncoding);
	retval |= UA_Int32_init(&p->maxStringLength);
	retval |= UA_Int32_init(&p->maxByteStringLength);
	retval |= UA_Int32_init(&p->maxArrayLength);
	retval |= UA_Int32_init(&p->maxMessageSize);
	retval |= UA_Int32_init(&p->maxBufferSize);
	retval |= UA_Int32_init(&p->channelLifetime);
	retval |= UA_Int32_init(&p->securityTokenLifetime);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EndpointConfiguration)
UA_Int32 UA_EndpointConfiguration_copy(const UA_EndpointConfiguration *src,UA_EndpointConfiguration *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EndpointConfiguration));
	return retval;
}

UA_TYPE_AS(UA_ComplianceLevel, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_ComplianceLevel, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ComplianceLevel)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ComplianceLevel)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ComplianceLevel
)
UA_Int32 UA_SupportedProfile_calcSizeBinary(UA_SupportedProfile const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SupportedProfile);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->organizationUri)
	 + UA_String_calcSizeBinary(&ptr->profileId)
	 + UA_String_calcSizeBinary(&ptr->complianceTool)
	 + sizeof(UA_DateTime) // complianceDate
	 + sizeof(UA_ComplianceLevel) // complianceLevel
	 + UA_Array_calcSizeBinary(ptr->unsupportedUnitIdsSize,UA_STRING,ptr->unsupportedUnitIds)
	;
}

UA_Int32 UA_SupportedProfile_encodeBinary(UA_SupportedProfile const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->organizationUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->profileId,dst,offset);
	retval |= UA_String_encodeBinary(&src->complianceTool,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->complianceDate,dst,offset);
	retval |= UA_ComplianceLevel_encodeBinary(&src->complianceLevel,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->unsupportedUnitIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->unsupportedUnitIds,src->unsupportedUnitIdsSize,UA_STRING,dst,offset);
	return retval;
}

UA_Int32 UA_SupportedProfile_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SupportedProfile * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SupportedProfile_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->organizationUri), UA_SupportedProfile_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->profileId), UA_SupportedProfile_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->complianceTool), UA_SupportedProfile_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->complianceDate), UA_SupportedProfile_deleteMembers(dst));
	CHECKED_DECODE(UA_ComplianceLevel_decodeBinary(src,offset,&dst->complianceLevel), UA_SupportedProfile_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->unsupportedUnitIdsSize),UA_SupportedProfile_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->unsupportedUnitIdsSize,UA_STRING,(void**)&dst->unsupportedUnitIds), UA_SupportedProfile_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SupportedProfile)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SupportedProfile)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SupportedProfile)
UA_Int32 UA_SupportedProfile_delete(UA_SupportedProfile *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SupportedProfile_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SupportedProfile_deleteMembers(UA_SupportedProfile *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->organizationUri);
	retval |= UA_String_deleteMembers(&p->profileId);
	retval |= UA_String_deleteMembers(&p->complianceTool);
	retval |= UA_Array_delete((void**)&p->unsupportedUnitIds,p->unsupportedUnitIdsSize,UA_STRING);
	return retval;
}

UA_Int32 UA_SupportedProfile_init(UA_SupportedProfile *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->organizationUri);
	retval |= UA_String_init(&p->profileId);
	retval |= UA_String_init(&p->complianceTool);
	retval |= UA_DateTime_init(&p->complianceDate);
	retval |= UA_ComplianceLevel_init(&p->complianceLevel);
	p->unsupportedUnitIdsSize = 0;
	p->unsupportedUnitIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SupportedProfile)
UA_Int32 UA_SupportedProfile_copy(const UA_SupportedProfile *src,UA_SupportedProfile *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SupportedProfile));
	retval |= UA_String_copy(&src->organizationUri,&dst->organizationUri);
	retval |= UA_String_copy(&src->profileId,&dst->profileId);
	retval |= UA_String_copy(&src->complianceTool,&dst->complianceTool);
	dst->unsupportedUnitIds = src->unsupportedUnitIds;
	retval |= UA_Array_copy(&src->unsupportedUnitIds, src->unsupportedUnitIdsSize,UA_STRING,(void**)&dst->unsupportedUnitIds);
	return retval;
}

UA_Int32 UA_SoftwareCertificate_calcSizeBinary(UA_SoftwareCertificate const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SoftwareCertificate);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->productName)
	 + UA_String_calcSizeBinary(&ptr->productUri)
	 + UA_String_calcSizeBinary(&ptr->vendorName)
	 + UA_ByteString_calcSizeBinary(&ptr->vendorProductCertificate)
	 + UA_String_calcSizeBinary(&ptr->softwareVersion)
	 + UA_String_calcSizeBinary(&ptr->buildNumber)
	 + sizeof(UA_DateTime) // buildDate
	 + UA_String_calcSizeBinary(&ptr->issuedBy)
	 + sizeof(UA_DateTime) // issueDate
	 + UA_Array_calcSizeBinary(ptr->supportedProfilesSize,UA_SUPPORTEDPROFILE,ptr->supportedProfiles)
	;
}

UA_Int32 UA_SoftwareCertificate_encodeBinary(UA_SoftwareCertificate const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->productName,dst,offset);
	retval |= UA_String_encodeBinary(&src->productUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->vendorName,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->vendorProductCertificate,dst,offset);
	retval |= UA_String_encodeBinary(&src->softwareVersion,dst,offset);
	retval |= UA_String_encodeBinary(&src->buildNumber,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->buildDate,dst,offset);
	retval |= UA_String_encodeBinary(&src->issuedBy,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->issueDate,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->supportedProfilesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->supportedProfiles,src->supportedProfilesSize,UA_SUPPORTEDPROFILE,dst,offset);
	return retval;
}

UA_Int32 UA_SoftwareCertificate_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SoftwareCertificate * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SoftwareCertificate_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->productName), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->productUri), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->vendorName), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->vendorProductCertificate), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->softwareVersion), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->buildNumber), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->buildDate), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->issuedBy), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->issueDate), UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->supportedProfilesSize),UA_SoftwareCertificate_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->supportedProfilesSize,UA_SUPPORTEDPROFILE,(void**)&dst->supportedProfiles), UA_SoftwareCertificate_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SoftwareCertificate)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SoftwareCertificate)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SoftwareCertificate)
UA_Int32 UA_SoftwareCertificate_delete(UA_SoftwareCertificate *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SoftwareCertificate_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SoftwareCertificate_deleteMembers(UA_SoftwareCertificate *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->productName);
	retval |= UA_String_deleteMembers(&p->productUri);
	retval |= UA_String_deleteMembers(&p->vendorName);
	retval |= UA_ByteString_deleteMembers(&p->vendorProductCertificate);
	retval |= UA_String_deleteMembers(&p->softwareVersion);
	retval |= UA_String_deleteMembers(&p->buildNumber);
	retval |= UA_String_deleteMembers(&p->issuedBy);
	retval |= UA_Array_delete((void**)&p->supportedProfiles,p->supportedProfilesSize,UA_SUPPORTEDPROFILE);
	return retval;
}

UA_Int32 UA_SoftwareCertificate_init(UA_SoftwareCertificate *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->productName);
	retval |= UA_String_init(&p->productUri);
	retval |= UA_String_init(&p->vendorName);
	retval |= UA_ByteString_init(&p->vendorProductCertificate);
	retval |= UA_String_init(&p->softwareVersion);
	retval |= UA_String_init(&p->buildNumber);
	retval |= UA_DateTime_init(&p->buildDate);
	retval |= UA_String_init(&p->issuedBy);
	retval |= UA_DateTime_init(&p->issueDate);
	p->supportedProfilesSize = 0;
	p->supportedProfiles = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SoftwareCertificate)
UA_Int32 UA_SoftwareCertificate_copy(const UA_SoftwareCertificate *src,UA_SoftwareCertificate *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SoftwareCertificate));
	retval |= UA_String_copy(&src->productName,&dst->productName);
	retval |= UA_String_copy(&src->productUri,&dst->productUri);
	retval |= UA_String_copy(&src->vendorName,&dst->vendorName);
	retval |= UA_ByteString_copy(&src->vendorProductCertificate,&dst->vendorProductCertificate);
	retval |= UA_String_copy(&src->softwareVersion,&dst->softwareVersion);
	retval |= UA_String_copy(&src->buildNumber,&dst->buildNumber);
	retval |= UA_String_copy(&src->issuedBy,&dst->issuedBy);
	dst->supportedProfiles = src->supportedProfiles;
	retval |= UA_Array_copy(&src->supportedProfiles, src->supportedProfilesSize,UA_SUPPORTEDPROFILE,(void**)&dst->supportedProfiles);
	return retval;
}

UA_Int32 UA_QueryDataDescription_calcSizeBinary(UA_QueryDataDescription const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_QueryDataDescription);
    	return 0
	 + UA_RelativePath_calcSizeBinary(&ptr->relativePath)
	 + sizeof(UA_UInt32) // attributeId
	 + UA_String_calcSizeBinary(&ptr->indexRange)
	;
}

UA_Int32 UA_QueryDataDescription_encodeBinary(UA_QueryDataDescription const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RelativePath_encodeBinary(&src->relativePath,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->attributeId,dst,offset);
	retval |= UA_String_encodeBinary(&src->indexRange,dst,offset);
	return retval;
}

UA_Int32 UA_QueryDataDescription_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_QueryDataDescription * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_QueryDataDescription_init(dst);
	CHECKED_DECODE(UA_RelativePath_decodeBinary(src,offset,&dst->relativePath), UA_QueryDataDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->attributeId), UA_QueryDataDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->indexRange), UA_QueryDataDescription_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_QueryDataDescription)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_QueryDataDescription)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_QueryDataDescription)
UA_Int32 UA_QueryDataDescription_delete(UA_QueryDataDescription *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_QueryDataDescription_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_QueryDataDescription_deleteMembers(UA_QueryDataDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RelativePath_deleteMembers(&p->relativePath);
	retval |= UA_String_deleteMembers(&p->indexRange);
	return retval;
}

UA_Int32 UA_QueryDataDescription_init(UA_QueryDataDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RelativePath_init(&p->relativePath);
	retval |= UA_UInt32_init(&p->attributeId);
	retval |= UA_String_init(&p->indexRange);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_QueryDataDescription)
UA_Int32 UA_QueryDataDescription_copy(const UA_QueryDataDescription *src,UA_QueryDataDescription *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_QueryDataDescription));
	retval |= UA_RelativePath_copy(&src->relativePath,&dst->relativePath);
	retval |= UA_String_copy(&src->indexRange,&dst->indexRange);
	return retval;
}

UA_Int32 UA_NodeTypeDescription_calcSizeBinary(UA_NodeTypeDescription const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_NodeTypeDescription);
    	return 0
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->typeDefinitionNode)
	 + sizeof(UA_Boolean) // includeSubTypes
	 + UA_Array_calcSizeBinary(ptr->dataToReturnSize,UA_QUERYDATADESCRIPTION,ptr->dataToReturn)
	;
}

UA_Int32 UA_NodeTypeDescription_encodeBinary(UA_NodeTypeDescription const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_encodeBinary(&src->typeDefinitionNode,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->includeSubTypes,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->dataToReturnSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->dataToReturn,src->dataToReturnSize,UA_QUERYDATADESCRIPTION,dst,offset);
	return retval;
}

UA_Int32 UA_NodeTypeDescription_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_NodeTypeDescription * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_NodeTypeDescription_init(dst);
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->typeDefinitionNode), UA_NodeTypeDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->includeSubTypes), UA_NodeTypeDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->dataToReturnSize),UA_NodeTypeDescription_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->dataToReturnSize,UA_QUERYDATADESCRIPTION,(void**)&dst->dataToReturn), UA_NodeTypeDescription_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NodeTypeDescription)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NodeTypeDescription)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NodeTypeDescription)
UA_Int32 UA_NodeTypeDescription_delete(UA_NodeTypeDescription *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeTypeDescription_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_NodeTypeDescription_deleteMembers(UA_NodeTypeDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_deleteMembers(&p->typeDefinitionNode);
	retval |= UA_Array_delete((void**)&p->dataToReturn,p->dataToReturnSize,UA_QUERYDATADESCRIPTION);
	return retval;
}

UA_Int32 UA_NodeTypeDescription_init(UA_NodeTypeDescription *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_init(&p->typeDefinitionNode);
	retval |= UA_Boolean_init(&p->includeSubTypes);
	p->dataToReturnSize = 0;
	p->dataToReturn = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_NodeTypeDescription)
UA_Int32 UA_NodeTypeDescription_copy(const UA_NodeTypeDescription *src,UA_NodeTypeDescription *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_NodeTypeDescription));
	retval |= UA_ExpandedNodeId_copy(&src->typeDefinitionNode,&dst->typeDefinitionNode);
	dst->dataToReturn = src->dataToReturn;
	retval |= UA_Array_copy(&src->dataToReturn, src->dataToReturnSize,UA_QUERYDATADESCRIPTION,(void**)&dst->dataToReturn);
	return retval;
}

UA_TYPE_AS(UA_FilterOperator, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_FilterOperator, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_FilterOperator)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_FilterOperator)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_FilterOperator
)
UA_Int32 UA_QueryDataSet_calcSizeBinary(UA_QueryDataSet const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_QueryDataSet);
    	return 0
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->typeDefinitionNode)
	 + UA_Array_calcSizeBinary(ptr->valuesSize,UA_VARIANT,ptr->values)
	;
}

UA_Int32 UA_QueryDataSet_encodeBinary(UA_QueryDataSet const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->typeDefinitionNode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->valuesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->values,src->valuesSize,UA_VARIANT,dst,offset);
	return retval;
}

UA_Int32 UA_QueryDataSet_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_QueryDataSet * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_QueryDataSet_init(dst);
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->nodeId), UA_QueryDataSet_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->typeDefinitionNode), UA_QueryDataSet_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->valuesSize),UA_QueryDataSet_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->valuesSize,UA_VARIANT,(void**)&dst->values), UA_QueryDataSet_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_QueryDataSet)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_QueryDataSet)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_QueryDataSet)
UA_Int32 UA_QueryDataSet_delete(UA_QueryDataSet *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_QueryDataSet_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_QueryDataSet_deleteMembers(UA_QueryDataSet *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_deleteMembers(&p->nodeId);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->typeDefinitionNode);
	retval |= UA_Array_delete((void**)&p->values,p->valuesSize,UA_VARIANT);
	return retval;
}

UA_Int32 UA_QueryDataSet_init(UA_QueryDataSet *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExpandedNodeId_init(&p->nodeId);
	retval |= UA_ExpandedNodeId_init(&p->typeDefinitionNode);
	p->valuesSize = 0;
	p->values = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_QueryDataSet)
UA_Int32 UA_QueryDataSet_copy(const UA_QueryDataSet *src,UA_QueryDataSet *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_QueryDataSet));
	retval |= UA_ExpandedNodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_ExpandedNodeId_copy(&src->typeDefinitionNode,&dst->typeDefinitionNode);
	dst->values = src->values;
	retval |= UA_Array_copy(&src->values, src->valuesSize,UA_VARIANT,(void**)&dst->values);
	return retval;
}

UA_Int32 UA_NodeReference_calcSizeBinary(UA_NodeReference const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_NodeReference);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_NodeId_calcSizeBinary(&ptr->referenceTypeId)
	 + sizeof(UA_Boolean) // isForward
	 + UA_Array_calcSizeBinary(ptr->referencedNodeIdsSize,UA_NODEID,ptr->referencedNodeIds)
	;
}

UA_Int32 UA_NodeReference_encodeBinary(UA_NodeReference const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->referenceTypeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isForward,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencedNodeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->referencedNodeIds,src->referencedNodeIdsSize,UA_NODEID,dst,offset);
	return retval;
}

UA_Int32 UA_NodeReference_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_NodeReference * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_NodeReference_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_NodeReference_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->referenceTypeId), UA_NodeReference_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isForward), UA_NodeReference_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencedNodeIdsSize),UA_NodeReference_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencedNodeIdsSize,UA_NODEID,(void**)&dst->referencedNodeIds), UA_NodeReference_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NodeReference)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NodeReference)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NodeReference)
UA_Int32 UA_NodeReference_delete(UA_NodeReference *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeReference_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_NodeReference_deleteMembers(UA_NodeReference *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_NodeId_deleteMembers(&p->referenceTypeId);
	retval |= UA_Array_delete((void**)&p->referencedNodeIds,p->referencedNodeIdsSize,UA_NODEID);
	return retval;
}

UA_Int32 UA_NodeReference_init(UA_NodeReference *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeId_init(&p->referenceTypeId);
	retval |= UA_Boolean_init(&p->isForward);
	p->referencedNodeIdsSize = 0;
	p->referencedNodeIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_NodeReference)
UA_Int32 UA_NodeReference_copy(const UA_NodeReference *src,UA_NodeReference *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_NodeReference));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_NodeId_copy(&src->referenceTypeId,&dst->referenceTypeId);
	dst->referencedNodeIds = src->referencedNodeIds;
	retval |= UA_Array_copy(&src->referencedNodeIds, src->referencedNodeIdsSize,UA_NODEID,(void**)&dst->referencedNodeIds);
	return retval;
}

UA_Int32 UA_ContentFilterElement_calcSizeBinary(UA_ContentFilterElement const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ContentFilterElement);
    	return 0
	 + sizeof(UA_FilterOperator) // filterOperator
	 + UA_Array_calcSizeBinary(ptr->filterOperandsSize,UA_EXTENSIONOBJECT,ptr->filterOperands)
	;
}

UA_Int32 UA_ContentFilterElement_encodeBinary(UA_ContentFilterElement const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_FilterOperator_encodeBinary(&src->filterOperator,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->filterOperandsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->filterOperands,src->filterOperandsSize,UA_EXTENSIONOBJECT,dst,offset);
	return retval;
}

UA_Int32 UA_ContentFilterElement_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ContentFilterElement * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ContentFilterElement_init(dst);
	CHECKED_DECODE(UA_FilterOperator_decodeBinary(src,offset,&dst->filterOperator), UA_ContentFilterElement_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->filterOperandsSize),UA_ContentFilterElement_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->filterOperandsSize,UA_EXTENSIONOBJECT,(void**)&dst->filterOperands), UA_ContentFilterElement_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ContentFilterElement)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ContentFilterElement)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ContentFilterElement)
UA_Int32 UA_ContentFilterElement_delete(UA_ContentFilterElement *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ContentFilterElement_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ContentFilterElement_deleteMembers(UA_ContentFilterElement *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->filterOperands,p->filterOperandsSize,UA_EXTENSIONOBJECT);
	return retval;
}

UA_Int32 UA_ContentFilterElement_init(UA_ContentFilterElement *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_FilterOperator_init(&p->filterOperator);
	p->filterOperandsSize = 0;
	p->filterOperands = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ContentFilterElement)
UA_Int32 UA_ContentFilterElement_copy(const UA_ContentFilterElement *src,UA_ContentFilterElement *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ContentFilterElement));
	dst->filterOperands = src->filterOperands;
	retval |= UA_Array_copy(&src->filterOperands, src->filterOperandsSize,UA_EXTENSIONOBJECT,(void**)&dst->filterOperands);
	return retval;
}

UA_Int32 UA_ContentFilter_calcSizeBinary(UA_ContentFilter const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ContentFilter);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->elementsSize,UA_CONTENTFILTERELEMENT,ptr->elements)
	;
}

UA_Int32 UA_ContentFilter_encodeBinary(UA_ContentFilter const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->elementsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->elements,src->elementsSize,UA_CONTENTFILTERELEMENT,dst,offset);
	return retval;
}

UA_Int32 UA_ContentFilter_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ContentFilter * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ContentFilter_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->elementsSize),UA_ContentFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->elementsSize,UA_CONTENTFILTERELEMENT,(void**)&dst->elements), UA_ContentFilter_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ContentFilter)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ContentFilter)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ContentFilter)
UA_Int32 UA_ContentFilter_delete(UA_ContentFilter *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ContentFilter_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ContentFilter_deleteMembers(UA_ContentFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->elements,p->elementsSize,UA_CONTENTFILTERELEMENT);
	return retval;
}

UA_Int32 UA_ContentFilter_init(UA_ContentFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->elementsSize = 0;
	p->elements = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ContentFilter)
UA_Int32 UA_ContentFilter_copy(const UA_ContentFilter *src,UA_ContentFilter *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ContentFilter));
	dst->elements = src->elements;
	retval |= UA_Array_copy(&src->elements, src->elementsSize,UA_CONTENTFILTERELEMENT,(void**)&dst->elements);
	return retval;
}

UA_Int32 UA_FilterOperand_calcSizeBinary(UA_FilterOperand const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_FilterOperand);
    	return 0
	;
}

UA_Int32 UA_FilterOperand_encodeBinary(UA_FilterOperand const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_FilterOperand_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_FilterOperand * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_FilterOperand_init(dst);
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_FilterOperand)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_FilterOperand)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_FilterOperand)
UA_Int32 UA_FilterOperand_delete(UA_FilterOperand *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_FilterOperand_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_FilterOperand_deleteMembers(UA_FilterOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_FilterOperand_init(UA_FilterOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_FilterOperand)
UA_Int32 UA_FilterOperand_copy(const UA_FilterOperand *src,UA_FilterOperand *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_FilterOperand));
	return retval;
}

UA_Int32 UA_ElementOperand_calcSizeBinary(UA_ElementOperand const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ElementOperand);
    	return 0
	 + sizeof(UA_UInt32) // index
	;
}

UA_Int32 UA_ElementOperand_encodeBinary(UA_ElementOperand const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->index,dst,offset);
	return retval;
}

UA_Int32 UA_ElementOperand_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ElementOperand * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ElementOperand_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->index), UA_ElementOperand_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ElementOperand)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ElementOperand)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ElementOperand)
UA_Int32 UA_ElementOperand_delete(UA_ElementOperand *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ElementOperand_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ElementOperand_deleteMembers(UA_ElementOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_ElementOperand_init(UA_ElementOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->index);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ElementOperand)
UA_Int32 UA_ElementOperand_copy(const UA_ElementOperand *src,UA_ElementOperand *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ElementOperand));
	return retval;
}

UA_Int32 UA_LiteralOperand_calcSizeBinary(UA_LiteralOperand const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_LiteralOperand);
    	return 0
	 + UA_Variant_calcSizeBinary(&ptr->value)
	;
}

UA_Int32 UA_LiteralOperand_encodeBinary(UA_LiteralOperand const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Variant_encodeBinary(&src->value,dst,offset);
	return retval;
}

UA_Int32 UA_LiteralOperand_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_LiteralOperand * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_LiteralOperand_init(dst);
	CHECKED_DECODE(UA_Variant_decodeBinary(src,offset,&dst->value), UA_LiteralOperand_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_LiteralOperand)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_LiteralOperand)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_LiteralOperand)
UA_Int32 UA_LiteralOperand_delete(UA_LiteralOperand *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_LiteralOperand_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_LiteralOperand_deleteMembers(UA_LiteralOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Variant_deleteMembers(&p->value);
	return retval;
}

UA_Int32 UA_LiteralOperand_init(UA_LiteralOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Variant_init(&p->value);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_LiteralOperand)
UA_Int32 UA_LiteralOperand_copy(const UA_LiteralOperand *src,UA_LiteralOperand *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_LiteralOperand));
	retval |= UA_Variant_copy(&src->value,&dst->value);
	return retval;
}

UA_Int32 UA_AttributeOperand_calcSizeBinary(UA_AttributeOperand const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AttributeOperand);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_String_calcSizeBinary(&ptr->alias)
	 + UA_RelativePath_calcSizeBinary(&ptr->browsePath)
	 + sizeof(UA_UInt32) // attributeId
	 + UA_String_calcSizeBinary(&ptr->indexRange)
	;
}

UA_Int32 UA_AttributeOperand_encodeBinary(UA_AttributeOperand const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_String_encodeBinary(&src->alias,dst,offset);
	retval |= UA_RelativePath_encodeBinary(&src->browsePath,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->attributeId,dst,offset);
	retval |= UA_String_encodeBinary(&src->indexRange,dst,offset);
	return retval;
}

UA_Int32 UA_AttributeOperand_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AttributeOperand * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AttributeOperand_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_AttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->alias), UA_AttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_RelativePath_decodeBinary(src,offset,&dst->browsePath), UA_AttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->attributeId), UA_AttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->indexRange), UA_AttributeOperand_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AttributeOperand)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AttributeOperand)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AttributeOperand)
UA_Int32 UA_AttributeOperand_delete(UA_AttributeOperand *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AttributeOperand_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AttributeOperand_deleteMembers(UA_AttributeOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_String_deleteMembers(&p->alias);
	retval |= UA_RelativePath_deleteMembers(&p->browsePath);
	retval |= UA_String_deleteMembers(&p->indexRange);
	return retval;
}

UA_Int32 UA_AttributeOperand_init(UA_AttributeOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_String_init(&p->alias);
	retval |= UA_RelativePath_init(&p->browsePath);
	retval |= UA_UInt32_init(&p->attributeId);
	retval |= UA_String_init(&p->indexRange);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AttributeOperand)
UA_Int32 UA_AttributeOperand_copy(const UA_AttributeOperand *src,UA_AttributeOperand *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AttributeOperand));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_String_copy(&src->alias,&dst->alias);
	retval |= UA_RelativePath_copy(&src->browsePath,&dst->browsePath);
	retval |= UA_String_copy(&src->indexRange,&dst->indexRange);
	return retval;
}

UA_Int32 UA_SimpleAttributeOperand_calcSizeBinary(UA_SimpleAttributeOperand const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SimpleAttributeOperand);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->typeDefinitionId)
	 + UA_Array_calcSizeBinary(ptr->browsePathSize,UA_QUALIFIEDNAME,ptr->browsePath)
	 + sizeof(UA_UInt32) // attributeId
	 + UA_String_calcSizeBinary(&ptr->indexRange)
	;
}

UA_Int32 UA_SimpleAttributeOperand_encodeBinary(UA_SimpleAttributeOperand const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->typeDefinitionId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->browsePathSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->browsePath,src->browsePathSize,UA_QUALIFIEDNAME,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->attributeId,dst,offset);
	retval |= UA_String_encodeBinary(&src->indexRange,dst,offset);
	return retval;
}

UA_Int32 UA_SimpleAttributeOperand_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SimpleAttributeOperand * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SimpleAttributeOperand_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->typeDefinitionId), UA_SimpleAttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->browsePathSize),UA_SimpleAttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->browsePathSize,UA_QUALIFIEDNAME,(void**)&dst->browsePath), UA_SimpleAttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->attributeId), UA_SimpleAttributeOperand_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->indexRange), UA_SimpleAttributeOperand_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SimpleAttributeOperand)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SimpleAttributeOperand)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SimpleAttributeOperand)
UA_Int32 UA_SimpleAttributeOperand_delete(UA_SimpleAttributeOperand *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SimpleAttributeOperand_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SimpleAttributeOperand_deleteMembers(UA_SimpleAttributeOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->typeDefinitionId);
	retval |= UA_Array_delete((void**)&p->browsePath,p->browsePathSize,UA_QUALIFIEDNAME);
	retval |= UA_String_deleteMembers(&p->indexRange);
	return retval;
}

UA_Int32 UA_SimpleAttributeOperand_init(UA_SimpleAttributeOperand *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->typeDefinitionId);
	p->browsePathSize = 0;
	p->browsePath = UA_NULL;
	retval |= UA_UInt32_init(&p->attributeId);
	retval |= UA_String_init(&p->indexRange);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SimpleAttributeOperand)
UA_Int32 UA_SimpleAttributeOperand_copy(const UA_SimpleAttributeOperand *src,UA_SimpleAttributeOperand *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SimpleAttributeOperand));
	retval |= UA_NodeId_copy(&src->typeDefinitionId,&dst->typeDefinitionId);
	dst->browsePath = src->browsePath;
	retval |= UA_Array_copy(&src->browsePath, src->browsePathSize,UA_QUALIFIEDNAME,(void**)&dst->browsePath);
	retval |= UA_String_copy(&src->indexRange,&dst->indexRange);
	return retval;
}

UA_Int32 UA_ContentFilterElementResult_calcSizeBinary(UA_ContentFilterElementResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ContentFilterElementResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_Array_calcSizeBinary(ptr->operandStatusCodesSize,UA_STATUSCODE,ptr->operandStatusCodes)
	 + UA_Array_calcSizeBinary(ptr->operandDiagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->operandDiagnosticInfos)
	;
}

UA_Int32 UA_ContentFilterElementResult_encodeBinary(UA_ContentFilterElementResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->operandStatusCodesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->operandStatusCodes,src->operandStatusCodesSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->operandDiagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->operandDiagnosticInfos,src->operandDiagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_ContentFilterElementResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ContentFilterElementResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ContentFilterElementResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_ContentFilterElementResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->operandStatusCodesSize),UA_ContentFilterElementResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->operandStatusCodesSize,UA_STATUSCODE,(void**)&dst->operandStatusCodes), UA_ContentFilterElementResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->operandDiagnosticInfosSize),UA_ContentFilterElementResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->operandDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->operandDiagnosticInfos), UA_ContentFilterElementResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ContentFilterElementResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ContentFilterElementResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ContentFilterElementResult)
UA_Int32 UA_ContentFilterElementResult_delete(UA_ContentFilterElementResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ContentFilterElementResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ContentFilterElementResult_deleteMembers(UA_ContentFilterElementResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->operandStatusCodes,p->operandStatusCodesSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->operandDiagnosticInfos,p->operandDiagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_ContentFilterElementResult_init(UA_ContentFilterElementResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	p->operandStatusCodesSize = 0;
	p->operandStatusCodes = UA_NULL;
	p->operandDiagnosticInfosSize = 0;
	p->operandDiagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ContentFilterElementResult)
UA_Int32 UA_ContentFilterElementResult_copy(const UA_ContentFilterElementResult *src,UA_ContentFilterElementResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ContentFilterElementResult));
	dst->operandStatusCodes = src->operandStatusCodes;
	retval |= UA_Array_copy(&src->operandStatusCodes, src->operandStatusCodesSize,UA_STATUSCODE,(void**)&dst->operandStatusCodes);
	dst->operandDiagnosticInfos = src->operandDiagnosticInfos;
	retval |= UA_Array_copy(&src->operandDiagnosticInfos, src->operandDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->operandDiagnosticInfos);
	return retval;
}

UA_Int32 UA_ContentFilterResult_calcSizeBinary(UA_ContentFilterResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ContentFilterResult);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->elementResultsSize,UA_CONTENTFILTERELEMENTRESULT,ptr->elementResults)
	 + UA_Array_calcSizeBinary(ptr->elementDiagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->elementDiagnosticInfos)
	;
}

UA_Int32 UA_ContentFilterResult_encodeBinary(UA_ContentFilterResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->elementResultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->elementResults,src->elementResultsSize,UA_CONTENTFILTERELEMENTRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->elementDiagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->elementDiagnosticInfos,src->elementDiagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_ContentFilterResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ContentFilterResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ContentFilterResult_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->elementResultsSize),UA_ContentFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->elementResultsSize,UA_CONTENTFILTERELEMENTRESULT,(void**)&dst->elementResults), UA_ContentFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->elementDiagnosticInfosSize),UA_ContentFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->elementDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->elementDiagnosticInfos), UA_ContentFilterResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ContentFilterResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ContentFilterResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ContentFilterResult)
UA_Int32 UA_ContentFilterResult_delete(UA_ContentFilterResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ContentFilterResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ContentFilterResult_deleteMembers(UA_ContentFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->elementResults,p->elementResultsSize,UA_CONTENTFILTERELEMENTRESULT);
	retval |= UA_Array_delete((void**)&p->elementDiagnosticInfos,p->elementDiagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_ContentFilterResult_init(UA_ContentFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->elementResultsSize = 0;
	p->elementResults = UA_NULL;
	p->elementDiagnosticInfosSize = 0;
	p->elementDiagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ContentFilterResult)
UA_Int32 UA_ContentFilterResult_copy(const UA_ContentFilterResult *src,UA_ContentFilterResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ContentFilterResult));
	dst->elementResults = src->elementResults;
	retval |= UA_Array_copy(&src->elementResults, src->elementResultsSize,UA_CONTENTFILTERELEMENTRESULT,(void**)&dst->elementResults);
	dst->elementDiagnosticInfos = src->elementDiagnosticInfos;
	retval |= UA_Array_copy(&src->elementDiagnosticInfos, src->elementDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->elementDiagnosticInfos);
	return retval;
}

UA_Int32 UA_ParsingResult_calcSizeBinary(UA_ParsingResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ParsingResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_Array_calcSizeBinary(ptr->dataStatusCodesSize,UA_STATUSCODE,ptr->dataStatusCodes)
	 + UA_Array_calcSizeBinary(ptr->dataDiagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->dataDiagnosticInfos)
	;
}

UA_Int32 UA_ParsingResult_encodeBinary(UA_ParsingResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->dataStatusCodesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->dataStatusCodes,src->dataStatusCodesSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->dataDiagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->dataDiagnosticInfos,src->dataDiagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_ParsingResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ParsingResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ParsingResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_ParsingResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->dataStatusCodesSize),UA_ParsingResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->dataStatusCodesSize,UA_STATUSCODE,(void**)&dst->dataStatusCodes), UA_ParsingResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->dataDiagnosticInfosSize),UA_ParsingResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->dataDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->dataDiagnosticInfos), UA_ParsingResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ParsingResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ParsingResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ParsingResult)
UA_Int32 UA_ParsingResult_delete(UA_ParsingResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ParsingResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ParsingResult_deleteMembers(UA_ParsingResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->dataStatusCodes,p->dataStatusCodesSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->dataDiagnosticInfos,p->dataDiagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_ParsingResult_init(UA_ParsingResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	p->dataStatusCodesSize = 0;
	p->dataStatusCodes = UA_NULL;
	p->dataDiagnosticInfosSize = 0;
	p->dataDiagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ParsingResult)
UA_Int32 UA_ParsingResult_copy(const UA_ParsingResult *src,UA_ParsingResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ParsingResult));
	dst->dataStatusCodes = src->dataStatusCodes;
	retval |= UA_Array_copy(&src->dataStatusCodes, src->dataStatusCodesSize,UA_STATUSCODE,(void**)&dst->dataStatusCodes);
	dst->dataDiagnosticInfos = src->dataDiagnosticInfos;
	retval |= UA_Array_copy(&src->dataDiagnosticInfos, src->dataDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->dataDiagnosticInfos);
	return retval;
}

UA_Int32 UA_QueryFirstRequest_calcSizeBinary(UA_QueryFirstRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_QueryFirstRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_ViewDescription_calcSizeBinary(&ptr->view)
	 + UA_Array_calcSizeBinary(ptr->nodeTypesSize,UA_NODETYPEDESCRIPTION,ptr->nodeTypes)
	 + UA_ContentFilter_calcSizeBinary(&ptr->filter)
	 + sizeof(UA_UInt32) // maxDataSetsToReturn
	 + sizeof(UA_UInt32) // maxReferencesToReturn
	;
}

UA_Int32 UA_QueryFirstRequest_encodeBinary(UA_QueryFirstRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_ViewDescription_encodeBinary(&src->view,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodeTypesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodeTypes,src->nodeTypesSize,UA_NODETYPEDESCRIPTION,dst,offset);
	retval |= UA_ContentFilter_encodeBinary(&src->filter,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxDataSetsToReturn,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxReferencesToReturn,dst,offset);
	return retval;
}

UA_Int32 UA_QueryFirstRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_QueryFirstRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_QueryFirstRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_QueryFirstRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ViewDescription_decodeBinary(src,offset,&dst->view), UA_QueryFirstRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodeTypesSize),UA_QueryFirstRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodeTypesSize,UA_NODETYPEDESCRIPTION,(void**)&dst->nodeTypes), UA_QueryFirstRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ContentFilter_decodeBinary(src,offset,&dst->filter), UA_QueryFirstRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxDataSetsToReturn), UA_QueryFirstRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxReferencesToReturn), UA_QueryFirstRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_QueryFirstRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_QueryFirstRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_QueryFirstRequest)
UA_Int32 UA_QueryFirstRequest_delete(UA_QueryFirstRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_QueryFirstRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_QueryFirstRequest_deleteMembers(UA_QueryFirstRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_ViewDescription_deleteMembers(&p->view);
	retval |= UA_Array_delete((void**)&p->nodeTypes,p->nodeTypesSize,UA_NODETYPEDESCRIPTION);
	retval |= UA_ContentFilter_deleteMembers(&p->filter);
	return retval;
}

UA_Int32 UA_QueryFirstRequest_init(UA_QueryFirstRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_ViewDescription_init(&p->view);
	p->nodeTypesSize = 0;
	p->nodeTypes = UA_NULL;
	retval |= UA_ContentFilter_init(&p->filter);
	retval |= UA_UInt32_init(&p->maxDataSetsToReturn);
	retval |= UA_UInt32_init(&p->maxReferencesToReturn);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_QueryFirstRequest)
UA_Int32 UA_QueryFirstRequest_copy(const UA_QueryFirstRequest *src,UA_QueryFirstRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_QueryFirstRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_ViewDescription_copy(&src->view,&dst->view);
	dst->nodeTypes = src->nodeTypes;
	retval |= UA_Array_copy(&src->nodeTypes, src->nodeTypesSize,UA_NODETYPEDESCRIPTION,(void**)&dst->nodeTypes);
	retval |= UA_ContentFilter_copy(&src->filter,&dst->filter);
	return retval;
}

UA_Int32 UA_QueryFirstResponse_calcSizeBinary(UA_QueryFirstResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_QueryFirstResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->queryDataSetsSize,UA_QUERYDATASET,ptr->queryDataSets)
	 + UA_ByteString_calcSizeBinary(&ptr->continuationPoint)
	 + UA_Array_calcSizeBinary(ptr->parsingResultsSize,UA_PARSINGRESULT,ptr->parsingResults)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	 + UA_ContentFilterResult_calcSizeBinary(&ptr->filterResult)
	;
}

UA_Int32 UA_QueryFirstResponse_encodeBinary(UA_QueryFirstResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->queryDataSetsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->queryDataSets,src->queryDataSetsSize,UA_QUERYDATASET,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->continuationPoint,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->parsingResultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->parsingResults,src->parsingResultsSize,UA_PARSINGRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	retval |= UA_ContentFilterResult_encodeBinary(&src->filterResult,dst,offset);
	return retval;
}

UA_Int32 UA_QueryFirstResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_QueryFirstResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_QueryFirstResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->queryDataSetsSize),UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->queryDataSetsSize,UA_QUERYDATASET,(void**)&dst->queryDataSets), UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->continuationPoint), UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->parsingResultsSize),UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->parsingResultsSize,UA_PARSINGRESULT,(void**)&dst->parsingResults), UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_QueryFirstResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ContentFilterResult_decodeBinary(src,offset,&dst->filterResult), UA_QueryFirstResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_QueryFirstResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_QueryFirstResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_QueryFirstResponse)
UA_Int32 UA_QueryFirstResponse_delete(UA_QueryFirstResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_QueryFirstResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_QueryFirstResponse_deleteMembers(UA_QueryFirstResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->queryDataSets,p->queryDataSetsSize,UA_QUERYDATASET);
	retval |= UA_ByteString_deleteMembers(&p->continuationPoint);
	retval |= UA_Array_delete((void**)&p->parsingResults,p->parsingResultsSize,UA_PARSINGRESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	retval |= UA_ContentFilterResult_deleteMembers(&p->filterResult);
	return retval;
}

UA_Int32 UA_QueryFirstResponse_init(UA_QueryFirstResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->queryDataSetsSize = 0;
	p->queryDataSets = UA_NULL;
	retval |= UA_ByteString_init(&p->continuationPoint);
	p->parsingResultsSize = 0;
	p->parsingResults = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	retval |= UA_ContentFilterResult_init(&p->filterResult);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_QueryFirstResponse)
UA_Int32 UA_QueryFirstResponse_copy(const UA_QueryFirstResponse *src,UA_QueryFirstResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_QueryFirstResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->queryDataSets = src->queryDataSets;
	retval |= UA_Array_copy(&src->queryDataSets, src->queryDataSetsSize,UA_QUERYDATASET,(void**)&dst->queryDataSets);
	retval |= UA_ByteString_copy(&src->continuationPoint,&dst->continuationPoint);
	dst->parsingResults = src->parsingResults;
	retval |= UA_Array_copy(&src->parsingResults, src->parsingResultsSize,UA_PARSINGRESULT,(void**)&dst->parsingResults);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	retval |= UA_ContentFilterResult_copy(&src->filterResult,&dst->filterResult);
	return retval;
}

UA_Int32 UA_QueryNextRequest_calcSizeBinary(UA_QueryNextRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_QueryNextRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_Boolean) // releaseContinuationPoint
	 + UA_ByteString_calcSizeBinary(&ptr->continuationPoint)
	;
}

UA_Int32 UA_QueryNextRequest_encodeBinary(UA_QueryNextRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->releaseContinuationPoint,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->continuationPoint,dst,offset);
	return retval;
}

UA_Int32 UA_QueryNextRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_QueryNextRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_QueryNextRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_QueryNextRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->releaseContinuationPoint), UA_QueryNextRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->continuationPoint), UA_QueryNextRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_QueryNextRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_QueryNextRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_QueryNextRequest)
UA_Int32 UA_QueryNextRequest_delete(UA_QueryNextRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_QueryNextRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_QueryNextRequest_deleteMembers(UA_QueryNextRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_ByteString_deleteMembers(&p->continuationPoint);
	return retval;
}

UA_Int32 UA_QueryNextRequest_init(UA_QueryNextRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_Boolean_init(&p->releaseContinuationPoint);
	retval |= UA_ByteString_init(&p->continuationPoint);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_QueryNextRequest)
UA_Int32 UA_QueryNextRequest_copy(const UA_QueryNextRequest *src,UA_QueryNextRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_QueryNextRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_ByteString_copy(&src->continuationPoint,&dst->continuationPoint);
	return retval;
}

UA_Int32 UA_QueryNextResponse_calcSizeBinary(UA_QueryNextResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_QueryNextResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->queryDataSetsSize,UA_QUERYDATASET,ptr->queryDataSets)
	 + UA_ByteString_calcSizeBinary(&ptr->revisedContinuationPoint)
	;
}

UA_Int32 UA_QueryNextResponse_encodeBinary(UA_QueryNextResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->queryDataSetsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->queryDataSets,src->queryDataSetsSize,UA_QUERYDATASET,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->revisedContinuationPoint,dst,offset);
	return retval;
}

UA_Int32 UA_QueryNextResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_QueryNextResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_QueryNextResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_QueryNextResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->queryDataSetsSize),UA_QueryNextResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->queryDataSetsSize,UA_QUERYDATASET,(void**)&dst->queryDataSets), UA_QueryNextResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->revisedContinuationPoint), UA_QueryNextResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_QueryNextResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_QueryNextResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_QueryNextResponse)
UA_Int32 UA_QueryNextResponse_delete(UA_QueryNextResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_QueryNextResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_QueryNextResponse_deleteMembers(UA_QueryNextResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->queryDataSets,p->queryDataSetsSize,UA_QUERYDATASET);
	retval |= UA_ByteString_deleteMembers(&p->revisedContinuationPoint);
	return retval;
}

UA_Int32 UA_QueryNextResponse_init(UA_QueryNextResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->queryDataSetsSize = 0;
	p->queryDataSets = UA_NULL;
	retval |= UA_ByteString_init(&p->revisedContinuationPoint);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_QueryNextResponse)
UA_Int32 UA_QueryNextResponse_copy(const UA_QueryNextResponse *src,UA_QueryNextResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_QueryNextResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->queryDataSets = src->queryDataSets;
	retval |= UA_Array_copy(&src->queryDataSets, src->queryDataSetsSize,UA_QUERYDATASET,(void**)&dst->queryDataSets);
	retval |= UA_ByteString_copy(&src->revisedContinuationPoint,&dst->revisedContinuationPoint);
	return retval;
}

UA_TYPE_AS(UA_TimestampsToReturn, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_TimestampsToReturn, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TimestampsToReturn)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TimestampsToReturn)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TimestampsToReturn
)
UA_Int32 UA_ReadValueId_calcSizeBinary(UA_ReadValueId const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReadValueId);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_UInt32) // attributeId
	 + UA_String_calcSizeBinary(&ptr->indexRange)
	 + UA_QualifiedName_calcSizeBinary(&ptr->dataEncoding)
	;
}

UA_Int32 UA_ReadValueId_encodeBinary(UA_ReadValueId const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->attributeId,dst,offset);
	retval |= UA_String_encodeBinary(&src->indexRange,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->dataEncoding,dst,offset);
	return retval;
}

UA_Int32 UA_ReadValueId_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReadValueId * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReadValueId_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_ReadValueId_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->attributeId), UA_ReadValueId_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->indexRange), UA_ReadValueId_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->dataEncoding), UA_ReadValueId_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReadValueId)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReadValueId)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReadValueId)
UA_Int32 UA_ReadValueId_delete(UA_ReadValueId *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadValueId_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReadValueId_deleteMembers(UA_ReadValueId *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_String_deleteMembers(&p->indexRange);
	retval |= UA_QualifiedName_deleteMembers(&p->dataEncoding);
	return retval;
}

UA_Int32 UA_ReadValueId_init(UA_ReadValueId *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_UInt32_init(&p->attributeId);
	retval |= UA_String_init(&p->indexRange);
	retval |= UA_QualifiedName_init(&p->dataEncoding);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReadValueId)
UA_Int32 UA_ReadValueId_copy(const UA_ReadValueId *src,UA_ReadValueId *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReadValueId));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_String_copy(&src->indexRange,&dst->indexRange);
	retval |= UA_QualifiedName_copy(&src->dataEncoding,&dst->dataEncoding);
	return retval;
}

UA_Int32 UA_ReadRequest_calcSizeBinary(UA_ReadRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReadRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_Double) // maxAge
	 + sizeof(UA_TimestampsToReturn) // timestampsToReturn
	 + UA_Array_calcSizeBinary(ptr->nodesToReadSize,UA_READVALUEID,ptr->nodesToRead)
	;
}

UA_Int32 UA_ReadRequest_encodeBinary(UA_ReadRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Double_encodeBinary(&src->maxAge,dst,offset);
	retval |= UA_TimestampsToReturn_encodeBinary(&src->timestampsToReturn,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToReadSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToRead,src->nodesToReadSize,UA_READVALUEID,dst,offset);
	return retval;
}

UA_Int32 UA_ReadRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReadRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReadRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_ReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->maxAge), UA_ReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_TimestampsToReturn_decodeBinary(src,offset,&dst->timestampsToReturn), UA_ReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToReadSize),UA_ReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToReadSize,UA_READVALUEID,(void**)&dst->nodesToRead), UA_ReadRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReadRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReadRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReadRequest)
UA_Int32 UA_ReadRequest_delete(UA_ReadRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReadRequest_deleteMembers(UA_ReadRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->nodesToRead,p->nodesToReadSize,UA_READVALUEID);
	return retval;
}

UA_Int32 UA_ReadRequest_init(UA_ReadRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_Double_init(&p->maxAge);
	retval |= UA_TimestampsToReturn_init(&p->timestampsToReturn);
	p->nodesToReadSize = 0;
	p->nodesToRead = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReadRequest)
UA_Int32 UA_ReadRequest_copy(const UA_ReadRequest *src,UA_ReadRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReadRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->nodesToRead = src->nodesToRead;
	retval |= UA_Array_copy(&src->nodesToRead, src->nodesToReadSize,UA_READVALUEID,(void**)&dst->nodesToRead);
	return retval;
}

UA_Int32 UA_ReadResponse_calcSizeBinary(UA_ReadResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReadResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_DATAVALUE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_ReadResponse_encodeBinary(UA_ReadResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_DATAVALUE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_ReadResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReadResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReadResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_ReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_ReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_DATAVALUE,(void**)&dst->results), UA_ReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_ReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_ReadResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReadResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReadResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReadResponse)
UA_Int32 UA_ReadResponse_delete(UA_ReadResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReadResponse_deleteMembers(UA_ReadResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_DATAVALUE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_ReadResponse_init(UA_ReadResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReadResponse)
UA_Int32 UA_ReadResponse_copy(const UA_ReadResponse *src,UA_ReadResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReadResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_DATAVALUE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_HistoryReadValueId_calcSizeBinary(UA_HistoryReadValueId const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryReadValueId);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_String_calcSizeBinary(&ptr->indexRange)
	 + UA_QualifiedName_calcSizeBinary(&ptr->dataEncoding)
	 + UA_ByteString_calcSizeBinary(&ptr->continuationPoint)
	;
}

UA_Int32 UA_HistoryReadValueId_encodeBinary(UA_HistoryReadValueId const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_String_encodeBinary(&src->indexRange,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->dataEncoding,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->continuationPoint,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryReadValueId_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryReadValueId * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryReadValueId_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_HistoryReadValueId_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->indexRange), UA_HistoryReadValueId_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->dataEncoding), UA_HistoryReadValueId_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->continuationPoint), UA_HistoryReadValueId_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryReadValueId)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryReadValueId)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryReadValueId)
UA_Int32 UA_HistoryReadValueId_delete(UA_HistoryReadValueId *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryReadValueId_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryReadValueId_deleteMembers(UA_HistoryReadValueId *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_String_deleteMembers(&p->indexRange);
	retval |= UA_QualifiedName_deleteMembers(&p->dataEncoding);
	retval |= UA_ByteString_deleteMembers(&p->continuationPoint);
	return retval;
}

UA_Int32 UA_HistoryReadValueId_init(UA_HistoryReadValueId *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_String_init(&p->indexRange);
	retval |= UA_QualifiedName_init(&p->dataEncoding);
	retval |= UA_ByteString_init(&p->continuationPoint);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryReadValueId)
UA_Int32 UA_HistoryReadValueId_copy(const UA_HistoryReadValueId *src,UA_HistoryReadValueId *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryReadValueId));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_String_copy(&src->indexRange,&dst->indexRange);
	retval |= UA_QualifiedName_copy(&src->dataEncoding,&dst->dataEncoding);
	retval |= UA_ByteString_copy(&src->continuationPoint,&dst->continuationPoint);
	return retval;
}

UA_Int32 UA_HistoryReadResult_calcSizeBinary(UA_HistoryReadResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryReadResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_ByteString_calcSizeBinary(&ptr->continuationPoint)
	 + UA_ExtensionObject_calcSizeBinary(&ptr->historyData)
	;
}

UA_Int32 UA_HistoryReadResult_encodeBinary(UA_HistoryReadResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->continuationPoint,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->historyData,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryReadResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryReadResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryReadResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_HistoryReadResult_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->continuationPoint), UA_HistoryReadResult_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->historyData), UA_HistoryReadResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryReadResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryReadResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryReadResult)
UA_Int32 UA_HistoryReadResult_delete(UA_HistoryReadResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryReadResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryReadResult_deleteMembers(UA_HistoryReadResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ByteString_deleteMembers(&p->continuationPoint);
	retval |= UA_ExtensionObject_deleteMembers(&p->historyData);
	return retval;
}

UA_Int32 UA_HistoryReadResult_init(UA_HistoryReadResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_ByteString_init(&p->continuationPoint);
	retval |= UA_ExtensionObject_init(&p->historyData);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryReadResult)
UA_Int32 UA_HistoryReadResult_copy(const UA_HistoryReadResult *src,UA_HistoryReadResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryReadResult));
	retval |= UA_ByteString_copy(&src->continuationPoint,&dst->continuationPoint);
	retval |= UA_ExtensionObject_copy(&src->historyData,&dst->historyData);
	return retval;
}

UA_Int32 UA_HistoryReadDetails_calcSizeBinary(UA_HistoryReadDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryReadDetails);
    	return 0
	;
}

UA_Int32 UA_HistoryReadDetails_encodeBinary(UA_HistoryReadDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_HistoryReadDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryReadDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryReadDetails_init(dst);
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryReadDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryReadDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryReadDetails)
UA_Int32 UA_HistoryReadDetails_delete(UA_HistoryReadDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryReadDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryReadDetails_deleteMembers(UA_HistoryReadDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_HistoryReadDetails_init(UA_HistoryReadDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryReadDetails)
UA_Int32 UA_HistoryReadDetails_copy(const UA_HistoryReadDetails *src,UA_HistoryReadDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryReadDetails));
	return retval;
}

UA_Int32 UA_ReadRawModifiedDetails_calcSizeBinary(UA_ReadRawModifiedDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReadRawModifiedDetails);
    	return 0
	 + sizeof(UA_Boolean) // isReadModified
	 + sizeof(UA_DateTime) // startTime
	 + sizeof(UA_DateTime) // endTime
	 + sizeof(UA_UInt32) // numValuesPerNode
	 + sizeof(UA_Boolean) // returnBounds
	;
}

UA_Int32 UA_ReadRawModifiedDetails_encodeBinary(UA_ReadRawModifiedDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Boolean_encodeBinary(&src->isReadModified,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->startTime,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->endTime,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->numValuesPerNode,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->returnBounds,dst,offset);
	return retval;
}

UA_Int32 UA_ReadRawModifiedDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReadRawModifiedDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReadRawModifiedDetails_init(dst);
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isReadModified), UA_ReadRawModifiedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->startTime), UA_ReadRawModifiedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->endTime), UA_ReadRawModifiedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->numValuesPerNode), UA_ReadRawModifiedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->returnBounds), UA_ReadRawModifiedDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReadRawModifiedDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReadRawModifiedDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReadRawModifiedDetails)
UA_Int32 UA_ReadRawModifiedDetails_delete(UA_ReadRawModifiedDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadRawModifiedDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReadRawModifiedDetails_deleteMembers(UA_ReadRawModifiedDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_ReadRawModifiedDetails_init(UA_ReadRawModifiedDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Boolean_init(&p->isReadModified);
	retval |= UA_DateTime_init(&p->startTime);
	retval |= UA_DateTime_init(&p->endTime);
	retval |= UA_UInt32_init(&p->numValuesPerNode);
	retval |= UA_Boolean_init(&p->returnBounds);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReadRawModifiedDetails)
UA_Int32 UA_ReadRawModifiedDetails_copy(const UA_ReadRawModifiedDetails *src,UA_ReadRawModifiedDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReadRawModifiedDetails));
	return retval;
}

UA_Int32 UA_ReadAtTimeDetails_calcSizeBinary(UA_ReadAtTimeDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReadAtTimeDetails);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->reqTimesSize,UA_DATETIME,ptr->reqTimes)
	 + sizeof(UA_Boolean) // useSimpleBounds
	;
}

UA_Int32 UA_ReadAtTimeDetails_encodeBinary(UA_ReadAtTimeDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->reqTimesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->reqTimes,src->reqTimesSize,UA_DATETIME,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->useSimpleBounds,dst,offset);
	return retval;
}

UA_Int32 UA_ReadAtTimeDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReadAtTimeDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReadAtTimeDetails_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->reqTimesSize),UA_ReadAtTimeDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->reqTimesSize,UA_DATETIME,(void**)&dst->reqTimes), UA_ReadAtTimeDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->useSimpleBounds), UA_ReadAtTimeDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReadAtTimeDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReadAtTimeDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReadAtTimeDetails)
UA_Int32 UA_ReadAtTimeDetails_delete(UA_ReadAtTimeDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadAtTimeDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReadAtTimeDetails_deleteMembers(UA_ReadAtTimeDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->reqTimes,p->reqTimesSize,UA_DATETIME);
	return retval;
}

UA_Int32 UA_ReadAtTimeDetails_init(UA_ReadAtTimeDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->reqTimesSize = 0;
	p->reqTimes = UA_NULL;
	retval |= UA_Boolean_init(&p->useSimpleBounds);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReadAtTimeDetails)
UA_Int32 UA_ReadAtTimeDetails_copy(const UA_ReadAtTimeDetails *src,UA_ReadAtTimeDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReadAtTimeDetails));
	dst->reqTimes = src->reqTimes;
	retval |= UA_Array_copy(&src->reqTimes, src->reqTimesSize,UA_DATETIME,(void**)&dst->reqTimes);
	return retval;
}

UA_Int32 UA_HistoryData_calcSizeBinary(UA_HistoryData const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryData);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->dataValuesSize,UA_DATAVALUE,ptr->dataValues)
	;
}

UA_Int32 UA_HistoryData_encodeBinary(UA_HistoryData const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->dataValuesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->dataValues,src->dataValuesSize,UA_DATAVALUE,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryData_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryData * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryData_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->dataValuesSize),UA_HistoryData_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->dataValuesSize,UA_DATAVALUE,(void**)&dst->dataValues), UA_HistoryData_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryData)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryData)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryData)
UA_Int32 UA_HistoryData_delete(UA_HistoryData *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryData_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryData_deleteMembers(UA_HistoryData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->dataValues,p->dataValuesSize,UA_DATAVALUE);
	return retval;
}

UA_Int32 UA_HistoryData_init(UA_HistoryData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->dataValuesSize = 0;
	p->dataValues = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryData)
UA_Int32 UA_HistoryData_copy(const UA_HistoryData *src,UA_HistoryData *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryData));
	dst->dataValues = src->dataValues;
	retval |= UA_Array_copy(&src->dataValues, src->dataValuesSize,UA_DATAVALUE,(void**)&dst->dataValues);
	return retval;
}

UA_Int32 UA_HistoryReadRequest_calcSizeBinary(UA_HistoryReadRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryReadRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_ExtensionObject_calcSizeBinary(&ptr->historyReadDetails)
	 + sizeof(UA_TimestampsToReturn) // timestampsToReturn
	 + sizeof(UA_Boolean) // releaseContinuationPoints
	 + UA_Array_calcSizeBinary(ptr->nodesToReadSize,UA_HISTORYREADVALUEID,ptr->nodesToRead)
	;
}

UA_Int32 UA_HistoryReadRequest_encodeBinary(UA_HistoryReadRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->historyReadDetails,dst,offset);
	retval |= UA_TimestampsToReturn_encodeBinary(&src->timestampsToReturn,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->releaseContinuationPoints,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToReadSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToRead,src->nodesToReadSize,UA_HISTORYREADVALUEID,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryReadRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryReadRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryReadRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_HistoryReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->historyReadDetails), UA_HistoryReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_TimestampsToReturn_decodeBinary(src,offset,&dst->timestampsToReturn), UA_HistoryReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->releaseContinuationPoints), UA_HistoryReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToReadSize),UA_HistoryReadRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToReadSize,UA_HISTORYREADVALUEID,(void**)&dst->nodesToRead), UA_HistoryReadRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryReadRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryReadRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryReadRequest)
UA_Int32 UA_HistoryReadRequest_delete(UA_HistoryReadRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryReadRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryReadRequest_deleteMembers(UA_HistoryReadRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_ExtensionObject_deleteMembers(&p->historyReadDetails);
	retval |= UA_Array_delete((void**)&p->nodesToRead,p->nodesToReadSize,UA_HISTORYREADVALUEID);
	return retval;
}

UA_Int32 UA_HistoryReadRequest_init(UA_HistoryReadRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_ExtensionObject_init(&p->historyReadDetails);
	retval |= UA_TimestampsToReturn_init(&p->timestampsToReturn);
	retval |= UA_Boolean_init(&p->releaseContinuationPoints);
	p->nodesToReadSize = 0;
	p->nodesToRead = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryReadRequest)
UA_Int32 UA_HistoryReadRequest_copy(const UA_HistoryReadRequest *src,UA_HistoryReadRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryReadRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_ExtensionObject_copy(&src->historyReadDetails,&dst->historyReadDetails);
	dst->nodesToRead = src->nodesToRead;
	retval |= UA_Array_copy(&src->nodesToRead, src->nodesToReadSize,UA_HISTORYREADVALUEID,(void**)&dst->nodesToRead);
	return retval;
}

UA_Int32 UA_HistoryReadResponse_calcSizeBinary(UA_HistoryReadResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryReadResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_HISTORYREADRESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_HistoryReadResponse_encodeBinary(UA_HistoryReadResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_HISTORYREADRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryReadResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryReadResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryReadResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_HistoryReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_HistoryReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_HISTORYREADRESULT,(void**)&dst->results), UA_HistoryReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_HistoryReadResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_HistoryReadResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryReadResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryReadResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryReadResponse)
UA_Int32 UA_HistoryReadResponse_delete(UA_HistoryReadResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryReadResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryReadResponse_deleteMembers(UA_HistoryReadResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_HISTORYREADRESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_HistoryReadResponse_init(UA_HistoryReadResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryReadResponse)
UA_Int32 UA_HistoryReadResponse_copy(const UA_HistoryReadResponse *src,UA_HistoryReadResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryReadResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_HISTORYREADRESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_WriteValue_calcSizeBinary(UA_WriteValue const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_WriteValue);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_UInt32) // attributeId
	 + UA_String_calcSizeBinary(&ptr->indexRange)
	 + UA_DataValue_calcSizeBinary(&ptr->value)
	;
}

UA_Int32 UA_WriteValue_encodeBinary(UA_WriteValue const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->attributeId,dst,offset);
	retval |= UA_String_encodeBinary(&src->indexRange,dst,offset);
	retval |= UA_DataValue_encodeBinary(&src->value,dst,offset);
	return retval;
}

UA_Int32 UA_WriteValue_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_WriteValue * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_WriteValue_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_WriteValue_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->attributeId), UA_WriteValue_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->indexRange), UA_WriteValue_deleteMembers(dst));
	CHECKED_DECODE(UA_DataValue_decodeBinary(src,offset,&dst->value), UA_WriteValue_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_WriteValue)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_WriteValue)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_WriteValue)
UA_Int32 UA_WriteValue_delete(UA_WriteValue *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_WriteValue_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_WriteValue_deleteMembers(UA_WriteValue *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_String_deleteMembers(&p->indexRange);
	retval |= UA_DataValue_deleteMembers(&p->value);
	return retval;
}

UA_Int32 UA_WriteValue_init(UA_WriteValue *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_UInt32_init(&p->attributeId);
	retval |= UA_String_init(&p->indexRange);
	retval |= UA_DataValue_init(&p->value);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_WriteValue)
UA_Int32 UA_WriteValue_copy(const UA_WriteValue *src,UA_WriteValue *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_WriteValue));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_String_copy(&src->indexRange,&dst->indexRange);
	retval |= UA_DataValue_copy(&src->value,&dst->value);
	return retval;
}

UA_Int32 UA_WriteRequest_calcSizeBinary(UA_WriteRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_WriteRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->nodesToWriteSize,UA_WRITEVALUE,ptr->nodesToWrite)
	;
}

UA_Int32 UA_WriteRequest_encodeBinary(UA_WriteRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodesToWriteSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodesToWrite,src->nodesToWriteSize,UA_WRITEVALUE,dst,offset);
	return retval;
}

UA_Int32 UA_WriteRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_WriteRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_WriteRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_WriteRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodesToWriteSize),UA_WriteRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodesToWriteSize,UA_WRITEVALUE,(void**)&dst->nodesToWrite), UA_WriteRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_WriteRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_WriteRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_WriteRequest)
UA_Int32 UA_WriteRequest_delete(UA_WriteRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_WriteRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_WriteRequest_deleteMembers(UA_WriteRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->nodesToWrite,p->nodesToWriteSize,UA_WRITEVALUE);
	return retval;
}

UA_Int32 UA_WriteRequest_init(UA_WriteRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->nodesToWriteSize = 0;
	p->nodesToWrite = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_WriteRequest)
UA_Int32 UA_WriteRequest_copy(const UA_WriteRequest *src,UA_WriteRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_WriteRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->nodesToWrite = src->nodesToWrite;
	retval |= UA_Array_copy(&src->nodesToWrite, src->nodesToWriteSize,UA_WRITEVALUE,(void**)&dst->nodesToWrite);
	return retval;
}

UA_Int32 UA_WriteResponse_calcSizeBinary(UA_WriteResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_WriteResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_WriteResponse_encodeBinary(UA_WriteResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_WriteResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_WriteResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_WriteResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_WriteResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_WriteResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_WriteResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_WriteResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_WriteResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_WriteResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_WriteResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_WriteResponse)
UA_Int32 UA_WriteResponse_delete(UA_WriteResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_WriteResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_WriteResponse_deleteMembers(UA_WriteResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_WriteResponse_init(UA_WriteResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_WriteResponse)
UA_Int32 UA_WriteResponse_copy(const UA_WriteResponse *src,UA_WriteResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_WriteResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_HistoryUpdateDetails_calcSizeBinary(UA_HistoryUpdateDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryUpdateDetails);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	;
}

UA_Int32 UA_HistoryUpdateDetails_encodeBinary(UA_HistoryUpdateDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryUpdateDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryUpdateDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryUpdateDetails_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_HistoryUpdateDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryUpdateDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryUpdateDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryUpdateDetails)
UA_Int32 UA_HistoryUpdateDetails_delete(UA_HistoryUpdateDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryUpdateDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryUpdateDetails_deleteMembers(UA_HistoryUpdateDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	return retval;
}

UA_Int32 UA_HistoryUpdateDetails_init(UA_HistoryUpdateDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryUpdateDetails)
UA_Int32 UA_HistoryUpdateDetails_copy(const UA_HistoryUpdateDetails *src,UA_HistoryUpdateDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryUpdateDetails));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	return retval;
}

UA_TYPE_AS(UA_HistoryUpdateType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_HistoryUpdateType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryUpdateType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryUpdateType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryUpdateType
)
UA_TYPE_AS(UA_PerformUpdateType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_PerformUpdateType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_PerformUpdateType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_PerformUpdateType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_PerformUpdateType
)
UA_Int32 UA_UpdateDataDetails_calcSizeBinary(UA_UpdateDataDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UpdateDataDetails);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_PerformUpdateType) // performInsertReplace
	 + UA_Array_calcSizeBinary(ptr->updateValuesSize,UA_DATAVALUE,ptr->updateValues)
	;
}

UA_Int32 UA_UpdateDataDetails_encodeBinary(UA_UpdateDataDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_PerformUpdateType_encodeBinary(&src->performInsertReplace,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->updateValuesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->updateValues,src->updateValuesSize,UA_DATAVALUE,dst,offset);
	return retval;
}

UA_Int32 UA_UpdateDataDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UpdateDataDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UpdateDataDetails_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_UpdateDataDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_PerformUpdateType_decodeBinary(src,offset,&dst->performInsertReplace), UA_UpdateDataDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->updateValuesSize),UA_UpdateDataDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->updateValuesSize,UA_DATAVALUE,(void**)&dst->updateValues), UA_UpdateDataDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UpdateDataDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UpdateDataDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UpdateDataDetails)
UA_Int32 UA_UpdateDataDetails_delete(UA_UpdateDataDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UpdateDataDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UpdateDataDetails_deleteMembers(UA_UpdateDataDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_Array_delete((void**)&p->updateValues,p->updateValuesSize,UA_DATAVALUE);
	return retval;
}

UA_Int32 UA_UpdateDataDetails_init(UA_UpdateDataDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_PerformUpdateType_init(&p->performInsertReplace);
	p->updateValuesSize = 0;
	p->updateValues = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UpdateDataDetails)
UA_Int32 UA_UpdateDataDetails_copy(const UA_UpdateDataDetails *src,UA_UpdateDataDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UpdateDataDetails));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	dst->updateValues = src->updateValues;
	retval |= UA_Array_copy(&src->updateValues, src->updateValuesSize,UA_DATAVALUE,(void**)&dst->updateValues);
	return retval;
}

UA_Int32 UA_UpdateStructureDataDetails_calcSizeBinary(UA_UpdateStructureDataDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UpdateStructureDataDetails);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_PerformUpdateType) // performInsertReplace
	 + UA_Array_calcSizeBinary(ptr->updateValuesSize,UA_DATAVALUE,ptr->updateValues)
	;
}

UA_Int32 UA_UpdateStructureDataDetails_encodeBinary(UA_UpdateStructureDataDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_PerformUpdateType_encodeBinary(&src->performInsertReplace,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->updateValuesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->updateValues,src->updateValuesSize,UA_DATAVALUE,dst,offset);
	return retval;
}

UA_Int32 UA_UpdateStructureDataDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UpdateStructureDataDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UpdateStructureDataDetails_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_UpdateStructureDataDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_PerformUpdateType_decodeBinary(src,offset,&dst->performInsertReplace), UA_UpdateStructureDataDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->updateValuesSize),UA_UpdateStructureDataDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->updateValuesSize,UA_DATAVALUE,(void**)&dst->updateValues), UA_UpdateStructureDataDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UpdateStructureDataDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UpdateStructureDataDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UpdateStructureDataDetails)
UA_Int32 UA_UpdateStructureDataDetails_delete(UA_UpdateStructureDataDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UpdateStructureDataDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UpdateStructureDataDetails_deleteMembers(UA_UpdateStructureDataDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_Array_delete((void**)&p->updateValues,p->updateValuesSize,UA_DATAVALUE);
	return retval;
}

UA_Int32 UA_UpdateStructureDataDetails_init(UA_UpdateStructureDataDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_PerformUpdateType_init(&p->performInsertReplace);
	p->updateValuesSize = 0;
	p->updateValues = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UpdateStructureDataDetails)
UA_Int32 UA_UpdateStructureDataDetails_copy(const UA_UpdateStructureDataDetails *src,UA_UpdateStructureDataDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UpdateStructureDataDetails));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	dst->updateValues = src->updateValues;
	retval |= UA_Array_copy(&src->updateValues, src->updateValuesSize,UA_DATAVALUE,(void**)&dst->updateValues);
	return retval;
}

UA_Int32 UA_DeleteRawModifiedDetails_calcSizeBinary(UA_DeleteRawModifiedDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteRawModifiedDetails);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_Boolean) // isDeleteModified
	 + sizeof(UA_DateTime) // startTime
	 + sizeof(UA_DateTime) // endTime
	;
}

UA_Int32 UA_DeleteRawModifiedDetails_encodeBinary(UA_DeleteRawModifiedDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isDeleteModified,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->startTime,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->endTime,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteRawModifiedDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteRawModifiedDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteRawModifiedDetails_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_DeleteRawModifiedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isDeleteModified), UA_DeleteRawModifiedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->startTime), UA_DeleteRawModifiedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->endTime), UA_DeleteRawModifiedDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteRawModifiedDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteRawModifiedDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteRawModifiedDetails)
UA_Int32 UA_DeleteRawModifiedDetails_delete(UA_DeleteRawModifiedDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteRawModifiedDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteRawModifiedDetails_deleteMembers(UA_DeleteRawModifiedDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	return retval;
}

UA_Int32 UA_DeleteRawModifiedDetails_init(UA_DeleteRawModifiedDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_Boolean_init(&p->isDeleteModified);
	retval |= UA_DateTime_init(&p->startTime);
	retval |= UA_DateTime_init(&p->endTime);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteRawModifiedDetails)
UA_Int32 UA_DeleteRawModifiedDetails_copy(const UA_DeleteRawModifiedDetails *src,UA_DeleteRawModifiedDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteRawModifiedDetails));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	return retval;
}

UA_Int32 UA_DeleteAtTimeDetails_calcSizeBinary(UA_DeleteAtTimeDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteAtTimeDetails);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_Array_calcSizeBinary(ptr->reqTimesSize,UA_DATETIME,ptr->reqTimes)
	;
}

UA_Int32 UA_DeleteAtTimeDetails_encodeBinary(UA_DeleteAtTimeDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->reqTimesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->reqTimes,src->reqTimesSize,UA_DATETIME,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteAtTimeDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteAtTimeDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteAtTimeDetails_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_DeleteAtTimeDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->reqTimesSize),UA_DeleteAtTimeDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->reqTimesSize,UA_DATETIME,(void**)&dst->reqTimes), UA_DeleteAtTimeDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteAtTimeDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteAtTimeDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteAtTimeDetails)
UA_Int32 UA_DeleteAtTimeDetails_delete(UA_DeleteAtTimeDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteAtTimeDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteAtTimeDetails_deleteMembers(UA_DeleteAtTimeDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_Array_delete((void**)&p->reqTimes,p->reqTimesSize,UA_DATETIME);
	return retval;
}

UA_Int32 UA_DeleteAtTimeDetails_init(UA_DeleteAtTimeDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	p->reqTimesSize = 0;
	p->reqTimes = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteAtTimeDetails)
UA_Int32 UA_DeleteAtTimeDetails_copy(const UA_DeleteAtTimeDetails *src,UA_DeleteAtTimeDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteAtTimeDetails));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	dst->reqTimes = src->reqTimes;
	retval |= UA_Array_copy(&src->reqTimes, src->reqTimesSize,UA_DATETIME,(void**)&dst->reqTimes);
	return retval;
}

UA_Int32 UA_DeleteEventDetails_calcSizeBinary(UA_DeleteEventDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteEventDetails);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_Array_calcSizeBinary(ptr->eventIdsSize,UA_BYTESTRING,ptr->eventIds)
	;
}

UA_Int32 UA_DeleteEventDetails_encodeBinary(UA_DeleteEventDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->eventIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->eventIds,src->eventIdsSize,UA_BYTESTRING,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteEventDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteEventDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteEventDetails_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_DeleteEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->eventIdsSize),UA_DeleteEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->eventIdsSize,UA_BYTESTRING,(void**)&dst->eventIds), UA_DeleteEventDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteEventDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteEventDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteEventDetails)
UA_Int32 UA_DeleteEventDetails_delete(UA_DeleteEventDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteEventDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteEventDetails_deleteMembers(UA_DeleteEventDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_Array_delete((void**)&p->eventIds,p->eventIdsSize,UA_BYTESTRING);
	return retval;
}

UA_Int32 UA_DeleteEventDetails_init(UA_DeleteEventDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	p->eventIdsSize = 0;
	p->eventIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteEventDetails)
UA_Int32 UA_DeleteEventDetails_copy(const UA_DeleteEventDetails *src,UA_DeleteEventDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteEventDetails));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	dst->eventIds = src->eventIds;
	retval |= UA_Array_copy(&src->eventIds, src->eventIdsSize,UA_BYTESTRING,(void**)&dst->eventIds);
	return retval;
}

UA_Int32 UA_HistoryUpdateResult_calcSizeBinary(UA_HistoryUpdateResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryUpdateResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_Array_calcSizeBinary(ptr->operationResultsSize,UA_STATUSCODE,ptr->operationResults)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_HistoryUpdateResult_encodeBinary(UA_HistoryUpdateResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->operationResultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->operationResults,src->operationResultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryUpdateResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryUpdateResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryUpdateResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_HistoryUpdateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->operationResultsSize),UA_HistoryUpdateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->operationResultsSize,UA_STATUSCODE,(void**)&dst->operationResults), UA_HistoryUpdateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_HistoryUpdateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_HistoryUpdateResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryUpdateResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryUpdateResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryUpdateResult)
UA_Int32 UA_HistoryUpdateResult_delete(UA_HistoryUpdateResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryUpdateResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryUpdateResult_deleteMembers(UA_HistoryUpdateResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->operationResults,p->operationResultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_HistoryUpdateResult_init(UA_HistoryUpdateResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	p->operationResultsSize = 0;
	p->operationResults = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryUpdateResult)
UA_Int32 UA_HistoryUpdateResult_copy(const UA_HistoryUpdateResult *src,UA_HistoryUpdateResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryUpdateResult));
	dst->operationResults = src->operationResults;
	retval |= UA_Array_copy(&src->operationResults, src->operationResultsSize,UA_STATUSCODE,(void**)&dst->operationResults);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_HistoryUpdateRequest_calcSizeBinary(UA_HistoryUpdateRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryUpdateRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->historyUpdateDetailsSize,UA_EXTENSIONOBJECT,ptr->historyUpdateDetails)
	;
}

UA_Int32 UA_HistoryUpdateRequest_encodeBinary(UA_HistoryUpdateRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->historyUpdateDetailsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->historyUpdateDetails,src->historyUpdateDetailsSize,UA_EXTENSIONOBJECT,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryUpdateRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryUpdateRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryUpdateRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_HistoryUpdateRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->historyUpdateDetailsSize),UA_HistoryUpdateRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->historyUpdateDetailsSize,UA_EXTENSIONOBJECT,(void**)&dst->historyUpdateDetails), UA_HistoryUpdateRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryUpdateRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryUpdateRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryUpdateRequest)
UA_Int32 UA_HistoryUpdateRequest_delete(UA_HistoryUpdateRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryUpdateRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryUpdateRequest_deleteMembers(UA_HistoryUpdateRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->historyUpdateDetails,p->historyUpdateDetailsSize,UA_EXTENSIONOBJECT);
	return retval;
}

UA_Int32 UA_HistoryUpdateRequest_init(UA_HistoryUpdateRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->historyUpdateDetailsSize = 0;
	p->historyUpdateDetails = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryUpdateRequest)
UA_Int32 UA_HistoryUpdateRequest_copy(const UA_HistoryUpdateRequest *src,UA_HistoryUpdateRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryUpdateRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->historyUpdateDetails = src->historyUpdateDetails;
	retval |= UA_Array_copy(&src->historyUpdateDetails, src->historyUpdateDetailsSize,UA_EXTENSIONOBJECT,(void**)&dst->historyUpdateDetails);
	return retval;
}

UA_Int32 UA_HistoryUpdateResponse_calcSizeBinary(UA_HistoryUpdateResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryUpdateResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_HISTORYUPDATERESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_HistoryUpdateResponse_encodeBinary(UA_HistoryUpdateResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_HISTORYUPDATERESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryUpdateResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryUpdateResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryUpdateResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_HistoryUpdateResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_HistoryUpdateResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_HISTORYUPDATERESULT,(void**)&dst->results), UA_HistoryUpdateResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_HistoryUpdateResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_HistoryUpdateResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryUpdateResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryUpdateResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryUpdateResponse)
UA_Int32 UA_HistoryUpdateResponse_delete(UA_HistoryUpdateResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryUpdateResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryUpdateResponse_deleteMembers(UA_HistoryUpdateResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_HISTORYUPDATERESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_HistoryUpdateResponse_init(UA_HistoryUpdateResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryUpdateResponse)
UA_Int32 UA_HistoryUpdateResponse_copy(const UA_HistoryUpdateResponse *src,UA_HistoryUpdateResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryUpdateResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_HISTORYUPDATERESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_CallMethodRequest_calcSizeBinary(UA_CallMethodRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CallMethodRequest);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->objectId)
	 + UA_NodeId_calcSizeBinary(&ptr->methodId)
	 + UA_Array_calcSizeBinary(ptr->inputArgumentsSize,UA_VARIANT,ptr->inputArguments)
	;
}

UA_Int32 UA_CallMethodRequest_encodeBinary(UA_CallMethodRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->objectId,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->methodId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->inputArgumentsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->inputArguments,src->inputArgumentsSize,UA_VARIANT,dst,offset);
	return retval;
}

UA_Int32 UA_CallMethodRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CallMethodRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CallMethodRequest_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->objectId), UA_CallMethodRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->methodId), UA_CallMethodRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->inputArgumentsSize),UA_CallMethodRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->inputArgumentsSize,UA_VARIANT,(void**)&dst->inputArguments), UA_CallMethodRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CallMethodRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CallMethodRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CallMethodRequest)
UA_Int32 UA_CallMethodRequest_delete(UA_CallMethodRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CallMethodRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CallMethodRequest_deleteMembers(UA_CallMethodRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->objectId);
	retval |= UA_NodeId_deleteMembers(&p->methodId);
	retval |= UA_Array_delete((void**)&p->inputArguments,p->inputArgumentsSize,UA_VARIANT);
	return retval;
}

UA_Int32 UA_CallMethodRequest_init(UA_CallMethodRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->objectId);
	retval |= UA_NodeId_init(&p->methodId);
	p->inputArgumentsSize = 0;
	p->inputArguments = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CallMethodRequest)
UA_Int32 UA_CallMethodRequest_copy(const UA_CallMethodRequest *src,UA_CallMethodRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CallMethodRequest));
	retval |= UA_NodeId_copy(&src->objectId,&dst->objectId);
	retval |= UA_NodeId_copy(&src->methodId,&dst->methodId);
	dst->inputArguments = src->inputArguments;
	retval |= UA_Array_copy(&src->inputArguments, src->inputArgumentsSize,UA_VARIANT,(void**)&dst->inputArguments);
	return retval;
}

UA_Int32 UA_CallMethodResult_calcSizeBinary(UA_CallMethodResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CallMethodResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_Array_calcSizeBinary(ptr->inputArgumentResultsSize,UA_STATUSCODE,ptr->inputArgumentResults)
	 + UA_Array_calcSizeBinary(ptr->inputArgumentDiagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->inputArgumentDiagnosticInfos)
	 + UA_Array_calcSizeBinary(ptr->outputArgumentsSize,UA_VARIANT,ptr->outputArguments)
	;
}

UA_Int32 UA_CallMethodResult_encodeBinary(UA_CallMethodResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->inputArgumentResultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->inputArgumentResults,src->inputArgumentResultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->inputArgumentDiagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->inputArgumentDiagnosticInfos,src->inputArgumentDiagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->outputArgumentsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->outputArguments,src->outputArgumentsSize,UA_VARIANT,dst,offset);
	return retval;
}

UA_Int32 UA_CallMethodResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CallMethodResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CallMethodResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_CallMethodResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->inputArgumentResultsSize),UA_CallMethodResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->inputArgumentResultsSize,UA_STATUSCODE,(void**)&dst->inputArgumentResults), UA_CallMethodResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->inputArgumentDiagnosticInfosSize),UA_CallMethodResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->inputArgumentDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->inputArgumentDiagnosticInfos), UA_CallMethodResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->outputArgumentsSize),UA_CallMethodResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->outputArgumentsSize,UA_VARIANT,(void**)&dst->outputArguments), UA_CallMethodResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CallMethodResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CallMethodResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CallMethodResult)
UA_Int32 UA_CallMethodResult_delete(UA_CallMethodResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CallMethodResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CallMethodResult_deleteMembers(UA_CallMethodResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->inputArgumentResults,p->inputArgumentResultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->inputArgumentDiagnosticInfos,p->inputArgumentDiagnosticInfosSize,UA_DIAGNOSTICINFO);
	retval |= UA_Array_delete((void**)&p->outputArguments,p->outputArgumentsSize,UA_VARIANT);
	return retval;
}

UA_Int32 UA_CallMethodResult_init(UA_CallMethodResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	p->inputArgumentResultsSize = 0;
	p->inputArgumentResults = UA_NULL;
	p->inputArgumentDiagnosticInfosSize = 0;
	p->inputArgumentDiagnosticInfos = UA_NULL;
	p->outputArgumentsSize = 0;
	p->outputArguments = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CallMethodResult)
UA_Int32 UA_CallMethodResult_copy(const UA_CallMethodResult *src,UA_CallMethodResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CallMethodResult));
	dst->inputArgumentResults = src->inputArgumentResults;
	retval |= UA_Array_copy(&src->inputArgumentResults, src->inputArgumentResultsSize,UA_STATUSCODE,(void**)&dst->inputArgumentResults);
	dst->inputArgumentDiagnosticInfos = src->inputArgumentDiagnosticInfos;
	retval |= UA_Array_copy(&src->inputArgumentDiagnosticInfos, src->inputArgumentDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->inputArgumentDiagnosticInfos);
	dst->outputArguments = src->outputArguments;
	retval |= UA_Array_copy(&src->outputArguments, src->outputArgumentsSize,UA_VARIANT,(void**)&dst->outputArguments);
	return retval;
}

UA_Int32 UA_CallRequest_calcSizeBinary(UA_CallRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CallRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->methodsToCallSize,UA_CALLMETHODREQUEST,ptr->methodsToCall)
	;
}

UA_Int32 UA_CallRequest_encodeBinary(UA_CallRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->methodsToCallSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->methodsToCall,src->methodsToCallSize,UA_CALLMETHODREQUEST,dst,offset);
	return retval;
}

UA_Int32 UA_CallRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CallRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CallRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_CallRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->methodsToCallSize),UA_CallRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->methodsToCallSize,UA_CALLMETHODREQUEST,(void**)&dst->methodsToCall), UA_CallRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CallRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CallRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CallRequest)
UA_Int32 UA_CallRequest_delete(UA_CallRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CallRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CallRequest_deleteMembers(UA_CallRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->methodsToCall,p->methodsToCallSize,UA_CALLMETHODREQUEST);
	return retval;
}

UA_Int32 UA_CallRequest_init(UA_CallRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->methodsToCallSize = 0;
	p->methodsToCall = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CallRequest)
UA_Int32 UA_CallRequest_copy(const UA_CallRequest *src,UA_CallRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CallRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->methodsToCall = src->methodsToCall;
	retval |= UA_Array_copy(&src->methodsToCall, src->methodsToCallSize,UA_CALLMETHODREQUEST,(void**)&dst->methodsToCall);
	return retval;
}

UA_Int32 UA_CallResponse_calcSizeBinary(UA_CallResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CallResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_CALLMETHODRESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_CallResponse_encodeBinary(UA_CallResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_CALLMETHODRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_CallResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CallResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CallResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_CallResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_CallResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_CALLMETHODRESULT,(void**)&dst->results), UA_CallResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_CallResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_CallResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CallResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CallResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CallResponse)
UA_Int32 UA_CallResponse_delete(UA_CallResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CallResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CallResponse_deleteMembers(UA_CallResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_CALLMETHODRESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_CallResponse_init(UA_CallResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CallResponse)
UA_Int32 UA_CallResponse_copy(const UA_CallResponse *src,UA_CallResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CallResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_CALLMETHODRESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_TYPE_AS(UA_MonitoringMode, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_MonitoringMode, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoringMode)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoringMode)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoringMode
)
UA_TYPE_AS(UA_DataChangeTrigger, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_DataChangeTrigger, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DataChangeTrigger)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DataChangeTrigger)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DataChangeTrigger
)
UA_TYPE_AS(UA_DeadbandType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_DeadbandType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeadbandType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeadbandType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeadbandType
)
UA_Int32 UA_MonitoringFilter_calcSizeBinary(UA_MonitoringFilter const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoringFilter);
    	return 0
	;
}

UA_Int32 UA_MonitoringFilter_encodeBinary(UA_MonitoringFilter const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_MonitoringFilter_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoringFilter * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoringFilter_init(dst);
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoringFilter)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoringFilter)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoringFilter)
UA_Int32 UA_MonitoringFilter_delete(UA_MonitoringFilter *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoringFilter_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoringFilter_deleteMembers(UA_MonitoringFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_MonitoringFilter_init(UA_MonitoringFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoringFilter)
UA_Int32 UA_MonitoringFilter_copy(const UA_MonitoringFilter *src,UA_MonitoringFilter *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoringFilter));
	return retval;
}

UA_Int32 UA_DataChangeFilter_calcSizeBinary(UA_DataChangeFilter const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DataChangeFilter);
    	return 0
	 + sizeof(UA_DataChangeTrigger) // trigger
	 + sizeof(UA_UInt32) // deadbandType
	 + sizeof(UA_Double) // deadbandValue
	;
}

UA_Int32 UA_DataChangeFilter_encodeBinary(UA_DataChangeFilter const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DataChangeTrigger_encodeBinary(&src->trigger,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->deadbandType,dst,offset);
	retval |= UA_Double_encodeBinary(&src->deadbandValue,dst,offset);
	return retval;
}

UA_Int32 UA_DataChangeFilter_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DataChangeFilter * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DataChangeFilter_init(dst);
	CHECKED_DECODE(UA_DataChangeTrigger_decodeBinary(src,offset,&dst->trigger), UA_DataChangeFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->deadbandType), UA_DataChangeFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->deadbandValue), UA_DataChangeFilter_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DataChangeFilter)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DataChangeFilter)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DataChangeFilter)
UA_Int32 UA_DataChangeFilter_delete(UA_DataChangeFilter *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DataChangeFilter_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DataChangeFilter_deleteMembers(UA_DataChangeFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_DataChangeFilter_init(UA_DataChangeFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DataChangeTrigger_init(&p->trigger);
	retval |= UA_UInt32_init(&p->deadbandType);
	retval |= UA_Double_init(&p->deadbandValue);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DataChangeFilter)
UA_Int32 UA_DataChangeFilter_copy(const UA_DataChangeFilter *src,UA_DataChangeFilter *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DataChangeFilter));
	return retval;
}

UA_Int32 UA_EventFilter_calcSizeBinary(UA_EventFilter const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EventFilter);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->selectClausesSize,UA_SIMPLEATTRIBUTEOPERAND,ptr->selectClauses)
	 + UA_ContentFilter_calcSizeBinary(&ptr->whereClause)
	;
}

UA_Int32 UA_EventFilter_encodeBinary(UA_EventFilter const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->selectClausesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->selectClauses,src->selectClausesSize,UA_SIMPLEATTRIBUTEOPERAND,dst,offset);
	retval |= UA_ContentFilter_encodeBinary(&src->whereClause,dst,offset);
	return retval;
}

UA_Int32 UA_EventFilter_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EventFilter * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EventFilter_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->selectClausesSize),UA_EventFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->selectClausesSize,UA_SIMPLEATTRIBUTEOPERAND,(void**)&dst->selectClauses), UA_EventFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_ContentFilter_decodeBinary(src,offset,&dst->whereClause), UA_EventFilter_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EventFilter)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EventFilter)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EventFilter)
UA_Int32 UA_EventFilter_delete(UA_EventFilter *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EventFilter_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EventFilter_deleteMembers(UA_EventFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->selectClauses,p->selectClausesSize,UA_SIMPLEATTRIBUTEOPERAND);
	retval |= UA_ContentFilter_deleteMembers(&p->whereClause);
	return retval;
}

UA_Int32 UA_EventFilter_init(UA_EventFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->selectClausesSize = 0;
	p->selectClauses = UA_NULL;
	retval |= UA_ContentFilter_init(&p->whereClause);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EventFilter)
UA_Int32 UA_EventFilter_copy(const UA_EventFilter *src,UA_EventFilter *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EventFilter));
	dst->selectClauses = src->selectClauses;
	retval |= UA_Array_copy(&src->selectClauses, src->selectClausesSize,UA_SIMPLEATTRIBUTEOPERAND,(void**)&dst->selectClauses);
	retval |= UA_ContentFilter_copy(&src->whereClause,&dst->whereClause);
	return retval;
}

UA_Int32 UA_AggregateConfiguration_calcSizeBinary(UA_AggregateConfiguration const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AggregateConfiguration);
    	return 0
	 + sizeof(UA_Boolean) // useServerCapabilitiesDefaults
	 + sizeof(UA_Boolean) // treatUncertainAsBad
	 + sizeof(UA_Byte) // percentDataBad
	 + sizeof(UA_Byte) // percentDataGood
	 + sizeof(UA_Boolean) // useSlopedExtrapolation
	;
}

UA_Int32 UA_AggregateConfiguration_encodeBinary(UA_AggregateConfiguration const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Boolean_encodeBinary(&src->useServerCapabilitiesDefaults,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->treatUncertainAsBad,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->percentDataBad,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->percentDataGood,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->useSlopedExtrapolation,dst,offset);
	return retval;
}

UA_Int32 UA_AggregateConfiguration_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AggregateConfiguration * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AggregateConfiguration_init(dst);
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->useServerCapabilitiesDefaults), UA_AggregateConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->treatUncertainAsBad), UA_AggregateConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->percentDataBad), UA_AggregateConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->percentDataGood), UA_AggregateConfiguration_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->useSlopedExtrapolation), UA_AggregateConfiguration_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AggregateConfiguration)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AggregateConfiguration)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AggregateConfiguration)
UA_Int32 UA_AggregateConfiguration_delete(UA_AggregateConfiguration *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AggregateConfiguration_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AggregateConfiguration_deleteMembers(UA_AggregateConfiguration *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_AggregateConfiguration_init(UA_AggregateConfiguration *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Boolean_init(&p->useServerCapabilitiesDefaults);
	retval |= UA_Boolean_init(&p->treatUncertainAsBad);
	retval |= UA_Byte_init(&p->percentDataBad);
	retval |= UA_Byte_init(&p->percentDataGood);
	retval |= UA_Boolean_init(&p->useSlopedExtrapolation);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AggregateConfiguration)
UA_Int32 UA_AggregateConfiguration_copy(const UA_AggregateConfiguration *src,UA_AggregateConfiguration *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AggregateConfiguration));
	return retval;
}

UA_Int32 UA_AggregateFilter_calcSizeBinary(UA_AggregateFilter const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AggregateFilter);
    	return 0
	 + sizeof(UA_DateTime) // startTime
	 + UA_NodeId_calcSizeBinary(&ptr->aggregateType)
	 + sizeof(UA_Double) // processingInterval
	 + sizeof(UA_AggregateConfiguration) // aggregateConfiguration
	;
}

UA_Int32 UA_AggregateFilter_encodeBinary(UA_AggregateFilter const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_encodeBinary(&src->startTime,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->aggregateType,dst,offset);
	retval |= UA_Double_encodeBinary(&src->processingInterval,dst,offset);
	retval |= UA_AggregateConfiguration_encodeBinary(&src->aggregateConfiguration,dst,offset);
	return retval;
}

UA_Int32 UA_AggregateFilter_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AggregateFilter * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AggregateFilter_init(dst);
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->startTime), UA_AggregateFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->aggregateType), UA_AggregateFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->processingInterval), UA_AggregateFilter_deleteMembers(dst));
	CHECKED_DECODE(UA_AggregateConfiguration_decodeBinary(src,offset,&dst->aggregateConfiguration), UA_AggregateFilter_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AggregateFilter)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AggregateFilter)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AggregateFilter)
UA_Int32 UA_AggregateFilter_delete(UA_AggregateFilter *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AggregateFilter_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AggregateFilter_deleteMembers(UA_AggregateFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->aggregateType);
	return retval;
}

UA_Int32 UA_AggregateFilter_init(UA_AggregateFilter *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_init(&p->startTime);
	retval |= UA_NodeId_init(&p->aggregateType);
	retval |= UA_Double_init(&p->processingInterval);
	retval |= UA_AggregateConfiguration_init(&p->aggregateConfiguration);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AggregateFilter)
UA_Int32 UA_AggregateFilter_copy(const UA_AggregateFilter *src,UA_AggregateFilter *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AggregateFilter));
	retval |= UA_NodeId_copy(&src->aggregateType,&dst->aggregateType);
	return retval;
}

UA_Int32 UA_MonitoringFilterResult_calcSizeBinary(UA_MonitoringFilterResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoringFilterResult);
    	return 0
	;
}

UA_Int32 UA_MonitoringFilterResult_encodeBinary(UA_MonitoringFilterResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_MonitoringFilterResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoringFilterResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoringFilterResult_init(dst);
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoringFilterResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoringFilterResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoringFilterResult)
UA_Int32 UA_MonitoringFilterResult_delete(UA_MonitoringFilterResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoringFilterResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoringFilterResult_deleteMembers(UA_MonitoringFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_MonitoringFilterResult_init(UA_MonitoringFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoringFilterResult)
UA_Int32 UA_MonitoringFilterResult_copy(const UA_MonitoringFilterResult *src,UA_MonitoringFilterResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoringFilterResult));
	return retval;
}

UA_Int32 UA_EventFilterResult_calcSizeBinary(UA_EventFilterResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EventFilterResult);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->selectClauseResultsSize,UA_STATUSCODE,ptr->selectClauseResults)
	 + UA_Array_calcSizeBinary(ptr->selectClauseDiagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->selectClauseDiagnosticInfos)
	 + UA_ContentFilterResult_calcSizeBinary(&ptr->whereClauseResult)
	;
}

UA_Int32 UA_EventFilterResult_encodeBinary(UA_EventFilterResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->selectClauseResultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->selectClauseResults,src->selectClauseResultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->selectClauseDiagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->selectClauseDiagnosticInfos,src->selectClauseDiagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	retval |= UA_ContentFilterResult_encodeBinary(&src->whereClauseResult,dst,offset);
	return retval;
}

UA_Int32 UA_EventFilterResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EventFilterResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EventFilterResult_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->selectClauseResultsSize),UA_EventFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->selectClauseResultsSize,UA_STATUSCODE,(void**)&dst->selectClauseResults), UA_EventFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->selectClauseDiagnosticInfosSize),UA_EventFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->selectClauseDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->selectClauseDiagnosticInfos), UA_EventFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_ContentFilterResult_decodeBinary(src,offset,&dst->whereClauseResult), UA_EventFilterResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EventFilterResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EventFilterResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EventFilterResult)
UA_Int32 UA_EventFilterResult_delete(UA_EventFilterResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EventFilterResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EventFilterResult_deleteMembers(UA_EventFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->selectClauseResults,p->selectClauseResultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->selectClauseDiagnosticInfos,p->selectClauseDiagnosticInfosSize,UA_DIAGNOSTICINFO);
	retval |= UA_ContentFilterResult_deleteMembers(&p->whereClauseResult);
	return retval;
}

UA_Int32 UA_EventFilterResult_init(UA_EventFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->selectClauseResultsSize = 0;
	p->selectClauseResults = UA_NULL;
	p->selectClauseDiagnosticInfosSize = 0;
	p->selectClauseDiagnosticInfos = UA_NULL;
	retval |= UA_ContentFilterResult_init(&p->whereClauseResult);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EventFilterResult)
UA_Int32 UA_EventFilterResult_copy(const UA_EventFilterResult *src,UA_EventFilterResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EventFilterResult));
	dst->selectClauseResults = src->selectClauseResults;
	retval |= UA_Array_copy(&src->selectClauseResults, src->selectClauseResultsSize,UA_STATUSCODE,(void**)&dst->selectClauseResults);
	dst->selectClauseDiagnosticInfos = src->selectClauseDiagnosticInfos;
	retval |= UA_Array_copy(&src->selectClauseDiagnosticInfos, src->selectClauseDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->selectClauseDiagnosticInfos);
	retval |= UA_ContentFilterResult_copy(&src->whereClauseResult,&dst->whereClauseResult);
	return retval;
}

UA_Int32 UA_AggregateFilterResult_calcSizeBinary(UA_AggregateFilterResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AggregateFilterResult);
    	return 0
	 + sizeof(UA_DateTime) // revisedStartTime
	 + sizeof(UA_Double) // revisedProcessingInterval
	 + sizeof(UA_AggregateConfiguration) // revisedAggregateConfiguration
	;
}

UA_Int32 UA_AggregateFilterResult_encodeBinary(UA_AggregateFilterResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_encodeBinary(&src->revisedStartTime,dst,offset);
	retval |= UA_Double_encodeBinary(&src->revisedProcessingInterval,dst,offset);
	retval |= UA_AggregateConfiguration_encodeBinary(&src->revisedAggregateConfiguration,dst,offset);
	return retval;
}

UA_Int32 UA_AggregateFilterResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AggregateFilterResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AggregateFilterResult_init(dst);
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->revisedStartTime), UA_AggregateFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->revisedProcessingInterval), UA_AggregateFilterResult_deleteMembers(dst));
	CHECKED_DECODE(UA_AggregateConfiguration_decodeBinary(src,offset,&dst->revisedAggregateConfiguration), UA_AggregateFilterResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AggregateFilterResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AggregateFilterResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AggregateFilterResult)
UA_Int32 UA_AggregateFilterResult_delete(UA_AggregateFilterResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AggregateFilterResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AggregateFilterResult_deleteMembers(UA_AggregateFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_AggregateFilterResult_init(UA_AggregateFilterResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_init(&p->revisedStartTime);
	retval |= UA_Double_init(&p->revisedProcessingInterval);
	retval |= UA_AggregateConfiguration_init(&p->revisedAggregateConfiguration);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AggregateFilterResult)
UA_Int32 UA_AggregateFilterResult_copy(const UA_AggregateFilterResult *src,UA_AggregateFilterResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AggregateFilterResult));
	return retval;
}

UA_Int32 UA_MonitoringParameters_calcSizeBinary(UA_MonitoringParameters const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoringParameters);
    	return 0
	 + sizeof(UA_UInt32) // clientHandle
	 + sizeof(UA_Double) // samplingInterval
	 + UA_ExtensionObject_calcSizeBinary(&ptr->filter)
	 + sizeof(UA_UInt32) // queueSize
	 + sizeof(UA_Boolean) // discardOldest
	;
}

UA_Int32 UA_MonitoringParameters_encodeBinary(UA_MonitoringParameters const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->clientHandle,dst,offset);
	retval |= UA_Double_encodeBinary(&src->samplingInterval,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->filter,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->queueSize,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->discardOldest,dst,offset);
	return retval;
}

UA_Int32 UA_MonitoringParameters_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoringParameters * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoringParameters_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->clientHandle), UA_MonitoringParameters_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->samplingInterval), UA_MonitoringParameters_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->filter), UA_MonitoringParameters_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->queueSize), UA_MonitoringParameters_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->discardOldest), UA_MonitoringParameters_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoringParameters)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoringParameters)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoringParameters)
UA_Int32 UA_MonitoringParameters_delete(UA_MonitoringParameters *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoringParameters_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoringParameters_deleteMembers(UA_MonitoringParameters *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExtensionObject_deleteMembers(&p->filter);
	return retval;
}

UA_Int32 UA_MonitoringParameters_init(UA_MonitoringParameters *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->clientHandle);
	retval |= UA_Double_init(&p->samplingInterval);
	retval |= UA_ExtensionObject_init(&p->filter);
	retval |= UA_UInt32_init(&p->queueSize);
	retval |= UA_Boolean_init(&p->discardOldest);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoringParameters)
UA_Int32 UA_MonitoringParameters_copy(const UA_MonitoringParameters *src,UA_MonitoringParameters *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoringParameters));
	retval |= UA_ExtensionObject_copy(&src->filter,&dst->filter);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateRequest_calcSizeBinary(UA_MonitoredItemCreateRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoredItemCreateRequest);
    	return 0
	 + UA_ReadValueId_calcSizeBinary(&ptr->itemToMonitor)
	 + sizeof(UA_MonitoringMode) // monitoringMode
	 + UA_MonitoringParameters_calcSizeBinary(&ptr->requestedParameters)
	;
}

UA_Int32 UA_MonitoredItemCreateRequest_encodeBinary(UA_MonitoredItemCreateRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadValueId_encodeBinary(&src->itemToMonitor,dst,offset);
	retval |= UA_MonitoringMode_encodeBinary(&src->monitoringMode,dst,offset);
	retval |= UA_MonitoringParameters_encodeBinary(&src->requestedParameters,dst,offset);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoredItemCreateRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoredItemCreateRequest_init(dst);
	CHECKED_DECODE(UA_ReadValueId_decodeBinary(src,offset,&dst->itemToMonitor), UA_MonitoredItemCreateRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_MonitoringMode_decodeBinary(src,offset,&dst->monitoringMode), UA_MonitoredItemCreateRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_MonitoringParameters_decodeBinary(src,offset,&dst->requestedParameters), UA_MonitoredItemCreateRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoredItemCreateRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoredItemCreateRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoredItemCreateRequest)
UA_Int32 UA_MonitoredItemCreateRequest_delete(UA_MonitoredItemCreateRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoredItemCreateRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateRequest_deleteMembers(UA_MonitoredItemCreateRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadValueId_deleteMembers(&p->itemToMonitor);
	retval |= UA_MonitoringParameters_deleteMembers(&p->requestedParameters);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateRequest_init(UA_MonitoredItemCreateRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadValueId_init(&p->itemToMonitor);
	retval |= UA_MonitoringMode_init(&p->monitoringMode);
	retval |= UA_MonitoringParameters_init(&p->requestedParameters);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoredItemCreateRequest)
UA_Int32 UA_MonitoredItemCreateRequest_copy(const UA_MonitoredItemCreateRequest *src,UA_MonitoredItemCreateRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoredItemCreateRequest));
	retval |= UA_ReadValueId_copy(&src->itemToMonitor,&dst->itemToMonitor);
	retval |= UA_MonitoringParameters_copy(&src->requestedParameters,&dst->requestedParameters);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateResult_calcSizeBinary(UA_MonitoredItemCreateResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoredItemCreateResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + sizeof(UA_UInt32) // monitoredItemId
	 + sizeof(UA_Double) // revisedSamplingInterval
	 + sizeof(UA_UInt32) // revisedQueueSize
	 + UA_ExtensionObject_calcSizeBinary(&ptr->filterResult)
	;
}

UA_Int32 UA_MonitoredItemCreateResult_encodeBinary(UA_MonitoredItemCreateResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->monitoredItemId,dst,offset);
	retval |= UA_Double_encodeBinary(&src->revisedSamplingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->revisedQueueSize,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->filterResult,dst,offset);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoredItemCreateResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoredItemCreateResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_MonitoredItemCreateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->monitoredItemId), UA_MonitoredItemCreateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->revisedSamplingInterval), UA_MonitoredItemCreateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->revisedQueueSize), UA_MonitoredItemCreateResult_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->filterResult), UA_MonitoredItemCreateResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoredItemCreateResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoredItemCreateResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoredItemCreateResult)
UA_Int32 UA_MonitoredItemCreateResult_delete(UA_MonitoredItemCreateResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoredItemCreateResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateResult_deleteMembers(UA_MonitoredItemCreateResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExtensionObject_deleteMembers(&p->filterResult);
	return retval;
}

UA_Int32 UA_MonitoredItemCreateResult_init(UA_MonitoredItemCreateResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_UInt32_init(&p->monitoredItemId);
	retval |= UA_Double_init(&p->revisedSamplingInterval);
	retval |= UA_UInt32_init(&p->revisedQueueSize);
	retval |= UA_ExtensionObject_init(&p->filterResult);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoredItemCreateResult)
UA_Int32 UA_MonitoredItemCreateResult_copy(const UA_MonitoredItemCreateResult *src,UA_MonitoredItemCreateResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoredItemCreateResult));
	retval |= UA_ExtensionObject_copy(&src->filterResult,&dst->filterResult);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsRequest_calcSizeBinary(UA_CreateMonitoredItemsRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CreateMonitoredItemsRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_TimestampsToReturn) // timestampsToReturn
	 + UA_Array_calcSizeBinary(ptr->itemsToCreateSize,UA_MONITOREDITEMCREATEREQUEST,ptr->itemsToCreate)
	;
}

UA_Int32 UA_CreateMonitoredItemsRequest_encodeBinary(UA_CreateMonitoredItemsRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_TimestampsToReturn_encodeBinary(&src->timestampsToReturn,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->itemsToCreateSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->itemsToCreate,src->itemsToCreateSize,UA_MONITOREDITEMCREATEREQUEST,dst,offset);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CreateMonitoredItemsRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CreateMonitoredItemsRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_CreateMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_CreateMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_TimestampsToReturn_decodeBinary(src,offset,&dst->timestampsToReturn), UA_CreateMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->itemsToCreateSize),UA_CreateMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->itemsToCreateSize,UA_MONITOREDITEMCREATEREQUEST,(void**)&dst->itemsToCreate), UA_CreateMonitoredItemsRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CreateMonitoredItemsRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CreateMonitoredItemsRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CreateMonitoredItemsRequest)
UA_Int32 UA_CreateMonitoredItemsRequest_delete(UA_CreateMonitoredItemsRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CreateMonitoredItemsRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsRequest_deleteMembers(UA_CreateMonitoredItemsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->itemsToCreate,p->itemsToCreateSize,UA_MONITOREDITEMCREATEREQUEST);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsRequest_init(UA_CreateMonitoredItemsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_TimestampsToReturn_init(&p->timestampsToReturn);
	p->itemsToCreateSize = 0;
	p->itemsToCreate = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CreateMonitoredItemsRequest)
UA_Int32 UA_CreateMonitoredItemsRequest_copy(const UA_CreateMonitoredItemsRequest *src,UA_CreateMonitoredItemsRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CreateMonitoredItemsRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->itemsToCreate = src->itemsToCreate;
	retval |= UA_Array_copy(&src->itemsToCreate, src->itemsToCreateSize,UA_MONITOREDITEMCREATEREQUEST,(void**)&dst->itemsToCreate);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsResponse_calcSizeBinary(UA_CreateMonitoredItemsResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CreateMonitoredItemsResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_MONITOREDITEMCREATERESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_CreateMonitoredItemsResponse_encodeBinary(UA_CreateMonitoredItemsResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_MONITOREDITEMCREATERESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CreateMonitoredItemsResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CreateMonitoredItemsResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_CreateMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_CreateMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_MONITOREDITEMCREATERESULT,(void**)&dst->results), UA_CreateMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_CreateMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_CreateMonitoredItemsResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CreateMonitoredItemsResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CreateMonitoredItemsResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CreateMonitoredItemsResponse)
UA_Int32 UA_CreateMonitoredItemsResponse_delete(UA_CreateMonitoredItemsResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CreateMonitoredItemsResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsResponse_deleteMembers(UA_CreateMonitoredItemsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_MONITOREDITEMCREATERESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_CreateMonitoredItemsResponse_init(UA_CreateMonitoredItemsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CreateMonitoredItemsResponse)
UA_Int32 UA_CreateMonitoredItemsResponse_copy(const UA_CreateMonitoredItemsResponse *src,UA_CreateMonitoredItemsResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CreateMonitoredItemsResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_MONITOREDITEMCREATERESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyRequest_calcSizeBinary(UA_MonitoredItemModifyRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoredItemModifyRequest);
    	return 0
	 + sizeof(UA_UInt32) // monitoredItemId
	 + UA_MonitoringParameters_calcSizeBinary(&ptr->requestedParameters)
	;
}

UA_Int32 UA_MonitoredItemModifyRequest_encodeBinary(UA_MonitoredItemModifyRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->monitoredItemId,dst,offset);
	retval |= UA_MonitoringParameters_encodeBinary(&src->requestedParameters,dst,offset);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoredItemModifyRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoredItemModifyRequest_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->monitoredItemId), UA_MonitoredItemModifyRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_MonitoringParameters_decodeBinary(src,offset,&dst->requestedParameters), UA_MonitoredItemModifyRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoredItemModifyRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoredItemModifyRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoredItemModifyRequest)
UA_Int32 UA_MonitoredItemModifyRequest_delete(UA_MonitoredItemModifyRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoredItemModifyRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyRequest_deleteMembers(UA_MonitoredItemModifyRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoringParameters_deleteMembers(&p->requestedParameters);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyRequest_init(UA_MonitoredItemModifyRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->monitoredItemId);
	retval |= UA_MonitoringParameters_init(&p->requestedParameters);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoredItemModifyRequest)
UA_Int32 UA_MonitoredItemModifyRequest_copy(const UA_MonitoredItemModifyRequest *src,UA_MonitoredItemModifyRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoredItemModifyRequest));
	retval |= UA_MonitoringParameters_copy(&src->requestedParameters,&dst->requestedParameters);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyResult_calcSizeBinary(UA_MonitoredItemModifyResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoredItemModifyResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + sizeof(UA_Double) // revisedSamplingInterval
	 + sizeof(UA_UInt32) // revisedQueueSize
	 + UA_ExtensionObject_calcSizeBinary(&ptr->filterResult)
	;
}

UA_Int32 UA_MonitoredItemModifyResult_encodeBinary(UA_MonitoredItemModifyResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_Double_encodeBinary(&src->revisedSamplingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->revisedQueueSize,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->filterResult,dst,offset);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoredItemModifyResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoredItemModifyResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_MonitoredItemModifyResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->revisedSamplingInterval), UA_MonitoredItemModifyResult_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->revisedQueueSize), UA_MonitoredItemModifyResult_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->filterResult), UA_MonitoredItemModifyResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoredItemModifyResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoredItemModifyResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoredItemModifyResult)
UA_Int32 UA_MonitoredItemModifyResult_delete(UA_MonitoredItemModifyResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoredItemModifyResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyResult_deleteMembers(UA_MonitoredItemModifyResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ExtensionObject_deleteMembers(&p->filterResult);
	return retval;
}

UA_Int32 UA_MonitoredItemModifyResult_init(UA_MonitoredItemModifyResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_Double_init(&p->revisedSamplingInterval);
	retval |= UA_UInt32_init(&p->revisedQueueSize);
	retval |= UA_ExtensionObject_init(&p->filterResult);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoredItemModifyResult)
UA_Int32 UA_MonitoredItemModifyResult_copy(const UA_MonitoredItemModifyResult *src,UA_MonitoredItemModifyResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoredItemModifyResult));
	retval |= UA_ExtensionObject_copy(&src->filterResult,&dst->filterResult);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsRequest_calcSizeBinary(UA_ModifyMonitoredItemsRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ModifyMonitoredItemsRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_TimestampsToReturn) // timestampsToReturn
	 + UA_Array_calcSizeBinary(ptr->itemsToModifySize,UA_MONITOREDITEMMODIFYREQUEST,ptr->itemsToModify)
	;
}

UA_Int32 UA_ModifyMonitoredItemsRequest_encodeBinary(UA_ModifyMonitoredItemsRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_TimestampsToReturn_encodeBinary(&src->timestampsToReturn,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->itemsToModifySize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->itemsToModify,src->itemsToModifySize,UA_MONITOREDITEMMODIFYREQUEST,dst,offset);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ModifyMonitoredItemsRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ModifyMonitoredItemsRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_ModifyMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_ModifyMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_TimestampsToReturn_decodeBinary(src,offset,&dst->timestampsToReturn), UA_ModifyMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->itemsToModifySize),UA_ModifyMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->itemsToModifySize,UA_MONITOREDITEMMODIFYREQUEST,(void**)&dst->itemsToModify), UA_ModifyMonitoredItemsRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ModifyMonitoredItemsRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ModifyMonitoredItemsRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ModifyMonitoredItemsRequest)
UA_Int32 UA_ModifyMonitoredItemsRequest_delete(UA_ModifyMonitoredItemsRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ModifyMonitoredItemsRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsRequest_deleteMembers(UA_ModifyMonitoredItemsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->itemsToModify,p->itemsToModifySize,UA_MONITOREDITEMMODIFYREQUEST);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsRequest_init(UA_ModifyMonitoredItemsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_TimestampsToReturn_init(&p->timestampsToReturn);
	p->itemsToModifySize = 0;
	p->itemsToModify = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ModifyMonitoredItemsRequest)
UA_Int32 UA_ModifyMonitoredItemsRequest_copy(const UA_ModifyMonitoredItemsRequest *src,UA_ModifyMonitoredItemsRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ModifyMonitoredItemsRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->itemsToModify = src->itemsToModify;
	retval |= UA_Array_copy(&src->itemsToModify, src->itemsToModifySize,UA_MONITOREDITEMMODIFYREQUEST,(void**)&dst->itemsToModify);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsResponse_calcSizeBinary(UA_ModifyMonitoredItemsResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ModifyMonitoredItemsResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_MONITOREDITEMMODIFYRESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_ModifyMonitoredItemsResponse_encodeBinary(UA_ModifyMonitoredItemsResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_MONITOREDITEMMODIFYRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ModifyMonitoredItemsResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ModifyMonitoredItemsResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_ModifyMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_ModifyMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_MONITOREDITEMMODIFYRESULT,(void**)&dst->results), UA_ModifyMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_ModifyMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_ModifyMonitoredItemsResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ModifyMonitoredItemsResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ModifyMonitoredItemsResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ModifyMonitoredItemsResponse)
UA_Int32 UA_ModifyMonitoredItemsResponse_delete(UA_ModifyMonitoredItemsResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ModifyMonitoredItemsResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsResponse_deleteMembers(UA_ModifyMonitoredItemsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_MONITOREDITEMMODIFYRESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_ModifyMonitoredItemsResponse_init(UA_ModifyMonitoredItemsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ModifyMonitoredItemsResponse)
UA_Int32 UA_ModifyMonitoredItemsResponse_copy(const UA_ModifyMonitoredItemsResponse *src,UA_ModifyMonitoredItemsResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ModifyMonitoredItemsResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_MONITOREDITEMMODIFYRESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_SetMonitoringModeRequest_calcSizeBinary(UA_SetMonitoringModeRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SetMonitoringModeRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_MonitoringMode) // monitoringMode
	 + UA_Array_calcSizeBinary(ptr->monitoredItemIdsSize,UA_UINT32,ptr->monitoredItemIds)
	;
}

UA_Int32 UA_SetMonitoringModeRequest_encodeBinary(UA_SetMonitoringModeRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_MonitoringMode_encodeBinary(&src->monitoringMode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->monitoredItemIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->monitoredItemIds,src->monitoredItemIdsSize,UA_UINT32,dst,offset);
	return retval;
}

UA_Int32 UA_SetMonitoringModeRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SetMonitoringModeRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SetMonitoringModeRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_SetMonitoringModeRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_SetMonitoringModeRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_MonitoringMode_decodeBinary(src,offset,&dst->monitoringMode), UA_SetMonitoringModeRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->monitoredItemIdsSize),UA_SetMonitoringModeRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->monitoredItemIdsSize,UA_UINT32,(void**)&dst->monitoredItemIds), UA_SetMonitoringModeRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SetMonitoringModeRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SetMonitoringModeRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SetMonitoringModeRequest)
UA_Int32 UA_SetMonitoringModeRequest_delete(UA_SetMonitoringModeRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SetMonitoringModeRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SetMonitoringModeRequest_deleteMembers(UA_SetMonitoringModeRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->monitoredItemIds,p->monitoredItemIdsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_SetMonitoringModeRequest_init(UA_SetMonitoringModeRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_MonitoringMode_init(&p->monitoringMode);
	p->monitoredItemIdsSize = 0;
	p->monitoredItemIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SetMonitoringModeRequest)
UA_Int32 UA_SetMonitoringModeRequest_copy(const UA_SetMonitoringModeRequest *src,UA_SetMonitoringModeRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SetMonitoringModeRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->monitoredItemIds = src->monitoredItemIds;
	retval |= UA_Array_copy(&src->monitoredItemIds, src->monitoredItemIdsSize,UA_UINT32,(void**)&dst->monitoredItemIds);
	return retval;
}

UA_Int32 UA_SetMonitoringModeResponse_calcSizeBinary(UA_SetMonitoringModeResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SetMonitoringModeResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_SetMonitoringModeResponse_encodeBinary(UA_SetMonitoringModeResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_SetMonitoringModeResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SetMonitoringModeResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SetMonitoringModeResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_SetMonitoringModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_SetMonitoringModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_SetMonitoringModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_SetMonitoringModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_SetMonitoringModeResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SetMonitoringModeResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SetMonitoringModeResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SetMonitoringModeResponse)
UA_Int32 UA_SetMonitoringModeResponse_delete(UA_SetMonitoringModeResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SetMonitoringModeResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SetMonitoringModeResponse_deleteMembers(UA_SetMonitoringModeResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_SetMonitoringModeResponse_init(UA_SetMonitoringModeResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SetMonitoringModeResponse)
UA_Int32 UA_SetMonitoringModeResponse_copy(const UA_SetMonitoringModeResponse *src,UA_SetMonitoringModeResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SetMonitoringModeResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_SetTriggeringRequest_calcSizeBinary(UA_SetTriggeringRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SetTriggeringRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_UInt32) // triggeringItemId
	 + UA_Array_calcSizeBinary(ptr->linksToAddSize,UA_UINT32,ptr->linksToAdd)
	 + UA_Array_calcSizeBinary(ptr->linksToRemoveSize,UA_UINT32,ptr->linksToRemove)
	;
}

UA_Int32 UA_SetTriggeringRequest_encodeBinary(UA_SetTriggeringRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->triggeringItemId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->linksToAddSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->linksToAdd,src->linksToAddSize,UA_UINT32,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->linksToRemoveSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->linksToRemove,src->linksToRemoveSize,UA_UINT32,dst,offset);
	return retval;
}

UA_Int32 UA_SetTriggeringRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SetTriggeringRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SetTriggeringRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_SetTriggeringRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_SetTriggeringRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->triggeringItemId), UA_SetTriggeringRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->linksToAddSize),UA_SetTriggeringRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->linksToAddSize,UA_UINT32,(void**)&dst->linksToAdd), UA_SetTriggeringRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->linksToRemoveSize),UA_SetTriggeringRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->linksToRemoveSize,UA_UINT32,(void**)&dst->linksToRemove), UA_SetTriggeringRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SetTriggeringRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SetTriggeringRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SetTriggeringRequest)
UA_Int32 UA_SetTriggeringRequest_delete(UA_SetTriggeringRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SetTriggeringRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SetTriggeringRequest_deleteMembers(UA_SetTriggeringRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->linksToAdd,p->linksToAddSize,UA_UINT32);
	retval |= UA_Array_delete((void**)&p->linksToRemove,p->linksToRemoveSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_SetTriggeringRequest_init(UA_SetTriggeringRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_UInt32_init(&p->triggeringItemId);
	p->linksToAddSize = 0;
	p->linksToAdd = UA_NULL;
	p->linksToRemoveSize = 0;
	p->linksToRemove = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SetTriggeringRequest)
UA_Int32 UA_SetTriggeringRequest_copy(const UA_SetTriggeringRequest *src,UA_SetTriggeringRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SetTriggeringRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->linksToAdd = src->linksToAdd;
	retval |= UA_Array_copy(&src->linksToAdd, src->linksToAddSize,UA_UINT32,(void**)&dst->linksToAdd);
	dst->linksToRemove = src->linksToRemove;
	retval |= UA_Array_copy(&src->linksToRemove, src->linksToRemoveSize,UA_UINT32,(void**)&dst->linksToRemove);
	return retval;
}

UA_Int32 UA_SetTriggeringResponse_calcSizeBinary(UA_SetTriggeringResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SetTriggeringResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->addResultsSize,UA_STATUSCODE,ptr->addResults)
	 + UA_Array_calcSizeBinary(ptr->addDiagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->addDiagnosticInfos)
	 + UA_Array_calcSizeBinary(ptr->removeResultsSize,UA_STATUSCODE,ptr->removeResults)
	 + UA_Array_calcSizeBinary(ptr->removeDiagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->removeDiagnosticInfos)
	;
}

UA_Int32 UA_SetTriggeringResponse_encodeBinary(UA_SetTriggeringResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->addResultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->addResults,src->addResultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->addDiagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->addDiagnosticInfos,src->addDiagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->removeResultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->removeResults,src->removeResultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->removeDiagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->removeDiagnosticInfos,src->removeDiagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_SetTriggeringResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SetTriggeringResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SetTriggeringResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->addResultsSize),UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->addResultsSize,UA_STATUSCODE,(void**)&dst->addResults), UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->addDiagnosticInfosSize),UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->addDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->addDiagnosticInfos), UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->removeResultsSize),UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->removeResultsSize,UA_STATUSCODE,(void**)&dst->removeResults), UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->removeDiagnosticInfosSize),UA_SetTriggeringResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->removeDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->removeDiagnosticInfos), UA_SetTriggeringResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SetTriggeringResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SetTriggeringResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SetTriggeringResponse)
UA_Int32 UA_SetTriggeringResponse_delete(UA_SetTriggeringResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SetTriggeringResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SetTriggeringResponse_deleteMembers(UA_SetTriggeringResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->addResults,p->addResultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->addDiagnosticInfos,p->addDiagnosticInfosSize,UA_DIAGNOSTICINFO);
	retval |= UA_Array_delete((void**)&p->removeResults,p->removeResultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->removeDiagnosticInfos,p->removeDiagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_SetTriggeringResponse_init(UA_SetTriggeringResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->addResultsSize = 0;
	p->addResults = UA_NULL;
	p->addDiagnosticInfosSize = 0;
	p->addDiagnosticInfos = UA_NULL;
	p->removeResultsSize = 0;
	p->removeResults = UA_NULL;
	p->removeDiagnosticInfosSize = 0;
	p->removeDiagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SetTriggeringResponse)
UA_Int32 UA_SetTriggeringResponse_copy(const UA_SetTriggeringResponse *src,UA_SetTriggeringResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SetTriggeringResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->addResults = src->addResults;
	retval |= UA_Array_copy(&src->addResults, src->addResultsSize,UA_STATUSCODE,(void**)&dst->addResults);
	dst->addDiagnosticInfos = src->addDiagnosticInfos;
	retval |= UA_Array_copy(&src->addDiagnosticInfos, src->addDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->addDiagnosticInfos);
	dst->removeResults = src->removeResults;
	retval |= UA_Array_copy(&src->removeResults, src->removeResultsSize,UA_STATUSCODE,(void**)&dst->removeResults);
	dst->removeDiagnosticInfos = src->removeDiagnosticInfos;
	retval |= UA_Array_copy(&src->removeDiagnosticInfos, src->removeDiagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->removeDiagnosticInfos);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsRequest_calcSizeBinary(UA_DeleteMonitoredItemsRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteMonitoredItemsRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + UA_Array_calcSizeBinary(ptr->monitoredItemIdsSize,UA_UINT32,ptr->monitoredItemIds)
	;
}

UA_Int32 UA_DeleteMonitoredItemsRequest_encodeBinary(UA_DeleteMonitoredItemsRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->monitoredItemIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->monitoredItemIds,src->monitoredItemIdsSize,UA_UINT32,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteMonitoredItemsRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteMonitoredItemsRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_DeleteMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_DeleteMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->monitoredItemIdsSize),UA_DeleteMonitoredItemsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->monitoredItemIdsSize,UA_UINT32,(void**)&dst->monitoredItemIds), UA_DeleteMonitoredItemsRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteMonitoredItemsRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteMonitoredItemsRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteMonitoredItemsRequest)
UA_Int32 UA_DeleteMonitoredItemsRequest_delete(UA_DeleteMonitoredItemsRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteMonitoredItemsRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsRequest_deleteMembers(UA_DeleteMonitoredItemsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->monitoredItemIds,p->monitoredItemIdsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsRequest_init(UA_DeleteMonitoredItemsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	p->monitoredItemIdsSize = 0;
	p->monitoredItemIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteMonitoredItemsRequest)
UA_Int32 UA_DeleteMonitoredItemsRequest_copy(const UA_DeleteMonitoredItemsRequest *src,UA_DeleteMonitoredItemsRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteMonitoredItemsRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->monitoredItemIds = src->monitoredItemIds;
	retval |= UA_Array_copy(&src->monitoredItemIds, src->monitoredItemIdsSize,UA_UINT32,(void**)&dst->monitoredItemIds);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsResponse_calcSizeBinary(UA_DeleteMonitoredItemsResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteMonitoredItemsResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_DeleteMonitoredItemsResponse_encodeBinary(UA_DeleteMonitoredItemsResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteMonitoredItemsResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteMonitoredItemsResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_DeleteMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_DeleteMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_DeleteMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_DeleteMonitoredItemsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_DeleteMonitoredItemsResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteMonitoredItemsResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteMonitoredItemsResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteMonitoredItemsResponse)
UA_Int32 UA_DeleteMonitoredItemsResponse_delete(UA_DeleteMonitoredItemsResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteMonitoredItemsResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsResponse_deleteMembers(UA_DeleteMonitoredItemsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_DeleteMonitoredItemsResponse_init(UA_DeleteMonitoredItemsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteMonitoredItemsResponse)
UA_Int32 UA_DeleteMonitoredItemsResponse_copy(const UA_DeleteMonitoredItemsResponse *src,UA_DeleteMonitoredItemsResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteMonitoredItemsResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_CreateSubscriptionRequest_calcSizeBinary(UA_CreateSubscriptionRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CreateSubscriptionRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_Double) // requestedPublishingInterval
	 + sizeof(UA_UInt32) // requestedLifetimeCount
	 + sizeof(UA_UInt32) // requestedMaxKeepAliveCount
	 + sizeof(UA_UInt32) // maxNotificationsPerPublish
	 + sizeof(UA_Boolean) // publishingEnabled
	 + sizeof(UA_Byte) // priority
	;
}

UA_Int32 UA_CreateSubscriptionRequest_encodeBinary(UA_CreateSubscriptionRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Double_encodeBinary(&src->requestedPublishingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestedLifetimeCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestedMaxKeepAliveCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxNotificationsPerPublish,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->publishingEnabled,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->priority,dst,offset);
	return retval;
}

UA_Int32 UA_CreateSubscriptionRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CreateSubscriptionRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CreateSubscriptionRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_CreateSubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->requestedPublishingInterval), UA_CreateSubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestedLifetimeCount), UA_CreateSubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestedMaxKeepAliveCount), UA_CreateSubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxNotificationsPerPublish), UA_CreateSubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->publishingEnabled), UA_CreateSubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->priority), UA_CreateSubscriptionRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CreateSubscriptionRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CreateSubscriptionRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CreateSubscriptionRequest)
UA_Int32 UA_CreateSubscriptionRequest_delete(UA_CreateSubscriptionRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CreateSubscriptionRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CreateSubscriptionRequest_deleteMembers(UA_CreateSubscriptionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	return retval;
}

UA_Int32 UA_CreateSubscriptionRequest_init(UA_CreateSubscriptionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_Double_init(&p->requestedPublishingInterval);
	retval |= UA_UInt32_init(&p->requestedLifetimeCount);
	retval |= UA_UInt32_init(&p->requestedMaxKeepAliveCount);
	retval |= UA_UInt32_init(&p->maxNotificationsPerPublish);
	retval |= UA_Boolean_init(&p->publishingEnabled);
	retval |= UA_Byte_init(&p->priority);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CreateSubscriptionRequest)
UA_Int32 UA_CreateSubscriptionRequest_copy(const UA_CreateSubscriptionRequest *src,UA_CreateSubscriptionRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CreateSubscriptionRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	return retval;
}

UA_Int32 UA_CreateSubscriptionResponse_calcSizeBinary(UA_CreateSubscriptionResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CreateSubscriptionResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_Double) // revisedPublishingInterval
	 + sizeof(UA_UInt32) // revisedLifetimeCount
	 + sizeof(UA_UInt32) // revisedMaxKeepAliveCount
	;
}

UA_Int32 UA_CreateSubscriptionResponse_encodeBinary(UA_CreateSubscriptionResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_Double_encodeBinary(&src->revisedPublishingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->revisedLifetimeCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->revisedMaxKeepAliveCount,dst,offset);
	return retval;
}

UA_Int32 UA_CreateSubscriptionResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CreateSubscriptionResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CreateSubscriptionResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_CreateSubscriptionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_CreateSubscriptionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->revisedPublishingInterval), UA_CreateSubscriptionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->revisedLifetimeCount), UA_CreateSubscriptionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->revisedMaxKeepAliveCount), UA_CreateSubscriptionResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CreateSubscriptionResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CreateSubscriptionResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CreateSubscriptionResponse)
UA_Int32 UA_CreateSubscriptionResponse_delete(UA_CreateSubscriptionResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CreateSubscriptionResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CreateSubscriptionResponse_deleteMembers(UA_CreateSubscriptionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_CreateSubscriptionResponse_init(UA_CreateSubscriptionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_Double_init(&p->revisedPublishingInterval);
	retval |= UA_UInt32_init(&p->revisedLifetimeCount);
	retval |= UA_UInt32_init(&p->revisedMaxKeepAliveCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CreateSubscriptionResponse)
UA_Int32 UA_CreateSubscriptionResponse_copy(const UA_CreateSubscriptionResponse *src,UA_CreateSubscriptionResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CreateSubscriptionResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_Int32 UA_ModifySubscriptionRequest_calcSizeBinary(UA_ModifySubscriptionRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ModifySubscriptionRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_Double) // requestedPublishingInterval
	 + sizeof(UA_UInt32) // requestedLifetimeCount
	 + sizeof(UA_UInt32) // requestedMaxKeepAliveCount
	 + sizeof(UA_UInt32) // maxNotificationsPerPublish
	 + sizeof(UA_Byte) // priority
	;
}

UA_Int32 UA_ModifySubscriptionRequest_encodeBinary(UA_ModifySubscriptionRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_Double_encodeBinary(&src->requestedPublishingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestedLifetimeCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->requestedMaxKeepAliveCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxNotificationsPerPublish,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->priority,dst,offset);
	return retval;
}

UA_Int32 UA_ModifySubscriptionRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ModifySubscriptionRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ModifySubscriptionRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_ModifySubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_ModifySubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->requestedPublishingInterval), UA_ModifySubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestedLifetimeCount), UA_ModifySubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->requestedMaxKeepAliveCount), UA_ModifySubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxNotificationsPerPublish), UA_ModifySubscriptionRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->priority), UA_ModifySubscriptionRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ModifySubscriptionRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ModifySubscriptionRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ModifySubscriptionRequest)
UA_Int32 UA_ModifySubscriptionRequest_delete(UA_ModifySubscriptionRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ModifySubscriptionRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ModifySubscriptionRequest_deleteMembers(UA_ModifySubscriptionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	return retval;
}

UA_Int32 UA_ModifySubscriptionRequest_init(UA_ModifySubscriptionRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_Double_init(&p->requestedPublishingInterval);
	retval |= UA_UInt32_init(&p->requestedLifetimeCount);
	retval |= UA_UInt32_init(&p->requestedMaxKeepAliveCount);
	retval |= UA_UInt32_init(&p->maxNotificationsPerPublish);
	retval |= UA_Byte_init(&p->priority);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ModifySubscriptionRequest)
UA_Int32 UA_ModifySubscriptionRequest_copy(const UA_ModifySubscriptionRequest *src,UA_ModifySubscriptionRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ModifySubscriptionRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	return retval;
}

UA_Int32 UA_ModifySubscriptionResponse_calcSizeBinary(UA_ModifySubscriptionResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ModifySubscriptionResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + sizeof(UA_Double) // revisedPublishingInterval
	 + sizeof(UA_UInt32) // revisedLifetimeCount
	 + sizeof(UA_UInt32) // revisedMaxKeepAliveCount
	;
}

UA_Int32 UA_ModifySubscriptionResponse_encodeBinary(UA_ModifySubscriptionResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Double_encodeBinary(&src->revisedPublishingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->revisedLifetimeCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->revisedMaxKeepAliveCount,dst,offset);
	return retval;
}

UA_Int32 UA_ModifySubscriptionResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ModifySubscriptionResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ModifySubscriptionResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_ModifySubscriptionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->revisedPublishingInterval), UA_ModifySubscriptionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->revisedLifetimeCount), UA_ModifySubscriptionResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->revisedMaxKeepAliveCount), UA_ModifySubscriptionResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ModifySubscriptionResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ModifySubscriptionResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ModifySubscriptionResponse)
UA_Int32 UA_ModifySubscriptionResponse_delete(UA_ModifySubscriptionResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ModifySubscriptionResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ModifySubscriptionResponse_deleteMembers(UA_ModifySubscriptionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	return retval;
}

UA_Int32 UA_ModifySubscriptionResponse_init(UA_ModifySubscriptionResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_Double_init(&p->revisedPublishingInterval);
	retval |= UA_UInt32_init(&p->revisedLifetimeCount);
	retval |= UA_UInt32_init(&p->revisedMaxKeepAliveCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ModifySubscriptionResponse)
UA_Int32 UA_ModifySubscriptionResponse_copy(const UA_ModifySubscriptionResponse *src,UA_ModifySubscriptionResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ModifySubscriptionResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	return retval;
}

UA_Int32 UA_SetPublishingModeRequest_calcSizeBinary(UA_SetPublishingModeRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SetPublishingModeRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_Boolean) // publishingEnabled
	 + UA_Array_calcSizeBinary(ptr->subscriptionIdsSize,UA_UINT32,ptr->subscriptionIds)
	;
}

UA_Int32 UA_SetPublishingModeRequest_encodeBinary(UA_SetPublishingModeRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->publishingEnabled,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->subscriptionIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->subscriptionIds,src->subscriptionIdsSize,UA_UINT32,dst,offset);
	return retval;
}

UA_Int32 UA_SetPublishingModeRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SetPublishingModeRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SetPublishingModeRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_SetPublishingModeRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->publishingEnabled), UA_SetPublishingModeRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->subscriptionIdsSize),UA_SetPublishingModeRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->subscriptionIdsSize,UA_UINT32,(void**)&dst->subscriptionIds), UA_SetPublishingModeRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SetPublishingModeRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SetPublishingModeRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SetPublishingModeRequest)
UA_Int32 UA_SetPublishingModeRequest_delete(UA_SetPublishingModeRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SetPublishingModeRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SetPublishingModeRequest_deleteMembers(UA_SetPublishingModeRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->subscriptionIds,p->subscriptionIdsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_SetPublishingModeRequest_init(UA_SetPublishingModeRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_Boolean_init(&p->publishingEnabled);
	p->subscriptionIdsSize = 0;
	p->subscriptionIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SetPublishingModeRequest)
UA_Int32 UA_SetPublishingModeRequest_copy(const UA_SetPublishingModeRequest *src,UA_SetPublishingModeRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SetPublishingModeRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->subscriptionIds = src->subscriptionIds;
	retval |= UA_Array_copy(&src->subscriptionIds, src->subscriptionIdsSize,UA_UINT32,(void**)&dst->subscriptionIds);
	return retval;
}

UA_Int32 UA_SetPublishingModeResponse_calcSizeBinary(UA_SetPublishingModeResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SetPublishingModeResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_SetPublishingModeResponse_encodeBinary(UA_SetPublishingModeResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_SetPublishingModeResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SetPublishingModeResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SetPublishingModeResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_SetPublishingModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_SetPublishingModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_SetPublishingModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_SetPublishingModeResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_SetPublishingModeResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SetPublishingModeResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SetPublishingModeResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SetPublishingModeResponse)
UA_Int32 UA_SetPublishingModeResponse_delete(UA_SetPublishingModeResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SetPublishingModeResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SetPublishingModeResponse_deleteMembers(UA_SetPublishingModeResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_SetPublishingModeResponse_init(UA_SetPublishingModeResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SetPublishingModeResponse)
UA_Int32 UA_SetPublishingModeResponse_copy(const UA_SetPublishingModeResponse *src,UA_SetPublishingModeResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SetPublishingModeResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_NotificationMessage_calcSizeBinary(UA_NotificationMessage const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_NotificationMessage);
    	return 0
	 + sizeof(UA_UInt32) // sequenceNumber
	 + sizeof(UA_DateTime) // publishTime
	 + UA_Array_calcSizeBinary(ptr->notificationDataSize,UA_EXTENSIONOBJECT,ptr->notificationData)
	;
}

UA_Int32 UA_NotificationMessage_encodeBinary(UA_NotificationMessage const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->sequenceNumber,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->publishTime,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->notificationDataSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->notificationData,src->notificationDataSize,UA_EXTENSIONOBJECT,dst,offset);
	return retval;
}

UA_Int32 UA_NotificationMessage_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_NotificationMessage * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_NotificationMessage_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->sequenceNumber), UA_NotificationMessage_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->publishTime), UA_NotificationMessage_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->notificationDataSize),UA_NotificationMessage_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->notificationDataSize,UA_EXTENSIONOBJECT,(void**)&dst->notificationData), UA_NotificationMessage_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NotificationMessage)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NotificationMessage)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NotificationMessage)
UA_Int32 UA_NotificationMessage_delete(UA_NotificationMessage *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NotificationMessage_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_NotificationMessage_deleteMembers(UA_NotificationMessage *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->notificationData,p->notificationDataSize,UA_EXTENSIONOBJECT);
	return retval;
}

UA_Int32 UA_NotificationMessage_init(UA_NotificationMessage *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->sequenceNumber);
	retval |= UA_DateTime_init(&p->publishTime);
	p->notificationDataSize = 0;
	p->notificationData = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_NotificationMessage)
UA_Int32 UA_NotificationMessage_copy(const UA_NotificationMessage *src,UA_NotificationMessage *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_NotificationMessage));
	dst->notificationData = src->notificationData;
	retval |= UA_Array_copy(&src->notificationData, src->notificationDataSize,UA_EXTENSIONOBJECT,(void**)&dst->notificationData);
	return retval;
}

UA_Int32 UA_NotificationData_calcSizeBinary(UA_NotificationData const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_NotificationData);
    	return 0
	;
}

UA_Int32 UA_NotificationData_encodeBinary(UA_NotificationData const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_NotificationData_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_NotificationData * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_NotificationData_init(dst);
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NotificationData)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NotificationData)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NotificationData)
UA_Int32 UA_NotificationData_delete(UA_NotificationData *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NotificationData_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_NotificationData_deleteMembers(UA_NotificationData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_NotificationData_init(UA_NotificationData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_NotificationData)
UA_Int32 UA_NotificationData_copy(const UA_NotificationData *src,UA_NotificationData *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_NotificationData));
	return retval;
}

UA_Int32 UA_MonitoredItemNotification_calcSizeBinary(UA_MonitoredItemNotification const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MonitoredItemNotification);
    	return 0
	 + sizeof(UA_UInt32) // clientHandle
	 + UA_DataValue_calcSizeBinary(&ptr->value)
	;
}

UA_Int32 UA_MonitoredItemNotification_encodeBinary(UA_MonitoredItemNotification const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->clientHandle,dst,offset);
	retval |= UA_DataValue_encodeBinary(&src->value,dst,offset);
	return retval;
}

UA_Int32 UA_MonitoredItemNotification_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MonitoredItemNotification * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MonitoredItemNotification_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->clientHandle), UA_MonitoredItemNotification_deleteMembers(dst));
	CHECKED_DECODE(UA_DataValue_decodeBinary(src,offset,&dst->value), UA_MonitoredItemNotification_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MonitoredItemNotification)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MonitoredItemNotification)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MonitoredItemNotification)
UA_Int32 UA_MonitoredItemNotification_delete(UA_MonitoredItemNotification *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MonitoredItemNotification_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MonitoredItemNotification_deleteMembers(UA_MonitoredItemNotification *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DataValue_deleteMembers(&p->value);
	return retval;
}

UA_Int32 UA_MonitoredItemNotification_init(UA_MonitoredItemNotification *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->clientHandle);
	retval |= UA_DataValue_init(&p->value);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MonitoredItemNotification)
UA_Int32 UA_MonitoredItemNotification_copy(const UA_MonitoredItemNotification *src,UA_MonitoredItemNotification *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MonitoredItemNotification));
	retval |= UA_DataValue_copy(&src->value,&dst->value);
	return retval;
}

UA_Int32 UA_EventFieldList_calcSizeBinary(UA_EventFieldList const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EventFieldList);
    	return 0
	 + sizeof(UA_UInt32) // clientHandle
	 + UA_Array_calcSizeBinary(ptr->eventFieldsSize,UA_VARIANT,ptr->eventFields)
	;
}

UA_Int32 UA_EventFieldList_encodeBinary(UA_EventFieldList const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->clientHandle,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->eventFieldsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->eventFields,src->eventFieldsSize,UA_VARIANT,dst,offset);
	return retval;
}

UA_Int32 UA_EventFieldList_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EventFieldList * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EventFieldList_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->clientHandle), UA_EventFieldList_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->eventFieldsSize),UA_EventFieldList_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->eventFieldsSize,UA_VARIANT,(void**)&dst->eventFields), UA_EventFieldList_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EventFieldList)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EventFieldList)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EventFieldList)
UA_Int32 UA_EventFieldList_delete(UA_EventFieldList *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EventFieldList_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EventFieldList_deleteMembers(UA_EventFieldList *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->eventFields,p->eventFieldsSize,UA_VARIANT);
	return retval;
}

UA_Int32 UA_EventFieldList_init(UA_EventFieldList *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->clientHandle);
	p->eventFieldsSize = 0;
	p->eventFields = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EventFieldList)
UA_Int32 UA_EventFieldList_copy(const UA_EventFieldList *src,UA_EventFieldList *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EventFieldList));
	dst->eventFields = src->eventFields;
	retval |= UA_Array_copy(&src->eventFields, src->eventFieldsSize,UA_VARIANT,(void**)&dst->eventFields);
	return retval;
}

UA_Int32 UA_HistoryEventFieldList_calcSizeBinary(UA_HistoryEventFieldList const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryEventFieldList);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->eventFieldsSize,UA_VARIANT,ptr->eventFields)
	;
}

UA_Int32 UA_HistoryEventFieldList_encodeBinary(UA_HistoryEventFieldList const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->eventFieldsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->eventFields,src->eventFieldsSize,UA_VARIANT,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryEventFieldList_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryEventFieldList * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryEventFieldList_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->eventFieldsSize),UA_HistoryEventFieldList_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->eventFieldsSize,UA_VARIANT,(void**)&dst->eventFields), UA_HistoryEventFieldList_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryEventFieldList)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryEventFieldList)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryEventFieldList)
UA_Int32 UA_HistoryEventFieldList_delete(UA_HistoryEventFieldList *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryEventFieldList_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryEventFieldList_deleteMembers(UA_HistoryEventFieldList *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->eventFields,p->eventFieldsSize,UA_VARIANT);
	return retval;
}

UA_Int32 UA_HistoryEventFieldList_init(UA_HistoryEventFieldList *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->eventFieldsSize = 0;
	p->eventFields = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryEventFieldList)
UA_Int32 UA_HistoryEventFieldList_copy(const UA_HistoryEventFieldList *src,UA_HistoryEventFieldList *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryEventFieldList));
	dst->eventFields = src->eventFields;
	retval |= UA_Array_copy(&src->eventFields, src->eventFieldsSize,UA_VARIANT,(void**)&dst->eventFields);
	return retval;
}

UA_Int32 UA_StatusChangeNotification_calcSizeBinary(UA_StatusChangeNotification const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_StatusChangeNotification);
    	return 0
	 + sizeof(UA_StatusCode) // status
	 + UA_DiagnosticInfo_calcSizeBinary(&ptr->diagnosticInfo)
	;
}

UA_Int32 UA_StatusChangeNotification_encodeBinary(UA_StatusChangeNotification const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->status,dst,offset);
	retval |= UA_DiagnosticInfo_encodeBinary(&src->diagnosticInfo,dst,offset);
	return retval;
}

UA_Int32 UA_StatusChangeNotification_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_StatusChangeNotification * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_StatusChangeNotification_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->status), UA_StatusChangeNotification_deleteMembers(dst));
	CHECKED_DECODE(UA_DiagnosticInfo_decodeBinary(src,offset,&dst->diagnosticInfo), UA_StatusChangeNotification_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_StatusChangeNotification)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_StatusChangeNotification)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_StatusChangeNotification)
UA_Int32 UA_StatusChangeNotification_delete(UA_StatusChangeNotification *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusChangeNotification_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_StatusChangeNotification_deleteMembers(UA_StatusChangeNotification *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DiagnosticInfo_deleteMembers(&p->diagnosticInfo);
	return retval;
}

UA_Int32 UA_StatusChangeNotification_init(UA_StatusChangeNotification *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->status);
	retval |= UA_DiagnosticInfo_init(&p->diagnosticInfo);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_StatusChangeNotification)
UA_Int32 UA_StatusChangeNotification_copy(const UA_StatusChangeNotification *src,UA_StatusChangeNotification *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_StatusChangeNotification));
	retval |= UA_DiagnosticInfo_copy(&src->diagnosticInfo,&dst->diagnosticInfo);
	return retval;
}

UA_Int32 UA_SubscriptionAcknowledgement_calcSizeBinary(UA_SubscriptionAcknowledgement const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SubscriptionAcknowledgement);
    	return 0
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_UInt32) // sequenceNumber
	;
}

UA_Int32 UA_SubscriptionAcknowledgement_encodeBinary(UA_SubscriptionAcknowledgement const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->sequenceNumber,dst,offset);
	return retval;
}

UA_Int32 UA_SubscriptionAcknowledgement_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SubscriptionAcknowledgement * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SubscriptionAcknowledgement_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_SubscriptionAcknowledgement_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->sequenceNumber), UA_SubscriptionAcknowledgement_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SubscriptionAcknowledgement)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SubscriptionAcknowledgement)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SubscriptionAcknowledgement)
UA_Int32 UA_SubscriptionAcknowledgement_delete(UA_SubscriptionAcknowledgement *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SubscriptionAcknowledgement_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SubscriptionAcknowledgement_deleteMembers(UA_SubscriptionAcknowledgement *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_SubscriptionAcknowledgement_init(UA_SubscriptionAcknowledgement *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_UInt32_init(&p->sequenceNumber);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SubscriptionAcknowledgement)
UA_Int32 UA_SubscriptionAcknowledgement_copy(const UA_SubscriptionAcknowledgement *src,UA_SubscriptionAcknowledgement *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SubscriptionAcknowledgement));
	return retval;
}

UA_Int32 UA_PublishRequest_calcSizeBinary(UA_PublishRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_PublishRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->subscriptionAcknowledgementsSize,UA_SUBSCRIPTIONACKNOWLEDGEMENT,ptr->subscriptionAcknowledgements)
	;
}

UA_Int32 UA_PublishRequest_encodeBinary(UA_PublishRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->subscriptionAcknowledgementsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->subscriptionAcknowledgements,src->subscriptionAcknowledgementsSize,UA_SUBSCRIPTIONACKNOWLEDGEMENT,dst,offset);
	return retval;
}

UA_Int32 UA_PublishRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_PublishRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_PublishRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_PublishRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->subscriptionAcknowledgementsSize),UA_PublishRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->subscriptionAcknowledgementsSize,UA_SUBSCRIPTIONACKNOWLEDGEMENT,(void**)&dst->subscriptionAcknowledgements), UA_PublishRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_PublishRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_PublishRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_PublishRequest)
UA_Int32 UA_PublishRequest_delete(UA_PublishRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_PublishRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_PublishRequest_deleteMembers(UA_PublishRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->subscriptionAcknowledgements,p->subscriptionAcknowledgementsSize,UA_SUBSCRIPTIONACKNOWLEDGEMENT);
	return retval;
}

UA_Int32 UA_PublishRequest_init(UA_PublishRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->subscriptionAcknowledgementsSize = 0;
	p->subscriptionAcknowledgements = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_PublishRequest)
UA_Int32 UA_PublishRequest_copy(const UA_PublishRequest *src,UA_PublishRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_PublishRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->subscriptionAcknowledgements = src->subscriptionAcknowledgements;
	retval |= UA_Array_copy(&src->subscriptionAcknowledgements, src->subscriptionAcknowledgementsSize,UA_SUBSCRIPTIONACKNOWLEDGEMENT,(void**)&dst->subscriptionAcknowledgements);
	return retval;
}

UA_Int32 UA_PublishResponse_calcSizeBinary(UA_PublishResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_PublishResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + UA_Array_calcSizeBinary(ptr->availableSequenceNumbersSize,UA_UINT32,ptr->availableSequenceNumbers)
	 + sizeof(UA_Boolean) // moreNotifications
	 + UA_NotificationMessage_calcSizeBinary(&ptr->notificationMessage)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_PublishResponse_encodeBinary(UA_PublishResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->availableSequenceNumbersSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->availableSequenceNumbers,src->availableSequenceNumbersSize,UA_UINT32,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->moreNotifications,dst,offset);
	retval |= UA_NotificationMessage_encodeBinary(&src->notificationMessage,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_PublishResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_PublishResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_PublishResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->availableSequenceNumbersSize),UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->availableSequenceNumbersSize,UA_UINT32,(void**)&dst->availableSequenceNumbers), UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->moreNotifications), UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_NotificationMessage_decodeBinary(src,offset,&dst->notificationMessage), UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_PublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_PublishResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_PublishResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_PublishResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_PublishResponse)
UA_Int32 UA_PublishResponse_delete(UA_PublishResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_PublishResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_PublishResponse_deleteMembers(UA_PublishResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->availableSequenceNumbers,p->availableSequenceNumbersSize,UA_UINT32);
	retval |= UA_NotificationMessage_deleteMembers(&p->notificationMessage);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_PublishResponse_init(UA_PublishResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	p->availableSequenceNumbersSize = 0;
	p->availableSequenceNumbers = UA_NULL;
	retval |= UA_Boolean_init(&p->moreNotifications);
	retval |= UA_NotificationMessage_init(&p->notificationMessage);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_PublishResponse)
UA_Int32 UA_PublishResponse_copy(const UA_PublishResponse *src,UA_PublishResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_PublishResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->availableSequenceNumbers = src->availableSequenceNumbers;
	retval |= UA_Array_copy(&src->availableSequenceNumbers, src->availableSequenceNumbersSize,UA_UINT32,(void**)&dst->availableSequenceNumbers);
	retval |= UA_NotificationMessage_copy(&src->notificationMessage,&dst->notificationMessage);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_RepublishRequest_calcSizeBinary(UA_RepublishRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RepublishRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_UInt32) // retransmitSequenceNumber
	;
}

UA_Int32 UA_RepublishRequest_encodeBinary(UA_RepublishRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->retransmitSequenceNumber,dst,offset);
	return retval;
}

UA_Int32 UA_RepublishRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RepublishRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RepublishRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_RepublishRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_RepublishRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->retransmitSequenceNumber), UA_RepublishRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RepublishRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RepublishRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RepublishRequest)
UA_Int32 UA_RepublishRequest_delete(UA_RepublishRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RepublishRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RepublishRequest_deleteMembers(UA_RepublishRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	return retval;
}

UA_Int32 UA_RepublishRequest_init(UA_RepublishRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_UInt32_init(&p->retransmitSequenceNumber);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RepublishRequest)
UA_Int32 UA_RepublishRequest_copy(const UA_RepublishRequest *src,UA_RepublishRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RepublishRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	return retval;
}

UA_Int32 UA_RepublishResponse_calcSizeBinary(UA_RepublishResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RepublishResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_NotificationMessage_calcSizeBinary(&ptr->notificationMessage)
	;
}

UA_Int32 UA_RepublishResponse_encodeBinary(UA_RepublishResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_NotificationMessage_encodeBinary(&src->notificationMessage,dst,offset);
	return retval;
}

UA_Int32 UA_RepublishResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RepublishResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RepublishResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_RepublishResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_NotificationMessage_decodeBinary(src,offset,&dst->notificationMessage), UA_RepublishResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RepublishResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RepublishResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RepublishResponse)
UA_Int32 UA_RepublishResponse_delete(UA_RepublishResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RepublishResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RepublishResponse_deleteMembers(UA_RepublishResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_NotificationMessage_deleteMembers(&p->notificationMessage);
	return retval;
}

UA_Int32 UA_RepublishResponse_init(UA_RepublishResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_NotificationMessage_init(&p->notificationMessage);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RepublishResponse)
UA_Int32 UA_RepublishResponse_copy(const UA_RepublishResponse *src,UA_RepublishResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RepublishResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	retval |= UA_NotificationMessage_copy(&src->notificationMessage,&dst->notificationMessage);
	return retval;
}

UA_Int32 UA_TransferResult_calcSizeBinary(UA_TransferResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TransferResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_Array_calcSizeBinary(ptr->availableSequenceNumbersSize,UA_UINT32,ptr->availableSequenceNumbers)
	;
}

UA_Int32 UA_TransferResult_encodeBinary(UA_TransferResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->availableSequenceNumbersSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->availableSequenceNumbers,src->availableSequenceNumbersSize,UA_UINT32,dst,offset);
	return retval;
}

UA_Int32 UA_TransferResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TransferResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TransferResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_TransferResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->availableSequenceNumbersSize),UA_TransferResult_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->availableSequenceNumbersSize,UA_UINT32,(void**)&dst->availableSequenceNumbers), UA_TransferResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TransferResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TransferResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TransferResult)
UA_Int32 UA_TransferResult_delete(UA_TransferResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TransferResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TransferResult_deleteMembers(UA_TransferResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->availableSequenceNumbers,p->availableSequenceNumbersSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_TransferResult_init(UA_TransferResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	p->availableSequenceNumbersSize = 0;
	p->availableSequenceNumbers = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TransferResult)
UA_Int32 UA_TransferResult_copy(const UA_TransferResult *src,UA_TransferResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TransferResult));
	dst->availableSequenceNumbers = src->availableSequenceNumbers;
	retval |= UA_Array_copy(&src->availableSequenceNumbers, src->availableSequenceNumbersSize,UA_UINT32,(void**)&dst->availableSequenceNumbers);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsRequest_calcSizeBinary(UA_TransferSubscriptionsRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TransferSubscriptionsRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->subscriptionIdsSize,UA_UINT32,ptr->subscriptionIds)
	 + sizeof(UA_Boolean) // sendInitialValues
	;
}

UA_Int32 UA_TransferSubscriptionsRequest_encodeBinary(UA_TransferSubscriptionsRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->subscriptionIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->subscriptionIds,src->subscriptionIdsSize,UA_UINT32,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->sendInitialValues,dst,offset);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TransferSubscriptionsRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TransferSubscriptionsRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_TransferSubscriptionsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->subscriptionIdsSize),UA_TransferSubscriptionsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->subscriptionIdsSize,UA_UINT32,(void**)&dst->subscriptionIds), UA_TransferSubscriptionsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->sendInitialValues), UA_TransferSubscriptionsRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TransferSubscriptionsRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TransferSubscriptionsRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TransferSubscriptionsRequest)
UA_Int32 UA_TransferSubscriptionsRequest_delete(UA_TransferSubscriptionsRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TransferSubscriptionsRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsRequest_deleteMembers(UA_TransferSubscriptionsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->subscriptionIds,p->subscriptionIdsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsRequest_init(UA_TransferSubscriptionsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->subscriptionIdsSize = 0;
	p->subscriptionIds = UA_NULL;
	retval |= UA_Boolean_init(&p->sendInitialValues);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TransferSubscriptionsRequest)
UA_Int32 UA_TransferSubscriptionsRequest_copy(const UA_TransferSubscriptionsRequest *src,UA_TransferSubscriptionsRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TransferSubscriptionsRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->subscriptionIds = src->subscriptionIds;
	retval |= UA_Array_copy(&src->subscriptionIds, src->subscriptionIdsSize,UA_UINT32,(void**)&dst->subscriptionIds);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsResponse_calcSizeBinary(UA_TransferSubscriptionsResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TransferSubscriptionsResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_TRANSFERRESULT,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_TransferSubscriptionsResponse_encodeBinary(UA_TransferSubscriptionsResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_TRANSFERRESULT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TransferSubscriptionsResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TransferSubscriptionsResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_TransferSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_TransferSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_TRANSFERRESULT,(void**)&dst->results), UA_TransferSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_TransferSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_TransferSubscriptionsResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TransferSubscriptionsResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TransferSubscriptionsResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TransferSubscriptionsResponse)
UA_Int32 UA_TransferSubscriptionsResponse_delete(UA_TransferSubscriptionsResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TransferSubscriptionsResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsResponse_deleteMembers(UA_TransferSubscriptionsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_TRANSFERRESULT);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_TransferSubscriptionsResponse_init(UA_TransferSubscriptionsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TransferSubscriptionsResponse)
UA_Int32 UA_TransferSubscriptionsResponse_copy(const UA_TransferSubscriptionsResponse *src,UA_TransferSubscriptionsResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TransferSubscriptionsResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_TRANSFERRESULT,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsRequest_calcSizeBinary(UA_DeleteSubscriptionsRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteSubscriptionsRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + UA_Array_calcSizeBinary(ptr->subscriptionIdsSize,UA_UINT32,ptr->subscriptionIds)
	;
}

UA_Int32 UA_DeleteSubscriptionsRequest_encodeBinary(UA_DeleteSubscriptionsRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->subscriptionIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->subscriptionIds,src->subscriptionIdsSize,UA_UINT32,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteSubscriptionsRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteSubscriptionsRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_DeleteSubscriptionsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->subscriptionIdsSize),UA_DeleteSubscriptionsRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->subscriptionIdsSize,UA_UINT32,(void**)&dst->subscriptionIds), UA_DeleteSubscriptionsRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteSubscriptionsRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteSubscriptionsRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteSubscriptionsRequest)
UA_Int32 UA_DeleteSubscriptionsRequest_delete(UA_DeleteSubscriptionsRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteSubscriptionsRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsRequest_deleteMembers(UA_DeleteSubscriptionsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Array_delete((void**)&p->subscriptionIds,p->subscriptionIdsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsRequest_init(UA_DeleteSubscriptionsRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	p->subscriptionIdsSize = 0;
	p->subscriptionIds = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteSubscriptionsRequest)
UA_Int32 UA_DeleteSubscriptionsRequest_copy(const UA_DeleteSubscriptionsRequest *src,UA_DeleteSubscriptionsRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteSubscriptionsRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	dst->subscriptionIds = src->subscriptionIds;
	retval |= UA_Array_copy(&src->subscriptionIds, src->subscriptionIdsSize,UA_UINT32,(void**)&dst->subscriptionIds);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsResponse_calcSizeBinary(UA_DeleteSubscriptionsResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DeleteSubscriptionsResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Array_calcSizeBinary(ptr->resultsSize,UA_STATUSCODE,ptr->results)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_DeleteSubscriptionsResponse_encodeBinary(UA_DeleteSubscriptionsResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->resultsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->results,src->resultsSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DeleteSubscriptionsResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DeleteSubscriptionsResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_DeleteSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->resultsSize),UA_DeleteSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->resultsSize,UA_STATUSCODE,(void**)&dst->results), UA_DeleteSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_DeleteSubscriptionsResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_DeleteSubscriptionsResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DeleteSubscriptionsResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DeleteSubscriptionsResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DeleteSubscriptionsResponse)
UA_Int32 UA_DeleteSubscriptionsResponse_delete(UA_DeleteSubscriptionsResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DeleteSubscriptionsResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsResponse_deleteMembers(UA_DeleteSubscriptionsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Array_delete((void**)&p->results,p->resultsSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_DeleteSubscriptionsResponse_init(UA_DeleteSubscriptionsResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	p->resultsSize = 0;
	p->results = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DeleteSubscriptionsResponse)
UA_Int32 UA_DeleteSubscriptionsResponse_copy(const UA_DeleteSubscriptionsResponse *src,UA_DeleteSubscriptionsResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DeleteSubscriptionsResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	dst->results = src->results;
	retval |= UA_Array_copy(&src->results, src->resultsSize,UA_STATUSCODE,(void**)&dst->results);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_TYPE_AS(UA_EnumeratedTestType, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_EnumeratedTestType, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EnumeratedTestType)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EnumeratedTestType)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EnumeratedTestType
)
UA_Int32 UA_ScalarTestType_calcSizeBinary(UA_ScalarTestType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ScalarTestType);
    	return 0
	 + sizeof(UA_Boolean) // boolean
	 + sizeof(UA_SByte) // sByte
	 + sizeof(UA_Byte) // byte
	 + sizeof(UA_Int16) // int16
	 + sizeof(UA_UInt16) // uInt16
	 + sizeof(UA_Int32) // int32
	 + sizeof(UA_UInt32) // uInt32
	 + sizeof(UA_Int64) // int64
	 + sizeof(UA_UInt64) // uInt64
	 + sizeof(UA_Float) // myFloat
	 + sizeof(UA_Double) // myDouble
	 + UA_String_calcSizeBinary(&ptr->string)
	 + sizeof(UA_DateTime) // dateTime
	 + sizeof(UA_Guid) // guid
	 + UA_ByteString_calcSizeBinary(&ptr->byteString)
	 + UA_XmlElement_calcSizeBinary(&ptr->xmlElement)
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + UA_ExpandedNodeId_calcSizeBinary(&ptr->expandedNodeId)
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_DiagnosticInfo_calcSizeBinary(&ptr->diagnosticInfo)
	 + UA_QualifiedName_calcSizeBinary(&ptr->qualifiedName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->localizedText)
	 + UA_ExtensionObject_calcSizeBinary(&ptr->extensionObject)
	 + UA_DataValue_calcSizeBinary(&ptr->dataValue)
	 + sizeof(UA_EnumeratedTestType) // enumeratedValue
	;
}

UA_Int32 UA_ScalarTestType_encodeBinary(UA_ScalarTestType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Boolean_encodeBinary(&src->boolean,dst,offset);
	retval |= UA_SByte_encodeBinary(&src->sByte,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->byte,dst,offset);
	retval |= UA_Int16_encodeBinary(&src->int16,dst,offset);
	retval |= UA_UInt16_encodeBinary(&src->uInt16,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->int32,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->uInt32,dst,offset);
	retval |= UA_Int64_encodeBinary(&src->int64,dst,offset);
	retval |= UA_UInt64_encodeBinary(&src->uInt64,dst,offset);
	retval |= UA_Float_encodeBinary(&src->myFloat,dst,offset);
	retval |= UA_Double_encodeBinary(&src->myDouble,dst,offset);
	retval |= UA_String_encodeBinary(&src->string,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->dateTime,dst,offset);
	retval |= UA_Guid_encodeBinary(&src->guid,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->byteString,dst,offset);
	retval |= UA_XmlElement_encodeBinary(&src->xmlElement,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_ExpandedNodeId_encodeBinary(&src->expandedNodeId,dst,offset);
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_DiagnosticInfo_encodeBinary(&src->diagnosticInfo,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->qualifiedName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->localizedText,dst,offset);
	retval |= UA_ExtensionObject_encodeBinary(&src->extensionObject,dst,offset);
	retval |= UA_DataValue_encodeBinary(&src->dataValue,dst,offset);
	retval |= UA_EnumeratedTestType_encodeBinary(&src->enumeratedValue,dst,offset);
	return retval;
}

UA_Int32 UA_ScalarTestType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ScalarTestType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ScalarTestType_init(dst);
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->boolean), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_SByte_decodeBinary(src,offset,&dst->sByte), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->byte), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int16_decodeBinary(src,offset,&dst->int16), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt16_decodeBinary(src,offset,&dst->uInt16), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->int32), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->uInt32), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int64_decodeBinary(src,offset,&dst->int64), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt64_decodeBinary(src,offset,&dst->uInt64), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Float_decodeBinary(src,offset,&dst->myFloat), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->myDouble), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->string), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->dateTime), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Guid_decodeBinary(src,offset,&dst->guid), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->byteString), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_XmlElement_decodeBinary(src,offset,&dst->xmlElement), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_ExpandedNodeId_decodeBinary(src,offset,&dst->expandedNodeId), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_DiagnosticInfo_decodeBinary(src,offset,&dst->diagnosticInfo), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->qualifiedName), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->localizedText), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_ExtensionObject_decodeBinary(src,offset,&dst->extensionObject), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_DataValue_decodeBinary(src,offset,&dst->dataValue), UA_ScalarTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_EnumeratedTestType_decodeBinary(src,offset,&dst->enumeratedValue), UA_ScalarTestType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ScalarTestType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ScalarTestType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ScalarTestType)
UA_Int32 UA_ScalarTestType_delete(UA_ScalarTestType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ScalarTestType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ScalarTestType_deleteMembers(UA_ScalarTestType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->string);
	retval |= UA_ByteString_deleteMembers(&p->byteString);
	retval |= UA_XmlElement_deleteMembers(&p->xmlElement);
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_ExpandedNodeId_deleteMembers(&p->expandedNodeId);
	retval |= UA_DiagnosticInfo_deleteMembers(&p->diagnosticInfo);
	retval |= UA_QualifiedName_deleteMembers(&p->qualifiedName);
	retval |= UA_LocalizedText_deleteMembers(&p->localizedText);
	retval |= UA_ExtensionObject_deleteMembers(&p->extensionObject);
	retval |= UA_DataValue_deleteMembers(&p->dataValue);
	return retval;
}

UA_Int32 UA_ScalarTestType_init(UA_ScalarTestType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Boolean_init(&p->boolean);
	retval |= UA_SByte_init(&p->sByte);
	retval |= UA_Byte_init(&p->byte);
	retval |= UA_Int16_init(&p->int16);
	retval |= UA_UInt16_init(&p->uInt16);
	retval |= UA_Int32_init(&p->int32);
	retval |= UA_UInt32_init(&p->uInt32);
	retval |= UA_Int64_init(&p->int64);
	retval |= UA_UInt64_init(&p->uInt64);
	retval |= UA_Float_init(&p->myFloat);
	retval |= UA_Double_init(&p->myDouble);
	retval |= UA_String_init(&p->string);
	retval |= UA_DateTime_init(&p->dateTime);
	retval |= UA_Guid_init(&p->guid);
	retval |= UA_ByteString_init(&p->byteString);
	retval |= UA_XmlElement_init(&p->xmlElement);
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_ExpandedNodeId_init(&p->expandedNodeId);
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_DiagnosticInfo_init(&p->diagnosticInfo);
	retval |= UA_QualifiedName_init(&p->qualifiedName);
	retval |= UA_LocalizedText_init(&p->localizedText);
	retval |= UA_ExtensionObject_init(&p->extensionObject);
	retval |= UA_DataValue_init(&p->dataValue);
	retval |= UA_EnumeratedTestType_init(&p->enumeratedValue);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ScalarTestType)
UA_Int32 UA_ScalarTestType_copy(const UA_ScalarTestType *src,UA_ScalarTestType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ScalarTestType));
	retval |= UA_String_copy(&src->string,&dst->string);
	retval |= UA_ByteString_copy(&src->byteString,&dst->byteString);
	retval |= UA_XmlElement_copy(&src->xmlElement,&dst->xmlElement);
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_ExpandedNodeId_copy(&src->expandedNodeId,&dst->expandedNodeId);
	retval |= UA_DiagnosticInfo_copy(&src->diagnosticInfo,&dst->diagnosticInfo);
	retval |= UA_QualifiedName_copy(&src->qualifiedName,&dst->qualifiedName);
	retval |= UA_LocalizedText_copy(&src->localizedText,&dst->localizedText);
	retval |= UA_ExtensionObject_copy(&src->extensionObject,&dst->extensionObject);
	retval |= UA_DataValue_copy(&src->dataValue,&dst->dataValue);
	return retval;
}

UA_Int32 UA_ArrayTestType_calcSizeBinary(UA_ArrayTestType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ArrayTestType);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->booleansSize,UA_BOOLEAN,ptr->booleans)
	 + UA_Array_calcSizeBinary(ptr->sBytesSize,UA_SBYTE,ptr->sBytes)
	 + UA_Array_calcSizeBinary(ptr->int16sSize,UA_INT16,ptr->int16s)
	 + UA_Array_calcSizeBinary(ptr->uInt16sSize,UA_UINT16,ptr->uInt16s)
	 + UA_Array_calcSizeBinary(ptr->int32sSize,UA_INT32,ptr->int32s)
	 + UA_Array_calcSizeBinary(ptr->uInt32sSize,UA_UINT32,ptr->uInt32s)
	 + UA_Array_calcSizeBinary(ptr->int64sSize,UA_INT64,ptr->int64s)
	 + UA_Array_calcSizeBinary(ptr->uInt64sSize,UA_UINT64,ptr->uInt64s)
	 + UA_Array_calcSizeBinary(ptr->floatsSize,UA_FLOAT,ptr->floats)
	 + UA_Array_calcSizeBinary(ptr->doublesSize,UA_DOUBLE,ptr->doubles)
	 + UA_Array_calcSizeBinary(ptr->stringsSize,UA_STRING,ptr->strings)
	 + UA_Array_calcSizeBinary(ptr->dateTimesSize,UA_DATETIME,ptr->dateTimes)
	 + UA_Array_calcSizeBinary(ptr->guidsSize,UA_GUID,ptr->guids)
	 + UA_Array_calcSizeBinary(ptr->byteStringsSize,UA_BYTESTRING,ptr->byteStrings)
	 + UA_Array_calcSizeBinary(ptr->xmlElementsSize,UA_XMLELEMENT,ptr->xmlElements)
	 + UA_Array_calcSizeBinary(ptr->nodeIdsSize,UA_NODEID,ptr->nodeIds)
	 + UA_Array_calcSizeBinary(ptr->expandedNodeIdsSize,UA_EXPANDEDNODEID,ptr->expandedNodeIds)
	 + UA_Array_calcSizeBinary(ptr->statusCodesSize,UA_STATUSCODE,ptr->statusCodes)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	 + UA_Array_calcSizeBinary(ptr->qualifiedNamesSize,UA_QUALIFIEDNAME,ptr->qualifiedNames)
	 + UA_Array_calcSizeBinary(ptr->localizedTextsSize,UA_LOCALIZEDTEXT,ptr->localizedTexts)
	 + UA_Array_calcSizeBinary(ptr->extensionObjectsSize,UA_EXTENSIONOBJECT,ptr->extensionObjects)
	 + UA_Array_calcSizeBinary(ptr->dataValuesSize,UA_DATAVALUE,ptr->dataValues)
	 + UA_Array_calcSizeBinary(ptr->variantsSize,UA_VARIANT,ptr->variants)
	 + UA_Array_calcSizeBinary(ptr->enumeratedValuesSize,UA_ENUMERATEDTESTTYPE,ptr->enumeratedValues)
	;
}

UA_Int32 UA_ArrayTestType_encodeBinary(UA_ArrayTestType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->booleansSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->booleans,src->booleansSize,UA_BOOLEAN,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->sBytesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->sBytes,src->sBytesSize,UA_SBYTE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->int16sSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->int16s,src->int16sSize,UA_INT16,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->uInt16sSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->uInt16s,src->uInt16sSize,UA_UINT16,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->int32sSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->int32s,src->int32sSize,UA_INT32,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->uInt32sSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->uInt32s,src->uInt32sSize,UA_UINT32,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->int64sSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->int64s,src->int64sSize,UA_INT64,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->uInt64sSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->uInt64s,src->uInt64sSize,UA_UINT64,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->floatsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->floats,src->floatsSize,UA_FLOAT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->doublesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->doubles,src->doublesSize,UA_DOUBLE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->stringsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->strings,src->stringsSize,UA_STRING,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->dateTimesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->dateTimes,src->dateTimesSize,UA_DATETIME,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->guidsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->guids,src->guidsSize,UA_GUID,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->byteStringsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->byteStrings,src->byteStringsSize,UA_BYTESTRING,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->xmlElementsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->xmlElements,src->xmlElementsSize,UA_XMLELEMENT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->nodeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->nodeIds,src->nodeIdsSize,UA_NODEID,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->expandedNodeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->expandedNodeIds,src->expandedNodeIdsSize,UA_EXPANDEDNODEID,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->statusCodesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->statusCodes,src->statusCodesSize,UA_STATUSCODE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->qualifiedNamesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->qualifiedNames,src->qualifiedNamesSize,UA_QUALIFIEDNAME,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->localizedTextsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->localizedTexts,src->localizedTextsSize,UA_LOCALIZEDTEXT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->extensionObjectsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->extensionObjects,src->extensionObjectsSize,UA_EXTENSIONOBJECT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->dataValuesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->dataValues,src->dataValuesSize,UA_DATAVALUE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->variantsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->variants,src->variantsSize,UA_VARIANT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->enumeratedValuesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->enumeratedValues,src->enumeratedValuesSize,UA_ENUMERATEDTESTTYPE,dst,offset);
	return retval;
}

UA_Int32 UA_ArrayTestType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ArrayTestType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ArrayTestType_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->booleansSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->booleansSize,UA_BOOLEAN,(void**)&dst->booleans), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->sBytesSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->sBytesSize,UA_SBYTE,(void**)&dst->sBytes), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->int16sSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->int16sSize,UA_INT16,(void**)&dst->int16s), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->uInt16sSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->uInt16sSize,UA_UINT16,(void**)&dst->uInt16s), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->int32sSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->int32sSize,UA_INT32,(void**)&dst->int32s), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->uInt32sSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->uInt32sSize,UA_UINT32,(void**)&dst->uInt32s), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->int64sSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->int64sSize,UA_INT64,(void**)&dst->int64s), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->uInt64sSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->uInt64sSize,UA_UINT64,(void**)&dst->uInt64s), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->floatsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->floatsSize,UA_FLOAT,(void**)&dst->floats), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->doublesSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->doublesSize,UA_DOUBLE,(void**)&dst->doubles), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->stringsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->stringsSize,UA_STRING,(void**)&dst->strings), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->dateTimesSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->dateTimesSize,UA_DATETIME,(void**)&dst->dateTimes), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->guidsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->guidsSize,UA_GUID,(void**)&dst->guids), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->byteStringsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->byteStringsSize,UA_BYTESTRING,(void**)&dst->byteStrings), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->xmlElementsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->xmlElementsSize,UA_XMLELEMENT,(void**)&dst->xmlElements), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->nodeIdsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->nodeIdsSize,UA_NODEID,(void**)&dst->nodeIds), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->expandedNodeIdsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->expandedNodeIdsSize,UA_EXPANDEDNODEID,(void**)&dst->expandedNodeIds), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->statusCodesSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->statusCodesSize,UA_STATUSCODE,(void**)&dst->statusCodes), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->qualifiedNamesSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->qualifiedNamesSize,UA_QUALIFIEDNAME,(void**)&dst->qualifiedNames), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->localizedTextsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->localizedTextsSize,UA_LOCALIZEDTEXT,(void**)&dst->localizedTexts), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->extensionObjectsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->extensionObjectsSize,UA_EXTENSIONOBJECT,(void**)&dst->extensionObjects), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->dataValuesSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->dataValuesSize,UA_DATAVALUE,(void**)&dst->dataValues), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->variantsSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->variantsSize,UA_VARIANT,(void**)&dst->variants), UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->enumeratedValuesSize),UA_ArrayTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->enumeratedValuesSize,UA_ENUMERATEDTESTTYPE,(void**)&dst->enumeratedValues), UA_ArrayTestType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ArrayTestType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ArrayTestType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ArrayTestType)
UA_Int32 UA_ArrayTestType_delete(UA_ArrayTestType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ArrayTestType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ArrayTestType_deleteMembers(UA_ArrayTestType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->booleans,p->booleansSize,UA_BOOLEAN);
	retval |= UA_Array_delete((void**)&p->sBytes,p->sBytesSize,UA_SBYTE);
	retval |= UA_Array_delete((void**)&p->int16s,p->int16sSize,UA_INT16);
	retval |= UA_Array_delete((void**)&p->uInt16s,p->uInt16sSize,UA_UINT16);
	retval |= UA_Array_delete((void**)&p->int32s,p->int32sSize,UA_INT32);
	retval |= UA_Array_delete((void**)&p->uInt32s,p->uInt32sSize,UA_UINT32);
	retval |= UA_Array_delete((void**)&p->int64s,p->int64sSize,UA_INT64);
	retval |= UA_Array_delete((void**)&p->uInt64s,p->uInt64sSize,UA_UINT64);
	retval |= UA_Array_delete((void**)&p->floats,p->floatsSize,UA_FLOAT);
	retval |= UA_Array_delete((void**)&p->doubles,p->doublesSize,UA_DOUBLE);
	retval |= UA_Array_delete((void**)&p->strings,p->stringsSize,UA_STRING);
	retval |= UA_Array_delete((void**)&p->dateTimes,p->dateTimesSize,UA_DATETIME);
	retval |= UA_Array_delete((void**)&p->guids,p->guidsSize,UA_GUID);
	retval |= UA_Array_delete((void**)&p->byteStrings,p->byteStringsSize,UA_BYTESTRING);
	retval |= UA_Array_delete((void**)&p->xmlElements,p->xmlElementsSize,UA_XMLELEMENT);
	retval |= UA_Array_delete((void**)&p->nodeIds,p->nodeIdsSize,UA_NODEID);
	retval |= UA_Array_delete((void**)&p->expandedNodeIds,p->expandedNodeIdsSize,UA_EXPANDEDNODEID);
	retval |= UA_Array_delete((void**)&p->statusCodes,p->statusCodesSize,UA_STATUSCODE);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	retval |= UA_Array_delete((void**)&p->qualifiedNames,p->qualifiedNamesSize,UA_QUALIFIEDNAME);
	retval |= UA_Array_delete((void**)&p->localizedTexts,p->localizedTextsSize,UA_LOCALIZEDTEXT);
	retval |= UA_Array_delete((void**)&p->extensionObjects,p->extensionObjectsSize,UA_EXTENSIONOBJECT);
	retval |= UA_Array_delete((void**)&p->dataValues,p->dataValuesSize,UA_DATAVALUE);
	retval |= UA_Array_delete((void**)&p->variants,p->variantsSize,UA_VARIANT);
	retval |= UA_Array_delete((void**)&p->enumeratedValues,p->enumeratedValuesSize,UA_ENUMERATEDTESTTYPE);
	return retval;
}

UA_Int32 UA_ArrayTestType_init(UA_ArrayTestType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->booleansSize = 0;
	p->booleans = UA_NULL;
	p->sBytesSize = 0;
	p->sBytes = UA_NULL;
	p->int16sSize = 0;
	p->int16s = UA_NULL;
	p->uInt16sSize = 0;
	p->uInt16s = UA_NULL;
	p->int32sSize = 0;
	p->int32s = UA_NULL;
	p->uInt32sSize = 0;
	p->uInt32s = UA_NULL;
	p->int64sSize = 0;
	p->int64s = UA_NULL;
	p->uInt64sSize = 0;
	p->uInt64s = UA_NULL;
	p->floatsSize = 0;
	p->floats = UA_NULL;
	p->doublesSize = 0;
	p->doubles = UA_NULL;
	p->stringsSize = 0;
	p->strings = UA_NULL;
	p->dateTimesSize = 0;
	p->dateTimes = UA_NULL;
	p->guidsSize = 0;
	p->guids = UA_NULL;
	p->byteStringsSize = 0;
	p->byteStrings = UA_NULL;
	p->xmlElementsSize = 0;
	p->xmlElements = UA_NULL;
	p->nodeIdsSize = 0;
	p->nodeIds = UA_NULL;
	p->expandedNodeIdsSize = 0;
	p->expandedNodeIds = UA_NULL;
	p->statusCodesSize = 0;
	p->statusCodes = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	p->qualifiedNamesSize = 0;
	p->qualifiedNames = UA_NULL;
	p->localizedTextsSize = 0;
	p->localizedTexts = UA_NULL;
	p->extensionObjectsSize = 0;
	p->extensionObjects = UA_NULL;
	p->dataValuesSize = 0;
	p->dataValues = UA_NULL;
	p->variantsSize = 0;
	p->variants = UA_NULL;
	p->enumeratedValuesSize = 0;
	p->enumeratedValues = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ArrayTestType)
UA_Int32 UA_ArrayTestType_copy(const UA_ArrayTestType *src,UA_ArrayTestType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ArrayTestType));
	dst->booleans = src->booleans;
	retval |= UA_Array_copy(&src->booleans, src->booleansSize,UA_BOOLEAN,(void**)&dst->booleans);
	dst->sBytes = src->sBytes;
	retval |= UA_Array_copy(&src->sBytes, src->sBytesSize,UA_SBYTE,(void**)&dst->sBytes);
	dst->int16s = src->int16s;
	retval |= UA_Array_copy(&src->int16s, src->int16sSize,UA_INT16,(void**)&dst->int16s);
	dst->uInt16s = src->uInt16s;
	retval |= UA_Array_copy(&src->uInt16s, src->uInt16sSize,UA_UINT16,(void**)&dst->uInt16s);
	dst->int32s = src->int32s;
	retval |= UA_Array_copy(&src->int32s, src->int32sSize,UA_INT32,(void**)&dst->int32s);
	dst->uInt32s = src->uInt32s;
	retval |= UA_Array_copy(&src->uInt32s, src->uInt32sSize,UA_UINT32,(void**)&dst->uInt32s);
	dst->int64s = src->int64s;
	retval |= UA_Array_copy(&src->int64s, src->int64sSize,UA_INT64,(void**)&dst->int64s);
	dst->uInt64s = src->uInt64s;
	retval |= UA_Array_copy(&src->uInt64s, src->uInt64sSize,UA_UINT64,(void**)&dst->uInt64s);
	dst->floats = src->floats;
	retval |= UA_Array_copy(&src->floats, src->floatsSize,UA_FLOAT,(void**)&dst->floats);
	dst->doubles = src->doubles;
	retval |= UA_Array_copy(&src->doubles, src->doublesSize,UA_DOUBLE,(void**)&dst->doubles);
	dst->strings = src->strings;
	retval |= UA_Array_copy(&src->strings, src->stringsSize,UA_STRING,(void**)&dst->strings);
	dst->dateTimes = src->dateTimes;
	retval |= UA_Array_copy(&src->dateTimes, src->dateTimesSize,UA_DATETIME,(void**)&dst->dateTimes);
	dst->guids = src->guids;
	retval |= UA_Array_copy(&src->guids, src->guidsSize,UA_GUID,(void**)&dst->guids);
	dst->byteStrings = src->byteStrings;
	retval |= UA_Array_copy(&src->byteStrings, src->byteStringsSize,UA_BYTESTRING,(void**)&dst->byteStrings);
	dst->xmlElements = src->xmlElements;
	retval |= UA_Array_copy(&src->xmlElements, src->xmlElementsSize,UA_XMLELEMENT,(void**)&dst->xmlElements);
	dst->nodeIds = src->nodeIds;
	retval |= UA_Array_copy(&src->nodeIds, src->nodeIdsSize,UA_NODEID,(void**)&dst->nodeIds);
	dst->expandedNodeIds = src->expandedNodeIds;
	retval |= UA_Array_copy(&src->expandedNodeIds, src->expandedNodeIdsSize,UA_EXPANDEDNODEID,(void**)&dst->expandedNodeIds);
	dst->statusCodes = src->statusCodes;
	retval |= UA_Array_copy(&src->statusCodes, src->statusCodesSize,UA_STATUSCODE,(void**)&dst->statusCodes);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	dst->qualifiedNames = src->qualifiedNames;
	retval |= UA_Array_copy(&src->qualifiedNames, src->qualifiedNamesSize,UA_QUALIFIEDNAME,(void**)&dst->qualifiedNames);
	dst->localizedTexts = src->localizedTexts;
	retval |= UA_Array_copy(&src->localizedTexts, src->localizedTextsSize,UA_LOCALIZEDTEXT,(void**)&dst->localizedTexts);
	dst->extensionObjects = src->extensionObjects;
	retval |= UA_Array_copy(&src->extensionObjects, src->extensionObjectsSize,UA_EXTENSIONOBJECT,(void**)&dst->extensionObjects);
	dst->dataValues = src->dataValues;
	retval |= UA_Array_copy(&src->dataValues, src->dataValuesSize,UA_DATAVALUE,(void**)&dst->dataValues);
	dst->variants = src->variants;
	retval |= UA_Array_copy(&src->variants, src->variantsSize,UA_VARIANT,(void**)&dst->variants);
	dst->enumeratedValues = src->enumeratedValues;
	retval |= UA_Array_copy(&src->enumeratedValues, src->enumeratedValuesSize,UA_ENUMERATEDTESTTYPE,(void**)&dst->enumeratedValues);
	return retval;
}

UA_Int32 UA_CompositeTestType_calcSizeBinary(UA_CompositeTestType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_CompositeTestType);
    	return 0
	 + UA_ScalarTestType_calcSizeBinary(&ptr->field1)
	 + UA_ArrayTestType_calcSizeBinary(&ptr->field2)
	;
}

UA_Int32 UA_CompositeTestType_encodeBinary(UA_CompositeTestType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ScalarTestType_encodeBinary(&src->field1,dst,offset);
	retval |= UA_ArrayTestType_encodeBinary(&src->field2,dst,offset);
	return retval;
}

UA_Int32 UA_CompositeTestType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_CompositeTestType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_CompositeTestType_init(dst);
	CHECKED_DECODE(UA_ScalarTestType_decodeBinary(src,offset,&dst->field1), UA_CompositeTestType_deleteMembers(dst));
	CHECKED_DECODE(UA_ArrayTestType_decodeBinary(src,offset,&dst->field2), UA_CompositeTestType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_CompositeTestType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_CompositeTestType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_CompositeTestType)
UA_Int32 UA_CompositeTestType_delete(UA_CompositeTestType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_CompositeTestType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_CompositeTestType_deleteMembers(UA_CompositeTestType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ScalarTestType_deleteMembers(&p->field1);
	retval |= UA_ArrayTestType_deleteMembers(&p->field2);
	return retval;
}

UA_Int32 UA_CompositeTestType_init(UA_CompositeTestType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ScalarTestType_init(&p->field1);
	retval |= UA_ArrayTestType_init(&p->field2);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_CompositeTestType)
UA_Int32 UA_CompositeTestType_copy(const UA_CompositeTestType *src,UA_CompositeTestType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_CompositeTestType));
	retval |= UA_ScalarTestType_copy(&src->field1,&dst->field1);
	retval |= UA_ArrayTestType_copy(&src->field2,&dst->field2);
	return retval;
}

UA_Int32 UA_TestStackRequest_calcSizeBinary(UA_TestStackRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TestStackRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // testId
	 + sizeof(UA_Int32) // iteration
	 + UA_Variant_calcSizeBinary(&ptr->input)
	;
}

UA_Int32 UA_TestStackRequest_encodeBinary(UA_TestStackRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->testId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->iteration,dst,offset);
	retval |= UA_Variant_encodeBinary(&src->input,dst,offset);
	return retval;
}

UA_Int32 UA_TestStackRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TestStackRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TestStackRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_TestStackRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->testId), UA_TestStackRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->iteration), UA_TestStackRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Variant_decodeBinary(src,offset,&dst->input), UA_TestStackRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TestStackRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TestStackRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TestStackRequest)
UA_Int32 UA_TestStackRequest_delete(UA_TestStackRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TestStackRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TestStackRequest_deleteMembers(UA_TestStackRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_Variant_deleteMembers(&p->input);
	return retval;
}

UA_Int32 UA_TestStackRequest_init(UA_TestStackRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->testId);
	retval |= UA_Int32_init(&p->iteration);
	retval |= UA_Variant_init(&p->input);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TestStackRequest)
UA_Int32 UA_TestStackRequest_copy(const UA_TestStackRequest *src,UA_TestStackRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TestStackRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_Variant_copy(&src->input,&dst->input);
	return retval;
}

UA_Int32 UA_TestStackResponse_calcSizeBinary(UA_TestStackResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TestStackResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_Variant_calcSizeBinary(&ptr->output)
	;
}

UA_Int32 UA_TestStackResponse_encodeBinary(UA_TestStackResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_Variant_encodeBinary(&src->output,dst,offset);
	return retval;
}

UA_Int32 UA_TestStackResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TestStackResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TestStackResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_TestStackResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_Variant_decodeBinary(src,offset,&dst->output), UA_TestStackResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TestStackResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TestStackResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TestStackResponse)
UA_Int32 UA_TestStackResponse_delete(UA_TestStackResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TestStackResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TestStackResponse_deleteMembers(UA_TestStackResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_Variant_deleteMembers(&p->output);
	return retval;
}

UA_Int32 UA_TestStackResponse_init(UA_TestStackResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_Variant_init(&p->output);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TestStackResponse)
UA_Int32 UA_TestStackResponse_copy(const UA_TestStackResponse *src,UA_TestStackResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TestStackResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	retval |= UA_Variant_copy(&src->output,&dst->output);
	return retval;
}

UA_Int32 UA_TestStackExRequest_calcSizeBinary(UA_TestStackExRequest const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TestStackExRequest);
    	return 0
	 + UA_RequestHeader_calcSizeBinary(&ptr->requestHeader)
	 + sizeof(UA_UInt32) // testId
	 + sizeof(UA_Int32) // iteration
	 + UA_CompositeTestType_calcSizeBinary(&ptr->input)
	;
}

UA_Int32 UA_TestStackExRequest_encodeBinary(UA_TestStackExRequest const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_encodeBinary(&src->requestHeader,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->testId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->iteration,dst,offset);
	retval |= UA_CompositeTestType_encodeBinary(&src->input,dst,offset);
	return retval;
}

UA_Int32 UA_TestStackExRequest_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TestStackExRequest * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TestStackExRequest_init(dst);
	CHECKED_DECODE(UA_RequestHeader_decodeBinary(src,offset,&dst->requestHeader), UA_TestStackExRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->testId), UA_TestStackExRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->iteration), UA_TestStackExRequest_deleteMembers(dst));
	CHECKED_DECODE(UA_CompositeTestType_decodeBinary(src,offset,&dst->input), UA_TestStackExRequest_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TestStackExRequest)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TestStackExRequest)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TestStackExRequest)
UA_Int32 UA_TestStackExRequest_delete(UA_TestStackExRequest *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TestStackExRequest_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TestStackExRequest_deleteMembers(UA_TestStackExRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_deleteMembers(&p->requestHeader);
	retval |= UA_CompositeTestType_deleteMembers(&p->input);
	return retval;
}

UA_Int32 UA_TestStackExRequest_init(UA_TestStackExRequest *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RequestHeader_init(&p->requestHeader);
	retval |= UA_UInt32_init(&p->testId);
	retval |= UA_Int32_init(&p->iteration);
	retval |= UA_CompositeTestType_init(&p->input);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TestStackExRequest)
UA_Int32 UA_TestStackExRequest_copy(const UA_TestStackExRequest *src,UA_TestStackExRequest *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TestStackExRequest));
	retval |= UA_RequestHeader_copy(&src->requestHeader,&dst->requestHeader);
	retval |= UA_CompositeTestType_copy(&src->input,&dst->input);
	return retval;
}

UA_Int32 UA_TestStackExResponse_calcSizeBinary(UA_TestStackExResponse const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TestStackExResponse);
    	return 0
	 + UA_ResponseHeader_calcSizeBinary(&ptr->responseHeader)
	 + UA_CompositeTestType_calcSizeBinary(&ptr->output)
	;
}

UA_Int32 UA_TestStackExResponse_encodeBinary(UA_TestStackExResponse const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_encodeBinary(&src->responseHeader,dst,offset);
	retval |= UA_CompositeTestType_encodeBinary(&src->output,dst,offset);
	return retval;
}

UA_Int32 UA_TestStackExResponse_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TestStackExResponse * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TestStackExResponse_init(dst);
	CHECKED_DECODE(UA_ResponseHeader_decodeBinary(src,offset,&dst->responseHeader), UA_TestStackExResponse_deleteMembers(dst));
	CHECKED_DECODE(UA_CompositeTestType_decodeBinary(src,offset,&dst->output), UA_TestStackExResponse_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TestStackExResponse)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TestStackExResponse)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TestStackExResponse)
UA_Int32 UA_TestStackExResponse_delete(UA_TestStackExResponse *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TestStackExResponse_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TestStackExResponse_deleteMembers(UA_TestStackExResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_deleteMembers(&p->responseHeader);
	retval |= UA_CompositeTestType_deleteMembers(&p->output);
	return retval;
}

UA_Int32 UA_TestStackExResponse_init(UA_TestStackExResponse *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ResponseHeader_init(&p->responseHeader);
	retval |= UA_CompositeTestType_init(&p->output);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TestStackExResponse)
UA_Int32 UA_TestStackExResponse_copy(const UA_TestStackExResponse *src,UA_TestStackExResponse *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TestStackExResponse));
	retval |= UA_ResponseHeader_copy(&src->responseHeader,&dst->responseHeader);
	retval |= UA_CompositeTestType_copy(&src->output,&dst->output);
	return retval;
}

UA_Int32 UA_BuildInfo_calcSizeBinary(UA_BuildInfo const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_BuildInfo);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->productUri)
	 + UA_String_calcSizeBinary(&ptr->manufacturerName)
	 + UA_String_calcSizeBinary(&ptr->productName)
	 + UA_String_calcSizeBinary(&ptr->softwareVersion)
	 + UA_String_calcSizeBinary(&ptr->buildNumber)
	 + sizeof(UA_DateTime) // buildDate
	;
}

UA_Int32 UA_BuildInfo_encodeBinary(UA_BuildInfo const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->productUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->manufacturerName,dst,offset);
	retval |= UA_String_encodeBinary(&src->productName,dst,offset);
	retval |= UA_String_encodeBinary(&src->softwareVersion,dst,offset);
	retval |= UA_String_encodeBinary(&src->buildNumber,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->buildDate,dst,offset);
	return retval;
}

UA_Int32 UA_BuildInfo_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_BuildInfo * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_BuildInfo_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->productUri), UA_BuildInfo_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->manufacturerName), UA_BuildInfo_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->productName), UA_BuildInfo_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->softwareVersion), UA_BuildInfo_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->buildNumber), UA_BuildInfo_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->buildDate), UA_BuildInfo_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_BuildInfo)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_BuildInfo)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_BuildInfo)
UA_Int32 UA_BuildInfo_delete(UA_BuildInfo *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BuildInfo_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_BuildInfo_deleteMembers(UA_BuildInfo *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->productUri);
	retval |= UA_String_deleteMembers(&p->manufacturerName);
	retval |= UA_String_deleteMembers(&p->productName);
	retval |= UA_String_deleteMembers(&p->softwareVersion);
	retval |= UA_String_deleteMembers(&p->buildNumber);
	return retval;
}

UA_Int32 UA_BuildInfo_init(UA_BuildInfo *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->productUri);
	retval |= UA_String_init(&p->manufacturerName);
	retval |= UA_String_init(&p->productName);
	retval |= UA_String_init(&p->softwareVersion);
	retval |= UA_String_init(&p->buildNumber);
	retval |= UA_DateTime_init(&p->buildDate);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_BuildInfo)
UA_Int32 UA_BuildInfo_copy(const UA_BuildInfo *src,UA_BuildInfo *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_BuildInfo));
	retval |= UA_String_copy(&src->productUri,&dst->productUri);
	retval |= UA_String_copy(&src->manufacturerName,&dst->manufacturerName);
	retval |= UA_String_copy(&src->productName,&dst->productName);
	retval |= UA_String_copy(&src->softwareVersion,&dst->softwareVersion);
	retval |= UA_String_copy(&src->buildNumber,&dst->buildNumber);
	return retval;
}

UA_TYPE_AS(UA_RedundancySupport, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_RedundancySupport, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RedundancySupport)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RedundancySupport)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RedundancySupport
)
UA_TYPE_AS(UA_ServerState, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_ServerState, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ServerState)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ServerState)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ServerState
)
UA_Int32 UA_RedundantServerDataType_calcSizeBinary(UA_RedundantServerDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_RedundantServerDataType);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->serverId)
	 + sizeof(UA_Byte) // serviceLevel
	 + sizeof(UA_ServerState) // serverState
	;
}

UA_Int32 UA_RedundantServerDataType_encodeBinary(UA_RedundantServerDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->serverId,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->serviceLevel,dst,offset);
	retval |= UA_ServerState_encodeBinary(&src->serverState,dst,offset);
	return retval;
}

UA_Int32 UA_RedundantServerDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_RedundantServerDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_RedundantServerDataType_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->serverId), UA_RedundantServerDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->serviceLevel), UA_RedundantServerDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServerState_decodeBinary(src,offset,&dst->serverState), UA_RedundantServerDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_RedundantServerDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_RedundantServerDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_RedundantServerDataType)
UA_Int32 UA_RedundantServerDataType_delete(UA_RedundantServerDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_RedundantServerDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_RedundantServerDataType_deleteMembers(UA_RedundantServerDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->serverId);
	return retval;
}

UA_Int32 UA_RedundantServerDataType_init(UA_RedundantServerDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->serverId);
	retval |= UA_Byte_init(&p->serviceLevel);
	retval |= UA_ServerState_init(&p->serverState);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_RedundantServerDataType)
UA_Int32 UA_RedundantServerDataType_copy(const UA_RedundantServerDataType *src,UA_RedundantServerDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_RedundantServerDataType));
	retval |= UA_String_copy(&src->serverId,&dst->serverId);
	return retval;
}

UA_Int32 UA_EndpointUrlListDataType_calcSizeBinary(UA_EndpointUrlListDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EndpointUrlListDataType);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->endpointUrlListSize,UA_STRING,ptr->endpointUrlList)
	;
}

UA_Int32 UA_EndpointUrlListDataType_encodeBinary(UA_EndpointUrlListDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->endpointUrlListSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->endpointUrlList,src->endpointUrlListSize,UA_STRING,dst,offset);
	return retval;
}

UA_Int32 UA_EndpointUrlListDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EndpointUrlListDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EndpointUrlListDataType_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->endpointUrlListSize),UA_EndpointUrlListDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->endpointUrlListSize,UA_STRING,(void**)&dst->endpointUrlList), UA_EndpointUrlListDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EndpointUrlListDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EndpointUrlListDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EndpointUrlListDataType)
UA_Int32 UA_EndpointUrlListDataType_delete(UA_EndpointUrlListDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EndpointUrlListDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EndpointUrlListDataType_deleteMembers(UA_EndpointUrlListDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->endpointUrlList,p->endpointUrlListSize,UA_STRING);
	return retval;
}

UA_Int32 UA_EndpointUrlListDataType_init(UA_EndpointUrlListDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->endpointUrlListSize = 0;
	p->endpointUrlList = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EndpointUrlListDataType)
UA_Int32 UA_EndpointUrlListDataType_copy(const UA_EndpointUrlListDataType *src,UA_EndpointUrlListDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EndpointUrlListDataType));
	dst->endpointUrlList = src->endpointUrlList;
	retval |= UA_Array_copy(&src->endpointUrlList, src->endpointUrlListSize,UA_STRING,(void**)&dst->endpointUrlList);
	return retval;
}

UA_Int32 UA_NetworkGroupDataType_calcSizeBinary(UA_NetworkGroupDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_NetworkGroupDataType);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->serverUri)
	 + UA_Array_calcSizeBinary(ptr->networkPathsSize,UA_ENDPOINTURLLISTDATATYPE,ptr->networkPaths)
	;
}

UA_Int32 UA_NetworkGroupDataType_encodeBinary(UA_NetworkGroupDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->serverUri,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->networkPathsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->networkPaths,src->networkPathsSize,UA_ENDPOINTURLLISTDATATYPE,dst,offset);
	return retval;
}

UA_Int32 UA_NetworkGroupDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_NetworkGroupDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_NetworkGroupDataType_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->serverUri), UA_NetworkGroupDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->networkPathsSize),UA_NetworkGroupDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->networkPathsSize,UA_ENDPOINTURLLISTDATATYPE,(void**)&dst->networkPaths), UA_NetworkGroupDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_NetworkGroupDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_NetworkGroupDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_NetworkGroupDataType)
UA_Int32 UA_NetworkGroupDataType_delete(UA_NetworkGroupDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NetworkGroupDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_NetworkGroupDataType_deleteMembers(UA_NetworkGroupDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->serverUri);
	retval |= UA_Array_delete((void**)&p->networkPaths,p->networkPathsSize,UA_ENDPOINTURLLISTDATATYPE);
	return retval;
}

UA_Int32 UA_NetworkGroupDataType_init(UA_NetworkGroupDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->serverUri);
	p->networkPathsSize = 0;
	p->networkPaths = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_NetworkGroupDataType)
UA_Int32 UA_NetworkGroupDataType_copy(const UA_NetworkGroupDataType *src,UA_NetworkGroupDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_NetworkGroupDataType));
	retval |= UA_String_copy(&src->serverUri,&dst->serverUri);
	dst->networkPaths = src->networkPaths;
	retval |= UA_Array_copy(&src->networkPaths, src->networkPathsSize,UA_ENDPOINTURLLISTDATATYPE,(void**)&dst->networkPaths);
	return retval;
}

UA_Int32 UA_SamplingIntervalDiagnosticsDataType_calcSizeBinary(UA_SamplingIntervalDiagnosticsDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SamplingIntervalDiagnosticsDataType);
    	return 0
	 + sizeof(UA_Double) // samplingInterval
	 + sizeof(UA_UInt32) // monitoredItemCount
	 + sizeof(UA_UInt32) // maxMonitoredItemCount
	 + sizeof(UA_UInt32) // disabledMonitoredItemCount
	;
}

UA_Int32 UA_SamplingIntervalDiagnosticsDataType_encodeBinary(UA_SamplingIntervalDiagnosticsDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_encodeBinary(&src->samplingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->monitoredItemCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxMonitoredItemCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->disabledMonitoredItemCount,dst,offset);
	return retval;
}

UA_Int32 UA_SamplingIntervalDiagnosticsDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SamplingIntervalDiagnosticsDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SamplingIntervalDiagnosticsDataType_init(dst);
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->samplingInterval), UA_SamplingIntervalDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->monitoredItemCount), UA_SamplingIntervalDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxMonitoredItemCount), UA_SamplingIntervalDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->disabledMonitoredItemCount), UA_SamplingIntervalDiagnosticsDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SamplingIntervalDiagnosticsDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SamplingIntervalDiagnosticsDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SamplingIntervalDiagnosticsDataType)
UA_Int32 UA_SamplingIntervalDiagnosticsDataType_delete(UA_SamplingIntervalDiagnosticsDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SamplingIntervalDiagnosticsDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SamplingIntervalDiagnosticsDataType_deleteMembers(UA_SamplingIntervalDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_SamplingIntervalDiagnosticsDataType_init(UA_SamplingIntervalDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_init(&p->samplingInterval);
	retval |= UA_UInt32_init(&p->monitoredItemCount);
	retval |= UA_UInt32_init(&p->maxMonitoredItemCount);
	retval |= UA_UInt32_init(&p->disabledMonitoredItemCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SamplingIntervalDiagnosticsDataType)
UA_Int32 UA_SamplingIntervalDiagnosticsDataType_copy(const UA_SamplingIntervalDiagnosticsDataType *src,UA_SamplingIntervalDiagnosticsDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SamplingIntervalDiagnosticsDataType));
	return retval;
}

UA_Int32 UA_ServerDiagnosticsSummaryDataType_calcSizeBinary(UA_ServerDiagnosticsSummaryDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ServerDiagnosticsSummaryDataType);
    	return 0
	 + sizeof(UA_UInt32) // serverViewCount
	 + sizeof(UA_UInt32) // currentSessionCount
	 + sizeof(UA_UInt32) // cumulatedSessionCount
	 + sizeof(UA_UInt32) // securityRejectedSessionCount
	 + sizeof(UA_UInt32) // rejectedSessionCount
	 + sizeof(UA_UInt32) // sessionTimeoutCount
	 + sizeof(UA_UInt32) // sessionAbortCount
	 + sizeof(UA_UInt32) // currentSubscriptionCount
	 + sizeof(UA_UInt32) // cumulatedSubscriptionCount
	 + sizeof(UA_UInt32) // publishingIntervalCount
	 + sizeof(UA_UInt32) // securityRejectedRequestsCount
	 + sizeof(UA_UInt32) // rejectedRequestsCount
	;
}

UA_Int32 UA_ServerDiagnosticsSummaryDataType_encodeBinary(UA_ServerDiagnosticsSummaryDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->serverViewCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->currentSessionCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->cumulatedSessionCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->securityRejectedSessionCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->rejectedSessionCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->sessionTimeoutCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->sessionAbortCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->currentSubscriptionCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->cumulatedSubscriptionCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->publishingIntervalCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->securityRejectedRequestsCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->rejectedRequestsCount,dst,offset);
	return retval;
}

UA_Int32 UA_ServerDiagnosticsSummaryDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ServerDiagnosticsSummaryDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ServerDiagnosticsSummaryDataType_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->serverViewCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->currentSessionCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->cumulatedSessionCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->securityRejectedSessionCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->rejectedSessionCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->sessionTimeoutCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->sessionAbortCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->currentSubscriptionCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->cumulatedSubscriptionCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->publishingIntervalCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->securityRejectedRequestsCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->rejectedRequestsCount), UA_ServerDiagnosticsSummaryDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ServerDiagnosticsSummaryDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ServerDiagnosticsSummaryDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ServerDiagnosticsSummaryDataType)
UA_Int32 UA_ServerDiagnosticsSummaryDataType_delete(UA_ServerDiagnosticsSummaryDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ServerDiagnosticsSummaryDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ServerDiagnosticsSummaryDataType_deleteMembers(UA_ServerDiagnosticsSummaryDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_ServerDiagnosticsSummaryDataType_init(UA_ServerDiagnosticsSummaryDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->serverViewCount);
	retval |= UA_UInt32_init(&p->currentSessionCount);
	retval |= UA_UInt32_init(&p->cumulatedSessionCount);
	retval |= UA_UInt32_init(&p->securityRejectedSessionCount);
	retval |= UA_UInt32_init(&p->rejectedSessionCount);
	retval |= UA_UInt32_init(&p->sessionTimeoutCount);
	retval |= UA_UInt32_init(&p->sessionAbortCount);
	retval |= UA_UInt32_init(&p->currentSubscriptionCount);
	retval |= UA_UInt32_init(&p->cumulatedSubscriptionCount);
	retval |= UA_UInt32_init(&p->publishingIntervalCount);
	retval |= UA_UInt32_init(&p->securityRejectedRequestsCount);
	retval |= UA_UInt32_init(&p->rejectedRequestsCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ServerDiagnosticsSummaryDataType)
UA_Int32 UA_ServerDiagnosticsSummaryDataType_copy(const UA_ServerDiagnosticsSummaryDataType *src,UA_ServerDiagnosticsSummaryDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ServerDiagnosticsSummaryDataType));
	return retval;
}

UA_Int32 UA_ServerStatusDataType_calcSizeBinary(UA_ServerStatusDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ServerStatusDataType);
    	return 0
	 + sizeof(UA_DateTime) // startTime
	 + sizeof(UA_DateTime) // currentTime
	 + sizeof(UA_ServerState) // state
	 + UA_BuildInfo_calcSizeBinary(&ptr->buildInfo)
	 + sizeof(UA_UInt32) // secondsTillShutdown
	 + UA_LocalizedText_calcSizeBinary(&ptr->shutdownReason)
	;
}

UA_Int32 UA_ServerStatusDataType_encodeBinary(UA_ServerStatusDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_encodeBinary(&src->startTime,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->currentTime,dst,offset);
	retval |= UA_ServerState_encodeBinary(&src->state,dst,offset);
	retval |= UA_BuildInfo_encodeBinary(&src->buildInfo,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->secondsTillShutdown,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->shutdownReason,dst,offset);
	return retval;
}

UA_Int32 UA_ServerStatusDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ServerStatusDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ServerStatusDataType_init(dst);
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->startTime), UA_ServerStatusDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->currentTime), UA_ServerStatusDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServerState_decodeBinary(src,offset,&dst->state), UA_ServerStatusDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_BuildInfo_decodeBinary(src,offset,&dst->buildInfo), UA_ServerStatusDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->secondsTillShutdown), UA_ServerStatusDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->shutdownReason), UA_ServerStatusDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ServerStatusDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ServerStatusDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ServerStatusDataType)
UA_Int32 UA_ServerStatusDataType_delete(UA_ServerStatusDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ServerStatusDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ServerStatusDataType_deleteMembers(UA_ServerStatusDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_BuildInfo_deleteMembers(&p->buildInfo);
	retval |= UA_LocalizedText_deleteMembers(&p->shutdownReason);
	return retval;
}

UA_Int32 UA_ServerStatusDataType_init(UA_ServerStatusDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_init(&p->startTime);
	retval |= UA_DateTime_init(&p->currentTime);
	retval |= UA_ServerState_init(&p->state);
	retval |= UA_BuildInfo_init(&p->buildInfo);
	retval |= UA_UInt32_init(&p->secondsTillShutdown);
	retval |= UA_LocalizedText_init(&p->shutdownReason);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ServerStatusDataType)
UA_Int32 UA_ServerStatusDataType_copy(const UA_ServerStatusDataType *src,UA_ServerStatusDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ServerStatusDataType));
	retval |= UA_BuildInfo_copy(&src->buildInfo,&dst->buildInfo);
	retval |= UA_LocalizedText_copy(&src->shutdownReason,&dst->shutdownReason);
	return retval;
}

UA_Int32 UA_SessionSecurityDiagnosticsDataType_calcSizeBinary(UA_SessionSecurityDiagnosticsDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SessionSecurityDiagnosticsDataType);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->sessionId)
	 + UA_String_calcSizeBinary(&ptr->clientUserIdOfSession)
	 + UA_Array_calcSizeBinary(ptr->clientUserIdHistorySize,UA_STRING,ptr->clientUserIdHistory)
	 + UA_String_calcSizeBinary(&ptr->authenticationMechanism)
	 + UA_String_calcSizeBinary(&ptr->encoding)
	 + UA_String_calcSizeBinary(&ptr->transportProtocol)
	 + sizeof(UA_MessageSecurityMode) // securityMode
	 + UA_String_calcSizeBinary(&ptr->securityPolicyUri)
	 + UA_ByteString_calcSizeBinary(&ptr->clientCertificate)
	;
}

UA_Int32 UA_SessionSecurityDiagnosticsDataType_encodeBinary(UA_SessionSecurityDiagnosticsDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->sessionId,dst,offset);
	retval |= UA_String_encodeBinary(&src->clientUserIdOfSession,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->clientUserIdHistorySize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->clientUserIdHistory,src->clientUserIdHistorySize,UA_STRING,dst,offset);
	retval |= UA_String_encodeBinary(&src->authenticationMechanism,dst,offset);
	retval |= UA_String_encodeBinary(&src->encoding,dst,offset);
	retval |= UA_String_encodeBinary(&src->transportProtocol,dst,offset);
	retval |= UA_MessageSecurityMode_encodeBinary(&src->securityMode,dst,offset);
	retval |= UA_String_encodeBinary(&src->securityPolicyUri,dst,offset);
	retval |= UA_ByteString_encodeBinary(&src->clientCertificate,dst,offset);
	return retval;
}

UA_Int32 UA_SessionSecurityDiagnosticsDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SessionSecurityDiagnosticsDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SessionSecurityDiagnosticsDataType_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->sessionId), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->clientUserIdOfSession), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->clientUserIdHistorySize),UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->clientUserIdHistorySize,UA_STRING,(void**)&dst->clientUserIdHistory), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->authenticationMechanism), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->encoding), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->transportProtocol), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_MessageSecurityMode_decodeBinary(src,offset,&dst->securityMode), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->securityPolicyUri), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ByteString_decodeBinary(src,offset,&dst->clientCertificate), UA_SessionSecurityDiagnosticsDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SessionSecurityDiagnosticsDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SessionSecurityDiagnosticsDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SessionSecurityDiagnosticsDataType)
UA_Int32 UA_SessionSecurityDiagnosticsDataType_delete(UA_SessionSecurityDiagnosticsDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SessionSecurityDiagnosticsDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SessionSecurityDiagnosticsDataType_deleteMembers(UA_SessionSecurityDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->sessionId);
	retval |= UA_String_deleteMembers(&p->clientUserIdOfSession);
	retval |= UA_Array_delete((void**)&p->clientUserIdHistory,p->clientUserIdHistorySize,UA_STRING);
	retval |= UA_String_deleteMembers(&p->authenticationMechanism);
	retval |= UA_String_deleteMembers(&p->encoding);
	retval |= UA_String_deleteMembers(&p->transportProtocol);
	retval |= UA_String_deleteMembers(&p->securityPolicyUri);
	retval |= UA_ByteString_deleteMembers(&p->clientCertificate);
	return retval;
}

UA_Int32 UA_SessionSecurityDiagnosticsDataType_init(UA_SessionSecurityDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->sessionId);
	retval |= UA_String_init(&p->clientUserIdOfSession);
	p->clientUserIdHistorySize = 0;
	p->clientUserIdHistory = UA_NULL;
	retval |= UA_String_init(&p->authenticationMechanism);
	retval |= UA_String_init(&p->encoding);
	retval |= UA_String_init(&p->transportProtocol);
	retval |= UA_MessageSecurityMode_init(&p->securityMode);
	retval |= UA_String_init(&p->securityPolicyUri);
	retval |= UA_ByteString_init(&p->clientCertificate);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SessionSecurityDiagnosticsDataType)
UA_Int32 UA_SessionSecurityDiagnosticsDataType_copy(const UA_SessionSecurityDiagnosticsDataType *src,UA_SessionSecurityDiagnosticsDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SessionSecurityDiagnosticsDataType));
	retval |= UA_NodeId_copy(&src->sessionId,&dst->sessionId);
	retval |= UA_String_copy(&src->clientUserIdOfSession,&dst->clientUserIdOfSession);
	dst->clientUserIdHistory = src->clientUserIdHistory;
	retval |= UA_Array_copy(&src->clientUserIdHistory, src->clientUserIdHistorySize,UA_STRING,(void**)&dst->clientUserIdHistory);
	retval |= UA_String_copy(&src->authenticationMechanism,&dst->authenticationMechanism);
	retval |= UA_String_copy(&src->encoding,&dst->encoding);
	retval |= UA_String_copy(&src->transportProtocol,&dst->transportProtocol);
	retval |= UA_String_copy(&src->securityPolicyUri,&dst->securityPolicyUri);
	retval |= UA_ByteString_copy(&src->clientCertificate,&dst->clientCertificate);
	return retval;
}

UA_Int32 UA_ServiceCounterDataType_calcSizeBinary(UA_ServiceCounterDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ServiceCounterDataType);
    	return 0
	 + sizeof(UA_UInt32) // totalCount
	 + sizeof(UA_UInt32) // errorCount
	;
}

UA_Int32 UA_ServiceCounterDataType_encodeBinary(UA_ServiceCounterDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->totalCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->errorCount,dst,offset);
	return retval;
}

UA_Int32 UA_ServiceCounterDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ServiceCounterDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ServiceCounterDataType_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->totalCount), UA_ServiceCounterDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->errorCount), UA_ServiceCounterDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ServiceCounterDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ServiceCounterDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ServiceCounterDataType)
UA_Int32 UA_ServiceCounterDataType_delete(UA_ServiceCounterDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ServiceCounterDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ServiceCounterDataType_deleteMembers(UA_ServiceCounterDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_ServiceCounterDataType_init(UA_ServiceCounterDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->totalCount);
	retval |= UA_UInt32_init(&p->errorCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ServiceCounterDataType)
UA_Int32 UA_ServiceCounterDataType_copy(const UA_ServiceCounterDataType *src,UA_ServiceCounterDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ServiceCounterDataType));
	return retval;
}

UA_Int32 UA_StatusResult_calcSizeBinary(UA_StatusResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_StatusResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_DiagnosticInfo_calcSizeBinary(&ptr->diagnosticInfo)
	;
}

UA_Int32 UA_StatusResult_encodeBinary(UA_StatusResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_DiagnosticInfo_encodeBinary(&src->diagnosticInfo,dst,offset);
	return retval;
}

UA_Int32 UA_StatusResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_StatusResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_StatusResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_StatusResult_deleteMembers(dst));
	CHECKED_DECODE(UA_DiagnosticInfo_decodeBinary(src,offset,&dst->diagnosticInfo), UA_StatusResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_StatusResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_StatusResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_StatusResult)
UA_Int32 UA_StatusResult_delete(UA_StatusResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_StatusResult_deleteMembers(UA_StatusResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DiagnosticInfo_deleteMembers(&p->diagnosticInfo);
	return retval;
}

UA_Int32 UA_StatusResult_init(UA_StatusResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_DiagnosticInfo_init(&p->diagnosticInfo);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_StatusResult)
UA_Int32 UA_StatusResult_copy(const UA_StatusResult *src,UA_StatusResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_StatusResult));
	retval |= UA_DiagnosticInfo_copy(&src->diagnosticInfo,&dst->diagnosticInfo);
	return retval;
}

UA_Int32 UA_SubscriptionDiagnosticsDataType_calcSizeBinary(UA_SubscriptionDiagnosticsDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SubscriptionDiagnosticsDataType);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->sessionId)
	 + sizeof(UA_UInt32) // subscriptionId
	 + sizeof(UA_Byte) // priority
	 + sizeof(UA_Double) // publishingInterval
	 + sizeof(UA_UInt32) // maxKeepAliveCount
	 + sizeof(UA_UInt32) // maxLifetimeCount
	 + sizeof(UA_UInt32) // maxNotificationsPerPublish
	 + sizeof(UA_Boolean) // publishingEnabled
	 + sizeof(UA_UInt32) // modifyCount
	 + sizeof(UA_UInt32) // enableCount
	 + sizeof(UA_UInt32) // disableCount
	 + sizeof(UA_UInt32) // republishRequestCount
	 + sizeof(UA_UInt32) // republishMessageRequestCount
	 + sizeof(UA_UInt32) // republishMessageCount
	 + sizeof(UA_UInt32) // transferRequestCount
	 + sizeof(UA_UInt32) // transferredToAltClientCount
	 + sizeof(UA_UInt32) // transferredToSameClientCount
	 + sizeof(UA_UInt32) // publishRequestCount
	 + sizeof(UA_UInt32) // dataChangeNotificationsCount
	 + sizeof(UA_UInt32) // eventNotificationsCount
	 + sizeof(UA_UInt32) // notificationsCount
	 + sizeof(UA_UInt32) // latePublishRequestCount
	 + sizeof(UA_UInt32) // currentKeepAliveCount
	 + sizeof(UA_UInt32) // currentLifetimeCount
	 + sizeof(UA_UInt32) // unacknowledgedMessageCount
	 + sizeof(UA_UInt32) // discardedMessageCount
	 + sizeof(UA_UInt32) // monitoredItemCount
	 + sizeof(UA_UInt32) // disabledMonitoredItemCount
	 + sizeof(UA_UInt32) // monitoringQueueOverflowCount
	 + sizeof(UA_UInt32) // nextSequenceNumber
	 + sizeof(UA_UInt32) // eventQueueOverFlowCount
	;
}

UA_Int32 UA_SubscriptionDiagnosticsDataType_encodeBinary(UA_SubscriptionDiagnosticsDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->sessionId,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->subscriptionId,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->priority,dst,offset);
	retval |= UA_Double_encodeBinary(&src->publishingInterval,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxKeepAliveCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxLifetimeCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxNotificationsPerPublish,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->publishingEnabled,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->modifyCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->enableCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->disableCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->republishRequestCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->republishMessageRequestCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->republishMessageCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->transferRequestCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->transferredToAltClientCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->transferredToSameClientCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->publishRequestCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->dataChangeNotificationsCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->eventNotificationsCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->notificationsCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->latePublishRequestCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->currentKeepAliveCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->currentLifetimeCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->unacknowledgedMessageCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->discardedMessageCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->monitoredItemCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->disabledMonitoredItemCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->monitoringQueueOverflowCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->nextSequenceNumber,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->eventQueueOverFlowCount,dst,offset);
	return retval;
}

UA_Int32 UA_SubscriptionDiagnosticsDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SubscriptionDiagnosticsDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SubscriptionDiagnosticsDataType_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->sessionId), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->subscriptionId), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->priority), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->publishingInterval), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxKeepAliveCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxLifetimeCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxNotificationsPerPublish), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->publishingEnabled), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->modifyCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->enableCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->disableCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->republishRequestCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->republishMessageRequestCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->republishMessageCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->transferRequestCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->transferredToAltClientCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->transferredToSameClientCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->publishRequestCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->dataChangeNotificationsCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->eventNotificationsCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->notificationsCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->latePublishRequestCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->currentKeepAliveCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->currentLifetimeCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->unacknowledgedMessageCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->discardedMessageCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->monitoredItemCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->disabledMonitoredItemCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->monitoringQueueOverflowCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->nextSequenceNumber), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->eventQueueOverFlowCount), UA_SubscriptionDiagnosticsDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SubscriptionDiagnosticsDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SubscriptionDiagnosticsDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SubscriptionDiagnosticsDataType)
UA_Int32 UA_SubscriptionDiagnosticsDataType_delete(UA_SubscriptionDiagnosticsDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SubscriptionDiagnosticsDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SubscriptionDiagnosticsDataType_deleteMembers(UA_SubscriptionDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->sessionId);
	return retval;
}

UA_Int32 UA_SubscriptionDiagnosticsDataType_init(UA_SubscriptionDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->sessionId);
	retval |= UA_UInt32_init(&p->subscriptionId);
	retval |= UA_Byte_init(&p->priority);
	retval |= UA_Double_init(&p->publishingInterval);
	retval |= UA_UInt32_init(&p->maxKeepAliveCount);
	retval |= UA_UInt32_init(&p->maxLifetimeCount);
	retval |= UA_UInt32_init(&p->maxNotificationsPerPublish);
	retval |= UA_Boolean_init(&p->publishingEnabled);
	retval |= UA_UInt32_init(&p->modifyCount);
	retval |= UA_UInt32_init(&p->enableCount);
	retval |= UA_UInt32_init(&p->disableCount);
	retval |= UA_UInt32_init(&p->republishRequestCount);
	retval |= UA_UInt32_init(&p->republishMessageRequestCount);
	retval |= UA_UInt32_init(&p->republishMessageCount);
	retval |= UA_UInt32_init(&p->transferRequestCount);
	retval |= UA_UInt32_init(&p->transferredToAltClientCount);
	retval |= UA_UInt32_init(&p->transferredToSameClientCount);
	retval |= UA_UInt32_init(&p->publishRequestCount);
	retval |= UA_UInt32_init(&p->dataChangeNotificationsCount);
	retval |= UA_UInt32_init(&p->eventNotificationsCount);
	retval |= UA_UInt32_init(&p->notificationsCount);
	retval |= UA_UInt32_init(&p->latePublishRequestCount);
	retval |= UA_UInt32_init(&p->currentKeepAliveCount);
	retval |= UA_UInt32_init(&p->currentLifetimeCount);
	retval |= UA_UInt32_init(&p->unacknowledgedMessageCount);
	retval |= UA_UInt32_init(&p->discardedMessageCount);
	retval |= UA_UInt32_init(&p->monitoredItemCount);
	retval |= UA_UInt32_init(&p->disabledMonitoredItemCount);
	retval |= UA_UInt32_init(&p->monitoringQueueOverflowCount);
	retval |= UA_UInt32_init(&p->nextSequenceNumber);
	retval |= UA_UInt32_init(&p->eventQueueOverFlowCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SubscriptionDiagnosticsDataType)
UA_Int32 UA_SubscriptionDiagnosticsDataType_copy(const UA_SubscriptionDiagnosticsDataType *src,UA_SubscriptionDiagnosticsDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SubscriptionDiagnosticsDataType));
	retval |= UA_NodeId_copy(&src->sessionId,&dst->sessionId);
	return retval;
}

UA_TYPE_AS(UA_ModelChangeStructureVerbMask, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_ModelChangeStructureVerbMask, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ModelChangeStructureVerbMask)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ModelChangeStructureVerbMask)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ModelChangeStructureVerbMask
)
UA_Int32 UA_ModelChangeStructureDataType_calcSizeBinary(UA_ModelChangeStructureDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ModelChangeStructureDataType);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->affected)
	 + UA_NodeId_calcSizeBinary(&ptr->affectedType)
	 + sizeof(UA_Byte) // verb
	;
}

UA_Int32 UA_ModelChangeStructureDataType_encodeBinary(UA_ModelChangeStructureDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->affected,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->affectedType,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->verb,dst,offset);
	return retval;
}

UA_Int32 UA_ModelChangeStructureDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ModelChangeStructureDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ModelChangeStructureDataType_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->affected), UA_ModelChangeStructureDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->affectedType), UA_ModelChangeStructureDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->verb), UA_ModelChangeStructureDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ModelChangeStructureDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ModelChangeStructureDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ModelChangeStructureDataType)
UA_Int32 UA_ModelChangeStructureDataType_delete(UA_ModelChangeStructureDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ModelChangeStructureDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ModelChangeStructureDataType_deleteMembers(UA_ModelChangeStructureDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->affected);
	retval |= UA_NodeId_deleteMembers(&p->affectedType);
	return retval;
}

UA_Int32 UA_ModelChangeStructureDataType_init(UA_ModelChangeStructureDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->affected);
	retval |= UA_NodeId_init(&p->affectedType);
	retval |= UA_Byte_init(&p->verb);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ModelChangeStructureDataType)
UA_Int32 UA_ModelChangeStructureDataType_copy(const UA_ModelChangeStructureDataType *src,UA_ModelChangeStructureDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ModelChangeStructureDataType));
	retval |= UA_NodeId_copy(&src->affected,&dst->affected);
	retval |= UA_NodeId_copy(&src->affectedType,&dst->affectedType);
	return retval;
}

UA_Int32 UA_SemanticChangeStructureDataType_calcSizeBinary(UA_SemanticChangeStructureDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SemanticChangeStructureDataType);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->affected)
	 + UA_NodeId_calcSizeBinary(&ptr->affectedType)
	;
}

UA_Int32 UA_SemanticChangeStructureDataType_encodeBinary(UA_SemanticChangeStructureDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->affected,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->affectedType,dst,offset);
	return retval;
}

UA_Int32 UA_SemanticChangeStructureDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SemanticChangeStructureDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SemanticChangeStructureDataType_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->affected), UA_SemanticChangeStructureDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->affectedType), UA_SemanticChangeStructureDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SemanticChangeStructureDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SemanticChangeStructureDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SemanticChangeStructureDataType)
UA_Int32 UA_SemanticChangeStructureDataType_delete(UA_SemanticChangeStructureDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SemanticChangeStructureDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SemanticChangeStructureDataType_deleteMembers(UA_SemanticChangeStructureDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->affected);
	retval |= UA_NodeId_deleteMembers(&p->affectedType);
	return retval;
}

UA_Int32 UA_SemanticChangeStructureDataType_init(UA_SemanticChangeStructureDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->affected);
	retval |= UA_NodeId_init(&p->affectedType);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SemanticChangeStructureDataType)
UA_Int32 UA_SemanticChangeStructureDataType_copy(const UA_SemanticChangeStructureDataType *src,UA_SemanticChangeStructureDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SemanticChangeStructureDataType));
	retval |= UA_NodeId_copy(&src->affected,&dst->affected);
	retval |= UA_NodeId_copy(&src->affectedType,&dst->affectedType);
	return retval;
}

UA_Int32 UA_Range_calcSizeBinary(UA_Range const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_Range);
    	return 0
	 + sizeof(UA_Double) // low
	 + sizeof(UA_Double) // high
	;
}

UA_Int32 UA_Range_encodeBinary(UA_Range const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_encodeBinary(&src->low,dst,offset);
	retval |= UA_Double_encodeBinary(&src->high,dst,offset);
	return retval;
}

UA_Int32 UA_Range_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_Range * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_Range_init(dst);
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->low), UA_Range_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->high), UA_Range_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Range)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Range)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Range)
UA_Int32 UA_Range_delete(UA_Range *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Range_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_Range_deleteMembers(UA_Range *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_Range_init(UA_Range *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_init(&p->low);
	retval |= UA_Double_init(&p->high);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_Range)
UA_Int32 UA_Range_copy(const UA_Range *src,UA_Range *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_Range));
	return retval;
}

UA_Int32 UA_EUInformation_calcSizeBinary(UA_EUInformation const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EUInformation);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->namespaceUri)
	 + sizeof(UA_Int32) // unitId
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	;
}

UA_Int32 UA_EUInformation_encodeBinary(UA_EUInformation const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->namespaceUri,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->unitId,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	return retval;
}

UA_Int32 UA_EUInformation_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EUInformation * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EUInformation_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->namespaceUri), UA_EUInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->unitId), UA_EUInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_EUInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_EUInformation_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EUInformation)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EUInformation)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EUInformation)
UA_Int32 UA_EUInformation_delete(UA_EUInformation *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EUInformation_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EUInformation_deleteMembers(UA_EUInformation *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->namespaceUri);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	return retval;
}

UA_Int32 UA_EUInformation_init(UA_EUInformation *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->namespaceUri);
	retval |= UA_Int32_init(&p->unitId);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EUInformation)
UA_Int32 UA_EUInformation_copy(const UA_EUInformation *src,UA_EUInformation *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EUInformation));
	retval |= UA_String_copy(&src->namespaceUri,&dst->namespaceUri);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	return retval;
}

UA_TYPE_AS(UA_AxisScaleEnumeration, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_AxisScaleEnumeration, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AxisScaleEnumeration)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AxisScaleEnumeration)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AxisScaleEnumeration
)
UA_Int32 UA_ComplexNumberType_calcSizeBinary(UA_ComplexNumberType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ComplexNumberType);
    	return 0
	 + sizeof(UA_Float) // real
	 + sizeof(UA_Float) // imaginary
	;
}

UA_Int32 UA_ComplexNumberType_encodeBinary(UA_ComplexNumberType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Float_encodeBinary(&src->real,dst,offset);
	retval |= UA_Float_encodeBinary(&src->imaginary,dst,offset);
	return retval;
}

UA_Int32 UA_ComplexNumberType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ComplexNumberType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ComplexNumberType_init(dst);
	CHECKED_DECODE(UA_Float_decodeBinary(src,offset,&dst->real), UA_ComplexNumberType_deleteMembers(dst));
	CHECKED_DECODE(UA_Float_decodeBinary(src,offset,&dst->imaginary), UA_ComplexNumberType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ComplexNumberType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ComplexNumberType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ComplexNumberType)
UA_Int32 UA_ComplexNumberType_delete(UA_ComplexNumberType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ComplexNumberType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ComplexNumberType_deleteMembers(UA_ComplexNumberType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_ComplexNumberType_init(UA_ComplexNumberType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Float_init(&p->real);
	retval |= UA_Float_init(&p->imaginary);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ComplexNumberType)
UA_Int32 UA_ComplexNumberType_copy(const UA_ComplexNumberType *src,UA_ComplexNumberType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ComplexNumberType));
	return retval;
}

UA_Int32 UA_DoubleComplexNumberType_calcSizeBinary(UA_DoubleComplexNumberType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DoubleComplexNumberType);
    	return 0
	 + sizeof(UA_Double) // real
	 + sizeof(UA_Double) // imaginary
	;
}

UA_Int32 UA_DoubleComplexNumberType_encodeBinary(UA_DoubleComplexNumberType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_encodeBinary(&src->real,dst,offset);
	retval |= UA_Double_encodeBinary(&src->imaginary,dst,offset);
	return retval;
}

UA_Int32 UA_DoubleComplexNumberType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DoubleComplexNumberType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DoubleComplexNumberType_init(dst);
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->real), UA_DoubleComplexNumberType_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->imaginary), UA_DoubleComplexNumberType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DoubleComplexNumberType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DoubleComplexNumberType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DoubleComplexNumberType)
UA_Int32 UA_DoubleComplexNumberType_delete(UA_DoubleComplexNumberType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DoubleComplexNumberType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DoubleComplexNumberType_deleteMembers(UA_DoubleComplexNumberType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_DoubleComplexNumberType_init(UA_DoubleComplexNumberType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_init(&p->real);
	retval |= UA_Double_init(&p->imaginary);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DoubleComplexNumberType)
UA_Int32 UA_DoubleComplexNumberType_copy(const UA_DoubleComplexNumberType *src,UA_DoubleComplexNumberType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DoubleComplexNumberType));
	return retval;
}

UA_Int32 UA_AxisInformation_calcSizeBinary(UA_AxisInformation const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_AxisInformation);
    	return 0
	 + UA_EUInformation_calcSizeBinary(&ptr->engineeringUnits)
	 + sizeof(UA_Range) // eURange
	 + UA_LocalizedText_calcSizeBinary(&ptr->title)
	 + sizeof(UA_AxisScaleEnumeration) // axisScaleType
	 + UA_Array_calcSizeBinary(ptr->axisStepsSize,UA_DOUBLE,ptr->axisSteps)
	;
}

UA_Int32 UA_AxisInformation_encodeBinary(UA_AxisInformation const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EUInformation_encodeBinary(&src->engineeringUnits,dst,offset);
	retval |= UA_Range_encodeBinary(&src->eURange,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->title,dst,offset);
	retval |= UA_AxisScaleEnumeration_encodeBinary(&src->axisScaleType,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->axisStepsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->axisSteps,src->axisStepsSize,UA_DOUBLE,dst,offset);
	return retval;
}

UA_Int32 UA_AxisInformation_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_AxisInformation * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_AxisInformation_init(dst);
	CHECKED_DECODE(UA_EUInformation_decodeBinary(src,offset,&dst->engineeringUnits), UA_AxisInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_Range_decodeBinary(src,offset,&dst->eURange), UA_AxisInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->title), UA_AxisInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_AxisScaleEnumeration_decodeBinary(src,offset,&dst->axisScaleType), UA_AxisInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->axisStepsSize),UA_AxisInformation_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->axisStepsSize,UA_DOUBLE,(void**)&dst->axisSteps), UA_AxisInformation_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_AxisInformation)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_AxisInformation)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_AxisInformation)
UA_Int32 UA_AxisInformation_delete(UA_AxisInformation *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_AxisInformation_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_AxisInformation_deleteMembers(UA_AxisInformation *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EUInformation_deleteMembers(&p->engineeringUnits);
	retval |= UA_LocalizedText_deleteMembers(&p->title);
	retval |= UA_Array_delete((void**)&p->axisSteps,p->axisStepsSize,UA_DOUBLE);
	return retval;
}

UA_Int32 UA_AxisInformation_init(UA_AxisInformation *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EUInformation_init(&p->engineeringUnits);
	retval |= UA_Range_init(&p->eURange);
	retval |= UA_LocalizedText_init(&p->title);
	retval |= UA_AxisScaleEnumeration_init(&p->axisScaleType);
	p->axisStepsSize = 0;
	p->axisSteps = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_AxisInformation)
UA_Int32 UA_AxisInformation_copy(const UA_AxisInformation *src,UA_AxisInformation *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_AxisInformation));
	retval |= UA_EUInformation_copy(&src->engineeringUnits,&dst->engineeringUnits);
	retval |= UA_LocalizedText_copy(&src->title,&dst->title);
	dst->axisSteps = src->axisSteps;
	retval |= UA_Array_copy(&src->axisSteps, src->axisStepsSize,UA_DOUBLE,(void**)&dst->axisSteps);
	return retval;
}

UA_Int32 UA_XVType_calcSizeBinary(UA_XVType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_XVType);
    	return 0
	 + sizeof(UA_Double) // x
	 + sizeof(UA_Float) // value
	;
}

UA_Int32 UA_XVType_encodeBinary(UA_XVType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_encodeBinary(&src->x,dst,offset);
	retval |= UA_Float_encodeBinary(&src->value,dst,offset);
	return retval;
}

UA_Int32 UA_XVType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_XVType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_XVType_init(dst);
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->x), UA_XVType_deleteMembers(dst));
	CHECKED_DECODE(UA_Float_decodeBinary(src,offset,&dst->value), UA_XVType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_XVType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_XVType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_XVType)
UA_Int32 UA_XVType_delete(UA_XVType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_XVType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_XVType_deleteMembers(UA_XVType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	return retval;
}

UA_Int32 UA_XVType_init(UA_XVType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Double_init(&p->x);
	retval |= UA_Float_init(&p->value);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_XVType)
UA_Int32 UA_XVType_copy(const UA_XVType *src,UA_XVType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_XVType));
	return retval;
}

UA_Int32 UA_ProgramDiagnosticDataType_calcSizeBinary(UA_ProgramDiagnosticDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ProgramDiagnosticDataType);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->createSessionId)
	 + UA_String_calcSizeBinary(&ptr->createClientName)
	 + sizeof(UA_DateTime) // invocationCreationTime
	 + sizeof(UA_DateTime) // lastTransitionTime
	 + UA_String_calcSizeBinary(&ptr->lastMethodCall)
	 + UA_NodeId_calcSizeBinary(&ptr->lastMethodSessionId)
	 + UA_Array_calcSizeBinary(ptr->lastMethodInputArgumentsSize,UA_ARGUMENT,ptr->lastMethodInputArguments)
	 + UA_Array_calcSizeBinary(ptr->lastMethodOutputArgumentsSize,UA_ARGUMENT,ptr->lastMethodOutputArguments)
	 + sizeof(UA_DateTime) // lastMethodCallTime
	 + UA_StatusResult_calcSizeBinary(&ptr->lastMethodReturnStatus)
	;
}

UA_Int32 UA_ProgramDiagnosticDataType_encodeBinary(UA_ProgramDiagnosticDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->createSessionId,dst,offset);
	retval |= UA_String_encodeBinary(&src->createClientName,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->invocationCreationTime,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->lastTransitionTime,dst,offset);
	retval |= UA_String_encodeBinary(&src->lastMethodCall,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->lastMethodSessionId,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->lastMethodInputArgumentsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->lastMethodInputArguments,src->lastMethodInputArgumentsSize,UA_ARGUMENT,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->lastMethodOutputArgumentsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->lastMethodOutputArguments,src->lastMethodOutputArgumentsSize,UA_ARGUMENT,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->lastMethodCallTime,dst,offset);
	retval |= UA_StatusResult_encodeBinary(&src->lastMethodReturnStatus,dst,offset);
	return retval;
}

UA_Int32 UA_ProgramDiagnosticDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ProgramDiagnosticDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ProgramDiagnosticDataType_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->createSessionId), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->createClientName), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->invocationCreationTime), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->lastTransitionTime), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->lastMethodCall), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->lastMethodSessionId), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->lastMethodInputArgumentsSize),UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->lastMethodInputArgumentsSize,UA_ARGUMENT,(void**)&dst->lastMethodInputArguments), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->lastMethodOutputArgumentsSize),UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->lastMethodOutputArgumentsSize,UA_ARGUMENT,(void**)&dst->lastMethodOutputArguments), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->lastMethodCallTime), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_StatusResult_decodeBinary(src,offset,&dst->lastMethodReturnStatus), UA_ProgramDiagnosticDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ProgramDiagnosticDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ProgramDiagnosticDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ProgramDiagnosticDataType)
UA_Int32 UA_ProgramDiagnosticDataType_delete(UA_ProgramDiagnosticDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ProgramDiagnosticDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ProgramDiagnosticDataType_deleteMembers(UA_ProgramDiagnosticDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->createSessionId);
	retval |= UA_String_deleteMembers(&p->createClientName);
	retval |= UA_String_deleteMembers(&p->lastMethodCall);
	retval |= UA_NodeId_deleteMembers(&p->lastMethodSessionId);
	retval |= UA_Array_delete((void**)&p->lastMethodInputArguments,p->lastMethodInputArgumentsSize,UA_ARGUMENT);
	retval |= UA_Array_delete((void**)&p->lastMethodOutputArguments,p->lastMethodOutputArgumentsSize,UA_ARGUMENT);
	retval |= UA_StatusResult_deleteMembers(&p->lastMethodReturnStatus);
	return retval;
}

UA_Int32 UA_ProgramDiagnosticDataType_init(UA_ProgramDiagnosticDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->createSessionId);
	retval |= UA_String_init(&p->createClientName);
	retval |= UA_DateTime_init(&p->invocationCreationTime);
	retval |= UA_DateTime_init(&p->lastTransitionTime);
	retval |= UA_String_init(&p->lastMethodCall);
	retval |= UA_NodeId_init(&p->lastMethodSessionId);
	p->lastMethodInputArgumentsSize = 0;
	p->lastMethodInputArguments = UA_NULL;
	p->lastMethodOutputArgumentsSize = 0;
	p->lastMethodOutputArguments = UA_NULL;
	retval |= UA_DateTime_init(&p->lastMethodCallTime);
	retval |= UA_StatusResult_init(&p->lastMethodReturnStatus);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ProgramDiagnosticDataType)
UA_Int32 UA_ProgramDiagnosticDataType_copy(const UA_ProgramDiagnosticDataType *src,UA_ProgramDiagnosticDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ProgramDiagnosticDataType));
	retval |= UA_NodeId_copy(&src->createSessionId,&dst->createSessionId);
	retval |= UA_String_copy(&src->createClientName,&dst->createClientName);
	retval |= UA_String_copy(&src->lastMethodCall,&dst->lastMethodCall);
	retval |= UA_NodeId_copy(&src->lastMethodSessionId,&dst->lastMethodSessionId);
	dst->lastMethodInputArguments = src->lastMethodInputArguments;
	retval |= UA_Array_copy(&src->lastMethodInputArguments, src->lastMethodInputArgumentsSize,UA_ARGUMENT,(void**)&dst->lastMethodInputArguments);
	dst->lastMethodOutputArguments = src->lastMethodOutputArguments;
	retval |= UA_Array_copy(&src->lastMethodOutputArguments, src->lastMethodOutputArgumentsSize,UA_ARGUMENT,(void**)&dst->lastMethodOutputArguments);
	retval |= UA_StatusResult_copy(&src->lastMethodReturnStatus,&dst->lastMethodReturnStatus);
	return retval;
}

UA_Int32 UA_Annotation_calcSizeBinary(UA_Annotation const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_Annotation);
    	return 0
	 + UA_String_calcSizeBinary(&ptr->message)
	 + UA_String_calcSizeBinary(&ptr->userName)
	 + sizeof(UA_DateTime) // annotationTime
	;
}

UA_Int32 UA_Annotation_encodeBinary(UA_Annotation const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_encodeBinary(&src->message,dst,offset);
	retval |= UA_String_encodeBinary(&src->userName,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->annotationTime,dst,offset);
	return retval;
}

UA_Int32 UA_Annotation_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_Annotation * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_Annotation_init(dst);
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->message), UA_Annotation_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->userName), UA_Annotation_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->annotationTime), UA_Annotation_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Annotation)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Annotation)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Annotation)
UA_Int32 UA_Annotation_delete(UA_Annotation *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Annotation_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_Annotation_deleteMembers(UA_Annotation *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->message);
	retval |= UA_String_deleteMembers(&p->userName);
	return retval;
}

UA_Int32 UA_Annotation_init(UA_Annotation *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_init(&p->message);
	retval |= UA_String_init(&p->userName);
	retval |= UA_DateTime_init(&p->annotationTime);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_Annotation)
UA_Int32 UA_Annotation_copy(const UA_Annotation *src,UA_Annotation *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_Annotation));
	retval |= UA_String_copy(&src->message,&dst->message);
	retval |= UA_String_copy(&src->userName,&dst->userName);
	return retval;
}

UA_TYPE_AS(UA_ExceptionDeviationFormat, UA_UInt32)
UA_TYPE_BINARY_ENCODING_AS(UA_ExceptionDeviationFormat, UA_UInt32)
UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ExceptionDeviationFormat)
UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ExceptionDeviationFormat)
UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ExceptionDeviationFormat
)
UA_Int32 UA_Node_calcSizeBinary(UA_Node const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_Node);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	;
}

UA_Int32 UA_Node_encodeBinary(UA_Node const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	return retval;
}

UA_Int32 UA_Node_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_Node * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_Node_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_Node_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_Node_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_Node)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_Node)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_Node)
UA_Int32 UA_Node_delete(UA_Node *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Node_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_Node_deleteMembers(UA_Node *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_Node_init(UA_Node *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_Node)
UA_Int32 UA_Node_copy(const UA_Node *src,UA_Node *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_Node));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_InstanceNode_calcSizeBinary(UA_InstanceNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_InstanceNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	;
}

UA_Int32 UA_InstanceNode_encodeBinary(UA_InstanceNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	return retval;
}

UA_Int32 UA_InstanceNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_InstanceNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_InstanceNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_InstanceNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_InstanceNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_InstanceNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_InstanceNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_InstanceNode)
UA_Int32 UA_InstanceNode_delete(UA_InstanceNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_InstanceNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_InstanceNode_deleteMembers(UA_InstanceNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_InstanceNode_init(UA_InstanceNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_InstanceNode)
UA_Int32 UA_InstanceNode_copy(const UA_InstanceNode *src,UA_InstanceNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_InstanceNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_TypeNode_calcSizeBinary(UA_TypeNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_TypeNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	;
}

UA_Int32 UA_TypeNode_encodeBinary(UA_TypeNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	return retval;
}

UA_Int32 UA_TypeNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_TypeNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_TypeNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_TypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_TypeNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_TypeNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_TypeNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_TypeNode)
UA_Int32 UA_TypeNode_delete(UA_TypeNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_TypeNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_TypeNode_deleteMembers(UA_TypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_TypeNode_init(UA_TypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_TypeNode)
UA_Int32 UA_TypeNode_copy(const UA_TypeNode *src,UA_TypeNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_TypeNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_ObjectNode_calcSizeBinary(UA_ObjectNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ObjectNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + sizeof(UA_Byte) // eventNotifier
	;
}

UA_Int32 UA_ObjectNode_encodeBinary(UA_ObjectNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->eventNotifier,dst,offset);
	return retval;
}

UA_Int32 UA_ObjectNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ObjectNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ObjectNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_ObjectNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->eventNotifier), UA_ObjectNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ObjectNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ObjectNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ObjectNode)
UA_Int32 UA_ObjectNode_delete(UA_ObjectNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ObjectNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ObjectNode_deleteMembers(UA_ObjectNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_ObjectNode_init(UA_ObjectNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Byte_init(&p->eventNotifier);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ObjectNode)
UA_Int32 UA_ObjectNode_copy(const UA_ObjectNode *src,UA_ObjectNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ObjectNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_ObjectTypeNode_calcSizeBinary(UA_ObjectTypeNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ObjectTypeNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + sizeof(UA_Boolean) // isAbstract
	;
}

UA_Int32 UA_ObjectTypeNode_encodeBinary(UA_ObjectTypeNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	return retval;
}

UA_Int32 UA_ObjectTypeNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ObjectTypeNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ObjectTypeNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_ObjectTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_ObjectTypeNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ObjectTypeNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ObjectTypeNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ObjectTypeNode)
UA_Int32 UA_ObjectTypeNode_delete(UA_ObjectTypeNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ObjectTypeNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ObjectTypeNode_deleteMembers(UA_ObjectTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_ObjectTypeNode_init(UA_ObjectTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Boolean_init(&p->isAbstract);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ObjectTypeNode)
UA_Int32 UA_ObjectTypeNode_copy(const UA_ObjectTypeNode *src,UA_ObjectTypeNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ObjectTypeNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_VariableNode_calcSizeBinary(UA_VariableNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_VariableNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + UA_Variant_calcSizeBinary(&ptr->value)
	 + UA_NodeId_calcSizeBinary(&ptr->dataType)
	 + sizeof(UA_Int32) // valueRank
	 + UA_Array_calcSizeBinary(ptr->arrayDimensionsSize,UA_UINT32,ptr->arrayDimensions)
	 + sizeof(UA_Byte) // accessLevel
	 + sizeof(UA_Byte) // userAccessLevel
	 + sizeof(UA_Double) // minimumSamplingInterval
	 + sizeof(UA_Boolean) // historizing
	;
}

UA_Int32 UA_VariableNode_encodeBinary(UA_VariableNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Variant_encodeBinary(&src->value,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->dataType,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->valueRank,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->arrayDimensionsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->arrayDimensions,src->arrayDimensionsSize,UA_UINT32,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->accessLevel,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->userAccessLevel,dst,offset);
	retval |= UA_Double_encodeBinary(&src->minimumSamplingInterval,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->historizing,dst,offset);
	return retval;
}

UA_Int32 UA_VariableNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_VariableNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_VariableNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Variant_decodeBinary(src,offset,&dst->value), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->dataType), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->valueRank), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->arrayDimensionsSize),UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->accessLevel), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->userAccessLevel), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->minimumSamplingInterval), UA_VariableNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->historizing), UA_VariableNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_VariableNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_VariableNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_VariableNode)
UA_Int32 UA_VariableNode_delete(UA_VariableNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_VariableNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_VariableNode_deleteMembers(UA_VariableNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	retval |= UA_Variant_deleteMembers(&p->value);
	retval |= UA_NodeId_deleteMembers(&p->dataType);
	retval |= UA_Array_delete((void**)&p->arrayDimensions,p->arrayDimensionsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_VariableNode_init(UA_VariableNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Variant_init(&p->value);
	retval |= UA_NodeId_init(&p->dataType);
	retval |= UA_Int32_init(&p->valueRank);
	p->arrayDimensionsSize = 0;
	p->arrayDimensions = UA_NULL;
	retval |= UA_Byte_init(&p->accessLevel);
	retval |= UA_Byte_init(&p->userAccessLevel);
	retval |= UA_Double_init(&p->minimumSamplingInterval);
	retval |= UA_Boolean_init(&p->historizing);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_VariableNode)
UA_Int32 UA_VariableNode_copy(const UA_VariableNode *src,UA_VariableNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_VariableNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	retval |= UA_Variant_copy(&src->value,&dst->value);
	retval |= UA_NodeId_copy(&src->dataType,&dst->dataType);
	dst->arrayDimensions = src->arrayDimensions;
	retval |= UA_Array_copy(&src->arrayDimensions, src->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions);
	return retval;
}

UA_Int32 UA_VariableTypeNode_calcSizeBinary(UA_VariableTypeNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_VariableTypeNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + UA_Variant_calcSizeBinary(&ptr->value)
	 + UA_NodeId_calcSizeBinary(&ptr->dataType)
	 + sizeof(UA_Int32) // valueRank
	 + UA_Array_calcSizeBinary(ptr->arrayDimensionsSize,UA_UINT32,ptr->arrayDimensions)
	 + sizeof(UA_Boolean) // isAbstract
	;
}

UA_Int32 UA_VariableTypeNode_encodeBinary(UA_VariableTypeNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Variant_encodeBinary(&src->value,dst,offset);
	retval |= UA_NodeId_encodeBinary(&src->dataType,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->valueRank,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->arrayDimensionsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->arrayDimensions,src->arrayDimensionsSize,UA_UINT32,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	return retval;
}

UA_Int32 UA_VariableTypeNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_VariableTypeNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_VariableTypeNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Variant_decodeBinary(src,offset,&dst->value), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->dataType), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->valueRank), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->arrayDimensionsSize),UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions), UA_VariableTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_VariableTypeNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_VariableTypeNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_VariableTypeNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_VariableTypeNode)
UA_Int32 UA_VariableTypeNode_delete(UA_VariableTypeNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_VariableTypeNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_VariableTypeNode_deleteMembers(UA_VariableTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	retval |= UA_Variant_deleteMembers(&p->value);
	retval |= UA_NodeId_deleteMembers(&p->dataType);
	retval |= UA_Array_delete((void**)&p->arrayDimensions,p->arrayDimensionsSize,UA_UINT32);
	return retval;
}

UA_Int32 UA_VariableTypeNode_init(UA_VariableTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Variant_init(&p->value);
	retval |= UA_NodeId_init(&p->dataType);
	retval |= UA_Int32_init(&p->valueRank);
	p->arrayDimensionsSize = 0;
	p->arrayDimensions = UA_NULL;
	retval |= UA_Boolean_init(&p->isAbstract);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_VariableTypeNode)
UA_Int32 UA_VariableTypeNode_copy(const UA_VariableTypeNode *src,UA_VariableTypeNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_VariableTypeNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	retval |= UA_Variant_copy(&src->value,&dst->value);
	retval |= UA_NodeId_copy(&src->dataType,&dst->dataType);
	dst->arrayDimensions = src->arrayDimensions;
	retval |= UA_Array_copy(&src->arrayDimensions, src->arrayDimensionsSize,UA_UINT32,(void**)&dst->arrayDimensions);
	return retval;
}

UA_Int32 UA_ReferenceTypeNode_calcSizeBinary(UA_ReferenceTypeNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReferenceTypeNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + sizeof(UA_Boolean) // isAbstract
	 + sizeof(UA_Boolean) // symmetric
	 + UA_LocalizedText_calcSizeBinary(&ptr->inverseName)
	;
}

UA_Int32 UA_ReferenceTypeNode_encodeBinary(UA_ReferenceTypeNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->symmetric,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->inverseName,dst,offset);
	return retval;
}

UA_Int32 UA_ReferenceTypeNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReferenceTypeNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReferenceTypeNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->symmetric), UA_ReferenceTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->inverseName), UA_ReferenceTypeNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReferenceTypeNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReferenceTypeNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReferenceTypeNode)
UA_Int32 UA_ReferenceTypeNode_delete(UA_ReferenceTypeNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReferenceTypeNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReferenceTypeNode_deleteMembers(UA_ReferenceTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	retval |= UA_LocalizedText_deleteMembers(&p->inverseName);
	return retval;
}

UA_Int32 UA_ReferenceTypeNode_init(UA_ReferenceTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Boolean_init(&p->isAbstract);
	retval |= UA_Boolean_init(&p->symmetric);
	retval |= UA_LocalizedText_init(&p->inverseName);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReferenceTypeNode)
UA_Int32 UA_ReferenceTypeNode_copy(const UA_ReferenceTypeNode *src,UA_ReferenceTypeNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReferenceTypeNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	retval |= UA_LocalizedText_copy(&src->inverseName,&dst->inverseName);
	return retval;
}

UA_Int32 UA_MethodNode_calcSizeBinary(UA_MethodNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_MethodNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + sizeof(UA_Boolean) // executable
	 + sizeof(UA_Boolean) // userExecutable
	;
}

UA_Int32 UA_MethodNode_encodeBinary(UA_MethodNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->executable,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->userExecutable,dst,offset);
	return retval;
}

UA_Int32 UA_MethodNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_MethodNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_MethodNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->executable), UA_MethodNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->userExecutable), UA_MethodNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_MethodNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_MethodNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_MethodNode)
UA_Int32 UA_MethodNode_delete(UA_MethodNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_MethodNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_MethodNode_deleteMembers(UA_MethodNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_MethodNode_init(UA_MethodNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Boolean_init(&p->executable);
	retval |= UA_Boolean_init(&p->userExecutable);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_MethodNode)
UA_Int32 UA_MethodNode_copy(const UA_MethodNode *src,UA_MethodNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_MethodNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_ViewNode_calcSizeBinary(UA_ViewNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ViewNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + sizeof(UA_Boolean) // containsNoLoops
	 + sizeof(UA_Byte) // eventNotifier
	;
}

UA_Int32 UA_ViewNode_encodeBinary(UA_ViewNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->containsNoLoops,dst,offset);
	retval |= UA_Byte_encodeBinary(&src->eventNotifier,dst,offset);
	return retval;
}

UA_Int32 UA_ViewNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ViewNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ViewNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->containsNoLoops), UA_ViewNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Byte_decodeBinary(src,offset,&dst->eventNotifier), UA_ViewNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ViewNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ViewNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ViewNode)
UA_Int32 UA_ViewNode_delete(UA_ViewNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ViewNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ViewNode_deleteMembers(UA_ViewNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_ViewNode_init(UA_ViewNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Boolean_init(&p->containsNoLoops);
	retval |= UA_Byte_init(&p->eventNotifier);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ViewNode)
UA_Int32 UA_ViewNode_copy(const UA_ViewNode *src,UA_ViewNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ViewNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_DataTypeNode_calcSizeBinary(UA_DataTypeNode const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DataTypeNode);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_NodeClass) // nodeClass
	 + UA_QualifiedName_calcSizeBinary(&ptr->browseName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->displayName)
	 + UA_LocalizedText_calcSizeBinary(&ptr->description)
	 + sizeof(UA_UInt32) // writeMask
	 + sizeof(UA_UInt32) // userWriteMask
	 + UA_Array_calcSizeBinary(ptr->referencesSize,UA_REFERENCENODE,ptr->references)
	 + sizeof(UA_Boolean) // isAbstract
	;
}

UA_Int32 UA_DataTypeNode_encodeBinary(UA_DataTypeNode const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_NodeClass_encodeBinary(&src->nodeClass,dst,offset);
	retval |= UA_QualifiedName_encodeBinary(&src->browseName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->displayName,dst,offset);
	retval |= UA_LocalizedText_encodeBinary(&src->description,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->writeMask,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->userWriteMask,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->referencesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->references,src->referencesSize,UA_REFERENCENODE,dst,offset);
	retval |= UA_Boolean_encodeBinary(&src->isAbstract,dst,offset);
	return retval;
}

UA_Int32 UA_DataTypeNode_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DataTypeNode * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DataTypeNode_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_NodeClass_decodeBinary(src,offset,&dst->nodeClass), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_QualifiedName_decodeBinary(src,offset,&dst->browseName), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->displayName), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_LocalizedText_decodeBinary(src,offset,&dst->description), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->writeMask), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->userWriteMask), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->referencesSize),UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->referencesSize,UA_REFERENCENODE,(void**)&dst->references), UA_DataTypeNode_deleteMembers(dst));
	CHECKED_DECODE(UA_Boolean_decodeBinary(src,offset,&dst->isAbstract), UA_DataTypeNode_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DataTypeNode)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DataTypeNode)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DataTypeNode)
UA_Int32 UA_DataTypeNode_delete(UA_DataTypeNode *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DataTypeNode_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DataTypeNode_deleteMembers(UA_DataTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_QualifiedName_deleteMembers(&p->browseName);
	retval |= UA_LocalizedText_deleteMembers(&p->displayName);
	retval |= UA_LocalizedText_deleteMembers(&p->description);
	retval |= UA_Array_delete((void**)&p->references,p->referencesSize,UA_REFERENCENODE);
	return retval;
}

UA_Int32 UA_DataTypeNode_init(UA_DataTypeNode *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_NodeClass_init(&p->nodeClass);
	retval |= UA_QualifiedName_init(&p->browseName);
	retval |= UA_LocalizedText_init(&p->displayName);
	retval |= UA_LocalizedText_init(&p->description);
	retval |= UA_UInt32_init(&p->writeMask);
	retval |= UA_UInt32_init(&p->userWriteMask);
	p->referencesSize = 0;
	p->references = UA_NULL;
	retval |= UA_Boolean_init(&p->isAbstract);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DataTypeNode)
UA_Int32 UA_DataTypeNode_copy(const UA_DataTypeNode *src,UA_DataTypeNode *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DataTypeNode));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_QualifiedName_copy(&src->browseName,&dst->browseName);
	retval |= UA_LocalizedText_copy(&src->displayName,&dst->displayName);
	retval |= UA_LocalizedText_copy(&src->description,&dst->description);
	dst->references = src->references;
	retval |= UA_Array_copy(&src->references, src->referencesSize,UA_REFERENCENODE,(void**)&dst->references);
	return retval;
}

UA_Int32 UA_ReadEventDetails_calcSizeBinary(UA_ReadEventDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReadEventDetails);
    	return 0
	 + sizeof(UA_UInt32) // numValuesPerNode
	 + sizeof(UA_DateTime) // startTime
	 + sizeof(UA_DateTime) // endTime
	 + UA_EventFilter_calcSizeBinary(&ptr->filter)
	;
}

UA_Int32 UA_ReadEventDetails_encodeBinary(UA_ReadEventDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_encodeBinary(&src->numValuesPerNode,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->startTime,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->endTime,dst,offset);
	retval |= UA_EventFilter_encodeBinary(&src->filter,dst,offset);
	return retval;
}

UA_Int32 UA_ReadEventDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReadEventDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReadEventDetails_init(dst);
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->numValuesPerNode), UA_ReadEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->startTime), UA_ReadEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->endTime), UA_ReadEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_EventFilter_decodeBinary(src,offset,&dst->filter), UA_ReadEventDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReadEventDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReadEventDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReadEventDetails)
UA_Int32 UA_ReadEventDetails_delete(UA_ReadEventDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadEventDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReadEventDetails_deleteMembers(UA_ReadEventDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EventFilter_deleteMembers(&p->filter);
	return retval;
}

UA_Int32 UA_ReadEventDetails_init(UA_ReadEventDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UInt32_init(&p->numValuesPerNode);
	retval |= UA_DateTime_init(&p->startTime);
	retval |= UA_DateTime_init(&p->endTime);
	retval |= UA_EventFilter_init(&p->filter);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReadEventDetails)
UA_Int32 UA_ReadEventDetails_copy(const UA_ReadEventDetails *src,UA_ReadEventDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReadEventDetails));
	retval |= UA_EventFilter_copy(&src->filter,&dst->filter);
	return retval;
}

UA_Int32 UA_ReadProcessedDetails_calcSizeBinary(UA_ReadProcessedDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ReadProcessedDetails);
    	return 0
	 + sizeof(UA_DateTime) // startTime
	 + sizeof(UA_DateTime) // endTime
	 + sizeof(UA_Double) // processingInterval
	 + UA_Array_calcSizeBinary(ptr->aggregateTypeSize,UA_NODEID,ptr->aggregateType)
	 + sizeof(UA_AggregateConfiguration) // aggregateConfiguration
	;
}

UA_Int32 UA_ReadProcessedDetails_encodeBinary(UA_ReadProcessedDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_encodeBinary(&src->startTime,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->endTime,dst,offset);
	retval |= UA_Double_encodeBinary(&src->processingInterval,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->aggregateTypeSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->aggregateType,src->aggregateTypeSize,UA_NODEID,dst,offset);
	retval |= UA_AggregateConfiguration_encodeBinary(&src->aggregateConfiguration,dst,offset);
	return retval;
}

UA_Int32 UA_ReadProcessedDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ReadProcessedDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ReadProcessedDetails_init(dst);
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->startTime), UA_ReadProcessedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->endTime), UA_ReadProcessedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->processingInterval), UA_ReadProcessedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->aggregateTypeSize),UA_ReadProcessedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->aggregateTypeSize,UA_NODEID,(void**)&dst->aggregateType), UA_ReadProcessedDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_AggregateConfiguration_decodeBinary(src,offset,&dst->aggregateConfiguration), UA_ReadProcessedDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ReadProcessedDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ReadProcessedDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ReadProcessedDetails)
UA_Int32 UA_ReadProcessedDetails_delete(UA_ReadProcessedDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ReadProcessedDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ReadProcessedDetails_deleteMembers(UA_ReadProcessedDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->aggregateType,p->aggregateTypeSize,UA_NODEID);
	return retval;
}

UA_Int32 UA_ReadProcessedDetails_init(UA_ReadProcessedDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_init(&p->startTime);
	retval |= UA_DateTime_init(&p->endTime);
	retval |= UA_Double_init(&p->processingInterval);
	p->aggregateTypeSize = 0;
	p->aggregateType = UA_NULL;
	retval |= UA_AggregateConfiguration_init(&p->aggregateConfiguration);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ReadProcessedDetails)
UA_Int32 UA_ReadProcessedDetails_copy(const UA_ReadProcessedDetails *src,UA_ReadProcessedDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ReadProcessedDetails));
	dst->aggregateType = src->aggregateType;
	retval |= UA_Array_copy(&src->aggregateType, src->aggregateTypeSize,UA_NODEID,(void**)&dst->aggregateType);
	return retval;
}

UA_Int32 UA_ModificationInfo_calcSizeBinary(UA_ModificationInfo const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_ModificationInfo);
    	return 0
	 + sizeof(UA_DateTime) // modificationTime
	 + sizeof(UA_HistoryUpdateType) // updateType
	 + UA_String_calcSizeBinary(&ptr->userName)
	;
}

UA_Int32 UA_ModificationInfo_encodeBinary(UA_ModificationInfo const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_encodeBinary(&src->modificationTime,dst,offset);
	retval |= UA_HistoryUpdateType_encodeBinary(&src->updateType,dst,offset);
	retval |= UA_String_encodeBinary(&src->userName,dst,offset);
	return retval;
}

UA_Int32 UA_ModificationInfo_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_ModificationInfo * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_ModificationInfo_init(dst);
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->modificationTime), UA_ModificationInfo_deleteMembers(dst));
	CHECKED_DECODE(UA_HistoryUpdateType_decodeBinary(src,offset,&dst->updateType), UA_ModificationInfo_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->userName), UA_ModificationInfo_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_ModificationInfo)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_ModificationInfo)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_ModificationInfo)
UA_Int32 UA_ModificationInfo_delete(UA_ModificationInfo *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_ModificationInfo_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_ModificationInfo_deleteMembers(UA_ModificationInfo *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_String_deleteMembers(&p->userName);
	return retval;
}

UA_Int32 UA_ModificationInfo_init(UA_ModificationInfo *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DateTime_init(&p->modificationTime);
	retval |= UA_HistoryUpdateType_init(&p->updateType);
	retval |= UA_String_init(&p->userName);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_ModificationInfo)
UA_Int32 UA_ModificationInfo_copy(const UA_ModificationInfo *src,UA_ModificationInfo *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_ModificationInfo));
	retval |= UA_String_copy(&src->userName,&dst->userName);
	return retval;
}

UA_Int32 UA_HistoryModifiedData_calcSizeBinary(UA_HistoryModifiedData const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryModifiedData);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->dataValuesSize,UA_DATAVALUE,ptr->dataValues)
	 + UA_Array_calcSizeBinary(ptr->modificationInfosSize,UA_MODIFICATIONINFO,ptr->modificationInfos)
	;
}

UA_Int32 UA_HistoryModifiedData_encodeBinary(UA_HistoryModifiedData const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->dataValuesSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->dataValues,src->dataValuesSize,UA_DATAVALUE,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->modificationInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->modificationInfos,src->modificationInfosSize,UA_MODIFICATIONINFO,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryModifiedData_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryModifiedData * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryModifiedData_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->dataValuesSize),UA_HistoryModifiedData_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->dataValuesSize,UA_DATAVALUE,(void**)&dst->dataValues), UA_HistoryModifiedData_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->modificationInfosSize),UA_HistoryModifiedData_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->modificationInfosSize,UA_MODIFICATIONINFO,(void**)&dst->modificationInfos), UA_HistoryModifiedData_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryModifiedData)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryModifiedData)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryModifiedData)
UA_Int32 UA_HistoryModifiedData_delete(UA_HistoryModifiedData *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryModifiedData_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryModifiedData_deleteMembers(UA_HistoryModifiedData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->dataValues,p->dataValuesSize,UA_DATAVALUE);
	retval |= UA_Array_delete((void**)&p->modificationInfos,p->modificationInfosSize,UA_MODIFICATIONINFO);
	return retval;
}

UA_Int32 UA_HistoryModifiedData_init(UA_HistoryModifiedData *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->dataValuesSize = 0;
	p->dataValues = UA_NULL;
	p->modificationInfosSize = 0;
	p->modificationInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryModifiedData)
UA_Int32 UA_HistoryModifiedData_copy(const UA_HistoryModifiedData *src,UA_HistoryModifiedData *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryModifiedData));
	dst->dataValues = src->dataValues;
	retval |= UA_Array_copy(&src->dataValues, src->dataValuesSize,UA_DATAVALUE,(void**)&dst->dataValues);
	dst->modificationInfos = src->modificationInfos;
	retval |= UA_Array_copy(&src->modificationInfos, src->modificationInfosSize,UA_MODIFICATIONINFO,(void**)&dst->modificationInfos);
	return retval;
}

UA_Int32 UA_HistoryEvent_calcSizeBinary(UA_HistoryEvent const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryEvent);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->eventsSize,UA_HISTORYEVENTFIELDLIST,ptr->events)
	;
}

UA_Int32 UA_HistoryEvent_encodeBinary(UA_HistoryEvent const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->eventsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->events,src->eventsSize,UA_HISTORYEVENTFIELDLIST,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryEvent_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryEvent * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryEvent_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->eventsSize),UA_HistoryEvent_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->eventsSize,UA_HISTORYEVENTFIELDLIST,(void**)&dst->events), UA_HistoryEvent_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryEvent)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryEvent)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryEvent)
UA_Int32 UA_HistoryEvent_delete(UA_HistoryEvent *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryEvent_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryEvent_deleteMembers(UA_HistoryEvent *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->events,p->eventsSize,UA_HISTORYEVENTFIELDLIST);
	return retval;
}

UA_Int32 UA_HistoryEvent_init(UA_HistoryEvent *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->eventsSize = 0;
	p->events = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryEvent)
UA_Int32 UA_HistoryEvent_copy(const UA_HistoryEvent *src,UA_HistoryEvent *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryEvent));
	dst->events = src->events;
	retval |= UA_Array_copy(&src->events, src->eventsSize,UA_HISTORYEVENTFIELDLIST,(void**)&dst->events);
	return retval;
}

UA_Int32 UA_UpdateEventDetails_calcSizeBinary(UA_UpdateEventDetails const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_UpdateEventDetails);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->nodeId)
	 + sizeof(UA_PerformUpdateType) // performInsertReplace
	 + UA_EventFilter_calcSizeBinary(&ptr->filter)
	 + UA_Array_calcSizeBinary(ptr->eventDataSize,UA_HISTORYEVENTFIELDLIST,ptr->eventData)
	;
}

UA_Int32 UA_UpdateEventDetails_encodeBinary(UA_UpdateEventDetails const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->nodeId,dst,offset);
	retval |= UA_PerformUpdateType_encodeBinary(&src->performInsertReplace,dst,offset);
	retval |= UA_EventFilter_encodeBinary(&src->filter,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->eventDataSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->eventData,src->eventDataSize,UA_HISTORYEVENTFIELDLIST,dst,offset);
	return retval;
}

UA_Int32 UA_UpdateEventDetails_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_UpdateEventDetails * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_UpdateEventDetails_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->nodeId), UA_UpdateEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_PerformUpdateType_decodeBinary(src,offset,&dst->performInsertReplace), UA_UpdateEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_EventFilter_decodeBinary(src,offset,&dst->filter), UA_UpdateEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->eventDataSize),UA_UpdateEventDetails_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->eventDataSize,UA_HISTORYEVENTFIELDLIST,(void**)&dst->eventData), UA_UpdateEventDetails_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_UpdateEventDetails)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_UpdateEventDetails)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_UpdateEventDetails)
UA_Int32 UA_UpdateEventDetails_delete(UA_UpdateEventDetails *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_UpdateEventDetails_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_UpdateEventDetails_deleteMembers(UA_UpdateEventDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->nodeId);
	retval |= UA_EventFilter_deleteMembers(&p->filter);
	retval |= UA_Array_delete((void**)&p->eventData,p->eventDataSize,UA_HISTORYEVENTFIELDLIST);
	return retval;
}

UA_Int32 UA_UpdateEventDetails_init(UA_UpdateEventDetails *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->nodeId);
	retval |= UA_PerformUpdateType_init(&p->performInsertReplace);
	retval |= UA_EventFilter_init(&p->filter);
	p->eventDataSize = 0;
	p->eventData = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_UpdateEventDetails)
UA_Int32 UA_UpdateEventDetails_copy(const UA_UpdateEventDetails *src,UA_UpdateEventDetails *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_UpdateEventDetails));
	retval |= UA_NodeId_copy(&src->nodeId,&dst->nodeId);
	retval |= UA_EventFilter_copy(&src->filter,&dst->filter);
	dst->eventData = src->eventData;
	retval |= UA_Array_copy(&src->eventData, src->eventDataSize,UA_HISTORYEVENTFIELDLIST,(void**)&dst->eventData);
	return retval;
}

UA_Int32 UA_HistoryUpdateEventResult_calcSizeBinary(UA_HistoryUpdateEventResult const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_HistoryUpdateEventResult);
    	return 0
	 + sizeof(UA_StatusCode) // statusCode
	 + UA_EventFilterResult_calcSizeBinary(&ptr->eventFilterResult)
	;
}

UA_Int32 UA_HistoryUpdateEventResult_encodeBinary(UA_HistoryUpdateEventResult const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_encodeBinary(&src->statusCode,dst,offset);
	retval |= UA_EventFilterResult_encodeBinary(&src->eventFilterResult,dst,offset);
	return retval;
}

UA_Int32 UA_HistoryUpdateEventResult_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_HistoryUpdateEventResult * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_HistoryUpdateEventResult_init(dst);
	CHECKED_DECODE(UA_StatusCode_decodeBinary(src,offset,&dst->statusCode), UA_HistoryUpdateEventResult_deleteMembers(dst));
	CHECKED_DECODE(UA_EventFilterResult_decodeBinary(src,offset,&dst->eventFilterResult), UA_HistoryUpdateEventResult_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_HistoryUpdateEventResult)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_HistoryUpdateEventResult)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_HistoryUpdateEventResult)
UA_Int32 UA_HistoryUpdateEventResult_delete(UA_HistoryUpdateEventResult *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_HistoryUpdateEventResult_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_HistoryUpdateEventResult_deleteMembers(UA_HistoryUpdateEventResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EventFilterResult_deleteMembers(&p->eventFilterResult);
	return retval;
}

UA_Int32 UA_HistoryUpdateEventResult_init(UA_HistoryUpdateEventResult *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_StatusCode_init(&p->statusCode);
	retval |= UA_EventFilterResult_init(&p->eventFilterResult);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_HistoryUpdateEventResult)
UA_Int32 UA_HistoryUpdateEventResult_copy(const UA_HistoryUpdateEventResult *src,UA_HistoryUpdateEventResult *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_HistoryUpdateEventResult));
	retval |= UA_EventFilterResult_copy(&src->eventFilterResult,&dst->eventFilterResult);
	return retval;
}

UA_Int32 UA_DataChangeNotification_calcSizeBinary(UA_DataChangeNotification const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_DataChangeNotification);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->monitoredItemsSize,UA_MONITOREDITEMNOTIFICATION,ptr->monitoredItems)
	 + UA_Array_calcSizeBinary(ptr->diagnosticInfosSize,UA_DIAGNOSTICINFO,ptr->diagnosticInfos)
	;
}

UA_Int32 UA_DataChangeNotification_encodeBinary(UA_DataChangeNotification const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->monitoredItemsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->monitoredItems,src->monitoredItemsSize,UA_MONITOREDITEMNOTIFICATION,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->diagnosticInfosSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->diagnosticInfos,src->diagnosticInfosSize,UA_DIAGNOSTICINFO,dst,offset);
	return retval;
}

UA_Int32 UA_DataChangeNotification_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_DataChangeNotification * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_DataChangeNotification_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->monitoredItemsSize),UA_DataChangeNotification_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->monitoredItemsSize,UA_MONITOREDITEMNOTIFICATION,(void**)&dst->monitoredItems), UA_DataChangeNotification_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->diagnosticInfosSize),UA_DataChangeNotification_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos), UA_DataChangeNotification_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_DataChangeNotification)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_DataChangeNotification)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_DataChangeNotification)
UA_Int32 UA_DataChangeNotification_delete(UA_DataChangeNotification *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_DataChangeNotification_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_DataChangeNotification_deleteMembers(UA_DataChangeNotification *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->monitoredItems,p->monitoredItemsSize,UA_MONITOREDITEMNOTIFICATION);
	retval |= UA_Array_delete((void**)&p->diagnosticInfos,p->diagnosticInfosSize,UA_DIAGNOSTICINFO);
	return retval;
}

UA_Int32 UA_DataChangeNotification_init(UA_DataChangeNotification *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->monitoredItemsSize = 0;
	p->monitoredItems = UA_NULL;
	p->diagnosticInfosSize = 0;
	p->diagnosticInfos = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_DataChangeNotification)
UA_Int32 UA_DataChangeNotification_copy(const UA_DataChangeNotification *src,UA_DataChangeNotification *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_DataChangeNotification));
	dst->monitoredItems = src->monitoredItems;
	retval |= UA_Array_copy(&src->monitoredItems, src->monitoredItemsSize,UA_MONITOREDITEMNOTIFICATION,(void**)&dst->monitoredItems);
	dst->diagnosticInfos = src->diagnosticInfos;
	retval |= UA_Array_copy(&src->diagnosticInfos, src->diagnosticInfosSize,UA_DIAGNOSTICINFO,(void**)&dst->diagnosticInfos);
	return retval;
}

UA_Int32 UA_EventNotificationList_calcSizeBinary(UA_EventNotificationList const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_EventNotificationList);
    	return 0
	 + UA_Array_calcSizeBinary(ptr->eventsSize,UA_EVENTFIELDLIST,ptr->events)
	;
}

UA_Int32 UA_EventNotificationList_encodeBinary(UA_EventNotificationList const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Int32_encodeBinary(&src->eventsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->events,src->eventsSize,UA_EVENTFIELDLIST,dst,offset);
	return retval;
}

UA_Int32 UA_EventNotificationList_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_EventNotificationList * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_EventNotificationList_init(dst);
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->eventsSize),UA_EventNotificationList_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->eventsSize,UA_EVENTFIELDLIST,(void**)&dst->events), UA_EventNotificationList_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_EventNotificationList)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_EventNotificationList)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_EventNotificationList)
UA_Int32 UA_EventNotificationList_delete(UA_EventNotificationList *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_EventNotificationList_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_EventNotificationList_deleteMembers(UA_EventNotificationList *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_Array_delete((void**)&p->events,p->eventsSize,UA_EVENTFIELDLIST);
	return retval;
}

UA_Int32 UA_EventNotificationList_init(UA_EventNotificationList *p) {
    	UA_Int32 retval = UA_SUCCESS;
	p->eventsSize = 0;
	p->events = UA_NULL;
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_EventNotificationList)
UA_Int32 UA_EventNotificationList_copy(const UA_EventNotificationList *src,UA_EventNotificationList *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_EventNotificationList));
	dst->events = src->events;
	retval |= UA_Array_copy(&src->events, src->eventsSize,UA_EVENTFIELDLIST,(void**)&dst->events);
	return retval;
}

UA_Int32 UA_SessionDiagnosticsDataType_calcSizeBinary(UA_SessionDiagnosticsDataType const * ptr) {
    	if(ptr==UA_NULL) return sizeof(UA_SessionDiagnosticsDataType);
    	return 0
	 + UA_NodeId_calcSizeBinary(&ptr->sessionId)
	 + UA_String_calcSizeBinary(&ptr->sessionName)
	 + UA_ApplicationDescription_calcSizeBinary(&ptr->clientDescription)
	 + UA_String_calcSizeBinary(&ptr->serverUri)
	 + UA_String_calcSizeBinary(&ptr->endpointUrl)
	 + UA_Array_calcSizeBinary(ptr->localeIdsSize,UA_STRING,ptr->localeIds)
	 + sizeof(UA_Double) // actualSessionTimeout
	 + sizeof(UA_UInt32) // maxResponseMessageSize
	 + sizeof(UA_DateTime) // clientConnectionTime
	 + sizeof(UA_DateTime) // clientLastContactTime
	 + sizeof(UA_UInt32) // currentSubscriptionsCount
	 + sizeof(UA_UInt32) // currentMonitoredItemsCount
	 + sizeof(UA_UInt32) // currentPublishRequestsInQueue
	 + sizeof(UA_ServiceCounterDataType) // totalRequestCount
	 + sizeof(UA_UInt32) // unauthorizedRequestCount
	 + sizeof(UA_ServiceCounterDataType) // readCount
	 + sizeof(UA_ServiceCounterDataType) // historyReadCount
	 + sizeof(UA_ServiceCounterDataType) // writeCount
	 + sizeof(UA_ServiceCounterDataType) // historyUpdateCount
	 + sizeof(UA_ServiceCounterDataType) // callCount
	 + sizeof(UA_ServiceCounterDataType) // createMonitoredItemsCount
	 + sizeof(UA_ServiceCounterDataType) // modifyMonitoredItemsCount
	 + sizeof(UA_ServiceCounterDataType) // setMonitoringModeCount
	 + sizeof(UA_ServiceCounterDataType) // setTriggeringCount
	 + sizeof(UA_ServiceCounterDataType) // deleteMonitoredItemsCount
	 + sizeof(UA_ServiceCounterDataType) // createSubscriptionCount
	 + sizeof(UA_ServiceCounterDataType) // modifySubscriptionCount
	 + sizeof(UA_ServiceCounterDataType) // setPublishingModeCount
	 + sizeof(UA_ServiceCounterDataType) // publishCount
	 + sizeof(UA_ServiceCounterDataType) // republishCount
	 + sizeof(UA_ServiceCounterDataType) // transferSubscriptionsCount
	 + sizeof(UA_ServiceCounterDataType) // deleteSubscriptionsCount
	 + sizeof(UA_ServiceCounterDataType) // addNodesCount
	 + sizeof(UA_ServiceCounterDataType) // addReferencesCount
	 + sizeof(UA_ServiceCounterDataType) // deleteNodesCount
	 + sizeof(UA_ServiceCounterDataType) // deleteReferencesCount
	 + sizeof(UA_ServiceCounterDataType) // browseCount
	 + sizeof(UA_ServiceCounterDataType) // browseNextCount
	 + sizeof(UA_ServiceCounterDataType) // translateBrowsePathsToNodeIdsCount
	 + sizeof(UA_ServiceCounterDataType) // queryFirstCount
	 + sizeof(UA_ServiceCounterDataType) // queryNextCount
	 + sizeof(UA_ServiceCounterDataType) // registerNodesCount
	 + sizeof(UA_ServiceCounterDataType) // unregisterNodesCount
	;
}

UA_Int32 UA_SessionDiagnosticsDataType_encodeBinary(UA_SessionDiagnosticsDataType const * src, UA_ByteString* dst, UA_UInt32 *offset) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_encodeBinary(&src->sessionId,dst,offset);
	retval |= UA_String_encodeBinary(&src->sessionName,dst,offset);
	retval |= UA_ApplicationDescription_encodeBinary(&src->clientDescription,dst,offset);
	retval |= UA_String_encodeBinary(&src->serverUri,dst,offset);
	retval |= UA_String_encodeBinary(&src->endpointUrl,dst,offset);
	retval |= UA_Int32_encodeBinary(&src->localeIdsSize,dst, offset);
	retval |= UA_Array_encodeBinary(&src->localeIds,src->localeIdsSize,UA_STRING,dst,offset);
	retval |= UA_Double_encodeBinary(&src->actualSessionTimeout,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->maxResponseMessageSize,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->clientConnectionTime,dst,offset);
	retval |= UA_DateTime_encodeBinary(&src->clientLastContactTime,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->currentSubscriptionsCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->currentMonitoredItemsCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->currentPublishRequestsInQueue,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->totalRequestCount,dst,offset);
	retval |= UA_UInt32_encodeBinary(&src->unauthorizedRequestCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->readCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->historyReadCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->writeCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->historyUpdateCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->callCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->createMonitoredItemsCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->modifyMonitoredItemsCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->setMonitoringModeCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->setTriggeringCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->deleteMonitoredItemsCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->createSubscriptionCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->modifySubscriptionCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->setPublishingModeCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->publishCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->republishCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->transferSubscriptionsCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->deleteSubscriptionsCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->addNodesCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->addReferencesCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->deleteNodesCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->deleteReferencesCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->browseCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->browseNextCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->translateBrowsePathsToNodeIdsCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->queryFirstCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->queryNextCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->registerNodesCount,dst,offset);
	retval |= UA_ServiceCounterDataType_encodeBinary(&src->unregisterNodesCount,dst,offset);
	return retval;
}

UA_Int32 UA_SessionDiagnosticsDataType_decodeBinary(UA_ByteString const * src, UA_UInt32 *offset, UA_SessionDiagnosticsDataType * dst) {
    	UA_Int32 retval = UA_SUCCESS;
	UA_SessionDiagnosticsDataType_init(dst);
	CHECKED_DECODE(UA_NodeId_decodeBinary(src,offset,&dst->sessionId), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->sessionName), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ApplicationDescription_decodeBinary(src,offset,&dst->clientDescription), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->serverUri), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_String_decodeBinary(src,offset,&dst->endpointUrl), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Int32_decodeBinary(src,offset,&dst->localeIdsSize),UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Array_decodeBinary(src,offset,dst->localeIdsSize,UA_STRING,(void**)&dst->localeIds), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_Double_decodeBinary(src,offset,&dst->actualSessionTimeout), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->maxResponseMessageSize), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->clientConnectionTime), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_DateTime_decodeBinary(src,offset,&dst->clientLastContactTime), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->currentSubscriptionsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->currentMonitoredItemsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->currentPublishRequestsInQueue), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->totalRequestCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_UInt32_decodeBinary(src,offset,&dst->unauthorizedRequestCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->readCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->historyReadCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->writeCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->historyUpdateCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->callCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->createMonitoredItemsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->modifyMonitoredItemsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->setMonitoringModeCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->setTriggeringCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->deleteMonitoredItemsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->createSubscriptionCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->modifySubscriptionCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->setPublishingModeCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->publishCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->republishCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->transferSubscriptionsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->deleteSubscriptionsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->addNodesCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->addReferencesCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->deleteNodesCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->deleteReferencesCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->browseCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->browseNextCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->translateBrowsePathsToNodeIdsCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->queryFirstCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->queryNextCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->registerNodesCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	CHECKED_DECODE(UA_ServiceCounterDataType_decodeBinary(src,offset,&dst->unregisterNodesCount), UA_SessionDiagnosticsDataType_deleteMembers(dst));
	return retval;
}

UA_TYPE_METHOD_CALCSIZEXML_NOTIMPL(UA_SessionDiagnosticsDataType)
    UA_TYPE_METHOD_ENCODEXML_NOTIMPL(UA_SessionDiagnosticsDataType)
    UA_TYPE_METHOD_DECODEXML_NOTIMPL(UA_SessionDiagnosticsDataType)
UA_Int32 UA_SessionDiagnosticsDataType_delete(UA_SessionDiagnosticsDataType *p) {
	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_SessionDiagnosticsDataType_deleteMembers(p);
	retval |= UA_free(p);
	return retval;
}

UA_Int32 UA_SessionDiagnosticsDataType_deleteMembers(UA_SessionDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_deleteMembers(&p->sessionId);
	retval |= UA_String_deleteMembers(&p->sessionName);
	retval |= UA_ApplicationDescription_deleteMembers(&p->clientDescription);
	retval |= UA_String_deleteMembers(&p->serverUri);
	retval |= UA_String_deleteMembers(&p->endpointUrl);
	retval |= UA_Array_delete((void**)&p->localeIds,p->localeIdsSize,UA_STRING);
	return retval;
}

UA_Int32 UA_SessionDiagnosticsDataType_init(UA_SessionDiagnosticsDataType *p) {
    	UA_Int32 retval = UA_SUCCESS;
	retval |= UA_NodeId_init(&p->sessionId);
	retval |= UA_String_init(&p->sessionName);
	retval |= UA_ApplicationDescription_init(&p->clientDescription);
	retval |= UA_String_init(&p->serverUri);
	retval |= UA_String_init(&p->endpointUrl);
	p->localeIdsSize = 0;
	p->localeIds = UA_NULL;
	retval |= UA_Double_init(&p->actualSessionTimeout);
	retval |= UA_UInt32_init(&p->maxResponseMessageSize);
	retval |= UA_DateTime_init(&p->clientConnectionTime);
	retval |= UA_DateTime_init(&p->clientLastContactTime);
	retval |= UA_UInt32_init(&p->currentSubscriptionsCount);
	retval |= UA_UInt32_init(&p->currentMonitoredItemsCount);
	retval |= UA_UInt32_init(&p->currentPublishRequestsInQueue);
	retval |= UA_ServiceCounterDataType_init(&p->totalRequestCount);
	retval |= UA_UInt32_init(&p->unauthorizedRequestCount);
	retval |= UA_ServiceCounterDataType_init(&p->readCount);
	retval |= UA_ServiceCounterDataType_init(&p->historyReadCount);
	retval |= UA_ServiceCounterDataType_init(&p->writeCount);
	retval |= UA_ServiceCounterDataType_init(&p->historyUpdateCount);
	retval |= UA_ServiceCounterDataType_init(&p->callCount);
	retval |= UA_ServiceCounterDataType_init(&p->createMonitoredItemsCount);
	retval |= UA_ServiceCounterDataType_init(&p->modifyMonitoredItemsCount);
	retval |= UA_ServiceCounterDataType_init(&p->setMonitoringModeCount);
	retval |= UA_ServiceCounterDataType_init(&p->setTriggeringCount);
	retval |= UA_ServiceCounterDataType_init(&p->deleteMonitoredItemsCount);
	retval |= UA_ServiceCounterDataType_init(&p->createSubscriptionCount);
	retval |= UA_ServiceCounterDataType_init(&p->modifySubscriptionCount);
	retval |= UA_ServiceCounterDataType_init(&p->setPublishingModeCount);
	retval |= UA_ServiceCounterDataType_init(&p->publishCount);
	retval |= UA_ServiceCounterDataType_init(&p->republishCount);
	retval |= UA_ServiceCounterDataType_init(&p->transferSubscriptionsCount);
	retval |= UA_ServiceCounterDataType_init(&p->deleteSubscriptionsCount);
	retval |= UA_ServiceCounterDataType_init(&p->addNodesCount);
	retval |= UA_ServiceCounterDataType_init(&p->addReferencesCount);
	retval |= UA_ServiceCounterDataType_init(&p->deleteNodesCount);
	retval |= UA_ServiceCounterDataType_init(&p->deleteReferencesCount);
	retval |= UA_ServiceCounterDataType_init(&p->browseCount);
	retval |= UA_ServiceCounterDataType_init(&p->browseNextCount);
	retval |= UA_ServiceCounterDataType_init(&p->translateBrowsePathsToNodeIdsCount);
	retval |= UA_ServiceCounterDataType_init(&p->queryFirstCount);
	retval |= UA_ServiceCounterDataType_init(&p->queryNextCount);
	retval |= UA_ServiceCounterDataType_init(&p->registerNodesCount);
	retval |= UA_ServiceCounterDataType_init(&p->unregisterNodesCount);
	return retval;
}

UA_TYPE_NEW_DEFAULT(UA_SessionDiagnosticsDataType)
UA_Int32 UA_SessionDiagnosticsDataType_copy(const UA_SessionDiagnosticsDataType *src,UA_SessionDiagnosticsDataType *dst) {
    	if(src == UA_NULL || dst == UA_NULL) return UA_ERROR;
    	UA_Int32 retval = UA_SUCCESS;
	memcpy(dst, src, sizeof(UA_SessionDiagnosticsDataType));
	retval |= UA_NodeId_copy(&src->sessionId,&dst->sessionId);
	retval |= UA_String_copy(&src->sessionName,&dst->sessionName);
	retval |= UA_ApplicationDescription_copy(&src->clientDescription,&dst->clientDescription);
	retval |= UA_String_copy(&src->serverUri,&dst->serverUri);
	retval |= UA_String_copy(&src->endpointUrl,&dst->endpointUrl);
	dst->localeIds = src->localeIds;
	retval |= UA_Array_copy(&src->localeIds, src->localeIdsSize,UA_STRING,(void**)&dst->localeIds);
	return retval;
}

